
; *****************************************************************************
;
;                                A N I M C
;
;          kompiltor animanho programu ANIM (vyaduje 180 KB pamti)
;
; *****************************************************************************

Code     SEGMENT   para
         ASSUME    cs:Code,ds:Data,ss:Stack

PUBLIC   Animc
Animc:                                      ; start programu (kompiltoru)

; ------ pedefinovn zsobnku na vrchol pamti

         cli                                ; zkaz peruen
         mov       ax,ds:[2]                ; segment s koncem pamti
         sub       ax,1000h                 ; rezerva 64 KB
         mov       ss,ax                    ; segment zsobnku
         mov       sp,0fff8h                ; offset zsobnku
         sti                                ; povolen peruen

; ------ oznaen konce zadn pkazovho dku

         mov       bl,ds:[80h]              ; poet znak pkazu
         mov       bh,0
         mov       byte ptr ds:[bx+81h],0   ; oznaen konce textu

; ------ kontrola voln pamti, inicializace segmentovch registr

         mov       dx,offset MemTxt         ; text - nedostatek pamti
         mov       ax,SEG Interp            ; segment s interpreterem
         add       ax,2800h                 ; rezerva 160 KB
         cmp       ax,ds:[2]                ; je dostatek pamti ?
         mov       ax,SEG Data              ; datov segment
         mov       ds,ax                    ; DS <- datov segment
         jae       Animc8                   ; chyba - nedostatek pamti
         mov       ds:[SegPSP],es           ; schova segmentu PSP
         mov       es,ax                    ; datov segment

; ------ zobrazen vodnho textu

         mov       dx,offset UvTxt          ; vodn text
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ rozbor zadn zdrojovho souboru

         cld                                ; smr nahoru
         mov       si,81h                   ; zatek textu
         call      RozbSpc                  ; vypustn oddlova z textu
         mov       dx,offset ZdrojTxt       ; text - zadejte soubor
         jc        Animc8                   ; chyba - nen nic zadno
         mov       di,offset Soubor         ; buffer k uloen jmna souboru
Animc1:  call      RozbCh                   ; ten znaku ze souboru
         jc        Animc3                   ; nen dal znak
         cmp       al,"/"                   ; je oddlova parametr ?
         je        Animc2                   ; jsou parametry
         cmp       al,","                   ; je oddlovac rka ?
         je        Animc2                   ; je oddlovac rka
         cmp       al," "                   ; je oddlova ?
         jbe       Animc2                   ; je oddlova
         stosb                              ; uloen znaku do bufferu
         jmp       short Animc1             ; dal znak
Animc2:  dec       si                       ; nvrat poslednho znaku
Animc3:  xor       al,al                    ; ukonovac bajt 0
         mov       bx,di                    ; schova konce jmna
         stosb                              ; uloen ukoovacho bajtu 0

; ------ nalezen ppadn ppony jmna souboru

Animc4:  dec       di                       ; nastaven na posledn znak
         cmp       byte ptr ds:[di],"."     ; je ppona zadan ?
         je        Animc6                   ; ppona je zadan
         cmp       byte ptr ds:[di],"\"     ; je oddlova cesty ?
         je        Animc5                   ; ppona nen zadan
         cmp       di,offset Soubor         ; bude ji ped zatkem jmna ?
         ja        Animc4                   ; nebude jet ped zatkem jmna

; ------ nastaven implicitn ppony

Animc5:  mov       di,bx                    ; konec specifikace souboru
         mov       si,offset PripAni        ; implicitn ppona .ANI
         mov       cx,5                     ; poet bajt ppony
         cld                                ; smr nahoru
         rep       movsb                    ; nastaven implicitn ppony
         mov       di,bx                    ; adresa ppony

; ------ oteven zdrojovho souboru

Animc6:  mov       dx,offset Soubor         ; jmno zdrojovho souboru
         mov       ax,3d00h                 ; funkce oteven pro ten
         int       21h                      ; oteven souboru pro ten
         mov       ds:[ZdrojId],ax          ; identifiktor zdrojovho souboru
         jnc       Animc9                   ; soubor oteven OK

; ------ chyba zadn zdrojovho souboru, jin chyba

Animc7:  mov       dx,offset FndTxt         ; text - soubor nenalezen
Animc8:  mov       ah,9
         int       21h                      ; zobrazen chybovho textu
         mov       ax,4c01h
         int       21h                      ; nvrat s chybou

; ------ sestaven jmna clovho souboru

Animc9:  mov       si,offset PripExe        ; ppona vstupnho souboru EXE
         mov       cx,5
         rep       movsb                    ; nastaven ppony souboru EXE

; ------ vytvoen clovho souboru

         mov       ah,3ch                   ; funkce vytvoen souboru
         xor       cx,cx                    ; atributy souboru
         int       21h                      ; vytvoen clovho souboru
         mov       dx,offset CilTxt         ; text - soubor nelze vytvoit
         jc        Animc8                   ; chybn zadn jmna souboru
         mov       ds:[CilId],ax            ; identifiktor clovho souboru

; ------ uloen interpreteru programu

         push      ds
         mov       ax,SEG Interp            ; segment s interpreterem
         mov       ds,ax                    ; segment zhlav interpreteru
         mov       cx,ax                    ; segment zhlav interpreteru
         add       cx,ds:[8]                ; zven segmentu o zhlav EXE
         mov       ds,cx                    ; segment s interpreterem
         add       cx,ds:[2]                ; segment konce interpreteru
         sub       cx,ax                    ; dlka interpreteru v odstavcch
         shl       cx,1
         shl       cx,1
         shl       cx,1
         shl       cx,1                     ; dlka interpreteru v bajtech
         pop       ds
         call      WritProg                 ; uloen interpeteru do souboru

; ------ inicializace buffer programu

         mov       ax,SEG Interp            ; segment s interpreterem
         add       ax,1000h                 ; buffer 64 KB
         mov       ds:[FlagBuf],ax          ; segment s tabulkou nvt
         add       ax,1000h                 ; buffer 64 KB
         mov       ds:[SrcBuf],ax           ; segment vstupnho bufferu 2000h B.

; ------ inicializace bufferu pro peklad programu (datov st)

         mov       word ptr ds:[ProgNum],2  ; inicializace ukazatele v bufferu
         push      ds
         mov       ds,ds:[ProgSeg]          ; segment s bufferem programu
         mov       word ptr ds:[0],2        ; dlka datovho bufferu programu
         pop       ds

; ------ kompilace programu

         call      Compil                   ; kompilace programu

; ------ zpis programu do souboru

         mov       cx,ds:[ProgNum]          ; poet bajt v bufferu
         cmp       cx,ds:[SizProg]
         jbe       Anixx1
         mov       ds:[SizProg],cx          ; schova velikosti programu
Anixx1:  call      WritProg                 ; zpis dat. promnnch do souboru

; ------ zpis koncovho objektu 0

         push      ds
         mov       ds,ds:[ProgSeg]          ; segment s programem
         mov       word ptr ds:[0],0        ; slo objektu 0
         pop       ds
         mov       cx,2                     ; poet bajt k zpisu
         call      WritProg                 ; zpis koncovho objektu 0

; ------ nastaven zhlav programu

         mov       bx,ds:[CilId]            ; clov soubor
         xor       cx,cx
         xor       dx,dx
         mov       ax,4202h
         int       21h                      ; zjitn velikosti programu

         mov       cx,512
         div       cx                       ; pepoet na strnky
         or        dx,dx                    ; je bajt v posledn strnce ?
         jz        Animca                   ; v posledn strnce nen bajt
         inc       ax                       ; strnka + 1
Animca:
         mov       word ptr ds:[CilSize],dx ; velikost vstupnho souboru
         mov       word ptr ds:[CilSize+2],ax

         mov       dx,2
         mov       cx,0
         mov       ax,4200h
         int       21h                      ; ukazatel na offset souboru 2

         mov       dx,offset CilSize
         mov       ah,40h
         mov       cx,4
         int       21h                      ; zpis nov velikosti programu

; ------ kontrola, zda byl program

         mov       dx,offset ErrMain        ; chyba - nen procedura MAIN
         cmp       byte ptr ds:[ParMain],0  ; byla hlavn procedura ?
         je        Navrat0                  ; nebyla hlavn procedura
         mov       dx,offset ErrClos        ; chyba - procedura neuzavena
         cmp       byte ptr ds:[ProgLev],2  ; zstala oteven procedura ?
         je        Navrat0                  ; zstala oteven procedura

         jmp       short Navrat

; ------ chyba

PUBLIC   Navrat0
Navrat0: mov       ah,9
         int       21h                      ; zobrazen chybovho textu
         inc       word ptr ds:[CitChyb]    ; zven tae chyb


PUBLIC   Navrat
Navrat:

; ------ zobrazen volnho msta

         mov       dx,offset FreeTxt        ; text - Voln prostor
         mov       ah,9
         int       21h                      ; zobrazen textu
         mov       ax,ds:[SizProg]          ; poet bajt programu
         neg       ax                       ; voln msto
         call      DispNum                  ; zobrazen volnho prostoru
         mov       dx,offset FreeTxt1       ; text "data"
         mov       ah,9
         int       21h
         mov       ax,ds:[SizDat]           ; poet bajt datovho segmentu
         neg       ax                       ; voln msto
         call      DispNum                  ; zobrazen volnho prostoru
         mov       dx,offset FreeTxt2       ; text "Symboly"
         mov       ah,9
         int       21h
         mov       ax,-70                   ; maximln konec tabulky symbol
         sub       ax,ds:[FlagNum]          ; voln msto
         call      DispNum                  ; zobrazen volnho msta
         mov       dx,offset FreeTxt3       ; zbytek textu
         mov       ah,9
         int       21h                      ; oddkovn

; ------ zobrazen potu chyb

         mov       dx,offset Err000         ; text - Poet chyb
         mov       ah,9
         int       21h                      ; zobrazen textu chyby
         mov       ax,ds:[CitChyb]          ; poet chyb
         push      ax                       ; schova potu chyb
         call      DispNum                  ; zobrazen potu chyb
         mov       dx,offset UvTxt1         ; text oddkovn
         mov       ah,9
         int       21h                      ; oddkovn textu

; ------ uzaven soubor

         mov       bx,ds:[ZdrojId]          ; identifiktor zdrojovho souboru
         mov       ah,3eh
         int       21h                      ; uzaven zdrojovho souboru
         mov       bx,ds:[CilId]            ; identifiktor clovho souboru
         mov       ah,3eh
         int       21h                      ; uzaven clovho souboru

; ------ konec programu

         pop       ax                       ; nvrat potu chyb
         or        al,ah                    ; byla njak chyba ?
         jz        Animcx                   ; nebyla dn chyba
         mov       dx,offset Soubor         ; jmno vstupnho souboru
         mov       ah,41h                   ; funkce zruen souboru
         int       21h                      ; zruen vstupnho souboru
         mov       al,1                     ; kd chyby 1
Animcx:  mov       ah,4ch
         int       21h                      ; nvrat z programu bez chyby

; 
;
;
;                      Rozbor pkazovho dku
;
;
; 

; -----------------------------------------------------------------------------
;        Vypustn oddlova z pkazovho dku
; -----------------------------------------------------------------------------

PUBLIC   RozbSpc
RozbSpc: call      RozbCh
         je        RozbSpc                  ; je mezera - vypustn
         jc        RozbSpc2                 ; je konec textu
         dec       si                       ; nvrat poslednho znaku
RozbSpc2:ret

; -----------------------------------------------------------------------------
;        Vstup znaku z pkazovho dku SI (CY=konec)
; -----------------------------------------------------------------------------

PUBLIC   RozbCh
RozbCh:  push      ds
         mov       ds,ds:[SegPSP]           ; segment PSP
         cld                                ; smr nahoru
         lodsb                              ; ten znaku
         call      UpCase                   ; pevod znaku na velk psmeno

; ------ nhrada tabeltoru mezerou

         cmp       al,9                     ; je tabeltor ?
         jne       RozbCh2                  ; nen tabeltor
         mov       al," "                   ; nhrada mezerou

; ------ kontrola, zda je oddlova

RozbCh2: cmp       al," "                   ; je oddlova ?
         jae       RozbCh3                  ; nen oddlova
         dec       si                       ; konec - nvrat poslednho znaku

RozbCh3: pop       ds
         ret

; 
;
;
;                            Kompiltor
;
;
; 


; -----------------------------------------------------------------------------
;        Kompilace programu
; -----------------------------------------------------------------------------

PUBLIC   Compil
Compil:  xor       ax,ax                    ; AX <- 0
         push      ax                       ; identifiktor konce etzce cykl

; ------ nalezen dalho pkazu

Compil0: call      InpSpc                   ; nalezen zatku dalho slova
         jnc       Compil01                 ; je dal znak
Compil00:jmp       CompRet                  ; nen dal znak
Compil01:cmp       al,";"                   ; je przdn pkaz ?
         je        Compil0                  ; je przdn pkaz - dal
         call      RetCh                    ; nvrat nalezenho znaku

; ------ schova odkazu na dek s pkazem (pro zobrazen chyby)

Compil1: mov       ax,word ptr ds:[UkazRad] ; souasn ukazatel dku - LOW
         mov       word ptr ds:[ErrARad],ax ; ukazatel dku s chybou - LOW
         mov       ax,word ptr ds:[UkazRad+2] ; souasn ukazatel dku - HIGH
         mov       word ptr ds:[ErrARad+2],ax ; ukazatel dku s chybou - HIGH
         mov       ax,ds:[CitRad]           ; souasn slo dku
         mov       ds:[ErrNRad],ax          ; slo dku s chybou

; ------ naten identifiktoru povelu, identifikace konce pekladu

         mov       bp,sp                    ; ukazatel na cykly v zsobnku
         call      ReadIdnt                 ; ten identifiktoru
         jnc       Compil4                  ; je platn identifiktor

; ------ chyba - neplatn symbol (hlen chyby a nalezen konce pkazu)

Compil2: mov       dx,offset Err001         ; chyba - Neplatn symbol
Compil3: call      DispErr                  ; zobrazen textu chyby
Compil32:call      InpSpc                   ; zruen znak oddlovae
         jc        Compil00                 ; nen dal znak
         cmp       al,";"                   ; je konec pkazu ?
         jne       Compil32                 ; nalezen konce pkazu
         jmp       short Compil0            ; peklad dalho znaku

; ------ nalezen identifiktoru v tabulce vnitnch procedur

Compil4: call      SrcIdnt                  ; nalezen slova v intern tabulce
         jc        Compil5                  ; intern identifiktor nenalezen

; ------ je intern klov slovo - kontrola oprvnnosti

                                          ;* deklaran st programu
         mov       bl,ds:[ProgLev]          ; stupe programu
         cmp       bl,0                     ; je zatek programu ?
         jne       Comp43                   ; nen zatek programu

         mov       dx,offset Err019         ; LINK nesm bt v deklar. sti
         cmp       al,0                     ; je LINK ?
         je        Compil3                  ; chyba - LINK nen povoleno
         cmp       al,5                     ; maximln povoleno PROC
         jbe       Comp4c                   ; povoleno
         jmp       short Compil3            ; chyba - nesm bt v deklar. sti

                                          ;* vnitn st, PROC nen otevena
Comp43:  cmp       bl,1                     ; je vnitn st - uzaven PROC ?
         jne       Comp46                   ; nen vnitn st

         cmp       al,0                     ; je LINK ?
         je        Comp4c                   ; je LINK - OK
         cmp       al,5                     ; je PROC ?
         je        Comp4c                   ; je PROC - OK
         jb        Comp47                   ; je men - test oprvnnosti
Comp44:  mov       dx,offset Err011         ; text - mus bt v procedue
         jmp       short Compil3            ; hlen chyby

                                          ;* vnitn st, PROC je otevena
Comp46:  cmp       bl,2                     ; je vnitn st - oteven PROC ?
         jne       Comp49                   ; nen vnitn st

         mov       dx,offset Err008         ; text - LINK nesm bt uvnit proc.
         cmp       al,0                     ; je LINK ?
         je        Compil3                  ; zobrazen chybovho hlen

Comp47:  mov       dx,offset Err003         ; text - BYTE sm bt jen v deklar.
         cmp       al,2                     ; je BYTE ?
         jb        Comp4c                   ; je INCLUDE - OK
         cmp       al,4                     ; je STRING ?
         jbe       Compil3                  ; chyba - nesm bt
         jmp       short Comp4c             ; ostatn OK

                                          ;* je konec programu
Comp49:  cmp       al,0                     ; je povoleno pouze LINK
         je        Comp4c                   ; povolen funkce

                                          ;* chyba - za LINK je program
         mov       dx,offset Err007         ; chyba - nesmi nsledovat program
         call      DispErr                  ; zobrazen textu chyby
         jmp       short CompRet            ; konec programu

; ------ intern identifiktor nalezen a povolen

Comp4c:  mov       ds:[LastIdn],al          ; schova identifiktoru
         call      OutCh                    ; uloen identifiktoru povelu
         mov       bh,0
         mov       bl,ds:[si]               ; dlka slova
         mov       ax,ss:[bp]               ; kd konstrukce v zsobnku
         call      word ptr ds:[si+bx+1]    ; vyvoln obsluhy procedury
         cmp       byte ptr ds:[LastIdn],24 ; je procedura ?
         jb        Compil02                 ; nen bn procedura
         call      TestKon                  ; test, zda je konec pkazu
Compil02:jmp       Compil0                  ; peklad dalho slova

; ------ nen vnitn identifiktor - pokus o nalezen v uivatelsk tabulce

Compil5: xor       al,al                    ; pznak - nvt nedefinovno
         call      StorFlg                  ; pokus o nalezen v tabulce
         jnc       Compil53                 ; nvt nebylo v tabulce nalezeno
         test      al,1                     ; bylo jmno definovno ?
         jz        Compil53                 ; jmno nebylo dosud definovno

; ------ je uivatelsk procedura

         test      al,2                     ; je to procedura ?
         jz        Compil51                 ; je to promnn
         mov       al,0ffh                  ; pznak uivatelsk procedury
         call      OutCh                    ; uloen pznak uivat. procedury
         mov       ax,es:[di+1]             ; adresa symbolu
         call      OutWrd                   ; uloen adresy
         call      TestKon                  ; test konce pkazu ";"
         jmp       short Compil02           ; dal slovo

; ------ je promnn - sestaven kdu promnn

Compil51:mov       al,0f8h                  ; pznak promnn
         test      byte ptr es:[di],4       ; je WORD ?
         jz        Compil56                 ; je BYTE
         or        al,1                     ; pznak WORD
Compil56:test      byte ptr es:[di],10h     ; je index ?
         jz        Compil57                 ; nen index
         or        al,2                     ; pznak indexu
Compil57:call      OutCh                    ; uloen pznaku promnn

; ------ adresa promnn

         mov       ax,es:[di+1]             ; adresa symbolu
         call      OutWrd                   ; uloen adresy

; ------ pro indexovanou poloku definice argumentu

         test      byte ptr es:[di],10h     ; je index ?
         jz        Compil58                 ; nen index
         mov       cx,1                     ; 1 argument
         call      Argum                    ; dekdovn argumentu

; ------ test piazen

Compil58:call      InpPri                   ; test, zda nsleduje pazen ":="
         mov       dx,offset Err004         ; chyba - :=
         jc        Compil35                 ; chyba definice promnn
         call      Vyraz                    ; uloen vrazu do programu
         jc        Compil35                 ; chyba vrazu
         call      TestKon                  ; test konce pkazu ";"
         jmp       short Compil02           ; dal pkaz

; ------ chyba - neznm jmno procedury nebo promnn

Compil53:mov       dx,offset Err002         ; text chyby - identifik. nenalezen
Compil35:jmp       Compil3                  ; hlen chyby

; ------ nvrat - zjitn neukonench cykl a podmnek

; V zsobnku 4 slova:
; SS:[BP+n+4] (DWORD)   ukazatel dku v souboru
; SS:[BP+n+2] (WORD)    slo dku se zatkem konstrukce
; SS:[BP+2]  n*(WORD)   adresy k proveden relokace konstrukce
; SS:[BP+1] (BYTE)      poet slov adres k relokaci (=n)
; SS:[BP+0] (BYTE)      00h - konec vnoench konstrukc
;
;                       10h - PROC
;                                       ;(; v zsob.:<- xENDPROC (pro RETURN))
;
;                       20h - IF-THEN       ; v zsob.:<- ENDIF,ELSE (IF nespl.)
;                       21h - IF-THEN-ELSE  ; v zsob.:<- ENDIF (konec THEN)
;
;                       30h - DO            ; v zsob.:<- xENDDO (ON)
;                                           ; v zsob.: zatek cyklu pro ENDDO
;                       (31h - FOR)
;
;                       40h - CASE-IN       ; v zsob.:<- ENDCASE,IN,OUT (ne-IN)
;                       41h - OUT           ; v zsob.:<- ENDCASE (konec IN)

; ------ test uzaven procedur a funkc

PUBLIC   CompRet
CompRet: mov       bp,sp
         call      ClosIf                   ; uzaven podmnek a cykl
         call      ClosProc                 ; uzaven procedur
         cmp       byte ptr ss:[bp],0       ; je ji konec ?
         jne       CompRet                  ; nen konec - dal

         pop       ax                       ; zruen identifiktoru 0
         ret

; -----------------------------------------------------------------------------
;        Test ukonen procedur (v zsobnku sm bt jen nvratov adresa)
; -----------------------------------------------------------------------------

PUBLIC   ClosProc
ClosProc:pop       word ptr ds:[RetClose]   ; schova nvratov adresy

; ------ test, zda je procedura otevena

ClosPrc1:mov       bp,sp
         mov       ax,ss:[bp]               ; identifiktor konstrukce
         cmp       al,10h                   ; je identifiktor PROC ?
         jne       ClosPrc9                 ; nen PROC - konec

; ------ zobrazen textu chyby

         mov       dx,offset Err010         ; text - procedura nen uzavena
         call      ClosDisp                 ; zobrazen textu chyby
         jmp       short ClosPrc1           ; dal test

ClosPrc9:jmp       word ptr ds:[RetClose]   ; nvrat z procedury

; -----------------------------------------------------------------------------
;        Test ukonen konstrukc (v zsobnku sm bt jen nvratov adresa)
; -----------------------------------------------------------------------------

PUBLIC   ClosIf
ClosIf:  pop       word ptr ds:[RetClose]   ; schova nvratov adresy

; ------ test, zda je nkter konstrukce otevena

ClosIf1: mov       bp,sp
         mov       ax,ss:[bp]               ; identifiktor konstrukce
         cmp       al,20h                   ; je identifiktor PROC ?
         jb        ClosIf9                  ; je PROC nebo konec - OK

; ------ zjitn textu chyby

         mov       dx,offset Err020         ; text - IF neuzaven
         cmp       al,30h                   ; je oteven IF ?
         jb        ClosIf3                  ; je oteven IF
         mov       dx,offset Err031         ; text - DO neuzaven
         cmp       al,30h                   ; je cyklus DO ?
         jb        ClosIf3                  ; je oteven DO
         mov       dx,offset Err040         ; text - CASE neuzaveno
ClosIf3: call      ClosDisp                 ; zobrazen textu chyby
         jmp       short ClosIf1            ; dal konstrukce

ClosIf9: jmp       word ptr ds:[RetClose]   ; nvrat z procedury

; -----------------------------------------------------------------------------
;        Zobrazen chyby neuzaven (v zsobnku sm bt jen nvratov adresa)
; -----------------------------------------------------------------------------

PUBLIC   ClosDisp
ClosDisp:pop       word ptr ds:[RetDisp]    ; schova nvratov adresy

; ------ nvrat parametr textu chyby

         pop       ax                       ; zruen kdu konstrukce
         or        ah,ah                    ; je njak slovo ?
         jz        ClosDis2                 ; nen dn slovo
ClosDis1:pop       cx                       ; zruen slova ze zsobnku
         dec       ah                       ; snen tae slov
         jnz       ClosDis1                 ; dal slovo
ClosDis2:pop       cx                       ; nvrat sla dku
         pop       ax                       ; nvrat adresy dku - LOW
         pop       bx                       ; nvrat adresy dku - HIGH

; ------ schova souasnch parametr dku

         push      word ptr ds:[ErrARad+2]  ; adresa dku - HIGH
         push      word ptr ds:[ErrARad]    ; adresa dku - LOW
         push      word ptr ds:[ErrNRad]    ; slo dku

; ------ nastaven novch ukazatel dku

         mov       ds:[ErrNRAd],cx          ; slo dku
         mov       word ptr ds:[ErrARad],ax ; adresa dku - LOW
         mov       word ptr ds:[ErrARad+2],bx ; adresa dku - HIGH

; ------ zobrazen chybovho hlen

         call      DispErr                  ; zobrazen chybovho hlen

; ------ nvrat ukazatel dku

         pop       word ptr ds:[ErrNRad]    ; slo dku
         pop       word ptr ds:[ErrARad]    ; adresa dku - LOW
         pop       word ptr ds:[ErrARad+2]  ; adresa dku - HIGH

         jmp       word ptr ds:[RetDisp]    ; nvrat z procedury

; -----------------------------------------------------------------------------
;        Definice argumentu (CX=poet poloek)
; -----------------------------------------------------------------------------

PUBLIC   Argum

Argum:   call      TestLeft                 ; test, zda je lev zvorka
         jc        Argum2                   ; nen lev zvorka
Argum1:  call      Vyraz                    ; vstup prvnho vrazu
         jc        Argum3                   ; chybn vraz v argumentu
         dec       cx
         jcxz      Argum5                   ; m bt konec
         call      TestCar                  ; test, zda je rka
         jc        Argum2                   ; chybn argument
         jmp       short Argum1             ; dal argument

Argum5:  call      TestRght                 ; test, zda je prav zvorka
         jnc       Argum4                   ; je prav zvorka OK

Argum2:  mov       dx,offset Err01b         ; text - chybn argument
Argum3:  call      DispErr                  ; zobrazen textu chyby
         stc
Argum4:  ret

; -----------------------------------------------------------------------------
;        Definice vrazu
; -----------------------------------------------------------------------------
;           0 - konec vrazu
;           1 - (
;           2 - )
;           3 - ^
;           4 - *
;           5 - /
;           6 - MOD
;           7 - <<
;           8 - >>
;           9 - +
;          10 - -
;          11 - =
;          12 - <>
;          13 - <
;          14 - >
;          15 - <=
;          16 - >=
;          17 - NOT
;          18 - AND
;          19 - OR
;          20 - XOR
;         81h - seln konstanta (v BX hodnota konstanty)
;         82h - intern procedura (v BL slo procedury)
;         83h - uivatelsk procedura (v BX adresa procedury)
;         84h - BYTE bez indexu (v BX adresa promnn)
;         85h - WORD bez indexu (v BX adresa promnn)
;         86h - BYTE s indexem (v BX adresa promnn, nsleduje index)
;         87h - WORD s indexem (v BX adresa promnn, nsleduje index)
; -----------------------------------------------------------------------------
;
PUBLIC   Vyraz
Vyraz:
         call      Vyraz0
         pushf
         mov       al,0
         call      OutCh                    ; oznaen konce vrazu
         popf
         ret


PUBLIC   Vyraz0
Vyraz0:

; ------ dekdovn prvnho operandu

         call      VyrUn                    ; dekdovn operandu
         jc        Vyraz9                   ; chyba

; ------ dekdovn opertoru

Vyraz1:  call      GetOper                  ; dekdovn opertoru
         cmc
         jnc       Vyraz9                   ; nen dal opertor - nevad

; ------ test, zda je konec vrazu

         cmp       al,2                     ; je prav zvorka ?
         jne       Vyraz2                   ; nen prav zvorka
         mov       al,")"                   ; pvodn prav zvorka
         call      RetCh                    ; nvrat prav zvorky
         jmp       short Vyraz9             ; konec vrazu

; ------ uloen kdu opertoru

Vyraz2:  call      OutCh                    ; uloen kdu opertoru

; ------ dekdovn druhho operandu

         call      VyrUn                    ; dekdovn druhho operandu
         jnc       Vyraz1                   ; OK, take dal opertor


Vyraz9:  mov       dx,offset Err005         ; text - cbybn vraz
         ret

; -----------------------------------------------------------------------------
;        Dekdovn jednoduchho vrazu (s unrnm opertorem)
; -----------------------------------------------------------------------------

PUBLIC   VyrUn

VyrUn:   push      bx
         push      cx

; ------ dekdovn unrnho opertoru

VyrUn1:  call      GetOper                  ; dekdovn ppadnho opertoru
         jc        VyrUn4                   ; nen platn opertor
         cmp       al,9                     ; je unrn + ?
         je        VyrUn1                   ; je unrn + (ignoruje se)
         cmp       al,10                    ; je unrn - ?
         je        VyrUn2                   ; je unrn - (ulo se)
         cmp       al,17                    ; je unrn NOT ?
         jne       VyrUn3                   ; nen unrn NOT - test zvorky
VyrUn2:  call      OutCh                    ; uloen unrnho opertoru
         jmp       short VyrUn1             ; dal unrn opertor

; ------ dekdovn vrazu v zvorce

VyrUn3:  cmp       al,1                     ; je lev zvorka ?
         stc                                ; pznak chyby
         jne       VyrUn9                   ; nen platn opertor - chyba
         call      Outch                    ; uloen kdu lev zvorky
         call      Vyraz0                   ; dekdovn vrazu v zvorce
         jc        VyrUn9                   ; byla njak chyba
         call      GetOper                  ; test dalho opertoru
         jc        VyrUn9                   ; nen prav zvorka - chyba
         cmp       al,2                     ; je prav zvorka ?
         stc                                ; pznak chyby
         jne       VyrUn9                   ; chyba - nen prav zvorka
         call      OutCh                    ; uloen kdu prav zvorky
         jmp       short VyrUn8             ; nvrat

; ------ dekdovn operandu

VyrUn4:  call      GetOpn                   ; dekdovn operandu
         jc        VyrUn9                   ; chyba - neplatn operand
         call      OutCh                    ; uloen kdu operandu
         xchg      al,bl                    ; AL <- ni bajt parametru
         call      OutCh                    ; uloen niho bajtu parametru
         cmp       bl,82h                   ; je intern procedura ?
         jne       VyrUn5                   ; nen intern procedura
         cmp       al,24                    ; je funkce ?
         jb        VyrUn8                   ; zakzan procedura

; ------ nalezen adresy intern procedury

         mov       bx,offset TabKey         ; tabulka slov
VyrUn6:  add       bl,ds:[bx]               ; piten dlky slova
         adc       bh,0                     ; penos do vyho bajtu
         add       bx,3                     ; peskoen bajtu dlky a adresy
         cmp       al,0                     ; procedura nalezena ?
         je        VyrUn62                  ; nalezena
         dec       al                       ; snen tae procedur
         jmp       short VyrUn6             ; dal slovo

; ------ vyvoln obsluhy procedury

VyrUn62: call      word ptr ds:[bx-2]       ; vyvoln obsluhy procedury
         jmp       short VyrUn8

VyrUn5:  mov       al,bh                    ; vy bajt k uloen
         call      OutCh                    ; uloen vyho bajtu

         cmp       bl,86h
         je        VyrUn7
         cmp       bl,87h
         jne       VyrUn8
VyrUn7:  mov       cx,1
         call      Argum                    ; argument prvku vektoru

VyrUn8:  clc                                ; pznak - operace OK
VyrUn9:  pop       cx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Dekdovn operandu (CY=neplatn operand)
; -----------------------------------------------------------------------------
; AL = typ operandu (bit 7 = 1):
;            0h - neplatn operand
;           81h - seln konstanta (v BX hodnota konstanty)
;           82h - intern procedura (v BL slo procedury)
;           83h - uivatelsk procedura (v BX adresa procedury)
;           84h - BYTE bez indexu (v BX adresa promnn)
;           85h - WORD bez indexu (v BX adresa promnn)
;           86h - BYTE s indexem (v BX adresa promnn, nsleduje index)
;           87h - WORD s indexem (v BX adresa promnn, nsleduje index)
; BX = adresa nebo hodnota operandu
; -----------------------------------------------------------------------------

PUBLIC   GetOpn
GetOpn:

; ------ schova registr

         push      si
         push      di
         push      es

; ------ pokus o naten jmna promnn nebo funkce

         call      ReadIdnt                 ; ten jmna operandu
         jc        GetOpn6                  ; nen platn jmno

; ------ pokus o nalezen v intern tabulce funkc

         call      SrcIdnt                  ; nalezen v intern tabulce
         jc        GetOpn3                  ; nen slovo intern tabulky
         mov       bl,al                    ; slo procedury
         mov       al,82h                   ; pznak, e je intern procedura
         cmp       bl,24                    ; me bt jako funkce ?
         jae       GetOpn9                  ; me bt pouit - OK

; ------ nvrat slova, protoe je neplatn

         call      RetIdnt                  ; nvrat jmna funkce
         jmp       short GetOpn8            ; nvrat s chybou

; ------ pokus o nalezen slova v uivatelsk tabulce

GetOpn3: mov       al,0                     ; pznak, e jmno nen definovno
         call      StorFlg                  ; nalezen jmna v tabulce
         jnc       GetOpn8                  ; nen definovno - to je chyba
         test      al,1                     ; je definovno ?
         jz        GetOpn8                  ; slovo nen definovno

; ------ je uivatelsk procedura

         mov       bx,es:[di+1]             ; adresa procedury nebo promnn
         test      al,2                     ; je procedura ?
         jz        GetOpn5                  ; nen procedura
         mov       al,83h                   ; pznak uivatelsk procedury
         jmp       short GetOpn9            ; nvrat

; ------ stanoven typu promnn

GetOpn5: test      al,8                     ; je OBJECT ?
         jnz       GetOpn8                  ; nen povolen promnn
         shr       al,1
         shr       al,1                     ; pznak WORD z bitu 2 na bit 0
         test      al,4                     ; je index ?
         jz        GetOpn4                  ; nen index
         or        al,2                     ; pznak indexu
GetOpn4: and       al,3                     ; typ
         or        al,84h
         jmp       short GetOpn9

; ------ pokus o interpretaci jako slo

GetOpn6: call      Numb                     ; interpretace jako slo
         mov       bx,ax                    ; hodnota konstanty
         mov       al,81h                   ; pznak seln konstanty
         jnc       GetOpn9                  ; je seln operand

; ------ chyba - neplatn operand

GetOpn8: mov       al,0                     ; pznak - neplatn operand
         mov       bx,0
         stc                                ; pznak chyby

; ------ nvrat registr

GetOpn9: pop       es
         pop       di
         pop       si
         ret

; -----------------------------------------------------------------------------
;        Vstup znaku opertoru (CY=neplatn opertor)
; -----------------------------------------------------------------------------
; AL = opertor (bit 7 = 0):
;           0 - neplatn opertor
;           1 - (
;           2 - )
;           3 - ^
;           4 - *
;           5 - /
;           6 - MOD
;           7 - <<
;           8 - >>
;           9 - +
;          10 - -
;          11 - =
;          12 - <>
;          13 - <
;          14 - >
;          15 - <=
;          16 - >=
;          17 - NOT
;          18 - AND
;          19 - OR
;          20 - XOR
;          (21 - unrn -)
; -----------------------------------------------------------------------------

PUBLIC   GetOper
GetOper:

; ------ schova registr

         push      cx
         push      si
         push      di
         push      es

         push      ds
         pop       es
         cld

; ------ naten max. 3 znak opertoru

         mov       di,offset BufOper        ; buffer opertoru
         mov       cx,3                     ; 3 znaky
         xor       al,al
         stosb                              ; poet bajt zatm je 0
         call      InpSpc                   ; vstup s vyputnm mezer
         jc        GetOper2                 ; nen dal znak
         cmp       al,'"'
         je        GetOpr11                 ; jsou uvozovky
GetOper1:stosb                              ; uloen znaku
         inc       byte ptr ds:[BufOper]    ; zven tae potu znak
         dec       cx
         jcxz      GetOper2
         call      InpChU                   ; vstup dalho znaku
         cmp       al,'"'
         jne       GetOper1
GetOpr11:call      RetCh                    ; nvrat znaku "

; ------ test, zda se provede hledn v tabulce

GetOper2:mov       al,0                     ; pednastaven - opertor nenalezen
         cmp       byte ptr ds:[BufOper],0  ; je jet nco v bufferu ?
         stc                                ; pznak chyby, e nic nen
         je        GetOper6                 ; slovo nenalezeno

; ------ tabulka bude prohledna

         mov       si,offset BufOper        ; buffer s opertorem
         mov       di,offset TabOper        ; tabulka opertor

; ------ test, zda je konec tabulky

GetOper3:inc       al                       ; zven ukazatele slov v tabulce
         mov       cl,ds:[di]               ; dlka opertoru v tabulce
         jcxz      GetOper4                 ; je ji konec tabulky
         inc       cl                       ; porovn se i dlka

; ------ porovnn jedn poloky v tabulce

         cld
         push      si
         push      di
         push      cx
         repe      cmpsb                    ; porovnn s polokou tabulky
         pop       cx
         pop       di
         pop       si
         je        GetOper6                 ; poloka nalezena OK

; ------ nastaven na dal poloku tabulky

         add       di,cx                    ; adresa dal poloky v tabulce
         jmp       short GetOper3           ; test dal poloky tabulky

; ------ nvrat poslednho znaku z bufferu

GetOper4:mov       cl,ds:[si]               ; poet znak v buferu
         dec       byte ptr ds:[si]         ; snen potu znak v bufferu
         add       si,cx                    ; adresa znaku v bufferu
         mov       al,ds:[si]               ; znak v bufferu
         call      RetCh                    ; nvrat znaku do bufferu
         jmp       short GetOper2           ; dal porovnn opertoru

; ------ nvrat registr

GetOper6:pop       es
         pop       di
         pop       si
         pop       cx
         ret

; -----------------------------------------------------------------------------
;        Zjitn, zda nsleduje znak piazen := (CY=nensleduje)
; -----------------------------------------------------------------------------

PUBLIC   InpPri
InpPri:
         push      ax
         call      InpSpc                   ; vstup prvnho znaku
         jc        InpPri3                  ; nen dal znak
         cmp       al,":"                   ; je znak ":" ?
         jne       InpPri2                  ; prvn znak nen ":"
         call      InpCh                    ; dal znak
         jc        InpPri1                  ; nen dal znak - chyba
         cmp       al,"="                   ; je znak "=" ?
         je        InpPri3                  ; je znak "=" - OK
         call      RetCh                    ; nvrat druhho znaku
InpPri1: mov       al,":"                   ; znak ":"
InpPri2: call      RetCh                    ; nvrat znaku ":"
         stc                                ; pznak chyby - nen ":="
InpPri3: pop       ax
         ret

; -----------------------------------------------------------------------------
;        Test konce pkazu (znak ;)
; -----------------------------------------------------------------------------

PUBLIC   TestKon
TestKon: call      InpSpc
         jc        TestKon1                 ; pkaz nen ukonen
         cmp       al,";"
         je        TestKon2
         call      RetCh                    ; nvrat znaku
TestKon1:mov       dx,offset Err01a         ; text - chyb stednk
         call      DispErr                  ; zobrazen chyby
TestKon2:ret

; -----------------------------------------------------------------------------
;        Test, zda je lev zvorka "("
; -----------------------------------------------------------------------------

PUBLIC   TestLeft
TestLeft:call      InpSpc                   ; naten dalho znaku
         jc        TestLft2                 ; chyba - nen lev zvorka
         cmp       al,"("                   ; je lev zvorka ?
         je        TestLft2                 ; je lev zvorka - OK
         call      RetCh                    ; nvrat znaku
         stc                                ; pznak chyby
TestLft2:ret

; -----------------------------------------------------------------------------
;        Test, zda je oddlovac rka ","
; -----------------------------------------------------------------------------

PUBLIC   TestCar
TestCar: call      InpSpc                   ; naten dalho znaku
         jc        TestCar2                 ; chyba - nen rka
         cmp       al,","                   ; je rka ?
         je        TestCar2                 ; je rka - OK
         call      RetCh                    ; nvrat znaku
         stc                                ; pznak chyby
TestCar2:ret

; -----------------------------------------------------------------------------
;        Test, zda je oddlovac dvojteka ":"
; -----------------------------------------------------------------------------

PUBLIC   TestDvj
TestDvj: call      InpSpc                   ; naten dalho znaku
         jc        TestDvj2                 ; chyba - nen dvojteka
         cmp       al,":"                   ; je dvojteka ?
         je        TestDvj2                 ; je dvojteka - OK
         call      RetCh                    ; nvrat znaku
         stc                                ; pznak chyby
TestDvj2:ret

; -----------------------------------------------------------------------------
;        Test, zda je prav zvorka ")"
; -----------------------------------------------------------------------------

PUBLIC   TestRght
TestRght:call      InpSpc                   ; naten dalho znaku
         jc        TestRgh2                 ; chyba - nen prav zvorka
         cmp       al,")"                   ; je prav zvorka ?
         je        TestRgh2                 ; je prav zvorka - OK
         call      RetCh                    ; nvrat znaku
         stc                                ; pznak chyby
TestRgh2:ret

; -----------------------------------------------------------------------------
;        Test, zda je oddlova intervalu
; -----------------------------------------------------------------------------

PUBLIC   TestInt
TestInt: push      ax
         call      InpCh                    ; ten dalho znaku
         jc        TestInt3                 ; nen dal znak
         cmp       al,"."                   ; je interval ?
         stc                                ; pznak, e nen interval
         jne       TestInt2                 ; nen interval
         call      InpCh                    ; ten dalho znaku
         jc        TestInt1                 ; nen dal znak
         cmp       al,"."                   ; je interval ?
         je        TestInt3                 ; je interval
         stc                                ; pznak, e nen interval
         call      RetCh                    ; nvrat znaku
TestInt1:mov       al,"."
TestInt2:call      RetCh
TestInt3:pop       ax
         ret

; -----------------------------------------------------------------------------
;        Zjitn dimenze promnn (vrac AX,BX=velikost)
; -----------------------------------------------------------------------------

PUBLIC   CompI
CompI:   mov       bx,1                     ; velikost promnn = 1
         call      InpCh                    ; ten dalho znaku
         cmc
         jnc       CompI6                   ; nen dal znak (to nevad)
         cmp       al,"("                   ; jsou parametry ?
         clc
         jne       CompI5                   ; nen dimenze - OK (bude 1)
         call      Numb                     ; ten sla
         jc        CompI6                   ; chybn slo
         mov       bx,ax                    ; nov velikost promnn
         call      InpCh                    ; ten dalho znaku
         jc        CompI6                   ; nen dal znak
         cmp       al,")"                   ; uzaven parametru ?
         je        CompI6                   ; ve je OK
         stc                                ; pznak chyby syntaxe
CompI5:  call      RetCh                    ; nvrat znaku

CompI6:  jnc       CompI7                   ; ve je OK
         mov       dx,offset Err014         ; text - chybn dimenze
         call      DispErr                  ; zobrazen chyby
CompI7:  mov       ax,bx                    ; velikost promnn
         ret

; -----------------------------------------------------------------------------
;        Dekdovn sla se znamnkem
; -----------------------------------------------------------------------------

PUBLIC   NumbS
NumbS:   call      InpSpc                   ; vstup prvnho znaku
         jc        NumbS9
         cmp       al,"+"
         je        NumbS                    ; + se ignoruje
         cmp       al,"-"
         jne       NumbS1                   ; nen slo se znamnkem

                                          ;* je slo s "-"
         call      NumbS
         jc        NumbS2
         neg       ax
         clc
NumbS9:  ret

NumbS2:  mov       al,"-"
         call      RetCh
         ret

NumbS1:  call      RetCh
         call      Numb
         ret

; -----------------------------------------------------------------------------
;        Dekdovn textovho sla
; -----------------------------------------------------------------------------

PUBLIC   Numbt
Numbt:   push      bx
         xor       bx,bx
Numbt0:  call      InpCh                    ; vstup prvnho znaku
         jc        Numbt5                   ; chyba - nen dn znak
         call      RetCh                    ; nvrat znaku
         call      Numbt00                  ; vstup prvnho znaku
         jc        Numbt5                   ; chyba - nen platn znak

; ------ je platn dal znak

Numbt1:  cmp       bh,0                     ; bude peteen ?
         stc
         jne       Numbt5                   ; bylo by peteen
         mov       bh,bl                    ; pedchoz znak
         mov       bl,al                    ; uloen novho znaku
         call      Numbt00                  ; vstup dalho znaku
         jnc       Numbt1                   ; je dal platn znak
         clc                                ; pznak - ve OK
Numbt5:  mov       ax,bx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Vstup textovho znaku (CY=konec, zru koncov uvozovky)
; -----------------------------------------------------------------------------

PUBLIC   Numbt00
Numbt00: call      InpCh                    ; vstup znaku
         jc        Numbt05                  ; nen dal znak
         cmp       al,'"'                   ; jsou uvozovky ?
         clc
         jne       Numbt05                  ; nejsou uvozovky - OK
         call      InpCh                    ; vstup dalho znaku
         cmp       al,'"'                   ; jsou zdvojen uvozovky ?
         je        Numbt05                  ; zdvojen uvozovky - OK
         call      RetCh                    ; nvrat znaku
         stc                                ; pznak konce textu
Numbt05: ret

; -----------------------------------------------------------------------------
;        Dekdovn sla (AX <-)
; -----------------------------------------------------------------------------

PUBLIC   Numb
                                          ;* test, zda je prvn znak slice
Numb:
         push      bx
         xor       bx,bx                    ; BX <- 0 stada sla
         call      InpSpc                   ; vyputn mezer z textu
         jc        Numb9                    ; nen dal znak - chyba
         cmp       al,"?"                   ; je konstanta 8000h ?
         jne       Numb0                    ; nen konstanta 8000h
         mov       bx,8000h                 ; konstanta 8000h
         jmp       short Numb9              ; nvrat
Numb0:   cmp       al,"$"                   ; je hexadecimln slo ?
         je        Numbh0                   ; vstup hexadecimlnho sla
         cmp       al,"%"                   ; je binrn slo ?
         je        Numbb0                   ; vstup binrnho sla
         cmp       al,'"'                   ; je textov slo ?
         je        Numbt0                   ; dekdovn textovho sla

         call      Numb00                   ; test, zda je znak slice
         jc        Numb8                    ; nen slice

         mov       bl,al                    ; prvn slice
Numb1:   call      InpCh                    ; vstup dalho znaku
         cmc
         jnc       Numb9                    ; nen dal znak
         call      Numb00                   ; test, zda je to slice
         cmc
         jnc       Numb8                    ; nen to slice
         push      ax
         mov       ax,10
         mul       bx                       ; star slo * 10
         pop       bx                       ; nov slice
         or        dx,dx                    ; je peteen sla ?
         stc                                ; pznak peteen sla
         jnz       Numb9                    ; chyba - peteen sla
         mov       bh,0
         add       bx,ax                    ; piten slice k stadai
         jc        Numb9                    ; chyba - peteen sla
         jmp       short Numb1              ; vstup dal slice

Numb8:   call      RetCh                    ; nvrat znaku do bufferu
Numb9:   mov       ax,bx                    ; naten slo
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Dekdovn hexadecimlnho sla (AX <-)
; -----------------------------------------------------------------------------

PUBLIC   Numbh
                                          ;* test, zda je prvn znak slice
Numbh:   push      bx
         xor       bx,bx                    ; BX <- 0 stada sla
Numbh0:  call      InpSpc                   ; vyputn mezer z textu
         jc        Numbh9                   ; nen dal znak - chyba
         call      Numbh00                  ; test, zda je znak slice
         jc        Numbh8                   ; nen slice

Numbh1:  add       bl,al                    ; piten slice
         call      InpChU                   ; vstup dalho znaku
         cmc
         jnc       Numbh9                   ; nen dal znak
         call      Numbh00                  ; test, zda je to slice
         cmc
         jnc       Numbh8                   ; nen to slice
         shl       bx,1
         jc        Numbh9                   ; peteen sla
         shl       bx,1
         jc        Numbh9                   ; peteen sla
         shl       bx,1
         jc        Numbh9                   ; peteen sla
         shl       bx,1                     ; star slo * 16
         jc        Numbh9                   ; peteen sla
         jmp       short Numbh1             ; vstup dal slice

Numbh8:  call      RetCh                    ; nvrat znaku do bufferu
Numbh9:  mov       ax,bx                    ; naten slo
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Dekdovn binrnho sla (AX <-)
; -----------------------------------------------------------------------------

PUBLIC   Numbb
                                          ;* test, zda je prvn znak slice
Numbb:   push      bx
         xor       bx,bx                    ; BX <- 0 stada sla
Numbb0:  call      InpSpc                   ; vyputn mezer z textu
         jc        Numbb9                   ; nen dal znak - chyba
         call      Numbb00                  ; test, zda je znak slice
         jc        Numbb8                   ; nen slice

Numbb1:  add       bl,al                    ; piten slice
         call      InpChU                   ; vstup dalho znaku
         cmc
         jnc       Numbb9                   ; nen dal znak
         call      Numbb00                  ; test, zda je to slice
         cmc
         jnc       Numbb8                   ; nen to slice
         shl       bx,1                     ; slo * 2
         jc        Numbb9                   ; peteen sla
         jmp       short Numbb1             ; vstup dal slice

Numbb8:  call      RetCh                    ; nvrat znaku do bufferu
Numbb9:  mov       ax,bx                    ; naten slo
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Test, zda je platn dekadick slice
; -----------------------------------------------------------------------------

PUBLIC   Numb00

Numb00:  cmp       al,"0"
         jb        Numb01                   ; nen slice
         cmp       al,"9"+1
         cmc
         jc        Numb01
         sub       al,"0"
Numb01:  ret

; -----------------------------------------------------------------------------
;        Test, zda je platn slice HEX
; -----------------------------------------------------------------------------

PUBLIC   Numbh00
Numbh00: cmp       al,"0"
         jb        Numbh02                  ; nen slice

         cmp       al,"9"
         jbe       Numbh01                  ; je slice

         cmp       al,"F"+1
         cmc
         jc        Numbh02                  ; nen slice HEX

         cmp       al,"A"
         jb        Numbh02                  ; nen slice HEX
         sub       al,7                     ; korekce na slici HEX

Numbh01: sub       al,"0"                   ; korekce na binrn slo
Numbh02: ret

; -----------------------------------------------------------------------------
;        Test, zda je platn slice BIN
; -----------------------------------------------------------------------------

PUBLIC   Numbb00
Numbb00: cmp       al,"0"
         jb        Numbb02                  ; nen slice

         cmp       al,"2"
         cmc
         jc        Numbb02                  ; je slice

         sub       al,"0"                   ; korekce na binrn slo
Numbb02: ret

; -----------------------------------------------------------------------------
;        Uloen identifiktoru konstrukce (v zsob. 2 nvrat. adresy)
; -----------------------------------------------------------------------------

PUBLIC   PushKod
PushKod: pop       word ptr ds:[RetPush]
         pop       word ptr ds:[RetComp]

         push      word ptr ds:[ErrARad+2]  ; adresa dku - vy slovo
         push      word ptr ds:[ErrARad]    ; adresa dku - ni slovo
         push      word ptr ds:[ErrNRad]    ; slo dku
         mov       ah,0                     ; nen dn adresa v bufferu
         push      ax                       ; uloen kdu adresy
         sub       bp,8                     ; nov adresa ukazatele

         push      word ptr ds:[RetComp]
         jmp       word ptr ds:[RetPush]

; -----------------------------------------------------------------------------
;        Uloen adresy AX do bufferu (v zsob. 2 nvrat. adresy) (ni BX)
; -----------------------------------------------------------------------------

PUBLIC   PushAdrX
PushAdrX:mov       ax,ds:[ProgNum]          ; ukazatel

PUBLIC   PushAdr
PushAdr: pop       word ptr ds:[RetPush]
         pop       word ptr ds:[RetComp]

         pop       bx                       ; ta a pznak
         push      ax                       ; uloen adresy
         inc       bh                       ; zven tae
         push      bx                       ; uloen kdu adresy
         sub       bp,2                     ; nov adresa ukazatele

         push      word ptr ds:[RetComp]
         jmp       word ptr ds:[RetPush]

; -----------------------------------------------------------------------------
;        Zruen identif. konstrukce (v zsob. 2 nvrat. adresy) (ni BX, AX)
; -----------------------------------------------------------------------------

PUBLIC   PopKod
PopKod:  pop       word ptr ds:[RetPush]
         pop       word ptr ds:[RetComp]

PopKod1: pop       ax                       ; ta a pznaky
         or        ah,ah                    ; je jet njak slovo ?
         jz        PopKod3                  ; nen dal slovo

         pop       bx                       ; adresa promnn
         dec       ah                       ; snen tae
         push      ax                       ; schova tae
         add       bp,2                     ; zven ukazatele

         push      es                       ; schova ES
         mov       es,ds:[ProgSeg]          ; segment s programem
         mov       ax,ds:[ProgNum]          ; ukazatel programu
         mov       es:[bx],ax               ; nastaven poadovan adresy
         pop       es                       ; nvrat ES

         jmp       short PopKod1            ; dal adresa

PopKod3: pop       ax                       ; slo dku
         pop       ax                       ; adresa dku - LOW
         pop       ax                       ; adresa dku - HIGH
         add       bp,8                     ; posledn posun ukazatele

         push      word ptr ds:[RetComp]
         jmp       word ptr ds:[RetPush]

; -----------------------------------------------------------------------------
;        Nastaven jedn adresy (ni AX a BX)
; -----------------------------------------------------------------------------

SetAdr:  pop       word ptr ds:[RetPush]
         pop       word ptr ds:[RetComp]

         pop       ax
         or        ah,ah
         jz        SetAdr3                  ; nen dn slovo

         pop       bx                       ; adresa promnn
         dec       ah                       ; snen tae
         add       bp,2                     ; zven ukazatele

         push      es                       ; schova ES
         push      ax
         mov       es,ds:[ProgSeg]          ; segment s programem
         mov       ax,ds:[ProgNum]          ; ukazatel programu
         mov       es:[bx],ax               ; nastaven poadovan adresy
         pop       ax
         pop       es                       ; nvrat ES

SetAdr3: push      ax
         push      word ptr ds:[RetComp]
         jmp       word ptr ds:[RetPush]

; -----------------------------------------------------------------------------
;        Vyjmut adresy z bufferu (CY=nen) (v zsob. 2 nvrat.adresy) (ni BX)
; -----------------------------------------------------------------------------

PUBLIC   PopAdr
PopAdr:  pop       word ptr ds:[RetPush]
         pop       word ptr ds:[RetComp]

         pop       bx                       ; ta a pznak
         or        bh,bh                    ; je dal slovo ?
         stc                                ; pznak - nen dal slovo
         jz        PopAdr2                  ; nen dal slovo

         pop       ax                       ; vyjmut adresy
         dec       bh                       ; snen tae
         add       bp,2                     ; nov adresa ukazatele
         clc                                ; pznak, e je ve OK

PopAdr2: push      bx                       ; nvrat tae

         push      word ptr ds:[RetComp]
         jmp       word ptr ds:[RetPush]


; *****************************************************************************
;
;                Obsluha internch klovch slov
;
; *****************************************************************************

; -----------------------------------------------------------------------------
;        LINK - pipojen objektu
; -----------------------------------------------------------------------------

XLink78: jmp       XLink7

PUBLIC   XLInk
XLink:
         call      OutRet                   ; zruen bajtu z bufferu
         mov       byte ptr ds:[ProgLev],3  ; pznak konce programu

; ------ uloen programu na disk

         mov       cx,ds:[ProgNum]          ; poet bajt v bufferu
         cmp       cx,ds:[SizProg]
         jbe       XLink1
         mov       ds:[SizProg],cx          ; schova velikosti programu
XLink1:  call      WritProg                 ; zpis dat. promnnch do souboru
         mov       word ptr ds:[ProgNum],2  ; zruen programu

; ------ test, zda je prvn znak zvorka "("

         call      TestLeft                 ; test, zda je lev zvorka
         jc        XLink78                  ; chyba - nejsou parametry

; ------ definice objektu

         call      DefObj                   ; definice sla objektu

; ------ oddlovac rka parametr

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XLink78                  ; chyba - neplatn znak

; ------ definice jmna souboru

         mov       dx,ds:[ProgNum]          ; zatek jmna souboru
         call      DefTxt                   ; definice jmna
         jc        XLink78                  ; chybn jmno souboru

; ------ test, zda je prav zvorka ")"

         call      TestRght                 ; test, zda je prav zvorka
         jc        XLink78                  ; chyba - nen prav zvorka

; ------ oteven zadanho souboru

         push      ds
         mov       ds,ds:[ProgSeg]          ; segment se jmnem souboru
         mov       ax,3d00h                 ; funkce oteven souboru pro ten
         int       21h                      ; oteven souboru pro ten
         pop       ds
XLink3:  mov       dx,offset Err016         ; text - chybn jmno souboru
         mov       ds:[LinkId],ax           ; identifiktor souboru
         mov       bx,ax                    ; identifiktor souboru
         mov       ax,4202h                 ; funkce pesunut na konec
         jc        XLink77                  ; chyba - soubor nenalezen

; ------ zjitn velikosti linkovanho souboru

         xor       cx,cx                    ; CX <- 0
         xor       dx,dx                    ; DX <- 0
         int       21h                      ; poskytnut velikosti
         jc        XLink3                   ; chyba souboru
         add       ax,15                    ; zaokrouhlen na odstavec
         adc       dx,0                     ; penos do vyho slova

; ------ pepoet velikosti na odstavce

         shr       dx,1
         rcr       ax,1
         shr       dx,1
         rcr       ax,1
         shr       dx,1
         rcr       ax,1
         shr       dx,1
         rcr       ax,1                     ; pepoet na odstavce

; ------ nastaven ukazatele opt na zatek souboru

         push      ax
         xor       cx,cx
         xor       dx,dx
         mov       ax,4200h
         int       21h                      ; nastaven na zatek souboru
         pop       ax
         jc        XLink3                   ; chyba souboru

; ------ kopie prvnho bloku souboru

         push      ds
         push      ax                       ; velikost souboru v odstavcch
         mov       bx,ds:[LinkId]           ; zdrojov soubor
         mov       ds,ds:[ProgSeg]          ; datov segment
         push      word ptr ds:[2]          ; schova sla objektu
         xor       dx,dx                    ; ukldac adresa - offset
         mov       cx,0e000h                ; maximln velikost bloku
         mov       ah,3fh                   ; funkce ten ze souboru
         int       21h                      ; ten bloku ze souboru
         mov       cx,ax                    ; poet natench bajt
         pop       word ptr ds:[0]          ; nvrat sla objektu
         pop       word ptr ds:[2]          ; nastaven velikosti souboru
         pop       ds
         jc        XLink3                   ; chyba ten
         call      WritProg                 ; uloen prvnho bloku souboru

; ------ kopie dalch blok souboru

XLink4:  push      ds
         mov       bx,ds:[LinkId]           ; zdrojov soubor
         mov       ds,ds:[ProgSeg]          ; datov segment
         xor       dx,dx                    ; ukldac adresa - offset
         mov       cx,0e000h                ; maximln velikost bloku
         mov       ah,3fh                   ; funkce ten ze souboru
         int       21h                      ; ten bloku ze souboru
         mov       cx,ax                    ; poet natench bajt
         pop       ds
         jc        XLink3                   ; chyba ten
         call      WritProg                 ; uloen bloku souboru
         jcxz      XLink83                  ; konec souboru
         jmp       short XLink4             ; kopie dalho bloku

XLink83: mov       ah,3eh
         mov       bx,ds:[LinkId]           ; zdrojov soubor
         int       21h                      ; uzaven vstupnho souboru
         jmp       short XLink8

; ------ chyba syntaxe pkazu LINK

XLink7:  mov       dx,offset Err015         ; text - chyba syntaxe
XLink77: call      DispErr                  ; zobrazen textu chyby

; ------ nvrat z obsluhy

XLink8:  mov       word ptr ds:[ProgNum],0  ; zruen natenho textu
         call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        Definice odkazu na objekt
; -----------------------------------------------------------------------------

PUBLIC   DefObj
DefObj:  call      ReadIdnt                 ; ten jmna objektu
         jc        DefObj4                  ; chyba - neplatn jmno
         mov       al,0dh                   ; identifiktor objektu
         call      StorFlg                  ; uloen identifiktoru
         mov       dx,offset Err009         ; chyba - vcensobn pouit jmna
         cmp       al,0dh                   ; je identifiktor objektu ?
         jne       DefObj5                  ; nen objekt - chyba
         mov       ax,di                    ; adresa objektu v tabulce
         inc       ax                       ; bude slo 1 a ve
         call      OutWrd                   ; uloen sla objektu
         clc                                ; pznak operace OK
         ret

DefObj4: mov       dx,offset Err012         ; text - neplatn jmno objektu
DefObj5: call      DispErr                  ; zobrazen textu chyby
         stc                                ; pznak chyby
DefObj6: ret

; -----------------------------------------------------------------------------
;        Definice textu v uvozovkch jako ASCIIZ (CY=nen text v uvozovkch)
; -----------------------------------------------------------------------------

PUBLIC   DefTxt
DefTxt:

; ------ test, zda je platn zatek textu

         call      InpSpc                   ; vypustn mezer z textu
         jc        DefTxt6                  ; chyba - nen dal znak
         cmp       al,'"'                   ; jsou uvozovky ?
         stc
         jne       DefTxt5                  ; nejsou uvozovky - neplatn text

; ------ naten znaku textu

DefTxt1: call      InpCh                    ; vstup dalho znaku
         jc        DefTxt4                  ; nen dal znak
         cmp       al,'"'                   ; jsou uvozovky ?
         je        DefTxt3                  ; je znak uvozovek
DefTxt2: call      OutCh                    ; uloen znaku
         jmp       short DefTxt1            ; dal znak textu

; ------ test, zda je platn znak uvozovek

DefTxt3: call      InpCh                    ; ten dalho znaku
         jc        DefTxt4                  ; nen dal znak
         cmp       al,'"'                   ; jsou uvozovky ?
         je        DefTxt2                  ; jsou zdvojen uvozovky
         clc                                ; pznak - konec textu OK

; ------ oznaen konce textu ASCIIZ

DefTxt4: push      ax
         mov       al,0
         call      OutCh                    ; uloen ukonovacho bajtu 0
         pop       ax
         clc
DefTxt5: call      RetCh                    ; nvrat poslednho znaku
DefTxt6: ret

; -----------------------------------------------------------------------------
;        INCLUDE - vnoen textovho souboru
; -----------------------------------------------------------------------------

PUBLIC   XInclud
XInclud:
         call      OutRet                   ; zruen bajtu z bufferu

         call      TestKon                  ; test, zda je konec

         ret

; -----------------------------------------------------------------------------
;        EXEC - proveden pkazu DOS
; -----------------------------------------------------------------------------

PUBLIC   XExec
XExec:  ; call      DefTxt
        ; jnc       XExec3                   ; zadn pkazu OK
        ;
        ; mov       dx,offset Err017         ; text - chyb pkaz
        ; call      DispErr                  ; zobrazen chyby

XExec3:
         ret

; -----------------------------------------------------------------------------
;        IF - podmnka
; -----------------------------------------------------------------------------

PUBLIC   XIf
XIf:
         mov       al,20h                   ; identifiktor IF
         call      PushKod                  ; uloen identifiktoru do zsob.

; ------ uloen vrazu jako podmnka funkce

         call      Vyraz                    ; uloen vrazu (podmnka)
         jnc       XIf5
         call      DispErr
XIf5:

; ------ kontrola, zda nsleduje THEN

         call      ReadIdnt                 ; naten identifiktoru THEN
         jc        XIf2                     ; chyba - neplatn jmno
         call      SrcIdnt                  ; nalezen identifiktoru v tabulce
         jc        XIf4                     ; neplatn jmno
         cmp       al,10                    ; je jmno THEN ?
         je        XIf3                     ; je jmno THEN - OK

; ------ chyba - nensleduje THEN

XIf4:    call      RetIdnt                  ; nvrat nvt do bufferu
XIf2:    mov       dx,offset Err021         ; text - mus nsledovat THEN
         call      DispErr                  ; zobrazen textu chyby

; ------ uloen adresy pro vtven IF (podmnka nesplnna)

XIf3:    call      PushAdrX                 ; uloen adresy ukazatele
         call      OutWrd                   ; rezerva pro uloen adresy
         ret

; -----------------------------------------------------------------------------
;        THEN - zatek pkaz v podmnce IF (nelze vcensobn)
; -----------------------------------------------------------------------------

PUBLIC   XThen
XThen:   mov       dx,offset Err023         ; text - THEN mus bt za IF
         call      DispErr                  ; zobrazen textu chyby
         ret

; -----------------------------------------------------------------------------
;        ELSE - zatek pkaz (podmnka IF nesplnna)
; -----------------------------------------------------------------------------

PUBLIC   XElse
XElse:   mov       dx,offset Err022         ; text - ELSE bez podmnky IF
         cmp       al,20h                   ; je oteven IF ?
         jne       XElse5                   ; zobrazen textu chyby
         mov       dx,offset Err025         ; text - ELSE nesm bt vckrt
         cmp       al,21h                   ; bylo ji ELSE ?
         je        XElse5                   ; zobrazen textu chyby

; ------ ELSE je povoleno

         mov       byte ptr ss:[bp],21h     ; pznak ELSE
         call      PopAdr                   ; vyjmut adresy za IF
         mov       si,ax                    ; adresa v programu
         call      PushAdrX                 ; adresa pro nastaven odkazu
         add       ax,2                     ; msto pro nvratovou adresu
         push      ds
         mov       ds,ds:[ProgSeg]          ; segment s programem
         mov       ds:[si],ax               ; oznaen adresy za ELSE
         pop       ds
         call      OutWrd                   ; rezerva msta pro adresu
         ret

XElse5:  call      DispErr                  ; zobrazen chyby
         ret

; -----------------------------------------------------------------------------
;        ENDIF - konec podmnky IF
; -----------------------------------------------------------------------------

PUBLIC   XEndif
XEndif:
         call      OutRet                   ; zruen bajtu z bufferu
         cmp       al,20h                   ; je IF ?
         je        XEndif1                  ; je IF-THEN
         cmp       al,21h                   ; je IF-THEN-ELSE ?
         jne       XEndif2                  ; nen IF

; ------ je oteven IF - uklizen

XEndif1: call      PopKod                   ; zruen kdu ze zsobnku
         call      TestKon                  ; test, zda je konec pkazu
         ret

; ------ chyba - nen oteven IF

XEndif2: mov       dx,offset Err022         ; text - nebyla podmnka IF
         call      DispErr                  ; zobrazen textu chyby
         ret

; -----------------------------------------------------------------------------
;        FOR - cyklus s parametrem
; -----------------------------------------------------------------------------

PUBLIC   XFor
XFor:
         call      OutRet                   ; zruen bajtu z bufferu
         ret


; -----------------------------------------------------------------------------
;        TO - koncov hodnota cyklu s parametrem
; -----------------------------------------------------------------------------

PUBLIC   XTo
XTo:
         call      OutRet                   ; zruen bajtu z bufferu
         ret

; -----------------------------------------------------------------------------
;        STEP - krok cyklu s parametrem
; -----------------------------------------------------------------------------

PUBLIC   XStep
XStep:
         call      OutRet                   ; zruen bajtu z bufferu
         ret

; -----------------------------------------------------------------------------
;        DO - cyklus
; -----------------------------------------------------------------------------

PUBLIC   XDo
XDo:
         call      OutRet                   ; zruen bajtu z bufferu
         mov       al,30h                   ; identifiktor DO
         call      PushKod                  ; uloen identifiktoru do zsob.

         call      PushAdrX                 ; uloen adresy zatku cyklu
         ret

; -----------------------------------------------------------------------------
;        ON - podmnka cyklu
; -----------------------------------------------------------------------------

PUBLIC   XOn
XOn:     cmp       al,30h                   ; je oteven cyklus DO ?
         je        XOn2                     ; je oteven cyklus FOR/DO

XOn1:    mov       dx,offset Err031         ; text - WHILE bez DO
         call      DispErr                  ; zobrazen textu chyby
         ret

; ------ uloen vrazu jako podmnka funkce

XOn2:    call      Vyraz                    ; uloen vrazu (podmnka)
         jnc       XOn6
         call      DispErr
XOn6:

; ------ uloen adresy pro ppad nesplnn podmnky

         call      PopAdr                   ; adresa zatku cyklu DO
         mov       cx,ax                    ; adresa zatku cyklu
         call      PushAdrX                 ; uloen adresy
         call      OutWrd                   ; rezerva pro uloen adresy
         mov       ax,cx                    ; adresa zatku cyklu
         call      PushAdr                  ; adresa zatku cyklu do zsobnku

; ------ kontrola, zda nsleduje EXIT

         call      ReadIdnt                 ; naten identifiktoru EXIT
         jc        XOn3                     ; chyba - neplatn jmno
         call      SrcIdnt                  ; nalezen identifiktoru v tabulce
         jc        XOn5                     ; neplatn jmno
         cmp       al,19                    ; je jmno EXIT ?
         je        XOn4                     ; je jmno EXIT - OK

; ------ chyba - nensleduje EXIT

XOn5:    call      RetIdnt                  ; nvrat nvt do bufferu

XOn3:    mov       dx,offset Err032         ; text - mus nsledovat EXIT
         call      DispErr                  ; zobrazen textu chyby

XOn4:
         ret

; -----------------------------------------------------------------------------
;        ENDDO - konec cyklu
; -----------------------------------------------------------------------------

PUBLIC   XEnddo
XEnddo:  cmp       al,30h                   ; je oteven cyklus DO ?
         jne       XOn1                     ; chyba - nen oteven cyklus

         call      PopAdr                   ; adresa zatku cyklu
         call      OutWrd                   ; nastaven adresy zatku cyklu

         call      PopKod                   ; zruen kdu ze zsobnku
         call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        EXIT - ukonen cyklu
; -----------------------------------------------------------------------------

PUBLIC   XExit
XExit:
         call      OutRet                   ; zruen bajtu z bufferu
         mov       dx,offset Err033         ; text - EXIT sm bt jen za ON
         call      DispErr                  ; zobrazen textu chyby
         ret

; -----------------------------------------------------------------------------
;        CASE - vcensobn vtven
; -----------------------------------------------------------------------------

PUBLIC   XCase
XCase:
         mov       al,40h
         call      PushKod

; ------ uloen vrazu jako podmnka funkce

         call      Vyraz                    ; uloen vrazu (podmnka)
         jnc       XCase4
         call      DispErr

XCase4:

; ------ kontrola, zda nsleduje IN

         call      ReadIdnt                 ; naten identifiktoru IN
         jc        XCase2                   ; chyba - neplatn jmno
         call      SrcIdnt                  ; nalezen identifiktoru v tabulce
         jc        XCase2                   ; neplatn jmno
         cmp       al,21                    ; je jmno IN ?
         je        XCase3                   ; je jmno IN - OK

; ------ chyba - nensleduje IN

XCase2:  mov       dx,offset Err046         ; text - mus nsledovat IN
         call      DispErr                  ; zobrazen textu chyby

; ------ uloen adresy pro vtven IN (podmnka nesplnna)

XCase3:  call      OutCh                    ; uloen kdu IN
         jmp       short XIn1               ; zpracovn IN

; -----------------------------------------------------------------------------
;        IN - podmnka vcensobnho vtven
; -----------------------------------------------------------------------------

PUBLIC   XIn
XIn:     cmp       al,41h                   ; bylo ji OUT ?
         jne       XIn01                    ; nebylo OUT - OK

; ------ chyba - IN je neoprvnn

         mov       dx,offset Err043         ; text - nesm bt IN po OUT
XIn00:   call      DispErr                  ; zobrazen textu chyby
         ret


XIn01:   cmp       al,40h                   ; je CASE-IN ?
         mov       dx,offset Err041         ; text - IN bez CASE
         jne       XIn00                    ; nebylo CASE-IN - chyba

; ------ nastaven adresy pokraovn etzce IN

XIn1:    call      OutRet                   ; zruen bajtu z bufferu
         call      SetAdr                   ; nastaven adresy
         call      OutInc                   ; zven ukazatele

; ------ zjitn intervalu hodnot promnn

XIn11:   call      NumbS                    ; ten sla spodnho okraje
         jc        XIn2                     ; chybn mez
         call      OutWrd                   ; uloen spodn meze
         call      OutWrd                   ; pednastaven jako horn mez
         call      TestInt                  ; test, zda je oddlova intervalu
         jc        XIn5                     ; nen interval
         call      NumbS                    ; ten sla hornho okraje
         jc        XIn2                     ; chyba - chybn slo
         call      OutRet                   ; zruen bajtu z bufferu
         call      OutRet                   ; zruen bajtu z bufferu
         call      OutWrd                   ; nastaven horn meze
         jmp       short XIn5               ; ve je OK

; ------ chybn zadn intervalu

XIn2:    mov       dx,offset Err047         ; text - chybn meze
         call      DispErr                  ; zobrazen textu chyby
         ret

; ------ rezervace adresy pro pokraovn etzce IN

XIn5:    call      PushAdrX                 ; schova adresy
         call      OutWrd                   ; rezerva msta pro adresu

; ------ test, zda nsleduje dvouteka ":"

         call      TestDvj
         jc        XIn2                     ; nen dvojteka - chyba
         ret

; -----------------------------------------------------------------------------
;        OUT - nesplnna podmnka CASE
; -----------------------------------------------------------------------------

PUBLIC   XOut
XOut:

; ------ test oprvnnosti funkce

         mov       dx,offset Err044         ; text - bylo ji OUT
         cmp       al,41h                   ; bylo ji OUT ?
         je        XOut1                    ; bylo ji OUT
         mov       dx,offset Err041         ; text - OUT bez CASE
         cmp       al,40h                   ; bylo CASE-IN ?
         je        XOut2                    ; bylo CASE-IN
XOUt1:   call      DispErr                  ; zobrazen chyby
         ret

; ------ nastaven adresy pokraovn

XOut2:
         call      OutRet                   ; zruen bajtu z bufferu
         call      SetAdr
         call      OutInc                   ; zven ukazatele

; ------ rezervace adresy pro pokraovn etzce IN

         call      PushAdrX                 ; schova adresy
         call      OutWrd                   ; rezerva msta pro adresu

         mov       byte ptr ss:[bp],41h     ; pznak OUT
         ret

; -----------------------------------------------------------------------------
;        ENDCASE - konec vtven
; -----------------------------------------------------------------------------

PUBLIC   XEndCAse
XEndCase:mov       dx,offset Err045         ; text - ENDCASE bez CASE
         cmp       al,40h                   ; je CASE ?
         je        XEndCas1                 ; bylo CASE
         cmp       al,41h
         jne       XEndCas2                 ; nebylo CASE
XEndCas1:call      PopKod                   ; zruen kdu ze zsobnku
         ret

XEndCas2:call      DispErr
         call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        PROC - definice procedury
; -----------------------------------------------------------------------------

PUBLIC   XProc
XProc:   call      OutRet                   ; zruen bajtu z bufferu

; ------ test uzaven procedur a funkc

         pop       word ptr ds:[RetProc]
XProc1:  call      ClosIf                   ; uzaven podmnek a cykl
         call      ClosProc                 ; uzaven procedur
         cmp       word ptr ss:[bp],0       ; je ji konec ?
         jne       XProc1                   ; nen konec - dal
         push      word ptr ds:[RetProc]    ; nvrat nvratov adresy

; ------ zpis datovho bufferu na disk, inicializace programovho bufferu

         cmp       byte ptr ds:[ProgLev],0  ; byla deklaran st ?
         jne       XProc2                   ; nebyla deklaran st
         mov       cx,ds:[ProgNum]          ; poet bajt bloku
         cmp       cx,ds:[SizDat]
         jbe       XProc12
         mov       ds:[SizDat],cx           ; schova velikosti programu
XProc12: call      WritProg                 ; zpis datovho bloku na disk
         mov       word ptr ds:[ProgNum],4  ; zruen dat v bufferu
         push      ds
         mov       ds,ds:[ProgSeg]          ; segment s programem
         mov       word ptr ds:[0],4        ; dlka bloku
         mov       word ptr ds:[2],0        ; startovac adresa nedefinovna
         pop       ds

; ------ definice novho jmna procedury

XProc2:  call      ReadIdnt                 ; ten jmna procedury
         jc        XProc4                   ; chyba - neplatn jmno

; ------ test, zda je procedura MAIN

         cmp       byte ptr ds:[DelIdent],4 ; dlka nvt = 4 ?
         jne       XProc3                   ; nen procedura MAIN
         cmp       word ptr ds:[BufIdent],"AM" ; je MAIN ?
         jne       XProc3                   ; nen MAIN
         cmp       word ptr ds:[BufIdent+2],"NI" ; je MAIN ?
         jne       XProc3                   ; nen MAIN
         inc       byte ptr ds:[ParMain]    ; pznak, e byla procedura MAIN
         push      ds
         mov       ax,ds:[ProgNum]          ; ukazatel programu
         mov       ds,ds:[ProgSeg]          ; segment s programem
         mov       ds:[2],ax                ; startovac adresa programu
         pop       ds

; ------ test, zda je rezervovan jmno procedury

XProc3:  call      SrcIdnt                  ; nalezen v intern tabulce
         mov       dx,offset Err013         ; text, e jmno je rezervovno
         jnc       XProc5                   ; slovo nalezeno - chyba

; ------ zaazen jmna do tabulky

         mov       al,3                     ; pznak definovan procedury
         call      StorFlg                  ; uloen identifiktoru
         mov       dx,offset Err009         ; chyba - vcensobn pouit jmna
         jc        XProc5                   ; chyba - jmno ji existuje
         mov       ax,ds:[ProgNum]          ; adresa procedury
         mov       es:[di+1],ax             ; schova adresy procedury
         jmp       short XProc6

; ------ chybn zadn jmna procedury

XProc4:  mov       dx,offset Err018         ; text - neplatn jmno procedury
XProc5:  call      DispErr                  ; zobrazen textu chyby

; ------ inicializace identifiktoru v zsobnku

XProc6:  mov       al,10h
         call      PushKod
         mov       byte ptr ds:[ProgLev],2  ; pznak oteven procedury
         ret

; -----------------------------------------------------------------------------
;        RETURN - nvrat z procedury
; -----------------------------------------------------------------------------

PUBLIC   XRet
XRet:
         call      TestLeft                 ; test, zda je lev zvorka
         jc        XRet1                    ; nen lev zvorka
         call      Vyraz                    ; dekdovn vrazu
         jc        XRet2                    ; chybn vraz
         call      TestRght                 ; test, zda je prav zvorka
         jnc       XRet3                    ; je prav zvorka OK

XRet1:   mov       dx,offset Err01b         ; text - chybn argument
XRet2:   call      DispErr                  ; zobrazen textu chyby
         ret

; ------ rezervace adresy pro konec

XRet3:   call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        ENDP - konec definice procedury
; -----------------------------------------------------------------------------

PUBLIC   XEndp
XEndp:

; ------ test uzaven procedur a funkc

         pop       word ptr ds:[RetProc]
         call      ClosIf                   ; uzaven vech konstrukc
         push      word ptr ds:[RetProc]    ; nvrat nvratov adresy

; ------ test, zda je otevena procedura

XEndp4:  cmp       byte ptr ss:[bp],10h     ; je otevena procedura ?
         je        XEndp5                   ; je otevena procedura

         mov       dx,offset Err011         ; text - nen dn procedura
         call      DispErr                  ; zobrazen textu chyby
         ret

XEndp5:  call      OutRet                   ; nvrat ukazatele
         call      PopKod                   ; zruen kdu ze zsobnku
         call      OutInc                   ; posun ukazatele
         mov       byte ptr ds:[ProgLev],1  ; pznak uzaven procedury
         call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        BYTE - definice bajtov promnn
; -----------------------------------------------------------------------------

PUBLIC   XBYte
XByte:

; ------ test, zda je povolen jmno

XByte1:  call      ReadIdnt                 ; ten jmna promnn
         mov       dx,offset Err001         ; text - neplatn jmno
         jc        XByte6                   ; chybn jmno
         call      SrcIdnt                  ; nalezen v intern tabulce
         mov       dx,offset Err013         ; text - jmno rezervovno
         jnc       XByte6                   ; jmno je rezervovno

; ------ zjitn rozmr promnn

         call      CompI                    ; zjitn rozmr promnn
         mov       cx,bx                    ; poet bajt promnn
         mov       al,1                     ; pznak - definovan bajt
         cmp       cx,1                     ; je 1 bajt ?
         je        XByte2                   ; je 1 bajt
         mov       al,11h                   ; pznak indexovan promnn

;------- definice jmna promnn

XByte2:  call      StorFlg                  ; uloen jmna promnn
         mov       dx,offset Err009         ; chyba - vcensobn pouit
         jc        XByte6                   ; promnn byla ji definovna

; ------ zjitn, zda je promnn uren

         call      InpPri                   ; test, zda je promnn uren
         jc        XByte7                   ; promnn nen uren

; ------ vstup jednotlivch defininch bajt

         call      TestLeft                 ; test, zda je lev zvorka
         jnc       XByte3                   ; je lev zvorka
         mov       dx,offset Err004         ; text - chybn naplnn promnn
         cmp       bx,1                     ; je 1 prvek ?
         jne       XByte6                   ; chybn zpis - je vce prvk

XByte3:  mov       dx,offset Err01c         ; text - pli mnoho daj
         jcxz      XByte6                   ; jsou vechny hodnoty - peplnn
         call      InpSpc                   ; vstup prvnho znaku
         jc        XByte7                   ; nen dal znak
         cmp       al,'"'                   ; je text ?
         jne       XByte4                   ; nen text

; ------ vstup textu

XByte32: call      InpCh                    ; vstup dalho bajtu
         jc        XByte5                   ; nen dal znak
         cmp       al,'"'                   ; jsou uvozovky ?
         je        XByte35                  ; jsou uvozovky
XByte33: jcxz      XByte3                   ; chyba - mnoho argument
         call      OutCh                    ; uloen dalho bajtu
         dec       cx
         jmp       short XByte32            ; dal znak

XByte35: call      InpCh
         jc        XByte5                   ; nen dal znak
         cmp       al,'"'                   ; jsou zdvojen uvozovky ?
         je        XByte33                  ; je platn znak
         call      RetCh                    ; nvrat znaku
         jmp       short XByte5             ; dal argument

; ------ vstup seln promnn

XByte4:  call      RetCh                    ; nvrat znaku
         call      NumbS                    ; vstup sla se znamnkem
         mov       dx,offset Err01b         ; text - chybn argument
         jc        XByte6                   ; chyba
         call      OutCh                    ; zpis bajtu
         dec       cx                       ; snen tae bajt

; ------ test, zda je dal hodnota

XByte5:  call      TestRght                 ; je konec ?
         jnc       XByte7                   ; je konec argumentu - OK
         cmp       bx,1                     ; m bt jen jeden argument ?
         je        XByte7                   ; m bt jen jeden argument - konec
         call      TestCar                  ; test, zda je rka
         jnc       XByte3                   ; vstup dalho bajtu
         mov       dx,offset Err01b         ; text - chybn argument

; ------ hlen chyby a nalezen konce pkazu

XByte6:  call      DispErr                  ; zobrazen textu chyby
Xbyte62: call      InpSpc
         jc        XByte63                  ; nen dal znak
         cmp       al,";"                   ; je konec pkazu ?
         jne       XByte62                  ; nalezen konce pkazu
XByte63: ret

; ------ vymazn zbytku promnn

XByte7:  jcxz      XByte72                  ; nen dal bajt
         xor       al,al                    ; inicializan bajt 0
         call      OutCh                    ; zpis bajtu
         loop      XByte7                   ; dal bajt

; ------ test, zda je dal promnn

XByte72: call      TestCar                  ; test, zda je oddlovac rka
         jc        XByte8
         jmp       XByte1                   ; definice dal promnn

XByte8:  call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        WORD - definice slovn promnn
; -----------------------------------------------------------------------------

PUBLIC   XWord
XWord:
; ------ test, zda je povolen jmno

XWord1:  call      ReadIdnt                 ; ten jmna promnn
         mov       dx,offset Err001         ; text - neplatn jmno
         jc        XWord6                   ; chybn jmno
         call      SrcIdnt                  ; nalezen v intern tabulce
         mov       dx,offset Err013         ; text - jmno rezervovno
         jnc       XWord6                   ; jmno je rezervovno

; ------ zjitn rozmr promnn

         call      CompI                    ; zjitn rozmr promnn
         mov       cx,bx                    ; poet slov promnn
         mov       al,5                     ; pznak - definovan slovo
         cmp       cx,1                     ; je 1 slovo ?
         je        XWord2                   ; je 1 slovo
         mov       al,15h                   ; pznak indexovan promnn

;------- definice jmna promnn

XWord2:  call      StorFlg                  ; uloen jmna promnn
         mov       dx,offset Err009         ; chyba - vcensobn pouit
         jc        XWord6                   ; promnn byla ji definovna

; ------ zjitn, zda je promnn uren

         call      InpPri                   ; test, zda je promnn uren
         jc        XWord7                   ; promnn nen uren

; ------ vstup jednotlivch defininch slovo

         call      TestLeft                 ; test, zda je lev zvorka
         jnc       XWord3                   ; je lev zvorka
         mov       dx,offset Err004         ; text - chybn naplnn promnn
         cmp       bx,1                     ; je 1 prvek ?
         jne       XWord6                   ; chybn zpis - je vce prvk

XWord3:  mov       dx,offset Err01c         ; text - pli mnoho daj
         jcxz      XWord6                   ; jsou vechny hodnoty - peplnn

; ------ vstup seln promnn

XWord4:  call      NumbS                    ; vstup sla se znamnkem
         mov       dx,offset Err01b         ; text - chybn argument
         jc        XWord6                   ; chyba
         call      OutWrd                   ; zpis slova
         dec       cx                       ; snen tae slov

; ------ test, zda je dal hodnota

XWord5:  call      TestRght                 ; je konec ?
         jnc       XWord7                   ; je konec
         cmp       bx,1                     ; m bt jen jeden argument ?
         je        XWord7                   ; m bt jen jeden argument - konec
         call      TestCar                  ; test, zda je rka
         jnc       XWord3                   ; vstup dalho slovou
         mov       dx,offset Err01b         ; text - chybn argument

; ------ hlen chyby a nalezen konce pkazu

XWord6:  call      DispErr                  ; zobrazen textu chyby
XWord62: call      InpSpc
         jc        XWord63                  ; nen dal znak
         cmp       al,";"                   ; je konec pkazu ?
         jne       XWord62                  ; nalezen konce pkazu
XWord63: ret

; ------ vymazn zbytku promnn

XWord7:  jcxz      XWord72                  ; nen dal slovo
         xor       ax,ax                    ; inicializan slovo 0
         call      OutWrd                   ; zpis slova
         loop      XWord7                   ; dal slovo

; ------ test, zda je dal promnn

XWord72: call      TestCar                  ; test, zda je oddlovac rka
         jnc       XWord1                   ; definice dal promnn

XWord8:  call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        STRING - definice textov promnn
; -----------------------------------------------------------------------------

PUBLIC   XString
XString:
         call      TestKon                  ; test, zda je konec pkazu
         ret

; -----------------------------------------------------------------------------
;        VAL - konverze etzce na slo
; -----------------------------------------------------------------------------

PUBLIC   XVal
XVal:
         ret

; -----------------------------------------------------------------------------
;        STR - konverze sla na etzec
; -----------------------------------------------------------------------------

PUBLIC   XStr
XStr:
         ret

; -----------------------------------------------------------------------------
;        LEN - dlka etzce
; -----------------------------------------------------------------------------

PUBLIC   XLen
XLen:
         ret

; -----------------------------------------------------------------------------
;        CARD - test grafick karty
; -----------------------------------------------------------------------------

PUBLIC   XCard
XCard:
         ret

; -----------------------------------------------------------------------------
;        VIDEO - nastaven videomdu
; -----------------------------------------------------------------------------

PUBLIC   XVideo
XVideo:
         mov       cx,1                     ; 1 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        GETVIDEO - zjitn videomdu
; -----------------------------------------------------------------------------

PUBLIC   XGVideo
XGVideo:
         ret

; -----------------------------------------------------------------------------
;        MODE - nastaven mdu displeje
; -----------------------------------------------------------------------------

PUBLIC   XMode
XMode:
         mov       cx,1                     ; 1 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        PAGE - nastaven strnek displeje
; -----------------------------------------------------------------------------

PUBLIC   XPage
XPage:
         mov       cx,2                     ; 2 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        XPAGE - zmna strnek displeje
; -----------------------------------------------------------------------------

PUBLIC   XXPage
XXPage:
         ret

; -----------------------------------------------------------------------------
;        WINDOW - definice vstupnho okna
; -----------------------------------------------------------------------------

PUBLIC   XWind
XWind:
         mov       cx,4                     ; 4 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        PALETTE - definice palet displeje
; -----------------------------------------------------------------------------

PUBLIC   XPal
XPal:
         mov       cx,17                    ; 17 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        XCOLOR - zmna barvy v okn
; -----------------------------------------------------------------------------

PUBLIC   XXCOl
XXCol:
         mov       cx,2                     ; 2 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        SETCURS - nastaven pozice kurzoru
; -----------------------------------------------------------------------------

PUBLIC   XSetCur
XSetCur:
         mov       cx,2                     ; 2 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        CURSOFF - vypnut kurzoru
; -----------------------------------------------------------------------------

PUBLIC   XCurOff
XCurOff:
         ret

; -----------------------------------------------------------------------------
;        LOAD - naten objektu do pamti
; -----------------------------------------------------------------------------

PUBLIC   XLoad
XLoad:

; ------ test, zda je prvn znak zvorka "("

         call      TestLeft                 ; test, zda je lev zvorka
         jc        XLoad7                   ; chyba - nejsou parametry

; ------ definice objektu

         call      DefObj                   ; definice sla objektu

; ------ oddlovac rka parametr

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XLoad7                   ; chyba - neplatn znak

; ------ definice jmna souboru

         call      DefTxt                   ; definice jmna
         jc        XLoad7                   ; chybn jmno souboru

; ------ test, zda je prav zvorka ")"

         call      TestRght                 ; test, zda je prav zvorka
         jnc       XLoad8                   ; je prav zvorka - OK

; ------ chyba syntaxe pkazu

XLoad7:  mov       dx,offset Err01b         ; text - chyba syntaxe
         call      DispErr                  ; zobrazen textu chyby
         ret

; ------ nvrat z obsluhy

XLoad8:
         ret


; -----------------------------------------------------------------------------
;        PIC - zobrazen objektu
; -----------------------------------------------------------------------------

PUBLIC   XObj
XObj:

; ------ test, zda je prvn znak zvorka "("

         call      TestLeft                 ; test, zda je lev zvorka
         jc        XObj7                    ; chyba - nejsou parametry

; ------ definice objektu

         call      DefObj                   ; definice sla objektu

; ------ oddlovac rka parametr

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XObj7                    ; chyba - neplatn znak

; ------ souadnice X

         call      Vyraz                    ; souadnice X

; ------ oddlovac rka parametr

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XObj7                    ; chyba - neplatn znak

; ------ souadnice Y

         call      Vyraz                    ; souadnice Y

; ------ test, zda je prav zvorka ")"

         call      TestRght                 ; test, zda je prav zvorka
         jnc       XObj8                   ; je prav zvorka - OK

; ------ chyba syntaxe pkazu

XObj7:   mov       dx,offset Err01b         ; text - chyba syntaxe
         call      DispErr                  ; zobrazen textu chyby
         ret

; ------ nvrat z obsluhy

XObj8:   ret

; -----------------------------------------------------------------------------
;        UNLOAD - zruen objektu v pamti
; -----------------------------------------------------------------------------

PUBLIC   XUnld
XUnld:

; ------ test, zda je prvn znak zvorka "("

         call      TestLeft                 ; test, zda je lev zvorka
         jc        XUnld7                   ; chyba - nejsou parametry

; ------ definice objektu

         call      DefObj                   ; definice sla objektu

; ------ test, zda je prav zvorka ")"

         call      TestRght                 ; test, zda je prav zvorka
         jnc       XUnld8                   ; je prav zvorka - OK

; ------ chyba syntaxe pkazu

XUnld7:  mov       dx,offset Err01b         ; text - chyba syntaxe
         call      DispErr                  ; zobrazen textu chyby
         ret

; ------ nvrat z obsluhy

XUnld8:  ret

; -----------------------------------------------------------------------------
;        TEXT - zobrazen textu
; -----------------------------------------------------------------------------

PUBLIC   XText
XText:

; ------ test, zda je prvn znak zvorka "("

         call      TestLeft                 ; test, zda je lev zvorka
         jc        XText7                   ; chyba - nejsou parametry

; ------ souadnice X

         call      Vyraz                    ; definice souadnice X
         jc        XText8

; ------ oddlovac rka

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XText7                   ; nen - chyba syntaxe

; ------ souadnice Y

         call      Vyraz                    ; definice souadnice Y
         jc        XText8

; ------ oddlovac rka

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XText7                   ; nen - chyba syntaxe

; ------ barva textu

         call      Vyraz                    ; definice barvy
         jc        XText8

; ------ oddlovac rka

         call      TestCar                  ; test, zda je oddlovac rka
         jc        XText7                   ; nen - chyba syntaxe

; ------ definice textu k zobrazen

         call      DefTxt                   ; definice textu
         jc        XText7                   ; chyba

; ------ test, zda je prav zvorka ")"

         call      TestRght                 ; test, zda je prav zvorka
         jnc       XText9                   ; je prav zvorka - OK

; ------ chyba syntaxe pkazu

XText7:  mov       dx,offset Err01b         ; text - chyba syntaxe
XText8:  call      DispErr                  ; zobrazen textu chyby
         ret

; ------ nvrat z obsluhy

XText9:  ret

; -----------------------------------------------------------------------------
;        POINT - zobrazen bodu
; -----------------------------------------------------------------------------

PUBLIC   XPoint
XPoint:
         mov       cx,3                     ; 3 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        XLINE - zobrazen ry
; -----------------------------------------------------------------------------

PUBLIC   XLine
XLine:
         mov       cx,5                     ; 5 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        XRLINE - zobrazen ry relativn
; -----------------------------------------------------------------------------

PUBLIC   XRline
XRline:
         mov       cx,3                     ; 3 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        BOX - zobrazen obdlnku
; -----------------------------------------------------------------------------

PUBLIC   XBox
XBox:
         mov       cx,5                     ; 5 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        FBOX - zobrazen plnho obdlnku
; -----------------------------------------------------------------------------

PUBLIC   XFBox
XFBox:
         mov       cx,5                     ; 5 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        CIRC - zobrazen krunice
; -----------------------------------------------------------------------------

PUBLIC   XCirc
XCirc:
         mov       cx,4                     ; 4 argumenty (barva, sou., polom.)
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        FCIRC - zobrazen pln krunice
; -----------------------------------------------------------------------------

PUBLIC   XFCirc
XFCirc:
         mov       cx,4                     ; 4 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        PRESS - test uren klvesy, zda je stisknuta
; -----------------------------------------------------------------------------

PUBLIC   XPress
XPress:
         mov       cx,1                     ; 1 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        TESTKEY - test pipraven klvesy
; -----------------------------------------------------------------------------

PUBLIC   XTstKey
XTstKey:
         ret

; -----------------------------------------------------------------------------
;        GETKEY - vstup znaku z klvesnice
; -----------------------------------------------------------------------------

PUBLIC   XGtKey
XGtKey:
         ret

; -----------------------------------------------------------------------------
;        STATKEY - stavov slovo klvesnice
; -----------------------------------------------------------------------------

PUBLIC   XStatKey
XStatKey:
         ret

; -----------------------------------------------------------------------------
;        INPUT - vstup textu
; -----------------------------------------------------------------------------

PUBLIC   XInp
XInp:
         ret

; -----------------------------------------------------------------------------
;        SOUND - ovldn zvukovho genertoru
; -----------------------------------------------------------------------------

PUBLIC   XSound
XSound:
         mov       cx,1                     ; 1 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        TON - zahrn tnu dan frekvence a dlky
; -----------------------------------------------------------------------------

PUBLIC   XTon
XTon:
         mov       cx,2                     ; 2 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        MUSIC - zahrn melodie
; -----------------------------------------------------------------------------

; ------ uloen slova dlky melodie

XMusK:
         push      es                       ; schova ES
         mov       es,ds:[ProgSeg]          ; segment s programem
         mov       ax,ds:[ProgNum]          ; ukazatel programu
         sub       ax,bx                    ; dlka melodie*2 + 2
         sub       ax,2                     ; dlka melodie*2
         shr       ax,1                     ; dlka melodie
         mov       es:[bx],ax               ; nastaven dlky melodie
         pop       es                       ; nvrat ES
         ret

; ------ chyba syntaxe pkazu

XMusX:   mov       dx,offset Err01b         ; text - chyba syntaxe
         call      DispErr                  ; zobrazen textu chyby
         ret




PUBLIC   XMusic
XMusic:

; ------ test, zda je prvn znak zvorka "("

         call      TestLeft                 ; test, zda je lev zvorka
         jc        XMusX                    ; chyba - nejsou parametry

; ------ schova ukazatele zatku melodie

         mov       bx,ds:[ProgNum]          ; schova ukazatele programu
         call      OutWrd                   ; rezerva pro slovo dlky melodie

; ------ inicializace ukazatel melodie

         mov       word ptr ds:[Oktava],4*12+1 ; inicializan oktva 4
         mov       byte ptr ds:[DelTon],4   ; inicializan dlka tnu 4
         mov       word ptr ds:[Krizky],0   ; zruen kk

; ------ nalezen platnho znaku

XMus1:   call      InpSpc
         jc        XMusX                    ; neoekvan konec
         cmp       al,")"                   ; je konec parametru ?
         je        XMusK                    ; konec parametru
         cmp       al,","                   ; je oddlovac rka ?
         je        XMus1                    ; oddlovac rka - ignoruje se

; ------ nastaven oktvy - parametr "On"

         cmp       al,"O"                   ; je nastaven oktvy "O" ?
         jne       XMus2                    ; nen nastaven oktvy "O"
         call      Numb                     ; vstup sla - nastaven oktvy
         jc        XMusX                    ; chyba
         cmp       ax,9
XMusXA:  ja        XMusX                    ; chybn slo oktvy
         mov       ah,12                    ; dlka oktvy v pltnech
         mul       ah                       ; pepoet oktvy na pltny
         inc       ax                       ; poten offset = 1
         mov       ds:[Oktava],ax           ; schova sla oktvy v pltnech
         jmp       short XMus1              ; vstup dalho parametru

; ------ zven tnu o oktvu - znak "+"

XMus2:   cmp       al,"+"                   ; je zven oktvy ?
         jne       XMus3                    ; nen zven oktvy "+"
         add       word ptr ds:[Krizky],12  ; zven tnu o oktvu
         jmp       short XMus1              ; vstup dalho parametru

; ------ snen oktvy - znak "-"

XMus3:   cmp       al,"-"                   ; je snen oktvy ?
         jne       XMus4                    ; nen snen oktvy "-"
         sub       word ptr ds:[Krizky],12  ; snen tnu o oktvu
         jmp       short XMus1              ; vstup dalho parametru

; ------ transpozice tniny - parametr "Tn"

XMus4:   cmp       al,"T"                   ; je transpozice tniny ?
         jne       XMus5                    ; nen transpozice tniny
         call      Numb                     ; vstup sla - transpozice
XMusXC:  jc        XMusX                    ; chyba syntaxe
         add       ds:[Oktava],ax           ; transpozice tniny
         jmp       short XMus1              ; vstup dalho parametru

; ------ posun tnu o pltn - znak "#"

XMus5:   cmp       al,"#"                   ; je posun o pltn ?
         jne       XMus6                    ; nen posun o pltn
         inc       word ptr ds:[Krizky]     ; zven tae kk
         jmp       short XMus1              ; vstup dalho parametru

; ------ nastaven dlky tnu - parametr "Ln"

XMus6:   cmp       al,"L"                   ; je nastaven dlky tnu ?
         jne       XMus7                    ; nen nastaven dlky tnu
         call      Numb                     ; vstup sla - dlka tnu
         jc        XMusXC                   ; chyba syntaxe
         cmp       ax,255                   ; max. dlka
XMusXA2: ja        XMusXA                   ; chyba dlky tnu
         mov       byte ptr ds:[DelTon],al  ; schova dlky tnu
XMus11:  jmp       short XMus1              ; vstup dalho parametru

; ------ prodleva - parametr R

XMus7:   cmp       al,"R"                   ; je prodleva ?
         mov       dl,0                     ; slo tnu - prodleva
         je        XMus9

; ------ je tn - parametr C, D, E, F, G, A, H

         mov       dl,1                     ; je tn C
         cmp       al,"C"
         je        XMus8                    ; je C

         mov       dl,3
         cmp       al,"D"
         je        XMus8                    ; je D

         mov       dl,5
         cmp       al,"E"
         je        XMus8                    ; je E

         mov       dl,6
         cmp       al,"F"
         je        XMus8                    ; je F

         mov       dl,8
         cmp       al,"G"
         je        XMus8                    ; je G

         mov       dl,10
         cmp       al,"A"
         je        XMus8                    ; je A

         mov       dl,12
         cmp       al,"H"
         stc
         jne       XMusXC                   ; nen "H" - chyba

; ------ zven tnu o oktvu a pltny

XMus8:   mov       dh,0
         add       dx,ds:[Oktava]           ; zven tnu o oktvy
         add       dx,ds:[Krizky]           ; zven tnu o kky
         cmp       dx,121                   ; maximln tn 121
XMusXA3: ja        XMusXA2                  ; peteen

; ------ uloen kdu tnu

XMus9:   mov       al,dl                    ; kd tnu
         call      OutCh                    ; zpis bajt kdu tnu
         mov       word ptr ds:[Krizky],0   ; zruen pznaku kk

; ------ prodlouen tnu o pltn

         mov       dx,0                     ; ta znak "." a "^"
XMusA:   call      InpSpc                   ; vstup dalho znaku
         jc        XMusXC                   ; to je chyba
         cmp       al,"."                   ; je prodlouen o pltn ?
         jne       XMusB                    ; nen prodlouen o pltn
         inc       dx                       ; zven tae pltn
         jmp       short XMusA              ; vstup dalho znaku

; ------ zkrcen tnu na polovinu

XMusB:   cmp       al,"<"                   ; je zkrcen tnu na polovinu ?
         jne       XMusC                    ; nen zkrcen tnu na polovinu
         sub       dx,2                     ; zven tae zkrcen
         jmp       short XMusA              ; vstup dalho znaku

; ------ prodlouen tnu na dvojnsobek

XMusC:   cmp       al,">"                   ; je dvojnsobn prodlouen tnu ?
         jne       XMusH                    ; nen dvojnsobn prodlouen tnu
         add       dx,2
         jmp       short XMusA              ; vstup dalho znaku

; ------ dekdovn dlky tnu

XMusH:   call      RetCh                    ; navrcen znaku
         call      NumB                     ; vstup sla dlky tnu
         jnc       XMusD                    ; dlka tnu OK
         mov       al,ds:[DelTon]           ; implicitn dlka tnu
         mov       ah,0
XMusD:   cmp       ax,255                   ; je dlka tnu povolen ?
         ja        XMusXA3                  ; dlka tnu nen povolen

; ------ prava dlky tnu podle pepna

         or        dx,dx                    ; je prodlouen nebo zkrcen ?
         je        XMusF                    ; nen dn oprava
         js        XMusE                    ; je zkrcen doby

; ------ je prodlouen doby

         mov       cx,dx                    ; poet prodlouen o pltn
         shr       cx,1                     ; poet prodlouen o cel tn
         shl       ax,cl                    ; prodlouen doby
         jmp       short XMusF

; ------ je zkrcen doby

XMusE:   neg       dx
         mov       cx,dx                    ; poet zkrcen o pltn
         shr       cx,1                     ; poet zkrcen o cel tn
         shr       ax,cl                    ; zkrcen doby

; ------ ppadn prodlouen doby o pltn

XMusF:   shr       dx,1                     ; je prodlouen o pltn ?
         jnc       XMusG                    ; nen prodlouen o pltn
         mov       dx,ax                    ;
         shr       dx,1
         add       ax,dx                    ; prodlouen o pltn

; ------ uloen dlky tnu

XMusG:   call      OutCh                    ; zpis bajtu dlky tnu
         jmp       XMus11                   ; dekdovn dalho parametru


; -----------------------------------------------------------------------------
;        MUSICSTOP - zastaven hry melodie
; -----------------------------------------------------------------------------

PUBLIC   XMStop
XMStop:
         ret

; -----------------------------------------------------------------------------
;        MUSICGET - poskytnut ukazatele melodie
; -----------------------------------------------------------------------------

PUBLIC   XMusGet
XMusGet:
         ret

; -----------------------------------------------------------------------------
;        WAIT - ekn po danou dobu
; -----------------------------------------------------------------------------

PUBLIC   XWait
XWait:
         mov       cx,1                     ; 1 argument
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        TIME - poskytnut systmovho asu
; -----------------------------------------------------------------------------

PUBLIC   XTime
XTime:
         ret

; -----------------------------------------------------------------------------
;        DATE - poskytnut systmovho data
; -----------------------------------------------------------------------------

PUBLIC   XDate
XDate:
         ret

; -----------------------------------------------------------------------------
;        XMOUSE - poskytnut pozice myi
; -----------------------------------------------------------------------------

PUBLIC   XXMous
XXMous:
         ret

; -----------------------------------------------------------------------------
;        YMOUSE - poskytnut dku myi
; -----------------------------------------------------------------------------

PUBLIC   XYMous
XYMous:
         ret

; -----------------------------------------------------------------------------
;        GETMOUSE - poskytnut tlatek myi
; -----------------------------------------------------------------------------

PUBLIC   XKMous
XKMous:
         ret

; -----------------------------------------------------------------------------
;        MOUSEON - zapnut kurzoru myi
; -----------------------------------------------------------------------------

PUBLIC   XMon
XMon:
         ret

; -----------------------------------------------------------------------------
;        MOUSEOFF - vypnut kurzoru myi
; -----------------------------------------------------------------------------

PUBLIC   XMoff
XMoff:
         ret

; -----------------------------------------------------------------------------
;        CURMOUSE - definice kurzoru myi
; -----------------------------------------------------------------------------

PUBLIC   XDefm
XDefm:
         ret

; -----------------------------------------------------------------------------
;        WINMOUSE - definice okna myi
; -----------------------------------------------------------------------------

PUBLIC   XWinm
XWinm:
         mov       cx,4                     ; 4 argumenty
         call      Argum                    ; vstup argumentu
         ret

; -----------------------------------------------------------------------------
;        RND - genertor nhodnho sla
; -----------------------------------------------------------------------------

PUBLIC   XRnd
XRnd:
         mov       cx,1
         call      Argum
         ret

; -----------------------------------------------------------------------------
;        REGISTER - nastaven registru CRT
; -----------------------------------------------------------------------------

PUBLIC   XReg
XReg:
         mov       cx,2                     ; 2 parametry
         call      Argum
         ret

; -----------------------------------------------------------------------------
;        HSYN - horizontln synchronizace
; -----------------------------------------------------------------------------

PUBLIC   XHSyn
XHSyn:
         mov       cx,1                     ; 1 parametr
         call      Argum
         ret

; -----------------------------------------------------------------------------
;        VSYN - vertikln synchronizace
; -----------------------------------------------------------------------------

PUBLIC   XVSyn
XVSyn:
         mov       cx,1                     ; 1 parametr
         call      Argum
         ret

; -----------------------------------------------------------------------------
;        PATTERN - vzorek vpln
; -----------------------------------------------------------------------------

PUBLIC   XPatt
XPatt:
         mov       cx,8                     ; 8 parametr
         call      Argum
         ret

; -----------------------------------------------------------------------------
;        STICK - joystickov vstup
; -----------------------------------------------------------------------------

PUBLIC   XStick
XStick:
         ret

; -----------------------------------------------------------------------------
;        TRIG - aktivan tlatko Joysticku
; -----------------------------------------------------------------------------

PUBLIC   XTrig
XTrig:
         ret

; -----------------------------------------------------------------------------
;        SIN - funkce sinus
; -----------------------------------------------------------------------------

PUBLIC   XSin
XSin:    mov       cx,1
         call      Argum                    ; 1 argument
         ret

; -----------------------------------------------------------------------------
;        COS - funkce cosinus
; -----------------------------------------------------------------------------

PUBLIC   XCos
XCos:    mov       cx,1
         call      Argum                    ; 1 argument
         ret

; -----------------------------------------------------------------------------
;        TAN - funkce tangent
; -----------------------------------------------------------------------------

PUBLIC   XTan
XTan:    mov       cx,1
         call      Argum                    ; 1 argument
         ret

; -----------------------------------------------------------------------------
;        ABS - absolutn hodnota
; -----------------------------------------------------------------------------

PUBLIC   XAbs
XAbs:    mov       cx,1
         call      Argum                    ; 1 argument
         ret

; -----------------------------------------------------------------------------
;        ATN - funkce arcutangent
; -----------------------------------------------------------------------------

PUBLIC   XAtn
XAtn:    mov       cx,1
         call      Argum                    ; 1 argument
         ret

; -----------------------------------------------------------------------------
;        SQR - funkce odmocnina
; -----------------------------------------------------------------------------

PUBLIC   XSqr
XSqr:    mov       cx,1
         call      Argum                    ; 1 argument
         ret



; *****************************************************************************
;
;                        Obsluha uivatelskho nvt
;
; *****************************************************************************

; -----------------------------------------------------------------------------
;                        Uloen jmna do bufferu
; -----------------------------------------------------------------------------
; VSTUP:  AL=typ jmna
; Vstup: AL=typ nalezenho jmna (indiktor)
;         ES:DI=adresa jmna v tabulce symbol
;         CY=je ji definovno
; -----------------------------------------------------------------------------
; Popis definice jmna v tabulce uivatelskch jmen:
;      00h=Indikan bajt: bit 0:    0=nen definovno, 1=jmno definovno
;                          bit 1:    0=data, 1=procedura
;                          bit 2,3:  0 = BYTE
;                                    1 = WORD
;                                    (2 = STRING)
;                                    3 = OBJECT
;                          bit 4:    1 = indexovan promnn
;      01h=adresa symbolu (slovo)
;      03h=dlka jmna (max. 64 bajt)
;      04h=text jmna
; -----------------------------------------------------------------------------
;
PUBLIC   StorFlg
StorFlg:

; ------ schova registr

         push      bx
         push      cx
         push      si

; ------ inicializace registr

         cld
         mov       es,ds:[FlagBuf]          ; segment s bufferem symbol
         xor       di,di                    ; poten adresa v bufferu
         mov       si,offset DelIdent       ; dlka jmna a text jmna
         mov       ch,0                     ; CH <- 0

; ------ test, zda je jet dal jmno v bufferu

StorFlg1:cmp       di,ds:[FlagNum]          ; je ji konec tabulky ?
         jae       StorFlg3                 ; je konec tabulky

; ------ porovnn, zda je hledan jmno

         mov       cl,es:[di+3]             ; dlka jmna
         inc       cl                       ; porovnv se i dlkov bajt
         push      si
         push      di
         push      cx
         add       di,3                     ; adresa zatku jmna s dlkou
         repe      cmpsb                    ; porovnn nvt
         pop       cx
         pop       di
         pop       si
         stc                                ; pznak, e jmno bylo nalezeno
         je        StorFlg5                 ; jmno nalezeno OK

; ------ nastaven na dal jmno v tabulce

         add       di,3                     ; peskoen vodnch bajt
         add       di,cx                    ; peskoen textu jmna
         jmp       short StorFlg1           ; test dalho jmna

; ------ uloen novho nvt do bufferu

StorFlg3:cmp       di,-70                   ; dosaeno konce bufferu ?
         jae       StorFlg7                 ; chyba peteen pamti
         push      di                       ; schova adresy zatku jmna
         stosb                              ; uloen indikanho bajtu
         mov       bx,ds:[ProgNum]          ; adresa ukazatele programu
         mov       es:[di],bx               ; nastaven adresy symbolu
         add       di,2                     ; zven adresy
         mov       cl,ds:[si]               ; dlka jmna symbolu
         inc       cx                       ; ulo se i bajt dlky
         rep       movsb                    ; uloen textu jmna
         mov       ds:[FlagNum],di          ; nov adresa konce bufferu
         pop       di                       ; adresa zatku jmna
         clc                                ; pznak, e je nov jmno

; ------ zjitn parametr jmna ES:DI

StorFlg5:mov       al,es:[di]               ; indikan bajt symbolu

; ------ nvrat registr

StorFlg6:pop       si
         pop       cx
         pop       bx
         ret

; ------ chyba peteen pamti

StorFlg7:mov       dx,offset Mem1Txt        ; text - peteen tabulky symbol
         jmp       WritPrg1                 ; chyba - peteen pamti

; *****************************************************************************
;
;                   Obsluha standardnho identifiktoru
;
; *****************************************************************************


; -----------------------------------------------------------------------------
;        Naten identifiktoru (symbolu) (CY=nen platn identifiktor)
; -----------------------------------------------------------------------------

PUBLIC   ReadIdnt

; ------ pprava registr

ReadIdnt:push      cx
         push      di
         push      es
         mov       byte ptr ds:[DelIdent],0 ; dlka nvt = 0
         mov       cx,64                    ; maximln poet znak identifik.
         mov       di,offset BufIdent       ; buffer k uloen
         push      ds
         pop       es                       ; ES <- datov segment
         cld                                ; smr nahoru

; ------ naten prvnho znaku identifiktoru

         call      InpSpc                   ; vstup znaku s vypustnm mezer
         jc        ReadIdn5                 ; nen dal znak
         call      IdentCh                  ; test, zda je to platn znak
         jc        ReadIdn4                 ; nen to platn znak - nvrat

; ------ test, zda to nen slice (= zakzan prvn znak)

         cmp       al,"0"                   ; je to slice ?
         jb        ReadIdn2                 ; nen to slice - OK
         cmp       al,"9"+1                 ; je to slice ?
         jb        ReadIdn4                 ; je to slice - zakzan znak

; ------ uloen znaku identifiktoru

ReadIdn2:stosb                              ; uloen znaku do bufferu
         inc       byte ptr ds:[DelIdent]   ; zven tae dlky nvt
         dec       cx                       ; snen tae max. potu znak
         jz        ReadIdn3                 ; pekroen max. poet znak

; ------ vstup dalho znaku identifiktoru

         call      InpCh                    ; vstup dalho znaku
         cmc
         jnc       ReadIdn5                 ; nen dal znak
         call      IdentCh                  ; test, zda to je platn znak
         jnc       ReadIdn2                 ; je platn znak - dal znak

; ------ nvrat poslednho znaku

ReadIdn3:clc                                ; pznak - nvt je OK
ReadIdn4:call      RetCh                    ; nvrat znaku
ReadIdn5:pop       es
         pop       di
         pop       cx
         ret

; -----------------------------------------------------------------------------
;        Test, zda je znak symbolu (CY=nen platn znak identifiktoru)
; -----------------------------------------------------------------------------

PUBLIC   IdentCh

IdentCh: call      UpCase                   ; pevod na velk psmeno
         cmp       al,"_"                   ; je podtrtko ?
         je        IdentCh2                 ; je platn znak identifiktoru
         cmp       al,"0"                   ; je slice ?
         jb        IdentCh2                 ; nen platn znak identifiktoru
         cmp       al,"9"+1                 ; je slice ?
         cmc
         jnc       IdentCh2                 ; je slice - je platn znak
         cmp       al,"A"                   ; je psmeno ?
         jb        IdentCh2                 ; nen platn znak identifiktoru
         cmp       al,"Z"+1                 ; je psmeno ?
         cmc
         jnc       IdentCh2                 ; je psmeno - je platn znak
         cmp       al,128                   ; je znak > 128 ?

IdentCh2:ret

; -----------------------------------------------------------------------------
;        Nalezen identifiktoru v tabulce internch povel
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; VSTUP: DS:SI=adresa slova v tabulce
;         AL=slo slova v tabulce (0...)
;         CY=slovo nenalezeno
; -----------------------------------------------------------------------------

PUBLIC   SrcIdnt

SrcIdnt:

; ------ schova registr

         push      cx
         push      di
         push      es
         push      ds
         pop       es                       ; ES <- DS

; ------ pprava registr

         cld                                ; smr posunu ukazatel nahoru
         mov       al,0                     ; ukazatel sla identifiktoru
         mov       si,offset TabKey         ; tabulka internch slov
         mov       di,offset DelIdent       ; dlka identifiktoru + identifik.
         mov       ch,0                     ; CH <- 0 vy bajt dlky

; ------ porovnn jednoho slova

SrcIdn1: mov       cl,ds:[si]               ; dlka slova
         stc                                ; pznak chyby - slovo nenalezeno
         jcxz      SrcIdn3                  ; je konec tabulky
         inc       cx                       ; piten bajtu dlky
         push      cx
         push      di
         push      si
         repe      cmpsb                    ; porovnn etzc
         pop       si
         pop       di
         pop       cx
         je        SrcIdn3                  ; slovo nalezeno

; ------ nastaven na dal slovo

         add       si,cx                    ; peskoen dlky a slova
         add       si,2                     ; peskoen adresy obsluhy
         inc       al                       ; zven tae slov
         jmp       short SrcIdn1            ; porovnn dalho slova

; ------ nvrat registr

SrcIdn3: pop       es
         pop       di
         pop       cx
         ret


; -----------------------------------------------------------------------------
;        Nvrat nvt do bufferu
; -----------------------------------------------------------------------------

PUBLIC   RetIdnt

RetIdnt: push      ax
         push      cx
         push      si
         mov       si,offset BufIdent-1     ; buffer s identifiktorem - 1
         mov       ch,0
         mov       cl,ds:[DelIdent]         ; dlka identifiktoru
         jcxz      RetIdnt2                 ; nen dn znak
         add       si,cx                    ; posledn znak v bufferu
RetIdnt1:std                                ; smr dol
         lodsb                              ; naten znaku k nvratu
         call      RetCh                    ; nvrat znaku do bufferu
         loop      RetIdnt1                 ; nvrat dalho znaku
RetIdnt2:cld                                ; smr nahoru
         pop       si
         pop       cx
         pop       ax
         ret

; *****************************************************************************
;
;                    Vstup ze vstupnho souboru
;
; *****************************************************************************

;; -----------------------------------------------------------------------------
;;        Nalezen oddlovae
;; -----------------------------------------------------------------------------
;
;PUBLIC   SrcSpc
;SrcSpc:  call      InpCh                    ; vstup dalho znaku
;         jc        SrcSpc2                  ; nen dal znak
;         cmp       al," "                   ; je oddlova ?
;         jbe       SrcSpc1                  ; je to oddlova
;         cmp       al,","                   ; je rka ?
;         je        SrcSpc1                  ; je rka - je to oddlova
;         cmp       al,";"                   ; je stednk ?
;         je        SrcSpc1                  ; je stednk - je to oddlova
;         cmp       al,"{"                   ; je poznmka ?
;         jne       SrcSpc                   ; nen poznmka - dal znak
;SrcSpc1: call      RetCh                    ; nvrat poslednho znaku
;         clc
;SrcSpc2: ret

; -----------------------------------------------------------------------------
;        Vstup znaku s pevodem na velk psmeno
; -----------------------------------------------------------------------------

PUBLIC   InpChU

InpChU:  call      InpCh                    ; vstup znaku ze vstupnho souboru
         jc        InpChU2                  ; nen dal znak
         call      UpCase                   ; pevod znaku na velk psmeno
InpChU2: ret

; -----------------------------------------------------------------------------
;        Pevod znaku na velk psmeno (ponechv registr pznak)
; -----------------------------------------------------------------------------

PUBLIC   UpCase

UpCase:  pushf
         cmp       al,"a"
         jb        UpCase2
         cmp       al,"z"
         ja        UpCase2
         sub       al,20h
UpCase2: popf
         ret

; -----------------------------------------------------------------------------
;        Vyputn oddlova z textu
; -----------------------------------------------------------------------------

PUBLIC   InpSpc

; ------ vypustn oddlovacch znak (mezera, tabeltor, CR, LF)

InpSpc:  call      InpCh                    ; vstup znaku ze souboru
         jc        InpSpc3                  ; nen dal znak (konec souboru)
         cmp       al," "                   ; je oddlova ?
         jbe       InpSpc                   ; je oddlovac znak

; ------ test, zda je poznmka (zvorka {)

         cmp       al,"{"                   ; je zatek poznmky ?
         clc                                ; pznak operace OK
         jne       InpSpc3                  ; nen poznmka - konec

; ------ vypustn textu po konce poznmky (zvorka })

InpSpc1: call      InpCh                    ; vstup dalho znaku ze souboru
         jc        InpSpc3                  ; nen dal znak
         cmp       al,"{"                   ; je zatek dal poznmky ?
         jne       InpSpc2                  ; nen zatek dal poznmky
         call      InpSpc1                  ; vypustn vnitn poznmky
         jc        InpSpc3                  ; nen dal znak
InpSpc2: cmp       al,"}"                   ; je konec poznmky ?
         jne       InpSpc1                  ; nalezen konce poznmky
         jmp       short InpSpc             ; vypustn oddlova

InpSpc3: call      UpCase                   ; pevod znaku na velk psmeno
         ret

; -----------------------------------------------------------------------------
;        Vstup znaku ze vstupnho souboru (CY=nen dal znak)
; -----------------------------------------------------------------------------

PUBLIC   InpCh

; ------ vyjmut znaku z pechodnho bufferu

InpCh:   cmp       word ptr ds:[BuffChU],0  ; je v pechodnm bufferu znak ?
         je        InpCh7                   ; v pechodnm bufferu nen znak
         push      si                       ; schova SI
         mov       si,ds:[BuffChU]          ; poet bajt v pechodnm bufferu
         dec       si                       ; snen potu bajt v bufferu
         mov       ds:[BuffChU],si          ; nov poet bajt v bufferu
         mov       al,ds:[BuffCh+si]        ; ten znaku z bufferu
         pop       si                       ; nvrat SI
         jmp       short InpCh22

; ------ kontrola, zda je v bufferu njak znak

InpCh7:  cmp       word ptr ds:[SrcNum],0   ; je v buffer jet njak znak ?
         jne       InpCh2                   ; v bufferu je jet njak znak

; ------ naten dalho bloku ze souboru

         push      ax
         push      bx
         push      cx
         push      dx

         cmp       byte ptr ds:[SrcEnd],0   ; byl ji konec souboru ?
         jne       InpCh4                   ; byl ji konec souboru

                                          ;* naten bloku dat ze souboru
         mov       ah,3fh                   ; funkce ten ze souboru
         mov       bx,ds:[ZdrojId]          ; identifiktor zdrojovho souboru
         mov       cx,2000h                 ; velikost vstupnho bufferu
         xor       dx,dx                    ; buffer k naten souboru
         mov       ds:[SrcUkaz],dx          ; nastaven ukazatele vstup. bufferu

         push      ds
         mov       ds,ds:[SrcBuf]           ; buffer vstupnho souboru
         int       21h                      ; naten bloku ze vstup. souboru
         pop       ds

                                          ;* kontrola sprvnosti operace
         jc        InpCh1                   ; chyba ten
         mov       ds:[SrcNum],ax           ; poet natench bajt
         or        ax,ax                    ; naten njak bajt ?
         jnz       InpCh1                   ; bylo nco nateno
         inc       byte ptr ds:[SrcEnd]     ; pznak konce souboru
InpCh4:  stc                                ; pznak konce souboru

InpCh1:  pop       dx
         pop       cx
         pop       bx
         pop       ax
         jc        InpCh3                   ; chyba - nejsou dal data

; ------ naten znaku z bufferu vstupnho souboru

InpCh2:  push      si
         push      ds
         cld                                ; smr nahoru
         mov       si,ds:[SrcUkaz]          ; ukazatel vstupnho bufferu
         mov       ds,ds:[SrcBuf]           ; buffer vstupnho souboru
         lodsb                              ; naten znak z bufferu
         pop       ds
         pop       si
         inc       word ptr ds:[SrcUkaz]    ; zven ukazatele vstup. bufferu
         dec       word ptr ds:[SrcNum]     ; snen tae znak v bufferu

; ------ obsluha ukazatele zatk dk v souboru

         add       word ptr ds:[UkazCh],1   ; zven ukazatele znak v souboru
         adc       word ptr ds:[UkazCh+2],0 ; penos do vyho slova
         cmp       al,13                    ; je CR ?
         je        InpCh21                  ; je CR
         cmp       al,10                    ; je LF ?
         jne       InpCh22                  ; nen LF
         inc       word ptr ds:[CitRad]     ; zven tae dk souboru
InpCh21: push      ax
         mov       ax,word ptr ds:[UkazCh]  ; ukazatel v souboru - ni slovo
         mov       word ptr ds:[UkazRad],ax ; ukazatel dku - ni slovo
         mov       ax,word ptr ds:[UkazCh+2] ; ukazatel v souboru - vy slovo
         mov       word ptr ds:[UkazRad+2],ax ; ukazatel dku - vy slovo
         pop       ax

InpCh22: clc                                ; pznak operace OK

InpCh3:  ret

; -----------------------------------------------------------------------------
;        Nvrat znaku do pechodnho bufferu
; -----------------------------------------------------------------------------

PUBLIC   RetCh

RetCh:   pushf
         push      si
         mov       si,ds:[BuffChU]          ; poet bajt v pechodnm bufferu
         cmp       si,64                    ; pekroen konec bufferu ?
         jae       RetCh2                   ; peteen bufferu
         mov       ds:[BuffCh+si],al        ; uloen znaku do bufferu
         inc       si                       ; zven ukazatele v bufferu
         mov       ds:[BuffChU],si          ; nov poet bajt v bufferu
RetCh2:  pop       si
         popf
         ret


; *****************************************************************************
;
;                      Zpis do vstupnho bufferu
;
; *****************************************************************************

; -----------------------------------------------------------------------------
;        Zven ukazatele v buferu
; -----------------------------------------------------------------------------

PUBLIC   OutInc
OutInc:  pushf
         push      ds
         cmp       word ptr ds:[ProgNum],-1 ; poet bajt ve vstupnm bufferu
         je        OutInc2                  ; je peteen bufferu
         inc       word ptr ds:[ProgNum]    ; zven ukazatele dat
         mov       ds,ds:[ProgSeg]          ; segment vstupnho bufferu
         inc       word ptr ds:[0]          ; zven ukazatele dlky
OutInc2: pop       ds
         popf
         ret

; -----------------------------------------------------------------------------
;        Zruen bajtu uloenho do buferu
; -----------------------------------------------------------------------------

PUBLIC   OutRet
OutRet:  pushf
         push      ds
         cmp       word ptr ds:[ProgNum],0  ; poet bajt ve vstupnm bufferu
         je        OutRet2                  ; je podteen bufferu
         dec       word ptr ds:[ProgNum]    ; snen ukazatele dat
         mov       ds,ds:[ProgSeg]          ; segment vstupnho bufferu
         dec       word ptr ds:[0]          ; snen ukazatele dlky
OutRet2: pop       ds
         popf
         ret

; -----------------------------------------------------------------------------
;        Zpis slova AX do vstupnho bufferu
; -----------------------------------------------------------------------------

PUBLIC   OutWrd
OutWrd:  push      ax
         call      OutCh
         mov       al,ah
         call      OutCh
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Zpis bajtu do vstupnho bufferu
; -----------------------------------------------------------------------------

PUBLIC   OutCh

OutCh:   push      di
         push      es
         cld                                ; smr nahoru
         mov       es,ds:[ProgSeg]          ; segment vstupnho bufferu
         mov       di,ds:[ProgNum]          ; poet bajt ve vstupnm bufferu
         stosb                              ; uloen bajtu do vstup. bufferu
         or        di,di                    ; je peteen bufferu ?
         stc                                ; pednastaven pznaku chyby
         jz        OutCh2                   ; je peteen bufferu
         mov       ds:[ProgNum],di          ; jinak nov poet bajt v bufferu
         inc       word ptr es:[0]          ; zven ukazatele dlky
         clc                                ; pznak operace OK
OutCh2:  pop       es
         pop       di
         ret

; -----------------------------------------------------------------------------
;        Zpis vstupnho bufferu do souboru (CX=poet bajt)
; -----------------------------------------------------------------------------

PUBLIC   WritProg
WritProg:push      ds
         mov       bx,ds:[CilId]            ; identifiktor vstupnho souboru
         mov       ds,ds:[ProgSeg]          ; segment s interpreterem
         xor       dx,dx                    ; poten offset
         add       cx,15                    ; zaokrouhlen na odstavec nahoru
         and       cx,not 15                ; zarovnn na odstavec
         mov       ax,cx                    ; poet bajt k zpisu
         jcxz      WritPrg3                 ; nen nic k zpisu
         mov       ah,40h                   ; funkce zpisu do souboru
         int       21h                      ; zpis interpreteru do souboru
WritPrg3:pop       ds
         mov       dx,offset WritTxt        ; text - chyba zpisu
         jc        WritPrg1                 ; chyba zpisu do vstupnho souboru
         cmp       ax,cx                    ; zapsno ve ?
         je        WritPrg2                 ; nen chyba - OK

; ------ chyba zpisu do vstupnho souboru nebo jin chyba

PUBLIC   WritPrg1
WritPrg1:
         jmp       Navrat0                  ; nvrat s chybou

WritPrg2:ret

; *****************************************************************************
;
;                     Obsluha chybovch hlen
;
; *****************************************************************************


; -----------------------------------------------------------------------------
;        Zobrazen chybovho hlen
; -----------------------------------------------------------------------------

PUBLIC   DispErr
DispErr:

; ------ schova registr

         pushf
         push      ax
         push      bx
         push      cx
         push      dx
         push      di
         push      es

         push      ds
         pop       es
         inc       word ptr ds:[CitChyb]    ; zven tae chyb

; ------ zobrazen sla dku s chybou

         push      dx                       ; schova adresy textu hlen
         mov       al,"["                   ; lev zvorka
         call      DispCh                   ; zobrazen znaku lev zvorky
         mov       ax,ds:[ErrNRad]          ; slo dku
         call      DispNum                  ; zobrazen sla aktulnho dku
         mov       al,"]"                   ; prav zvorka
         call      DispCh                   ; zobrazen prav zvorky
         mov       al," "                   ; oddlovac mezera za slem dku
         call      DispCh                   ; zobrazen oddlovac mezery
         pop       di                       ; chybov hlen

; ------ zobrazen textu chybovho hlen

DispErr1:mov       al,ds:[di]
         inc       di
         or        al,al                    ; konec texty ?
         jz        DispErr3                 ; konec textu
         cmp       al,"%"                   ; parametr ?
         jne       DispErr2                 ; nen parametr

         mov       ch,0
         mov       dx,offset BufIdent       ; buffer identifiktoru
         mov       cl,ds:[DelIdent]         ; dlka identifiktoru
         call      DispTxt                  ; zobrazen textu identifiktoru
         jmp       short DispErr1           ; dal znak

DispErr2:call      DispCh                   ; zobrazen znaku textu
         jmp       short DispErr1
DispErr3:mov       al,":"                   ; oddlova hlen
         call      DispCh                   ; zobrazen znaku ":"
         mov       al," "                   ; oddlovac mezera textu
         call      DispCh                   ; zobrazen oddlovac mezery

; ------ schova aktuln pozice v souboru

         mov       ax,4201h                 ; funkce pesunu od souasn pozice
         mov       bx,ds:[ZdrojId]          ; identifiktor zdrojovho souboru
         xor       cx,cx
         xor       dx,dx
         int       21h                      ; poskytnut aktulnho ukazatele
         push      ax                       ; ukazatel - ni slovo
         push      dx                       ; ukazatel - vy slovo

; ------ nastaven pozice dku s chybou

         mov       ax,4200h                 ; funkce nastaven od zatku soub.
         mov       dx,word ptr ds:[ErrARad] ; ukazatel dku - ni slovo
         mov       cx,word ptr ds:[ErrARad+2] ; ukazatel dku - vy slovo
         int       21h                      ; nastaven ukazatele na dek

; ------ naten dku do bufferu

         mov       ah,3fh                   ; funkce ten ze souboru
         mov       dx,offset ErrRad         ; buffer pro chybov dek
         mov       cx,255                   ; maximln poet znak
         int       21h                      ; naten dku ze souboru
         xor       ah,ah                    ; AH <- 0 pojitn
         mov       di,ax                    ; schova potu natench znak

; ------ nvrat pvodnho ukazatele v souboru

         mov       ax,4200h                 ; funkce nastaven ukazatele
         pop       cx                       ; ukazatel - vy slovo
         pop       dx                       ; ukazatel - ni slovo
         int       21h                      ; nastaven pvodnho ukazatele

; ------ nalezen konce dku v bufferu

         mov       cx,di                    ; poet znak v bufferu
         push      cx
         mov       al,13                    ; hledan znak - CR
         mov       di,offset ErrRad         ; buffer s chybovm dkem
         mov       dx,di                    ; buffer s chybovm dkem
         repne     scasb                    ; nalezen znaku CR
         mov       byte ptr ds:[di-1],0     ; nhrada bajtem 0 (konec textu)
         pop       cx                       ; poet znak v bufferu

; ------ nalezen zatku textu

         jcxz      DispErr7                 ; nen dal znak
DispErr5:mov       di,dx                    ; ukazatel adresy v bufferu
         cmp       byte ptr ds:[di]," "     ; je oddlova ?
         ja        DispErr7                 ; nen oddlova - zobrazen textu
         inc       dx                       ; zven adresy
         loop      DispErr5                 ; dal znak

; ------ zobrazen chybovho dku

DispErr7:mov       si,dx                    ; text k zobrazen
         cld
DispErr6:lodsb
         or        al,al                    ; je konec textu ?
         jz        DispErr4                 ; je konec textu
         call      DispCh                   ; zobrazen textu dku
         jmp       short DispErr6           ; dal znak k zobrazen

; ------ oddkovn textu

DispErr4:mov       al,13
         call      DispCh                   ; zobrazen CR
         mov       al,10
         call      DispCh                   ; zobrazen LF

; ------ nvrat registr

         pop       es
         pop       di
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         popf
         ret

; -----------------------------------------------------------------------------
;        Zobrazen sla AX
; -----------------------------------------------------------------------------

PUBLIC   DispNum

; ------ pprava registr

DispNum: push      ax
         push      bx
         push      cx
         push      dx
         mov       bx,10                    ; seln soustava
         xor       cx,cx                    ; ta slic v zsobnku

; ------ vpoet jedn slice

DispNm1: xor       dx,dx                    ; DX <- 0 vy slovo sla
         div       bx                       ; vpoet jedn slice
         add       dl,"0"                   ; korekce na znak ASCII
         push      dx                       ; uloen znaku do zsobnku
         inc       cx                       ; zven tae znak
         or        ax,ax                    ; zbylo njak slo ?
         jnz       DispNm1                  ; je dal slo

; ------ zobrazen sla

DispNm2: pop       ax                       ; znak k zobrazen
         call      DispCh                   ; zobrazen slice
         loop      DispNm2                  ; zobrazen dal slice

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Zobrazen textu DS:DX o dlce CX znak
; -----------------------------------------------------------------------------

PUBLIC   DispTxt
DispTxt: push      ax
         push      cx
         push      si
         mov       si,dx                    ; adresa textu
         jcxz      DispTxt2                 ; nen dn znak
         cld
DispTxt1:lodsb
         call      DispCh                   ; zobrazen znaku
         loop      DispTxt1                 ; dal znak
DispTxt2:pop       si
         pop       cx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Zobrazen znaku DOS
; -----------------------------------------------------------------------------

PUBLIC   DispCh
DispCh:  push      ax
         push      dx
         mov       dl,al                    ; znak k zobrazen
         mov       ah,2                     ; funkce zobrazen znaku
         int       21h                      ; zobrazen znaku
         pop       dx
         pop       ax
         ret




code     ends

; -----------------------------------------------------------------------------
;        Data
; -----------------------------------------------------------------------------

Data     SEGMENT

TabOper  label     byte                   ;* tabulka opertor

         db        1,'('                    ; 1
         db        1,')'                    ; 2
         db        1,'^'                    ; 3
         db        1,'*'                    ; 4
         db        1,'/'                    ; 5
         db        3,'MOD'                  ; 6
         db        2,'<<'                   ; 7
         db        2,'>>'                   ; 8
         db        1,'+'                    ; 9
         db        1,'-'                    ; 10
         db        1,'='                    ; 11
         db        2,'<>'                   ; 12
         db        1,'<'                    ; 13
         db        1,'>'                    ; 14
         db        2,'<='                   ; 15
         db        2,'>='                   ; 16
         db        3,'NOT'                  ; 17
         db        3,'AND'                  ; 18
         db        2,'OR'                   ; 19
         db        3,'XOR'                  ; 20
         db        0


; Za kadm pkazem mus bt uveden znak stednku ";" (= konec pkazu).
; Vnitn oddlovae st konstrukc: THEN, ELSE, ENDIF, DO uvnit FOR, ENDDO,
;                                      IN, OUT, ENDCASE, ENDPROC;
; - za pkazem ped vnitnm oddlovaem se nepe stednk.
;
; znak ? = speciln hodnota 8000h=-32768, u nkterch pkaz zpsob, e
;          se tato hodnota nenastav (nap. definice jen nkterch palet)

; -----------------------------------------------------------------------------
; Podmnn vtven:
;     IF c THEN [s1; s2; ... sn] [ELSE [s1; s2; ... sn]] ENDIF;
;
; Vcensobn vtven:
;     CASE e
;     IN [a1..a2 | a]: [s1; s2; ... sn]
;     .....
;     [OUT [s1; s2; ... sn]
;     ENDCASE;
;
; Cyklus:
;    [FOR v [:= e1] [TO e2] [STEP e3]] DO
;           [s1; s2; ... sn;]
;    [WHILE c;]
;           [s1; s2; ... sn;]
;    [WHILE c;]
;           .....
;           [s1; s2; ... sn]
;    ENDDO;
;
; Definice procedury:
;    PROC p;
;           [s1; s2; ... sn;]
;           [RETURN[(e)];]
;           ....
;           [s1; s2; ... sn]
;    ENDPROC;
;
; Pouit symboly:
;    a1, a2, a - seln konstanty
;    c - podmnka
;    e - vraz
;    s - pkaz
;    v - promnn
;    p - jmno procedury
; -----------------------------------------------------------------------------

TabKey   label     byte                   ;* tabulka klovch slov
                                            ; FF: uivatelsk procedura

                                            ; FB: naplnn WORD s indexem
                                            ; FA: naplnn BYTE s indexem
                                            ; F9: naplnn WORD
                                            ; F8: naplnn BYTE


                                          ;* povoleno jen na konci programu

         db        4,'LINK'                 ;  0: pilinkovn objektu
         dw        offset XLink

                                          ;* povoleno kdykoliv

         db        7,'include'              ;  (1: vnoen vstupnho souboru)
         dw        offset XInclud

                                          ;* povoleno jen na zatku programu

         db        4,'BYTE'                 ;  2: definice promnn bajt
         dw        offset XByte
         db        4,'WORD'                 ;  3: definice promnn slov
         dw        offset XWord
         db        6,'string'               ;  (4: definice etzcov promnn)
         dw        offset XString

                                          ;* povoleno na zatku i uvnit

         db        4,'PROC'                 ;  5: definice procedury
         dw        offset XProc

                                          ;* povoleno uvnit procedur

         db        7,'ENDPROC'              ;  6: konec definice procedury
         dw        offset XEndp
         db        6,'RETURN'               ;  7: nvrat z procedury
         dw        offset XRet
         db        4,'exec'                 ;  8: proveden pkazu DOS
         dw        offset XExec

         db        2,'IF'                   ;  9: identifiktor podmnky
         dw        offset XIf
         db        4,'THEN'                 ; 10: zatek pkaz - podmnka splnna
         dw        offset XThen
         db        4,'ELSE'                 ; 11: zatek pkaz - podm. nesplnna
         dw        offset XElse
         db        5,'ENDIF'                ; 12: konec podmnky IF
         dw        offset XEndif

         db        3,'for'                  ; 13: cyklus s parametrem
         dw        offset XFor
         db        2,'to'                   ; 14: podmnka konce cyklu
         dw        offset XTo
         db        4,'step'                 ; 15: krok cyklu s parametrem
         dw        offset XStep

         db        2,'DO'                   ; 16: cyklus s podmnkou
         dw        offset XDo
         db        2,'ON'                   ; 17: podmnka cyklu
         dw        offset XOn
         db        5,'ENDDO'                ; 18: konec cyklu
         dw        offset XEnddo

         db        4,'EXIT'                 ; 19: pedasn ukonen cyklu
         dw        offset XExit

         db        4,'CASE'                 ; 20: vcensobn vtven
         dw        offset XCase
         db        2,'IN'                   ; 21: podmnka intervalu nebo hodnoty
         dw        offset XIn
         db        3,'OUT'                  ; 22: podmnka nesplnn dn hodnoty
         dw        offset XOut
         db        7,'ENDCASE'              ; 23: konec vtven CASE
         dw        offset XEndCase

                                          ;* povoleno jako funkce
         db        3,'val'                  ; 24: pevod etzce na slo
         dw        offset XVal
         db        3,'str'                  ; 25: pevod sla na etzec
         dw        offset XStr
         db        3,'len'                  ; 26: zjitn dlky etzce
         dw        offset XLen
         db        4,'CARD'                 ; 27: test grafick karty
         dw        offset XCard
         db        5,'VIDEO'                ; 28: nastaven videomdu
         dw        offset XVideo
         db        8,'getvideo'             ; 29: zjitn videomdu
         dw        offset XGVideo
         db        4,'MODE'                 ; 30: nastaven mdu displeje
         dw        offset XMode
         db        4,'PAGE'                 ; 31: nastaven strnek displeje
         dw        offset XPage
         db        5,'XPAGE'                ; 32: pepnut strnek displeje
         dw        offset XXPage
         db        6,'WINDOW'               ; 33: definice vstupnho okna
         dw        offset XWind
         db        7,'PALETTE'              ; 34: definice palet displeje
         dw        offset XPal
         db        6,'XCOLOR'               ; 35: zmna barvy v okn
         dw        offset XXCol
         db        7,'SETCURS'              ; 36: nastaven pozice kurzoru
         dw        offset XSetCur
         db        7,'CURSOFF'              ; 37: vypnut kurzoru
         dw        offset XCurOff
         db        4,'LOAD'                 ; 38: naten objektu ze souboru
         dw        offset XLoad
         db        3,'PIC'                  ; 39: zobrazen objektu
         dw        offset XObj
         db        6,'UNLOAD'               ; 40: zruen objektu z pamti
         dw        offset XUnld
         db        4,'TEXT'                 ; 41: zobrazen textu
         dw        offset XText
         db        5,'POINT'                ; 42: zobrazen bodu
         dw        offset XPoint
         db        4,'LINE'                 ; 43: zobrazen ry
         dw        offset XLine
         db        5,'RLINE'                ; 44: zobrazen ry relativn
         dw        offset XRline
         db        3,'BOX'                  ; 45: zobrazen opbdlnku
         dw        offset XBox
         db        4,'FBOX'                 ; 46: zobrazen plnho obdlnku
         dw        offset XFBox
         db        4,'CIRC'                 ; 47: zobrazen krunice
         dw        offset XCirc
         db        5,'FCIRC'                ; 48: zobrazen pln krunice
         dw        offset XFCirc
         db        5,'PRESS'                ; 49: test urit klvesy na stisk
         dw        offset XPress
         db        7,'TESTKEY'              ; 50: test pipraven klvesy
         dw        offset XTstKey
         db        6,'GETKEY'               ; 51: vstup znaku z klvesnice
         dw        offset XGtKey
         db        7,'STATKEY'              ; 52: stavov slovo klvesnice
         dw        offset XStatKey
         db        5,'INPUT'                ; 53: vstup textu
         dw        offset XInp
         db        5,'SOUND'                ; 54: ovldn zvukovho genertoru
         dw        offset XSound
         db        3,'TON'                  ; 55: zahrn tnu dan frekvence
         dw        offset XTon
         db        5,'MUSIC'                ; 56: zahrn melodie
         dw        offset XMusic
         db        9,'MUSICSTOP'            ; 57: zastaven hry melodie
         dw        offset XMStop
         db        8,'MUSICGET'             ; 58: poskytnut ukazatele melodie
         dw        offset XMusGet
         db        4,'WAIT'                 ; 59: ekn po danou dobu
         dw        offset XWait
         db        4,'TIME'                 ; 60: poskytnut systmovho asu
         dw        offset XTime
         db        4,'DATE'                 ; 61: poskytnut systmovho data
         dw        offset XDate
         db        6,'XMOUSE'               ; 62: poskytnut pozice myi
         dw        offset XXMous
         db        6,'YMOUSE'               ; 63: poskytnut linky myi
         dw        offset XYMous
         db        8,'GETMOUSE'             ; 64: poskytnut tlatek myi
         dw        offset XKMous
         db        7,'MOUSEON'              ; 65: zapnut kurzoru myi
         dw        offset XMon
         db        8,'MOUSEOFF'             ; 66: vypnut kurzoru myi
         dw        offset XMoff
         db        8,'CURMOUSE'             ; 67: definice kurzoru myi
         dw        offset XDefm
         db        8,'WINMOUSE'             ; 68: definice okna myi
         dw        offset XWinm
         db        3,'RND'                  ; 69: genertor nhodnho sla
         dw        offset XRnd
         db        8,'REGISTER'             ; 70: nastaven registru CRT
         dw        offset XReg
         db        4,'HSYN'                 ; 71: horizontln synchronizace
         dw        offset XHSyn
         db        4,'VSYN'                 ; 72: vertikln synchronizace
         dw        offset XVSyn
         db        7,'PATTERN'              ; 73: vzorek vpln
         dw        offset XPatt
         db        5,'STICK'                ; 74: joystickov vstup
         dw        offset XStick
         db        4,'TRIG'                 ; 75: aktivan tlatko joysticku
         dw        offset XTrig
         db        3,'SIN'                  ; 76: funkce SINUS
         dw        offset XSin
         db        3,'COS'                  ; 77: funkce COSINUS
         dw        offset XCos
         db        3,'TAN'                  ; 78: funkce Tangens
         dw        offset XTan
         db        3,'ABS'                  ; 79: absolutn hodnota
         dw        offset XAbs
         db        3,'ATN'                  ; 80: ArcTangent
         dw        offset XAtn
         db        3,'SQR'                  ; 81: odmocnina
         dw        offset XSqr

         db        0                        ; identifikace konce tabulky

; ------ vodn a zkladn chybov hlen

UvTxt    db        'ANIM V 1.00 - graficka animace;  (c) Miroslav Nemecek',13,10,'$'

MemTxt   db        'Chyba - nedostatek pameti !',13,10,'$'
Mem1Txt  db        'Chyba - preteceni tabulky symbolu !',13,10,'$'
Mem2Txt  db        'Chyba - preteceni datoveho modulu !',13,10,'$'
Mem3Txt  db        'Chyba - preteceni programoveho modulu !',13,10,'$'
ZdrojTxt db        'Zadejte specifikaci zdrojoveho souboru !',13,10,'$'
FndTxt   db        'Chybne zadani zdrojoveho souboru !',13,10,'$'
CilTxt   db        'Vystupni soubor .EXE nelze vytvorit'
Err0Txt  db        ' !'
UvTxt1   db        13,10,'$'
WritTxt  db        'Chyba zapisu do vystupniho souboru !',13,10,'$'
ErrMain  db        'Nebyla definovana procedura MAIN',13,10,'$'
ErrClos  db        'Procedura neni uzavrena !',13,10,'$'

FreeTxt  db        13,10,'Volna pamet: program $'
FreeTxt1 db        ', data $'
FreeTxt2 db        ', symboly $'
FreeTxt3 db        13,10,'$'

ProgLev  db        0                        ; rove zpracovn programu
                                            ;  0=deklaran st promnnch
                                            ;  1=programov st - uzaveno PROC
                                            ;  2=programov st - oteveno PROC
                                            ;  3=konec programu - LINK
ParMain  db        0                        ; pznak, e byla hlavn porcedura
LastIdn  db        0                        ; posledn identifiktor

SegPSP   dw        0                        ; segment PSP

; ------ obsluha chyb pekladu

Err000   db        'Pocet chyb : $'

Err001   db        'Neplatne symbolicke jmeno',0
Err002   db        'Jmeno % nedefinovano',0
Err003   db        '% smi byt jen v deklaracni casti',0
Err004   db        'Chybny zapis pro naplneni promenne',0
Err005   db        'Chybny zapis vyrazu',0
Err007   db        'Za prikazem LINK nesmi nasledovat program',0
Err008   db        '% nesmi byt uvnitr procedury',0
Err009   db        'Vicenasobne pouziti jmena %',0

Err010   db        'Procedura neni uzavrena',0
Err011   db        '% musi byt uvedeno v procedure',0
Err012   db        'Neplatne jmeno objektu',0
Err013   db        'Jmeno % je rezervovano',0
Err014   db        'Chybne zadani dimenze promenne %',0
Err015   db        'Chyba syntaxe prikazu LINK',0
Err016   db        'Chybne jmeno souboru',0
Err017   db        'Chybne zadani jmena programu ke startu',0
Err018   db        'Neplatne jmeno procedury',0
Err019   db        '% nesmi byt v deklaracni casti',0
Err01a   db        'Za prikazem chybi strednik',0
Err01b   db        'Chybny argument prikazu',0
Err01c   db        'Prilis mnoho udaju',0

Err020   db        'Podminka IF neuzavrena',0
Err021   db        'Za IF musi nasledovat THEN',0
Err022   db        '% bez podminky IF',0
Err023   db        'THEN musi nasledovat za podminkou IF',0
Err025   db        '% nelze uvest vicenasobne',0

Err030   db        'Cyklus DO neuzavren',0
Err031   db        '% bez zacatku cyklu DO',0
Err032   db        'Za ON musi nasledovat EXIT',0
Err033   db        'EXIT smi byt pouze za ON',0

Err040   db        'Vicenasobne vetveni CASE neuzavreno',0
Err041   db        '% bez CASE',0
Err043   db        '% nelze uvest po OUT',0
Err044   db        'Vetev % jiz byla pouzita',0
Err045   db        '% bez CASE',0
Err046   db        'Za CASE musi nasledovat IN',0
Err047   db        'Chybne meze pro IN',0

ErrARad  dd        0                        ; schova ukazatele chybovho dku
ErrNRad  dw        0                        ; schova sla chybovho dku
ErrRad   db        256 dup(0)               ; text chybovho dku
RetClose dw        0                        ; schova nvrat. adresy uzaven
RetDisp  dw        0                        ; schova nvrat. adresy zobrazen
RetComp  dw        0                        ; nvratov adresa do kompiltoru
RetPush  dw        0                        ; nvratov adresa z schovy reg.
RetProc  dw        0                        ; nvratov adresa z schovy PROC
CitChyb  dw        0                        ; ta chyb pipekladu

; ------ ukazatele pro spojovn modul LINK

LinkId   dw        0                        ; identifiktor zdrojovho modulu

; ------ parametry pro genertor melodie

Oktava   dw        0                        ; oktva
Krizky   dw        0                        ; ta kk
DelTon   db        0                        ; dlka tnu

; ------ buffer nvt a identifiktor

BufOper  db        4 dup(0)                 ; buffer opertoru

DelIdent db        0                        ; dlka nvt (dodret poad !)
BufIdent db        64 dup(0)                ; buffer nvt

FlagBuf  dw        0                        ; segment s tabulkou nvt
FlagNum  dw        0                        ; poet bajt v tabulce nvt

; ------ vstupn buffer (velikost 64 KB)

ProgSeg  dw        SEG Interp               ; segment s programem
ProgNum  dw        2                        ; poet bajt programu



SizProg  dw        0                        ; poet bajt programu
SizDat   dw        0                        ; poet bajt v dat. segmentu

; ------ vstupn buffer (velikost 2000h bajt)

SrcBuf   dw        0                        ; segment vstupnho bufferu
SrcUkaz  dw        0                        ; ukazatel ve vstupnm bufferu
SrcNum   dw        0                        ; poet zbylch znak vstup. bufferu
UkazCh   dd        0                        ; ukazatel znak v souboru
UkazRad  dd        0                        ; ukazatel zatku dku v souboru
CitRad   dw        1                        ; ta dk v souboru
SrcEnd   db        0                        ; 1=pznak konce souboru

BuffChU  dw        0                        ; poet bajt v pechodnm bufferu
BuffCh   db        64 dup(0)                ; pechodn buffer

; ------ obsluha soubor

SoubLinn db        0                        ; poet bajt jmna souboru
SoubLink db        128 dup(0)               ; pracovn soubor

PripAni  db        '.ANI',0                 ; ppona animanho zdroj. souboru
PripExe  db        '.EXE',0                 ; ppona vstupnho souboru
Soubor   db        128 dup(0)               ; buffer k uloen jmna souboru

CilSize  dd        0                        ; velikost vstupnho souboru
ZdrojId  dw        0                        ; identifiktor zdrojovho souboru
CilId    dw        0                        ; identifiktor clovho souboru


Konec    label     byte                     ; ukazatel konce programu

Data     ENDS


; *****************************************************************************
;
;                  Pechodn zsobnk pro kompiltor
;
; *****************************************************************************

Stack    SEGMENT   stack para

         dw        20h dup(0)               ; mus bt nco definovan !

Stack    ENDS


; *****************************************************************************
;
;        Segment s interpreterem programu (ppoj se pi kompilaci)
;
; *****************************************************************************

Interp   SEGMENT   para

Interp   ENDS

         END       Animc
