

; *****************************************************************************
;
;                               A N I M I
;
;                     animan program - interpreter
;
; *****************************************************************************


Code     SEGMENT
         ASSUME    cs:Code,ds:Code,ss:Stack

         dw        SEG SegProg              ; segment animanho programu

         db        'ANIM - pocitacova animace; (c) Miroslav Nemecek',13,10

Start:

; ------ pedefinovn zsobnku na vrchol pamti

         cli                                ; zkaz peruen
         mov       ax,ds:[2]                ; segment s koncem pamti
         sub       ax,1000h                 ; rezerva 64 KB
         mov       ss,ax                    ; segment zsobnku
         mov       sp,0fff8h                ; offset zsobnku
         sti                                ; povolen peruen

; ------ inicializace segmentovch registr

         mov       ax,cs                    ; datov segment
         mov       ds,ax                    ; DS <- datov segment
         mov       ds:[SegPSP],es           ; schova segmentu PSP
         mov       es,ax                    ; datov segment

; ------ nastaven pznaku karty EGA

         mov       ah,12h                   ; funkce poskytnut informac EGA
         mov       bx,05e10h                ; podfunkce informac
         int       10h                      ; poskytnut informac EGA/VGA
         cmp       bh,2                     ; md displeje 0 nebo 1
         jae       Start2                   ; chyba - neplatn obsah registru
         cmp       bl,5                     ; maximln velikost pamti 1 MB
         jbe       Start3                   ; velikost pamti OK
Start2:  mov       byte ptr ds:[EgaVga],0   ; pznak, e nen karta EGA/VGA

; ------ schova videomdu

Start3:  mov       ah,0fh
         call      Int10                    ; poskytnut aktivnho videomdu
         mov       ds:[OldVMod],al          ; schova aktivnho videomdu

; ------ uren segment jednotlivch blok

         push      es
         mov       cl,4                     ; poet rotac pro pevod
         mov       ax,SEG SegProg           ; segment s daty programu
         mov       es,ax                    ; segment datovho modulu
         mov       bx,es:[0]                ; dlka datovho modulu
         add       bx,15                    ; zaokrouhlen na odstavec
         shr       bx,cl                    ; pepoet na odstavce
         add       ax,bx                    ; adresa segmentu s programem
         mov       ds:[ProgMem],ax          ; segment s programem
         mov       es,ax                    ; segment s programem
         mov       bx,es:[0]                ; dlka segmentu s programem
         add       bx,15                    ; zaokrouhlen na odstavec
         shr       bx,cl                    ; pepoet na odstavce
         add       ax,bx                    ; adresa segmentu s objekty
         mov       ds:[ObjMem],ax           ; segment s objekty
         pop       es

; ------ uren adresy konce tabulky blok

         mov       word ptr ds:[TopMem],-1  ; pednastaven - zruen konce
         xor       ax,ax                    ; hledan blok 0
         call      SrcObj
         mov       ds:[TopMem],dx           ; nov konec pamti

; ------ definice obsluhy uivatelskho peruen Ctrl-Break

         push      ds
         push      cs
         pop       ds
         mov       ax,2523h
         mov       dx,offset Prerus
         int       21h                      ; adresa peruen programu
         pop       ds

; ------ definice obsluhy hodin INT 08h

         push      es
         mov       ax,3508h
         int       21h
         mov       word ptr cs:[Old08],bx
         mov       word ptr cs:[Old08+2],es
         pop       es
         push      ds
         push      cs
         pop       ds
         mov       dx,offset Int08
         mov       ax,2508h
         int       21h
         pop       ds

; ------ definice obsluhy chyby dlenm INT 00h

         push      es
         mov       ax,3500h
         int       21h
         mov       word ptr cs:[Old00],bx
         mov       word ptr cs:[Old00+2],es
         pop       es
         push      ds
         push      cs
         pop       ds
         mov       dx,offset Int00
         mov       ax,2500h
         int       21h
         pop       ds

; ------ definice obsluhy chyby dlenm INT 1Bh

         push      es
         mov       ax,351Bh
         int       21h
         mov       word ptr cs:[Old1B],bx
         mov       word ptr cs:[Old1B+2],es
         pop       es
         push      ds
         push      cs
         pop       ds
         mov       dx,offset Int1B
         mov       ax,251Bh
         int       21h
         pop       ds

; ------ inicializace genertoru nhody

         push      ds
         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[46ch]
         mov       dx,ds:[46eh]
         pop       ds
         mov       word ptr ds:[RandNum],ax
         mov       word ptr ds:[RandNum+2],dx

; ------ interpretace programu

         push      ds
         mov       ds,ds:[ProgMem]          ; segment s programem
         mov       ax,ds:[2]                ; startovac adresa programu
         pop       ds
         mov       ds:[ProgUkaz],ax         ; inicializace ukazatele programu
         call      Anim                     ; interpretace programu (procedury)
         mov       byte ptr ds:[RetKod],al  ; nvratov kd programu

; ------ ukonen programu (nebo peruen)

Prerus:  mov       ax,cs                    ; datov segment
         mov       ds,ax                    ; datov segment
         mov       al,ds:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

; ------ nvrat obsluhy peruen INT 08h

Prerus2: push      ds
         lds       dx,cs:[Old08]
         mov       ax,2508h
         int       21h                      ; nvrat adresy obsluhy INT 08h
         pop       ds

; ------ nvrat obsluhy peruen INT 00h

         push      ds
         lds       dx,cs:[Old00]
         mov       ax,2500h
         int       21h                      ; nvrat adresy obsluhy INT 00h
         pop       ds

; ------ nvrat obsluhy peruen INT 1Bh

         push      ds
         lds       dx,cs:[Old1B]
         mov       ax,251Bh
         int       21h                      ; nvrat adresy obsluhy INT 1Bh
         pop       ds

; ------ vypnut zvukovho genertoru

         in        al,[61h]                 ; vstup na reproduktor
         and       al,not 3
         out       [61h],al                 ; vypnut vstupu na reproduktor

; ------ nvrat z programu

         mov       al,ds:[RetKod]           ; nvratov kd z programu
         mov       ah,4ch
         int       21h                      ; ukonen programu

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 08h
; -----------------------------------------------------------------------------

Citac    dw        0                        ; ta asu
Old08    dd        0                        ; pvodn adresa INT 08h

public   int08
INT08    PROC      FAR

         inc       word ptr cs:[Citac]
         jnz       Int082                   ; nen peteen
         dec       word ptr cs:[Citac]      ; nvrat sla -1
Int082:  jmp       dword ptr cs:[Old08]

Int08    ENDP

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 00h
; -----------------------------------------------------------------------------

Old00    dd        0                        ; pvodn adresa INT 00h

INT00    PROC      FAR

         iret

INT00    ENDP

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 1Bh
; -----------------------------------------------------------------------------

ParBreak db        0                        ; pznak peruen programu
Old1B    dd        0                        ; pvodn adresa INT 1Bh

INT1B    PROC      FAR

         mov       byte ptr cs:[ParBreak],1 ; pznak peruen
         iret

INT1B    ENDP

; -----------------------------------------------------------------------------
;        Interpretace procedury programu (po pkaz ENDPROC)
; -----------------------------------------------------------------------------

PUBLIC   Anim

Anim:    sti
         call      InpProg                  ; ten bajtu z programu
         jc        Anim9                    ; je konec bufferu

; ------ obsluha ENDPROC

         cmp       byte ptr cs:[ParBreak],0 ; je peruen programu ?
         jne       Anim1                    ; je peruen programu
         cmp       al,6                     ; je ENDPROC ?
         jne       Anim2                    ; nen ENDPROC
Anim1:   xor       ax,ax                    ; nvratov kd
         jmp       short Anim9              ; konec

; ------ obsluha RETURN

Anim2:   cmp       al,7                     ; je RETURN ?
         jne       Anim3                    ; nen RETURN
         call      Vyraz                    ; vpoet hodnoty vrazu
         jmp       short Anim9              ; konec

; ------ obsluha intern funkce

Anim3:   cmp       al,0ffh                  ; je uivatelsk procedura ?
         je        Anim4                    ; je uivatelsk procedura
         mov       bl,al                    ; slo funkce
         mov       bh,0
         shl       bx,1
         call      word ptr ds:[TabFnc+bx]  ; vyvoln obsluhy funkce
         jmp       short Anim               ; dal pkaz

; ------ obsluha uivatelsk procedury

Anim4:   call      InpWord                  ; adresa uivatelsk procedury
         push      word ptr ds:[ProgUkaz]   ; schova ukazatele pogramu
         mov       word ptr ds:[ProgUkaz],ax ; nov adresa programu (procedura)
         call      Anim                     ; proveden obsluhy procedury
         pop       word ptr ds:[ProgUkaz]   ; nvrat ukazatele programu
         jmp       short Anim               ; dal pkaz

Anim9:   ret

; -----------------------------------------------------------------------------
;        Vpoet hodnoty vrazu (CY=je hodnota 8000h = nenastavuje se)
; -----------------------------------------------------------------------------

PUBLIC   Vyraz
Vyraz:
         push      bx
         push      cx
         push      dx

; ------ prvn operand vrazu

         call      GetOper                  ; vpoet prvnho operandu
         mov       cx,ax                    ; prvn operand
         jc        Vyraz7                   ; neplatn operand

; ------ vnitn opertor vrazu

Vyraz1:  call      GetProm                  ; poskytnut opertoru
         jc        Vyraz7                   ; nen dal opertor
         cmp       dl,2                     ; je prav zvorka ?
         je        Vyraz7                   ; je prav zvorka - konec
         or        dl,dl                    ; je to operand ?
         js        Vyraz1                   ; je operand - chyba

; ------ vpoet druhho operandu

         call      GetOper                  ; vpoet druhho operandu
         jc        Vyraz7                   ; konec vrazu
         mov       bl,dl
         mov       bh,0
         add       bx,bx                    ; slo opertoru * 2
         call      word ptr ds:[TabOper+bx] ; obsluha opertoru
         jmp       short Vyraz1             ; vpoet dalho operandu

; ------ zhodnocen vsledku operace

Vyraz7:  mov       ax,cx                    ; vsledek vpotu
         cmp       ax,8000h
         clc
         jne       Vyraz8
         stc                                ; pznak hodnoty 8000h

Vyraz8:  pop       dx
         pop       cx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Vpoet hodnoty jednoho operandu (AX, CY=konec)
; -----------------------------------------------------------------------------

PUBLIC   GetOper

GetOper: push      bx
         push      dx

; ------ ten parametr operandu (unrnho opertoru)

GetOper1:call      GetProm                  ; poskytnut typu operandu
         jc        GetOper9                 ; nen dal operand

; ------ je vraz v zvorce

         cmp       dl,1                     ; je lev zvorka ?
         jne       GetOper2                 ; nen lev zvorka
         call      Vyraz                    ; vpoet vrazu v zvorce
         jmp       short GetOper8

; ------ je unrn mnus

GetOper2:cmp       dl,10                    ; je unrn mnus ?
         jne       GetOper3                 ; nen unrn mnus
         call      GetOper                  ; vpoet hodnoty operandu
         jc        GetOper9                 ; nen platn operand
         neg       ax                       ; negace hodnoty
         jmp       short GetOper8           ; konec

; ------ je unrn NOT

GetOper3:cmp       dl,17                    ; je unrn NOT ?
         jne       GetOper5                 ; nen unrn NOT
         call      GetOper                  ; vpoet hodnoty operandu
         jc        GetOper9                 ; nen platn operand
         not       ax                       ; inverze kdu
         jmp       short GetOper8           ; konec

; ------ je seln konstanta

GetOper5:or        dl,dl                    ; je operand ?
         jns       GetOPer1                 ; nen operand (chyba kompiltoru)
         mov       ax,bx                    ; hodnota konstanty
         cmp       dl,81h                   ; je seln konstanta ?
         je        GetOper8                 ; je seln konstanta

; ------ je intern procedura

         cmp       dl,82h                   ; je intern procedura ?
         jne       GetOper6                 ; nen intern procedura
         mov       bh,0
         shl       bx,1                     ; slo funkce * 2
         call      word ptr ds:[TabFnc+bx]  ; vyvoln obsluhy funkce
         jmp       short GetOper8

; ------ je uivatelsk procedura

GetOper6:cmp       dl,83h                   ; je uivatelsk procedura ?
         jne       GetOper7                 ; nen uivatelsk procedura
         push      word ptr ds:[ProgUkaz]   ; schova ukazatele pogramu
         mov       word ptr ds:[ProgUkaz],bx; nov adresa programu (procedura)
         call      Anim                     ; proveden obsluhy procedury
         pop       word ptr ds:[ProgUkaz]   ; nvrat ukazatele programu
         jmp       short GetOper8

; ------ je promnn typu BYTE nebo WORD

GetOper7:push      ds
         mov       ds,ds:[DatMem]           ; datov segment programu
         mov       al,ds:[bx]               ; ni bajt
         mov       ah,ds:[bx+1]             ; vy bajt
         pop       ds
         test      dl,1                     ; m to bt bajt ?
         jnz       GetOper8                 ; je to slovo
         cbw                                ; pevod na slovo

; ------ nvrat z obsluhy

GetOper8:or        ax,ax
GetOper9:pop       dx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Zjitn typu (=DL) a adresy (= BX) promnn nebo opertoru (CY=konec)
; -----------------------------------------------------------------------------

PUBLIC   GetProm

GetProm: push      ax
         call      InpProg                  ; ten identifiktoru promnn
         mov       dl,al                    ; schova typu promnn

; ------ test, zda je konec vrazu

         cmp       dl,0                     ; je konec vrazu ?
         stc                                ; pznak konce vrazu
         je        GetProm3                 ; je konec vrazu

; ------ test, zda je operand (zda nsleduje argument)

GetProm1:cmp       dl,80h                   ; je to operand ?
         jb        GetProm2                 ; nen to operand

; ------ ten adresy promnn nebo procedury

         call      InpProg                  ; ten prvnho bajtu operandu
         mov       bl,al                    ; ni bajt operandu
         cmp       dl,82h                   ; je intern procedura ?
         je        GetProm2                 ; je intern procedura
         call      InpProg                  ; ten druhho bajtu operandu
         mov       bh,al                    ; vy bajt operandu

; ------ vpoet indexu indexovan promnn

         cmp       dl,86h                   ; je promnn s indexem ?
         jb        GetProm2                 ; nen indexovan promnn
         call      Vyraz                    ; vpoet indexu promnn
         add       bx,ax                    ; piten offsetu pro BYTE
         cmp       dl,87h                   ; je WORD ?
         jne       GetProm2                 ; nen WORD
         add       bx,ax                    ; pro WORD je index dvojnsobn

GetProm2:clc
GetProm3:pop       ax
         ret

; -----------------------------------------------------------------------------
;        ^ mocnina
; -----------------------------------------------------------------------------

PUBLIC   OpMoc
OpMoc:   xchg      ax,cx
         jcxz      OpMoc3                   ; umocnno na 0

         push      bx
         mov       bx,ax                    ; tmto slem se bude nsobit
OpMoc1:  dec       cx
         jcxz      OpMoc2
         mul       bx                       ; vynsoben
         jmp       short OpMoc1
OpMoc2:  pop       bx
         mov       cx,ax                    ; vsledek operace
         ret

OpMoc3:  mov       cx,1
         ret

; -----------------------------------------------------------------------------
;        * nsoben
; -----------------------------------------------------------------------------

PUBLIC   OpMul
OpMul:   push      dx
         imul      cx                       ; nsobek
         mov       cx,ax                    ; vsledek
         pop       dx
         ret

; -----------------------------------------------------------------------------
;        / dlen
; -----------------------------------------------------------------------------

PUBLIC   OpDiv
OpDiv:   xchg      ax,cx
         jcxz      OpDiv1                   ; byla by chyba dlen (peteen)
         push      dx
         cwd
         idiv      cx
         mov       cx,ax                    ; podl
         pop       dx
         ret

OpDiv1:  mov       cx,8000h                 ; peteen
         ret

; -----------------------------------------------------------------------------
;        MOD
; -----------------------------------------------------------------------------

PUBLIC   OpMod
OpMod:   xchg      ax,cx
         jcxz      OpMod1                   ; byla by chyba dlen (peteen)
         push      dx
         cwd
         idiv      cx
         mov       cx,dx                    ; zbytek
         pop       dx
         ret

OpMod1:  mov       cx,8000h                 ; peteen
         ret

; -----------------------------------------------------------------------------
;        <<
; -----------------------------------------------------------------------------

PUBLIC   OpShl
OpShl:   xchg      ax,cx
         cmp       cx,16
         jbe       OpShl1
         mov       cl,16
OpShl1:  shl       ax,cl
         mov       cx,ax
         ret

; -----------------------------------------------------------------------------
;        >>
; -----------------------------------------------------------------------------

PUBLIC   OpShr
OpShr:   xchg      ax,cx
         cmp       cx,16
         jbe       OpShr1
         mov       cl,16                    ; omezen potu rotac
OpShr1:  shr       ax,cl                    ; rotace o dan poet bit
         mov       cx,ax
         ret

; -----------------------------------------------------------------------------
;        +
; -----------------------------------------------------------------------------

PUBLIC   OpAdd
OpAdd:   add       cx,ax
         ret

; -----------------------------------------------------------------------------
;        -
; -----------------------------------------------------------------------------

PUBLIC   OpSub
OpSub:   sub       cx,ax
         ret

; -----------------------------------------------------------------------------
;        =
; -----------------------------------------------------------------------------

PUBLIC   OpEqu
OpEqu:   cmp       cx,ax
         mov       cx,-1
         je        OpEqu1
         xor       cx,cx
OpEqu1:  ret

; -----------------------------------------------------------------------------
;        <>
; -----------------------------------------------------------------------------

PUBLIC   OpNeq
OpNeq:   cmp       cx,ax
         mov       cx,-1
         jne       OpNeq1
         xor       cx,cx
OpNeq1:  ret

; -----------------------------------------------------------------------------
;        <
; -----------------------------------------------------------------------------

PUBLIC   OpLt
OpLt:    cmp       cx,ax
         mov       cx,-1
         jl        OpGt1
         xor       cx,cx
OpLt1:   ret

; -----------------------------------------------------------------------------
;        >
; -----------------------------------------------------------------------------

PUBLIC   OpGt
OpGt:    cmp       cx,ax
         mov       cx,-1
         jg        OpGt1
         xor       cx,cx
OpGt1:   ret

; -----------------------------------------------------------------------------
;        <=
; -----------------------------------------------------------------------------

PUBLIC   OpLte
OpLte:   cmp       cx,ax
         mov       cx,-1
         jle       OpLte1
         xor       cx,cx
OpLte1:  ret

; -----------------------------------------------------------------------------
;        >=
; -----------------------------------------------------------------------------

PUBLIC   OpGte
OpGte:   cmp       cx,ax
         mov       cx,-1                    ; podmnka splnna
         jge       OpGte1
         xor       cx,cx
OpGte1:  ret

; -----------------------------------------------------------------------------
;        NOT
; -----------------------------------------------------------------------------

PUBLIC   OpNot
OpNot:   not       ax
         mov       cx,ax
         ret

; -----------------------------------------------------------------------------
;        AND
; -----------------------------------------------------------------------------

PUBLIC   OpAnd
OpAnd:   and       cx,ax
         ret

; -----------------------------------------------------------------------------
;        OR
; -----------------------------------------------------------------------------

PUBLIC   OpOr
OpOr:    or        cx,ax
         ret

; -----------------------------------------------------------------------------
;        XOR
; -----------------------------------------------------------------------------

PUBLIC   OpXor
OpXor:   xor       cx,ax
         ret

; -----------------------------------------------------------------------------
;        ten slova z programu
; -----------------------------------------------------------------------------

PUBLIC   InpWord

InpWord: call      InpProg
         mov       ah,al
         call      InpProg
         xchg      ah,al
         ret

; -----------------------------------------------------------------------------
;        ten bajtu programu (ZY=je bajt 0)
; -----------------------------------------------------------------------------

PUBLIC   InpProg

InpProg: push      es
         push      di

         mov       es,cs:[ProgMem]          ; segment s natenm programem
         mov       di,cs:[ProgUkaz]         ; ukazatel programu
         mov       al,es:[di]               ; peten bajtu programu
         clc
         inc       word ptr cs:[ProgUkaz]   ; zven ukazatele programu
         or        al,al                    ; test, zda je 0
         pop       di
         pop       es
         ret

; -----------------------------------------------------------------------------
;        Nalezen objektu AX v pamti -> DX
; -----------------------------------------------------------------------------

PUBLIC   SrcObj

SrcObj:
         mov       dx,cs:[ObjMem]           ; segment s objekty

                                          ;* test, zda je jet dal objekt
SrcObj1: cmp       dx,cs:[TopMem]           ; dosaeno konce pamti ?
         cmc
         jc        SrcObj3                  ; objekt nenalezen

                                          ;* test, zda je to hledan objekt
SrcObj2: push      ds
         mov       ds,dx                    ; segment objektu
         cmp       ax,ds:[0]                ; je to hledan objekt ?
         pop       ds
         je        SrcObj3                  ; objekt nalezen

                                          ;* nastaven na dal objekt
         push      ds
         mov       ds,dx                    ; segment objektu
         add       dx,ds:[2]                ; zven adresy segmentu
         pop       ds
         jmp       short SrcObj1            ; test dalho objektu

SrcObj3:
         ret

; -----------------------------------------------------------------------------
;        Zruen objektu z pamti (DX=adresa objektu)
; -----------------------------------------------------------------------------

PUBLIC   DelObj

DelObj:  push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      ds
         push      es

         sti                                ; mus bt povoleno peruen
         cld                                ; smr nahoru
         mov       es,dx                    ; clov segment k pesunu
         mov       cx,es:[2]                ; velikost objektu
         add       dx,cx                    ; adresa dalho objektu
         mov       bx,cs:[TopMem]           ; konec pamti s objekty
         sub       cs:[TopMem],cx           ; snen konce pamti
         sub       bx,dx                    ; velikost zbytku dat
         jz        DelObj5                  ; nejsou dn data k pesunu
         mov       ds,dx                    ; zdrojov adresa pesunu
         jmp       short DelObj3

; ------ Penos dalho bloku dat

DelObj2: mov       cx,es                    ; clov segment
         add       cx,1000h                 ; zven o 1 segment 64 KB
         mov       es,cx                    ; nov clov segment
         mov       cx,ds                    ; zdrojov segment
         add       cx,1000h                 ; zven o 1 segment 64 KB
         mov       ds,cx                    ; nov zdrojov segment

; ------ Nastaven velikosti penenho bloku

DelObj3: mov       cx,1000h                 ; omezen na 64 KB
         cmp       bx,cx                    ; je blok vt ne 1 segment ?
         jae       DelObj4                  ; je velk segment
         mov       cx,bx                    ; velikost bloku v odstavcch
DelObj4: shl       cx,1
         shl       cx,1
         shl       cx,1                     ; pevod odstavc na slova

; ------ Penos jednoho bloku dat

         xor       si,si
         xor       di,di
         rep       movsw                    ; penos jednoho segmentu
         sub       bx,1000h                 ; je dal segment k penosu ?
         ja        DelObj2                  ; penos dalho segmentu

DelObj5: pop       es
         pop       ds
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Zobrazen objektu slo AX (pozice BX, linka DX)
; -----------------------------------------------------------------------------
; VSTUP: AX=slo objektu
;        BX=pozice
;        DX=linka
;        DS=datov segment
; -----------------------------------------------------------------------------
; 
PUBLIC   Objekt

; ------ schova registr

Objekt:  push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      ds
         push      es

; ------ nastaven ukazatele loklnch promnnch

         push      bp
         mov       bp,sp                    ; ukazatel promnnch v zsobnku
         sub       sp,28h                   ; rezerva pro lokln promnn

; ------ inicializace promnnch v zsobnku





; ------ nalezen zhlav objektu

         push      dx
         call      SrcObj                   ; nalezen adresy objektu
         mov       ds,dx                    ; segment objektu
         pop       dx
         jc        Objekt9                  ; objekt nenalezen

; ------ schova parametr objektu

Objekt0: push      cs
         pop       es                       ; ES <- CS
         mov       si,4                     ; adresa ky objektu
         mov       di,offset Sirka          ; buffer k schov parametr
         mov       cx,6                     ; dlka (slov)
         cld
         rep       movsw                    ; schova zhlav objektu

; ------ pprava ukazatel pro zobrazen objektu

         call      GetVRAM                  ; poskytnut adresy VRAM
         call      GetTabMod                ; adresa definice videomdu
         mov       ax,ds                    ; segment objektu
         inc       ax
         mov       ds,ax                    ; segment prvn roviny
         xor       si,si                    ; poten offset
         xor       ax,ax                    ; ta rovin

; ------ maskovn obrzku

         test      byte ptr cs:[Param],8    ; je maska obrzku ?
         jz        Objekt1                  ; nen maska

         mov       word ptr cs:[AdrMask+2],ds ; segment masky pozad (offset=0)

         call      word ptr cs:[bp+ModNext] ; nastaven adresy SI dal roviny

         push      ax
         push      dx
         mov       ax,si                    ; konen stav v bufferu
         shr       ax,1
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pepoet na odstavce
         mov       dx,ds                    ; souasn segment
         add       ax,dx                    ; nov segment
         mov       ds,ax                    ; nov segment
         and       si,0fh                   ; offset
         pop       dx
         pop       ax


                                          ;* zobrazen jedn barevn roviny
Objekt1: cld
         push      di                       ; schova adresy videostrnky
         push      si                       ; schova adresy obrzku
         mov       word ptr cs:[AdrMask],0  ; offset adresy masky

         call      word ptr cs:[bp+ModSet]  ; pprava pro zobrazen roviny

         mov       cx,cs:[bp+ModVys]        ; vka displeje
         sub       cx,dx                    ; maximln mon vka objektu
         cmp       cx,cs:[Vyska]            ; je vka objektu men ?
         jbe       Objekt11                 ; vka objektu nen men
         mov       cx,cs:[Vyska]            ; vka obrzku
Objekt11:jcxz      Objekt4                  ; vka obrzku = 0

                                          ;* zobrazen jedn linky
Objekt2: push      cx

         mov       cx,cs:[bp+ModSir]        ; ka displeje
         sub       cx,bx                    ; maximln mon ka objektu
         cmp       cx,cs:[Sirka]            ; je ka objektu men ?
         jbe       Objekt22                 ; ka objektu nen men
         mov       cx,cs:[Sirka]            ; ka obrzku
Objekt22:jcxz      Objekt3                  ; ka obrzku = 0
         call      word ptr cs:[bp+ModDisp] ; zobrazen jedn linky
Objekt3: pop       cx
         loop      Objekt2                  ; zobrazen dal linky

                                          ;* zven adresy pro dal rovinu
Objekt4: pop       si                       ; nvrat adresy obrzku
         pop       di                       ; nvrat adresy videostrnky

         call      word ptr cs:[bp+ModNext] ; nastaven adresy SI dal roviny

         test      byte ptr cs:[Param],4    ; je paraleln uloen barev ?
         jnz       Objekt9                  ; je paraleln uloen barev - konec

         push      ax
         push      dx
         mov       ax,si                    ; konen stav v bufferu
         shr       ax,1
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pepoet na odstavce
         mov       dx,ds                    ; souasn segment
         add       ax,dx                    ; nov segment
         mov       ds,ax                    ; nov segment
         and       si,0fh                   ; offset
         pop       dx
         pop       ax

         inc       ax                       ; zven sla roviny
         cmp       ax,cs:[Rovin]            ; jsou ji vechny roviny ?
         jb        Objekt1                  ; nejsou jet vechny roviny

; ------ nvrat registr

Objekt9: mov       sp,bp                    ; nvrat ukazatele zsobnku
         pop       bp                       ; nvrat BP

         pop       es
         pop       ds
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret


; -----------------------------------------------------------------------------
;        Poskytnut adresy tabulky videomdu
; -----------------------------------------------------------------------------

GetTabMod:
         push      ax
         push      dx

         xor       ax,ax
         mov       al,cs:[VMod]             ; aktuln videomd
         mov       bp,offset(TabMod0-TabMod); dlka jedn poloky tabulky
         mul       bp                       ; offset v tabulce
         add       ax,offset TabMod         ; tabulka parametr displeje
         mov       bp,ax                    ; adresa parametr displeje

         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Poskytnut adresy vstupn videostrnky ES:DI
; -----------------------------------------------------------------------------

GetVRAM:
         push      ax
         push      dx
         mov       ah,0
         mov       al,cs:[Page2]            ; vstupn videostrnka
         mul       word ptr cs:[DelVRAM]    ; vpoet offsetu videostrnky
         mov       di,ax                    ; offset adresy videostrnky
         mov       es,cs:[SegVRAM]          ; segment videopamti
         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Vymazn displeje v textovm mdu
; -----------------------------------------------------------------------------

PUBLIC   ClrTXT

ClrTxt:  push      ax
         push      cx
         push      dx
         push      di
         push      es

         call      GetVRAM                  ; poskytnut adresy videostrnky

                                          ;* uren dlky videostrnky
         push      ax
         mov       ax,cs:[bp+ModSir]        ; ka dku (znak)
         mul       word ptr cs:[bp+ModVys]  ; x vka = poet znak celkem
         mov       cx,ax                    ; celkov dlka videostrnky
         pop       ax

         shl       al,1
         shl       al,1
         shl       al,1
         shl       al,1                     ; posun barvy jako pozad
         mov       ah,al                    ; barva
         mov       al," "                   ; mazac znak - mezera

         cld
         rep       stosw                    ; vymazn obrazovky

         pop       es
         pop       di
         pop       dx
         pop       cx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Pprava textovho mdu
; -----------------------------------------------------------------------------

PUBLIC   SetTXT

SetTxt:  push      ax
         push      dx

         add       di,ax                    ; korekce pro poadovanou rovinu

         mov       ax,cs:[bp]               ; poet znak na dek
         mul       dx                       ; pevod dk na pozici
         add       ax,bx                    ; piten pozice na dku
         shl       ax,1                     ; poet bajt na dek
         add       di,ax                    ; adresa ve videopamti

         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v textovm mdu
; -----------------------------------------------------------------------------

PUBLIC   DispTXT

DispTXT: push      ax
         push      cx
         push      si
         push      di

DispTXT1:movsb
         inc       di
         loop      DispTXT1

         pop       di
         pop       si
         pop       cx
         pop       ax

         add       si,cs:[Sirka]
         add       di,cs:[bp]               ; piten potu znak na dek
         add       di,cs:[bp]               ; (adresa dal linky)
         ret

; -----------------------------------------------------------------------------
;        Nastaven adresy dal roviny textovho mdu
; -----------------------------------------------------------------------------

NextTXT: push      ax
         push      dx
         mov       ax,cs:[Vyska]            ; poet linek
         mul       word ptr cs:[Sirka]      ; poet bajt na rovinu
         add       si,ax                    ; adresa dal roviny
         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Vymazn displeje CGA
; -----------------------------------------------------------------------------

PUBLIC   ClrCGA
ClrCGA:  push      ax
         push      cx
         push      di
         push      es

         call      GetVRAM                  ; poskytnut adresy videostrnky

         cmp       byte ptr cs:[VMod],6
         jae       ClrCGA2

         and       al,3
         mov       cl,al
         shl       cl,1
         shl       cl,1
         or        cl,al
         shl       cl,1
         shl       cl,1
         shl       cl,1
         shl       cl,1
         or        al,cl
         jmp       short ClrCGA3

ClrCGA2: shr       al,1
         mov       al,0
         jnc       ClrCGA3
         dec       al

ClrCGA3: mov       cx,2000h
         mov       ah,al
         cld
         rep       stosw                    ; vymazn obrazovky

         pop       es
         pop       di
         pop       cx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Pprava mdu CGA
; -----------------------------------------------------------------------------

PUBLIC   SetCGA
SetCGA:
         push      ax
         push      bx
         push      dx

                                          ;* korekce pro videomd 4 nebo 5
         cmp       byte ptr cs:[VMod],6     ; je videomd 6 nebo vy ?
         jae       SetCGA1
         add       bx,bx                    ; zdvojnsoben pozice

                                          ;* pevod bitov pozice na bajtovou
SetCGA1: shr       bx,1
         shr       bx,1
         shr       bx,1

                                          ;* korekce pro lichou linku
         cmp       byte ptr cs:[VMod],17    ; je videomd 17 (MCGA) ?
         je        SetCGA2                  ; je videomd 17 (MCGA)
         shr       dx,1                     ; poet dk / 2
         jnc       SetCGA2                  ; je sud linka
         xor       di,2000h                 ; korekce pro lichou linku

                                          ;* vpoet adresy
SetCGA2: mov       ax,80                    ; poet bajt na dek
         mul       dx                       ; pevod dk na bajty
         add       ax,bx                    ; piten pozice na dku
         add       di,ax                    ; adresa ve videopamti

         pop       dx
         pop       bx
         pop       ax
         ret


; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu CGA
; -----------------------------------------------------------------------------

PUBLIC   DispCGA
DispCGA:
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di

         add       cx,3
         shr       cx,1
         shr       cx,1

         cmp       byte ptr cs:[VMod],6
         jb        DispCGA2

         inc       cx
         shr       cx,1

DispCGA2:
         rep       movsb

         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx

                                          ;* zven adresy v bufferu
         mov       ax,cs:[Sirka]            ; ka objektu
         add       ax,3                     ; zaokrouhlen na tveice bit
         shr       ax,1
         shr       ax,1                     ; ka / 4 (pro mdy 4 a 5)
         cmp       byte ptr cs:[VMod],6     ; je videomd 6 nebo 17 ?
         jb        DispCGA7                 ; nen videomd 6 ani 17
         inc       ax                       ; zaokrouhlen
         shr       ax,1                     ; ka / 8
DispCGA7:add       si,ax                    ; zven adresy v bufferu

                                          ;* zven adresy displeje
         cmp       byte ptr cs:[VMod],17    ; je videomd 17 (MCGA) ?
         je        DispCGA8                 ; je videomd 17 (MCGA)
         xor       di,2000h
         test      di,2000h                 ; je sud linka ?
         jnz       DispCGA9                 ; je lich linka
DispCGA8:add       di,80                    ; piten potu bajt na dek

DispCGA9:pop       ax
         ret

; -----------------------------------------------------------------------------
;        Adresa dal roviny CGA
; -----------------------------------------------------------------------------

NextCGA:
         ret

; -----------------------------------------------------------------------------
;        Vymazn displeje EGA
; -----------------------------------------------------------------------------

PUBLIC   ClrEGA
ClrEGA:
         push      ax
         push      bx
         push      cx
         push      dx
         push      bp
         push      si
         push      di
         push      es

         call      GetVRAM                  ; poskytnut adresy videostrnky
         call      GetTabMod                ; adresa tabulky videomdu

         mov       cx,cs:[DelVRAM]          ; dlka videostrnky (bajt)
         shr       cx,1                     ; dlka videostrnky (slov)
         mov       si,ax                    ; poadovan barva
         mov       bx,1                     ; ukazatel a ta rovin
         mov       dx,3c4h                  ; port pro nastaven barevn roviny
         cld

                                          ;* cyklus vymazn jedn roviny
ClrEGA1: push      di
         push      cx

                                          ;* nastaven barevn roviny
         mov       al,2
         out       dx,al                    ; registr 0 - volba barevn roviny
         inc       dx
         mov       al,bl                    ; maska roviny
         out       dx,al                    ; volba barevn roviny
         dec       dx

                                          ;* stanoven zpisovho vzorku
         xor       ax,ax                    ; rovina nebude nastavena
         shr       si,1                     ; je barevn rovina nastavena ?
         jnc       ClrEGA2                  ; rovina nebude nastavena
         dec       ax                       ; rovina bude nastavena

ClrEGA2: rep       stosw                    ; vymazn barevn roviny

         pop       cx
         pop       di

                                          ;* pprava pro dal rovinu
         shl       bl,1                     ; posun masky barevn roviny
         inc       bh                       ; zven tae rovin
         cmp       bh,cs:[bp+ModRov]        ; jsou ji vechny roviny ?
         jb        ClrEGA1                  ; vymazn dal roviny

         pop       es
         pop       di
         pop       si
         pop       bp
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Pprava mdu EGA
; -----------------------------------------------------------------------------
; 
PUBLIC   SetEGA
SetEGA:  push      ax
         push      bx
         push      cx
         push      dx

                                          ;* uren vstupn roviny
         mov       cl,al                    ; slo roviny
         mov       al,1
         shl       al,cl                    ; rotace na pozici
         mov       cl,al

                                          ;* pevod bitov pozice na bajtovou
         shr       bx,1
         shr       bx,1
         shr       bx,1

                                          ;* vpoet adresy
         mov       ax,40                    ; poet bajt na dek
         cmp       byte ptr cs:[VMod],13
         je        SetEGA1
         mov       ax,80
SetEGA1: mul       dx                       ; pevod linek na bajty
         add       ax,bx                    ; piten pozice na dku
         add       di,ax                    ; adresa ve videopamti

                                          ;* nastaven roviny pro vstup
         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; registr 0 - volba barevn roviny
         inc       dx
         mov       al,cl                    ; maska roviny
         out       dx,al                    ; volba barevn roviny

         mov       dx,3ceh
         mov       al,8
         out       dx,al
         inc       dx
         mov       al,0ffh
         out       dx,al

SetEGA2:
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu EGA
; -----------------------------------------------------------------------------
; VSTUP:
; -----------------------------------------------------------------------------

PUBLIC   DispEGA
DispEGA:

         cld

         shr       cx,1
         shr       cx,1
         shr       cx,1


         test      byte ptr cs:[Param],8    ; je maska ?
         jz        DispEGA4                 ; nen maska

         jcxz      DispEGA5

         mov       bx,word ptr cs:[AdrMask] ; offset adresy masky
         mov       bp,word ptr cs:[AdrMask+2] ; segment adresy masky

; ------ pprava registru masky

         mov       dx,3ceh
         mov       al,8
         out       dx,al
         inc       dx

; ------ zobrazen prvnho bajtu linky
                                            ; BX=adresa masky
                                            ; CL=poten bitov pozice
                                            ; DX=adresa portu masky (03cfh)
                                            ; SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         mov       ds,ObjMaskS              ; segment masky
         mov       al,ds:[bx]               ; maska
         and       al,ObjMaskF              ; zamaskovn prvnho bajtu
         shr       al,cl                    ; rotace na pozici
         out       dx,al                    ; nastaven masky pro zpis
         mov       ds,ObjZdrjS              ; segment roviny
         mov       al,ds:[si]               ; rovina
         shr       al,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy

; ------ zobrazen vnitnch bajt linky
                                            ; BX=adresa masky
                                            ; CL=rotace vpravo
                                            ; CH=poet bajt
                                            ; DX=adresa portu masky (03cfh)
                                            ; SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         or        ch,ch                    ; je njak vnitn bajt ?
         jz        DispEGA3                 ; nen dn vnitn bajt
DispEGA2:mov       ds,ObjMaskS              ; segment masky
         mov       ax,ds:[bx]               ; maska
         inc       bx                       ; zven ukazatele masky
         xchg      ah,al                    ; oprava bajt na pozice
         ror       ax,cl                    ; rotace na pozici
         out       dx,al                    ; nastaven masky pro zpis
         mov       ds,ObjZdrjS              ; segment roviny
         mov       ax,ds:[si]               ; rovina
         inc       si                       ; zven adresy roviny
         xchg      ah,al                    ; oprava bajt na pozice
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy
         dec       ch                       ; snen tae bajt
         jnz       DispEGA2                 ; zpis dalho bajtu


DispEGA3:





         jmp       short DispEGA5

DispEGA4:rep       movsb

DispEGA5:pop       dx
         pop       cx
         pop       bx
         pop       bp
         pop       di
         pop       si
         pop       ax

         add       di,40
         cmp       byte ptr cs:[VMod],13
         je        DispEGA8
         add       di,40

DispEGA8:push      ax
         mov       ax,cs:[Sirka]
         add       ax,7
         shr       ax,1
         shr       ax,1
         shr       ax,1
         add       si,ax
         add       word ptr cs:[AdrMask],ax ; zven adresy masky
         pop       ax


         pop       bp
         ret

; -----------------------------------------------------------------------------
;        Adresa dal roviny EGA
; -----------------------------------------------------------------------------

NextEGA: push      ax
         push      dx
         mov       ax,cs:[sirka]            ; poet bod
         add       ax,7
         shr       ax,1
         shr       ax,1
         shr       ax,1
         mul       word ptr cs:[Vyska]      ; vpoet offsetu
         add       si,ax                    ; adresa dal roviny

         mov       dx,3ceh
         mov       al,8
         out       dx,al
         inc       dx
         mov       al,0ffh
         out       dx,al

         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Vymazn displeje MCGA
; -----------------------------------------------------------------------------

ClrMCG:
         ret

; -----------------------------------------------------------------------------
;        Pprava mdu MCGA
; -----------------------------------------------------------------------------

SetMCG:

         ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu MCGA
; -----------------------------------------------------------------------------

DispMCG:
         ret

; -----------------------------------------------------------------------------
;        Adresa dal roviny MCGA
; -----------------------------------------------------------------------------

NextMCG:
         ret



ClrPCJ:
         ret

SetPCJ:
         ret

DispPCJ:
         ret

NextPCJ:
         ret




; 

; -----------------------------------------------------------------------------
;        NOP - dn funkce
; -----------------------------------------------------------------------------

PUBLIC   XNop
XNop:    xor       ax,ax
         ret

; -----------------------------------------------------------------------------
;        EXEC
; -----------------------------------------------------------------------------

PUBLIC   XExec
XExec:
         ret

; -----------------------------------------------------------------------------
;        IF
; -----------------------------------------------------------------------------

PUBLIC   XIf
XIf:     call      Vyraz                    ; vpoet vrazu
         mov       bx,ax                    ; schova hodnoty vrazu
         call      InpWord                  ; adresa, pokud podmnka nesplnna
         or        bx,bx                    ; je podmnka splnna ?
         jnz       XIf2                     ; podmnka je splnna - dle
         mov       word ptr ds:[ProgUkaz],ax ; jinak ELSE resp. ENDIF
XIf2:    ret

; -----------------------------------------------------------------------------
;        ELSE
; -----------------------------------------------------------------------------

PUBLIC   XElse
XElse:   call      InpWord                  ; adresa za ELSE
         mov       word ptr ds:[ProgUkaz],ax ; vtev s ELSE se pesko
         ret

; -----------------------------------------------------------------------------
;        FOR
; -----------------------------------------------------------------------------

PUBLIC   XFor
XFor:
         ret

; -----------------------------------------------------------------------------
;        ON
; -----------------------------------------------------------------------------

PUBLIC   XOn
XOn:     call      Vyraz                    ; vpoet vrazu
         mov       bx,ax                    ; schova hodnoty vrazu
         call      InpWord                  ; adresa, pokud podmnka nesplnna
         or        bx,bx                    ; je podmnka splnna ?
         jz        XOn2                     ; podmnka nesplnna - dle
         mov       word ptr ds:[ProgUkaz],ax ; jinak ENDDO
XOn2:    ret

; -----------------------------------------------------------------------------
;        ENDDO
; -----------------------------------------------------------------------------

PUBLIC   XEndDo
XEndDo:  call      InpWord                  ; adresa skoku na zatek cyklu
         mov       word ptr ds:[ProgUkaz],ax ; nepodmnn skok na DO
         ret

; -----------------------------------------------------------------------------
;        CASE
; -----------------------------------------------------------------------------

PUBLIC   XCase
XCase:   call      Vyraz                    ; testovan vraz
         mov       bx,ax                    ; testovan vraz

; ------ naten parametr vtve IN

XCase1:  call      InpProg                  ; ten bajtu IN
         cmp       al,21                    ; je kd IN ?
         jne       XCase5                   ; nen dal podmnka IN
         call      InpWord                  ; spodn mez intervalu
         mov       cx,ax                    ; spodn mez intervalu
         call      InpWord                  ; horn mez intervalu
         mov       dx,ax                    ; horn mez intervalu
         call      InpWord                  ; adresa pi nesplnn podmnce
         cmp       cx,dx                    ; je spodn mez pod horn ?
         ja        XCase2                   ; spodn mez je nad horn

; ------ porovnn bnho poad mez

         cmp       bx,cx                    ; porovnn se spodn mez intervalu
         jb        XCase4                   ; nen v intervalu
         cmp       bx,dx                    ; porovnn s horn mez intervalu
         ja        XCase4                   ; nen v intervalu
         jmp       short XCase8             ; podmnka splnna

; ------ porovnn obrcenho poad mez

XCase2:  cmp       bx,cx                    ; porovnn se spodn mez intervalu
         jae       XCase8                   ; je v intervalu
         cmp       bx,dx                    ; porovnn s horn mez intervalu
         jbe       XCase8                   ; je v intervalu

; ------ podmnka nesplnna - nastaven na dal vtev IN

XCase4:  mov       word ptr ds:[ProgUkaz],ax ; adresa dalho pkazu IN
         jmp       short XCase1             ; dal pkaz IN

; ------ ppadn peskoen povelu OUT

XCase5:  cmp       al,22                    ; je vtev OUT ?
         je        XCase6                   ; je vtev OUT
         dec       word ptr ds:[ProgUkaz]   ; nvrat kdu povelu
         jmp       short XCase8             ; pokraovn v programu
XCase6:  call      InpWord                  ; vyjmut adresy konce CASE
XCase8:  ret

; -----------------------------------------------------------------------------
;        IN
; -----------------------------------------------------------------------------

PUBLIC   XIn
XIn:     call      InpWord                  ; peskoen spodn meze
         call      InpWord                  ; peskoen horn meze
         call      InpWord                  ; adresa dalho pokraovn
         mov       ds:[ProgUkaz],ax         ; adresa pokraovn v programu
         ret

; -----------------------------------------------------------------------------
;        OUT
; -----------------------------------------------------------------------------

PUBLIC   XOut
XOut:    call      InpWord                  ; adresa dalho pokraovn
         mov       ds:[ProgUkaz],ax         ; adresa pokraovn v programu
         ret

; -----------------------------------------------------------------------------
;        VAL
; -----------------------------------------------------------------------------

PUBLIC   XVal
XVal:
         ret

; -----------------------------------------------------------------------------
;        STR
; -----------------------------------------------------------------------------

PUBLIC   XStr
XStr:
         ret

; -----------------------------------------------------------------------------
;        LEN
; -----------------------------------------------------------------------------

PUBLIC   XLen
XLen:
         ret

; -----------------------------------------------------------------------------
;        CARD
; -----------------------------------------------------------------------------

PUBLIC   XCard
XCard:
         mov       ah,0
         mov       al,ds:[EgaVga]           ; pznak karty EGA/VGA
         ret

; -----------------------------------------------------------------------------
;        VIDEO
; -----------------------------------------------------------------------------

PUBLIC   XVideo
XVideo:

; ------ nastaven poadovanho videomdu

         call      Vyraz                    ; ten sla videomdu
         jc        XVideo1                  ; nem se nastavit
         mov       ah,0                     ; funkce nastaven videomdu
         call      Int10                    ; nastaven videomdu
XVideo1: mov       ah,0fh                   ; funkce poskytnut videomdu
         call      Int10                    ; poskytnut videomdu
         mov       ds:[VMod],al             ; schova videomdu

; ------ stanoven adresy videostrnky

         mov       bx,0b800h
         cmp       al,7
         jb        XVideo2
         mov       bh,0b0h
         cmp       al,13
         jb        XVideo2
         mov       bh,0a0h
XVideo2: mov       ds:[SegVRAM],bx          ; segment videopamti

; ------ stanoven dlky videostrnky

         push      ds
         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[44ch]             ; dlka videostrnky
         pop       ds
         mov       ds:[DelVRAM],ax          ; dlka videostrnky

; ------ nastaven aktivn videostrnky

         mov       al,ds:[Page1]            ; aktivn videostrnka
         mov       bh,al
         mov       ah,5
         call      Int10                    ; nastaven aktivn strnky displeje

; ------ nastaven pvodn pozice kurzoru

         mov       dx,ds:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
         call      Int10                    ; nastaven pvodn pozice kurzoru

; ------ stanoven nvratovho kdu (slo videomdu)

         mov       ah,0
         mov       al,ds:[VMod]             ; aktuln videomd
         ret

; -----------------------------------------------------------------------------
;        MODE
; -----------------------------------------------------------------------------

PUBLIC   XMode
XMode:
         call      Vyraz                    ; zjitn mdu displeje
         jc        XMode8                   ; nepoaduje se nastaven
         mov       ds:[BitDisp],ax          ; pznakov bity

         cmp       byte ptr ds:[VMod],4
         je        XMode1
         cmp       byte ptr ds:[VMod],5
         jne       XMode3
XMode1:  mov       ah,0bh
         mov       bh,1
         mov       bl,al
         call      Int10
         jmp       short XMode8


XMode3:

XMode8:  mov       ax,ds:[BitDisp]
         ret

; -----------------------------------------------------------------------------
;        PAGE
; -----------------------------------------------------------------------------

PUBLIC   XPage
XPage:

; ------ zjitn sel novch videostrnek

         call      Vyraz                    ; ten slova
         jc        XPage1                   ; nenastavuje se
         mov       byte ptr ds:[Page1],al   ; aktivn videostrnka
XPage1:  call      Vyraz
         jc        XPage2                   ; nenastavuje se
         mov       byte ptr ds:[Page2],al   ; vstupn videostrnka

; ------ nastaven nov aktivn videostrnky

XPage2:  mov       al,ds:[Page1]
         mov       bh,al
         mov       ah,5
         call      Int10                    ; nastaven aktivn strnky displeje

; ------ nastaven pvodn pozice kurzoru

         mov       dx,ds:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
         call      Int10                    ; nastaven pvodn pozice kurzoru

; ------ navrcen aktivn videostrnky

         mov       ah,0
         mov       al,ds:[Page1]            ; aktivn videostrnka
         ret

; -----------------------------------------------------------------------------
;        XPAGE
; -----------------------------------------------------------------------------

PUBLIC   XXPage
XXPage:

; ------ zmna videostrnek

         mov       ax,word ptr ds:[Page1]
         xchg      ah,al                    ; zmna videostrnek
         mov       word ptr ds:[Page1],ax

; ------ nastaven nov aktivn videostrnky

         mov       al,ds:[Page1]
         mov       bh,al
         mov       ah,5
         call      Int10                    ; nastaven aktivn strnky displeje

; ------ nastaven pvodn pozice kurzoru

         mov       dx,ds:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
         call      Int10                    ; nastaven pvodn pozice kurzoru

; ------ navrcen vstupn videostrnky

         mov       ah,0
         mov       al,ds:[Page2]            ; vstupn videostrnka
         ret

; -----------------------------------------------------------------------------
;        WINDOW
; -----------------------------------------------------------------------------

PUBLIC   XWind
XWind:   mov       di,offset Wind1          ; lev okraj okna
         mov       cx,4                     ; poet parametr
XWind1:  call      Vyraz                    ; parametr - rozmr okna
         jc        XWind2                   ; parametr se nenastavuje
         mov       ds:[di],ax               ; nastaven parametru
XWind2:  add       di,2                     ; zven adresy
         loop      XWind1                   ; dal parametr
         mov       ax,ds:[Wind1]            ; lev pozice
         ret

; -----------------------------------------------------------------------------
;        PALETE
; -----------------------------------------------------------------------------

PUBLIC   XPal
XPal:
         mov       di,offset TabPal         ; tabulka palet
         mov       cx,17                    ; poet palet v definici

; ------ vpoet hodnot paletovch registr

XPal1:   call      Vyraz                    ; ten hodnoty registru
         jc        XPal2                    ; hodnota se nemn
         mov       ds:[di],al               ; definice palety
XPal2:   inc       di
         loop      XPal1                    ; dal registr

; ------ pprava registr pro pedefinovn palet

         mov       si,offset TabPal         ; ukazatel tabulky palet
         mov       cx,16                    ; poet palet k pedefinovn
         mov       ah,0                     ; slo registru 0
         cld                                ; smr nahoru
         push      ds
         xor       dx,dx
         mov       ds,dx
         mov       dx,ds:[463h]             ; adresa dicho registru CRT
         pop       ds
         add       dx,6                     ; stavov registr CRT

; ------ synchronizace na zatek vertiklnho synchronizanho impulsu

XPal4:   in        al,dx
         test      al,8
         jnz       XPal4                   ; ekn na konec synchroimpulsu
XPal5:   in        al,dx
         test      al,8
         jz        XPal5                   ; ekn na zatek synchoimpulsu

; ------ definice vech paletovch registr

         mov       dx,3c0h                  ; adresa portu adie
XPal6:   mov       al,ah                    ; slo registru
         out       dx,al                    ; nastaven sla registru
         lodsb                              ; poadovan paleta registru
         out       dx,al                    ; definice palety
         inc       ah                       ; zven sla registru
         loop      XPal6                   ; definice dalho registru

; ------ pedefinovn paletovho registru pozad

         mov       al,11h                   ; slo registru palety pozad
         out       dx,al                    ; nastaven sla registru
         lodsb                              ; poadovan paleta registru
         out       dx,al                    ; definice palety registru pozad

; ------ optovn zapnut videosignlu

         mov       al,20h                   ; ukonovac bajt
         out       dx,al                    ; zapnut videosignlu
         ret

; -----------------------------------------------------------------------------
;        XCOLOR
; -----------------------------------------------------------------------------

PUBLIC   XXCol
XXCol:
         ret

; -----------------------------------------------------------------------------
;        SETCURS
; -----------------------------------------------------------------------------

PUBLIC   XSetCur
XSetCur:
         call      Vyraz                    ; pozice kurzoru
         jc        XSetCur1
         mov       byte ptr ds:[KurzPoz],al ; pozice
XSetCur1:call      Vyraz                    ; dek kurzoru
         jc        XSetCur2
         mov       byte ptr ds:[KurzPoz+1],al ; dek

XSetCur2:mov       dx,ds:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
         mov       bh,ds:[Page1]
         call      Int10                    ; nastaven pvodn pozice kurzoru

         mov       ah,0
         mov       al,byte ptr ds:[KurzPoz] ; souasn pozice
         ret

; -----------------------------------------------------------------------------
;        CURSOFF
; -----------------------------------------------------------------------------

PUBLIC   XCurOff
XCurOff:
         mov       dh,ds:[MaxRad]           ; maximln poet dk
         mov       dl,0
         mov       ah,2
         mov       bh,ds:[Page1]
         call      Int10
         mov       ah,0
         mov       al,ds:[MaxRad]           ; dek, na kterm je kurzor
         ret

; -----------------------------------------------------------------------------
;        LOAD
; -----------------------------------------------------------------------------

PUBLIC   XLoad
XLoad:

; ------ pokud objekt existuje, jeho zruen

         call      InpWord                  ; ten sla objektu
         call      SrcObj                   ; nalezen objektu v pamti
         jc        XLoad1                   ; objekt nen v pamti
         call      DelObj                   ; zruen objektu DX z pamti

; ------ oteven poadovanho souboru

XLoad1:  mov       si,ax                    ; schova sla objektu
         push      ds
         mov       dx,ds:[ProgUkaz]         ; ukazatel na jmno programu
         mov       ds,ds:[ProgMem]          ; segment s programem
         mov       ax,3d00h
         int       21h                      ; oteven souboru
         pop       ds
         mov       bx,ax                    ; identifiktor souboru
         jnc       XLoad6                   ; soubor oteven OK

; ------ chyba - soubor nenalezen

         mov       al,ds:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

         mov       dx,offset FndTxt         ; text - "Soubor"
         mov       ah,9
         int       21h                      ; zobrazen prvn sti hlen

XLoad2:  call      InpProg                  ; ten znaku
         or        al,al
         jz        XLoad3                   ; konec textu
         mov       dl,al
         mov       ah,2
         int       21h                      ; zobrazen znaku jmna souboru
         jmp       short XLoad2

XLoad3:  mov       dx,offset Fnd2Txt        ; text "nenalezen"
XLoad4:  mov       ah,9
         int       21h                      ; zobrazen zbytku hlen

         jmp       Prerus2                  ; nvrat z programu

; ------ chyba - nedostatek pamti

XLoad5:  mov       al,ds:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

         mov       dx,offset MemTxt         ; text - nedostatek pamti
         jmp       short XLoad4

; ------ zjitn volnho msta pro jeden blok

XLoad6:  mov       dx,ds:[TopMem]           ; adresa k naten bloku
XLoad7:  mov       cx,ss                    ; konec pamti
         add       cx,0f00h                 ; rezerva pro zsobnk 4 KB
         sub       cx,ds:[TopMem]           ; voln prostor v pamti
         jbe       XLoad5                   ; nen voln pam
         cmp       cx,0f00h                 ; je blok vt ne 0f000h bajt ?
         jbe       XLoad8                   ; nen vt
         mov       cx,0f00h                 ; omezen na 0f000h bajt

; ------ naten jednoho bloku ze souboru

XLoad8:  shl       cx,1
         shl       cx,1
         shl       cx,1
         shl       cx,1                     ; pevod na bajty
         push      ds
         push      dx
         mov       ds,dx                    ; segment k naten bloku souboru
         xor       dx,dx                    ; offset ke ten souboru
         mov       ah,3fh
         int       21h                      ; naten bloku ze souboru
         pop       dx
         pop       ds
         jc        XLoada                   ; chyba ten - konec

; ------ zven adresy segmentu

         cmp       ax,cx                    ; navrceno vce bajt ne bylo ?
         jbe       XLoad9                   ; daj je OK
         mov       ax,cx                    ; omezen na poadovan bajty
XLoad9:  add       ax,15                    ; zaokrouhlen
         shr       ax,1
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pevod na odstavce
         add       dx,ax                    ; zven segmentu
         or        ax,ax                    ; bylo nco nateno ?
         jnz       XLoad7                   ; bylo nco nateno - dal

; ------ inicializace ukazatel objektu a pamti

XLoada:  mov       ax,dx                    ; segment konce dat
         sub       ax,ds:[TopMem]           ; velikost novho bloku
         push      ds
         mov       ds,ds:[TopMem]           ; zatek novho bloku
         mov       ds:[0],si                ; slo objektu
         mov       ds:[2],ax                ; velikost bloku
         pop       ds
         mov       ds:[TopMem],dx           ; nov konec pamti

; ------ uzaven souboru

         mov       ah,3eh
         int       21h                      ; uzaven souboru

; ------ nalezen konce textu v programu

XLoadb:  call      InpProg                  ; ten znaku
         or        al,al
         jnz       XLoadb                   ; nen konec textu - dal znak
         ret

; -----------------------------------------------------------------------------
;        OBJECT
; -----------------------------------------------------------------------------

PUBLIC   XObj
XObj:    call      InpWord                  ; slo objektu
         push      ax                       ; schova sla objektu
         call      Vyraz                    ; ten slova - pozice X
         mov       bx,ax                    ; pozice X
         call      Vyraz                    ; ten slova - linka Y
         mov       dx,ax                    ; linka Y
         pop       ax                       ; slo objektu
         call      Objekt                   ; zobrazen objektu
         ret

; -----------------------------------------------------------------------------
;        UNLOAD
; -----------------------------------------------------------------------------

PUBLIC   XUnld
XUnld:
         call      InpWord                  ; ten sla objektu
         call      SrcObj                   ; nalezen objektu v pamti
         jc        XUnld2                   ; objekt nen v pamti
         call      DelObj                   ; zruen objektu DX z pamti
XUnld2:  ret

; -----------------------------------------------------------------------------
;        DISP
; -----------------------------------------------------------------------------

PUBLIC   XDisp
XDisp:
         call      Vyraz                    ; souadnice X
         mov       dl,al                    ; souadnice X
         call      Vyraz                    ; souadnice Y
         mov       dh,al                    ; souadnice Y
         call      Vyraz                    ; barva textu
         mov       bl,al                    ; barva

; ------ nastaven pozice kurzoru

XDisp1:  push      dx
         push      bx
         mov       ah,2
         mov       bh,ds:[Page2]            ; vstupn strnka
         int       10h                      ; nastaven pozice kurzoru
         pop       bx
         pop       dx

; ------ zobrazen jednoho znaku

         call      InpProg                  ; ten dalho znaku
         jz        XDisp2                   ; konec textu
         push      dx
         push      bx
         mov       ah,9
         mov       cx,1
         int       10h                      ; zobrazen znaku
         pop       bx
         pop       dx

; ------ zven pozice kurzoru

         inc       dl                       ; zven pozice na dku
         cmp       dl,ds:[MaxPoz]           ; dosaeno maximln pozice ?
         jb        XDisp1                   ; nen jet maximln pozice
         xor       dl,dl                    ; pozice 0
         inc       dh                       ; zven sla dku
         jmp       short XDisp1             ; zobrazen dalho znaku

XDisp2:  ret

; -----------------------------------------------------------------------------
;        POINT
; -----------------------------------------------------------------------------

PUBLIC   XPoint
XPoint:
         ret

; -----------------------------------------------------------------------------
;        LINE
; -----------------------------------------------------------------------------

PUBLIC   XLine
XLine:
         ret

; -----------------------------------------------------------------------------
;        RLINE
; -----------------------------------------------------------------------------

PUBLIC   XRLine
XRLine:
         ret

; -----------------------------------------------------------------------------
;        BOX
; -----------------------------------------------------------------------------

PUBLIC   XBox
XBox:
         ret

; -----------------------------------------------------------------------------
;        FBOX
; -----------------------------------------------------------------------------

PUBLIC   XFBox
XFBox:
         call      InpWord                  ; ten slova - barva
         call      GetTabMod                ; poskytnut tabulky videomdu
         call      word ptr cs:[bp+ModCLR]  ; vymazn displeje zadanou barvou

         ret

; -----------------------------------------------------------------------------
;        CIRC
; -----------------------------------------------------------------------------

PUBLIC   XCirc
XCirc:
         ret

; -----------------------------------------------------------------------------
;        FCIRC
; -----------------------------------------------------------------------------

PUBLIC   XFCirc
XFCirc:
         ret

; -----------------------------------------------------------------------------
;        PRESS
; -----------------------------------------------------------------------------

PUBLIC   XPress
XPress:

         ret

; -----------------------------------------------------------------------------
;        TESTKEY
; -----------------------------------------------------------------------------

PUBLIC   XTstKey
XTstKey:
         mov       ah,1
         int       16h                      ; test stavu klvesnice
         jnz       XTstKey1                 ; je pipraven njak znak
         xor       ax,ax                    ; nen dn znak
XTstKey1:ret

; -----------------------------------------------------------------------------
;        GETKEY
; -----------------------------------------------------------------------------

PUBLIC   XGtKey
XGtKey:
         xor       ax,ax
         int       16h                      ; vstup znaku z klvesnice
         ret

; -----------------------------------------------------------------------------
;        FLUSHKEY
; -----------------------------------------------------------------------------

PUBLIC   XFlush
XFlush:  call      XTstKey                  ; test stavu klvesnice
         jz        XFlush2                  ; nen dal znak
         call      XGtKey                   ; zruen znaku
         jmp       short XFlush             ; dal znak
XFlush2: ret

; -----------------------------------------------------------------------------
;        INPUT
; -----------------------------------------------------------------------------

PUBLIC   XInp
XInp:
         ret

; -----------------------------------------------------------------------------
;        SOUND
; -----------------------------------------------------------------------------

PUBLIC   XSound
XSound:
         call      Vyraz                    ; ten slova
         or        ax,ax                    ; vypnut genertoru ?
         jnz       Sound2                   ; nen vypnut genertoru

         in        al,[61h]
         and       al,not 3
         out       [61h],al                 ; vypnut genertoru
         ret


Sound2:  mov       bx,ax
         mov       al,0b6h
         out       [43h],al
         mov       al,bl
         out       [42h],al
         mov       al,bh
         out       [42h],al
         in        al,[61h]
         or        al,3
         out       [61h],al

         ret

; -----------------------------------------------------------------------------
;        TON
; -----------------------------------------------------------------------------

PUBLIC   XTon
XTon:
         ret

; -----------------------------------------------------------------------------
;        MUSIC
; -----------------------------------------------------------------------------

PUBLIC   XMusic
XMusic:
         ret

; -----------------------------------------------------------------------------
;        MUSICSTOP
; -----------------------------------------------------------------------------

PUBLIC   XMStop
XMStop:
         ret

; -----------------------------------------------------------------------------
;        MUSICGET
; -----------------------------------------------------------------------------

PUBLIC   XMusGet
XMusGet:
         ret

; -----------------------------------------------------------------------------
;        WAIT
; -----------------------------------------------------------------------------

PUBLIC   XWait
XWait:
         call      Vyraz                    ; ten slova
         sti                                ; povolen peruen
XWait1:  cmp       word ptr cs:[Citac],ax
         jb        XWait1                   ; nen jet dosaen as
         mov       word ptr cs:[Citac],0    ; inicializace tae
         ret

; -----------------------------------------------------------------------------
;        TIME
; -----------------------------------------------------------------------------

PUBLIC   XTime
XTime:
         ret

; -----------------------------------------------------------------------------
;        DATE
; -----------------------------------------------------------------------------

PUBLIC   XDate
XDate:
         ret

; -----------------------------------------------------------------------------
;        XMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XXMous
XXMous:
         ret

; -----------------------------------------------------------------------------
;        YMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XYMous
XYMous:
         ret

; -----------------------------------------------------------------------------
;        GETMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XKMous
XKMous:
         ret

; -----------------------------------------------------------------------------
;        MOUSEON
; -----------------------------------------------------------------------------

PUBLIC   XMon
XMon:
         ret

; -----------------------------------------------------------------------------
;        MOUSEOFF
; -----------------------------------------------------------------------------

PUBLIC   XMoff
XMoff:
         ret

; -----------------------------------------------------------------------------
;        CURMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XDefm
XDefm:
         ret

; -----------------------------------------------------------------------------
;        WINMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XWinm
XWinm:
         ret

; -----------------------------------------------------------------------------
;        RND
; -----------------------------------------------------------------------------

PUBLIC   XRnd
XRnd:    call      Vyraz                    ; poadovan interval
         mov       bx,ax                    ; interval
         or        ax,ax
         jz        XRnd2

         mov       ax,word ptr ds:[RandNum]
         mov       si,word ptr ds:[RandNum+2]
         rol       ax,1
         rol       si,1
         xor       ax,ss:[si]
         xor       si,ax
         mov       word ptr ds:[RandNum],ax
         mov       word ptr ds:[RandNum+2],si

         xor       dx,dx
         div       bx
         mov       ax,dx

XRnd2:   or        ax,ax
         ret

RandNum  dd        0



; -----------------------------------------------------------------------------
;        BYTE
; -----------------------------------------------------------------------------

PUBLIC   XUsrByte
XUsrByte:call      InpWord                  ; adresa promnn
         mov       bx,ax                    ; adresa promnn
         call      Vyraz                    ; vpoet vrazu
         push      ds
         mov       ds,ds:[DatMem]
         mov       ds:[bx],al               ; nastaven promnn BYTE
         pop       ds
         ret

; -----------------------------------------------------------------------------
;        WORD
; -----------------------------------------------------------------------------

PUBLIC   XUsrWord
XUsrWord:call      InpWord                  ; adresa promnn
         mov       bx,ax                    ; adresa promnn
         call      Vyraz                    ; vpoet vrazu
         push      ds
         mov       ds,ds:[DatMem]
         mov       ds:[bx],ax               ; nastaven promnn WORD
         pop       ds
         ret

; -----------------------------------------------------------------------------
;        BYTE index
; -----------------------------------------------------------------------------

PUBLIC   XUsrBytI
XUsrBytI:call      InpWord                  ; adresa promnn
         mov       bx,ax                    ; adresa promnn
         call      Vyraz                    ; vpoet indexu
         add       bx,ax                    ; adresa promnn
         push      ds
         mov       ds,ds:[DatMem]
         mov       ds:[bx],al               ; nastaven promnn BYTE
         pop       ds
         ret

; -----------------------------------------------------------------------------
;        WORD index
; -----------------------------------------------------------------------------

PUBLIC   XUsrWorI
XUsrWorI:call      InpWord                  ; adresa promnn
         mov       bx,ax                    ; adresa promnn
         call      Vyraz                    ; vpoet vrazu
         add       bx,ax
         add       bx,ax                    ; skuten adresa promnn
         push      ds
         mov       ds,ds:[DatMem]
         mov       ds:[bx],ax               ; nastaven promnn WORD
         pop       ds
         ret

; *****************************************************************************
;
;                          Obsluhy funkc BIOS
;
; *****************************************************************************

PUBLIC   Int10
Int10:   pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es
         int       10h
         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret




; *****************************************************************************
;
;                         Datov segment
;
; *****************************************************************************

TabOper  label     word                   ;* tabulka obsluh opertor

         dw        offset XNop              ; 0:
         dw        offset XNop              ; 1: (
         dw        offset XNop              ; 2: )
         dw        offset OpMoc             ; 3: ^
         dw        offset OpMul             ; 4: *
         dw        offset OpDiv             ; 5: /
         dw        offset OpMod             ; 6: MOD
         dw        offset OpShl             ; 7: <<
         dw        offset OpShr             ; 8: >>
         dw        offset OpAdd             ; 9: +
         dw        offset OpSub             ; 10: -
         dw        offset OpEqu             ; 11: =
         dw        offset OpNeq             ; 12: <>
         dw        offset OpLt              ; 13: <
         dw        offset OpGt              ; 14: >
         dw        offset OpLte             ; 15: <=
         dw        offset OpGte             ; 16: >=
         dw        offset OpNot             ; 17: NOT
         dw        offset OpAnd             ; 18: AND
         dw        offset OpOr              ; 19: OR
         dw        offset OpXor             ; 20: XOR


TabFnc   label     word                   ;* tabulka internch funkc

         dw        offset XNop              ; 0   (LINK)
         dw        offset XNop              ; 1   (INCLUDE)
         dw        offset XNop              ; 2   (BYTE)
         dw        offset XNop              ; 3   (WORD)
         dw        offset XNop              ; 4   (STRING)
         dw        offset XNop              ; 5   (PROC)
         dw        offset XNop              ; 6 ENDPROC
         dw        offset XNop              ; 7 RETURN
         dw        offset XExec             ; 8 EXEC
         dw        offset XIf               ; 9 IF
         dw        offset XNop              ; 10   (THEN)
         dw        offset XElse             ; 11   ELSE
         dw        offset XNop              ; 12   (ENDIF)
         dw        offset XFor              ; 13 FOR
         dw        offset XNop              ; 14   (TO)
         dw        offset XNop              ; 15   (STEP)
         dw        offset XNop              ; 16   (DO)
         dw        offset XOn               ; 17 ON
         dw        offset XEndDo            ; 18 ENDDO
         dw        offset XNop              ; 19   (EXIT)
         dw        offset XCase             ; 20 CASE
         dw        offset XIn               ; 21 IN
         dw        offset XOut              ; 22 OUT
         dw        offset XNop              ; 23   (ENDCASE)
         dw        offset XVal              ; 24 VAL
         dw        offset XStr              ; 25 STR
         dw        offset XLen              ; 26 LEN
         dw        offset XCard             ; 27 CARD
         dw        offset XVideo            ; 28 VIDEO
         dw        offset XNop              ; 29   (GVIDEO)
         dw        offset XMode             ; 30 MODE
         dw        offset XPage             ; 31 PAGE
         dw        offset XXPage            ; 32 XPAGE
         dw        offset XWind             ; 33 WINDOW
         dw        offset XPal              ; 34 PALETE
         dw        offset XXCol             ; 35 XCOLOR
         dw        offset XSetCur           ; 36 SETCURS
         dw        offset XCurOff           ; 37 CURSOFF
         dw        offset XLoad             ; 38 LOAD
         dw        offset XObj              ; 39 OBJECT
         dw        offset XUnld             ; 40 UNLOAD
         dw        offset XDisp             ; 41 DISP
         dw        offset XPoint            ; 42 POINT
         dw        offset XLine             ; 43 LINE
         dw        offset XRLine            ; 44 RLINE
         dw        offset XBox              ; 45 BOX
         dw        offset XFBox             ; 46 FBOX
         dw        offset XCirc             ; 47 CIRC
         dw        offset XFCirc            ; 48 FCIRC
         dw        offset XPress            ; 49 PRESS
         dw        offset XTstKey           ; 50 TESTKEY
         dw        offset XGtKey            ; 51 GETKEY
         dw        offset XFlush            ; 52 FLUSHKEY
         dw        offset XInp              ; 53 INPUT
         dw        offset XSound            ; 54 SOUND
         dw        offset XTon              ; 55 TON
         dw        offset XMusic            ; 56 MUSIC
         dw        offset XMStop            ; 57 MUSICSTOP
         dw        offset XMusGet           ; 58 MUSICGET
         dw        offset XWait             ; 59 WAIT
         dw        offset XTime             ; 60 TIME
         dw        offset XDate             ; 61 DATE
         dw        offset XXMous            ; 62 XMOUSE
         dw        offset XYMous            ; 63 YMOUSE
         dw        offset XKMous            ; 64 GETMOUSE
         dw        offset XMon              ; 65 MOUSEON
         dw        offset XMoff             ; 66 MOUSEOFF
         dw        offset XDefm             ; 67 CURMOUSE
         dw        offset XWinm             ; 68 WINMOUSE
         dw        offset XRnd              ; 69 XRND

         dw        0f8h - 69 - 1 dup(offset XNop)

         dw        offset XUsrByte          ; f8h BYTE
         dw        offset XUsrWord          ; f9h WORD
         dw        offset XUsrBytI          ; fah BYTE index
         dw        offset XUsrWorI          ; fbh WORD index

         dw        3 dup(offset XNop)

         dw        offset XNop              ; ffh uivatelsk procedura



; Struktura objekt:
;                     0 (2) = slo objektu
;                     2 (2) = velikost bloku pamti (v odstavcch)
;                     4 (2) = rozmry X
;                     6 (2) = rozmry Y
;                     8 (2) = poet barevnch rovin
;                    10 (2) = barva pozad
;                    12 (2) = poet bajt definice palet
;                    14 (1) = videomd
;                    15 (1) = parametry
;                                bit 0: 1=komprese
;                                bit 1: 1=textov md
;                                bit 2: 1=paraleln uloen barev
;                    10h    = data

ModSir   EQU       0                        ; ka dku (bod)
ModVys   EQU       2                        ; poet linek celkem
ModSirB  EQU       4                        ; poet bajt na linku
ModRov   EQU       4                        ; poet barevnch rovin
ModCLR   EQU       6                        ; obsluha vymazn displeje
ModSet   EQU       8                        ; nastaven parametr pro zobrazen
ModDisp  EQU       10                       ; obsluha zobrazen linky
ModNext  EQU       12                       ; nastaven adresy dal roviny

TabMod   label     word                   ;* tabulka videomd

                                          ;* 0: 40x25 text
         dw        40                       ; ka (jednotek)
         dw        25                       ; vka (linek)
         dw        2                        ; poet barevnch rovin
         dw        offset ClrTXT            ; vymazn nastavenou barvou
         dw        offset SetTXT            ; nastaven parametr pro zobrazen
         dw        offset DispTxt           ; zobrazen linky
         dw        offset NextTxt           ; nastaven adresy dal roviny

TabMod0  label     word                     ; nvt pro vpoet dlky poloky

                                          ;* 1: 40x25 text
         dw        40,25,2
         dw        offset ClrTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset NextTXT

                                          ;* 2: 80x25 text
         dw        80,25,2
         dw        offset ClrTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset NextTXT

                                          ;* 3: 80x25 text
         dw        80,25,2
         dw        offset ClrTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset NextTXT

                                          ;* 4: 320x200/4 graf
         dw        320,200,2
         dw        offset ClrCGA
         dw        offset SetCGA
         dw        offset DispCGA
         dw        offset NextCGA

                                          ;* 5: 320x200/4 graf
         dw        320,200,2
         dw        offset ClrCGA
         dw        offset SetCGA
         dw        offset DispCGA
         dw        offset NextCGA

                                          ;* 6: 640x200/2 graf
         dw        640,200,1
         dw        offset ClrCGA
         dw        offset SetCGA
         dw        offset DispCGA
         dw        offset NextCGA

                                          ;* 7: 80x25 text
         dw        80,25,2
         dw        offset ClrTXT
         dw        offset SetTXT
         dw        offset DispTXT
         dw        offset NextTXT

                                          ;* 8: 160x200/16 graf.
         dw        160,200,4
         dw        offset ClrPCJ
         dw        offset SetPCJ
         dw        offset DispPCJ
         dw        offset NextPCJ

                                          ;* 9: 320x200/16 graf.
         dw        320,200,4
         dw        offset ClrPCJ
         dw        offset SetPCJ
         dw        offset DispPCJ
         dw        offset NextPCJ

                                          ;* 10: 640x200/4 graf.
         dw        640,200,4
         dw        offset ClrPCJ
         dw        offset SetPCJ
         dw        offset DispPCJ
         dw        offset NextPCJ

                                          ;* 11: intern
         dw        80,25,2
         dw        offset ClrTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset NextTXT

                                          ;* 12: intern
         dw        80,25,2
         dw        offset ClrTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset NextTXT

                                          ;* 13: 320x200/16 graf
         dw        320,200,4
         dw        offset ClrEGA
         dw        offset SetEGA
         dw        offset DispEGA
         dw        offset NextEGA

                                          ;* 14: 640x200/16 graf
         dw        640,200,4
         dw        offset ClrEGA
         dw        offset SetEGA
         dw        offset DispEGA
         dw        offset NextEGA

                                          ;* 15: 640x350/2 graf
         dw        640,350,1
         dw        offset ClrEGA
         dw        offset SetEGA
         dw        offset DispEGA
         dw        offset NextEGA

                                          ;* 16: 640x350/16 graf
         dw        640,350,4
         dw        offset ClrEGA
         dw        offset SetEGA
         dw        offset DispEGA
         dw        offset NextEGA

                                          ;* 17: 640x480/2 graf
         dw        640,480,1
         dw        offset ClrCGA
         dw        offset SetCGA
         dw        offset DispCGA
         dw        offset NextCGA

                                          ;* 18: 640x480/16 graf
         dw        640,480,4
         dw        offset ClrEGA
         dw        offset SetEGA
         dw        offset DispEGA
         dw        offset NextEGA

                                          ;* 19: 320x200/256 graf
         dw        320,200,8
         dw        offset ClrMCG
         dw        offset SetMCG
         dw        offset DispMCG
         dw        offset NextMCG

TabPal   db        0,1,2,3,4,5,14h,7,38h,39h,3ah,3bh,3ch,3dh,3eh,3fh,0 ; palety

; ------ parametry pro zobrazen objekt

                                          ;* parametry ze zhlav objektu
Sirka    dw        0                        ; ka vezu (pozic)
Vyska    dw        0                        ; vka vezu (linek)
Rovin    dw        0                        ; poet barevnch rovin
Pozadi   dw        0                        ; barva pozad
Palet    dw        0                        ; poet bajt palet
Mod      db        0                        ; videomd displeje
Param    db        0                        ; parametry
                                            ;  bit 0: 1=komprese
                                            ;  bit 1: 1=textov videomd
                                            ;  bit 2: 1=paraleln uloen barev
                                            ;  bit 3: 1=je maska pozad

                                          ;* parametry pro zobrazen
ZdrojAdr dd        0                        ; zdrojov adresa obrzku (roviny)
MaskAdr  dd        0                        ; adresa masky
MaskFrst db        0                        ; maska prvnho bajtu linky
MaskLst  db        0                        ; maska poslednho bajtu linky

; ------ obsluha klvesnice

Keys     dw        0                        ; posledn znak z klvesnice

; ------ parametry pro prci s pamt

ProgUkaz dw        0                        ; ukazatel programu
DatMem   dw        SEG SegProg              ; segment s daty programu
ProgMem  dw        0                        ; segment s natenm programem
ObjMem   dw        0                        ; segment s prvnm objektem
TopMem   dw        0                        ; segment zatku voln pamti

; ------ parametry displeje

Wind1    dw        0                        ; lev okraj okna
Wind2    dw        0                        ; horn okraj okna
Wind3    dw        0                        ; prav okraj okna
Wind4    dw        0                        ; spodn okraj okna

BitDisp  dw        0                        ; md displeje (pznakov bity)
OldVMod  db        3                        ; pvodn videomd
VMod     db        3                        ; aktuln videomd
SegVRAM  dw        0b800h                   ; segment videopamti
DelVRAM  dw        2000h                    ; dlka videostrnky
EgaVga   db        1                        ; pznak karty EGA/VGA
KurzPoz  dw        0                        ; aktuln pozice kurzoru
MaxPoz   db        80                       ; maximln poet pozic
MaxRad   db        25                       ; maximln poet dk

Page1    db        0                        ; aktivn zobrazen strnka
Page2    db        0                        ; vstupn strnka


; ------ Chybov texty

MemTxt   db        'Chyba - nedostatek pameti !',13,10,'$'

FndTxt   db        'Chyba - soubor $'
Fnd2Txt  db        ' nenalezen !',13,10,'$'

RetKod   db        -1                       ; nvrat. kd z programu (=peru.)
SegPSP   dw        0                        ; schova adresy PSP


Code     ENDS

; *****************************************************************************
;
;                  Pechodn zsobnk pro interpreter
;
; *****************************************************************************

Stack    SEGMENT   stack para

         db        20h dup(0)

Stack    ENDS

; *****************************************************************************
;
;                       Segment programu
;
; *****************************************************************************

SegProg  SEGMENT PARA


SegProg  ENDS

         END       Start
