
; *****************************************************************************
;
;                               A N I M I
;
;                     animan program - interpreter
;
; *****************************************************************************


Code     SEGMENT
         ASSUME    cs:Code,ds:Code,ss:Stack

         db        'XX'                     ; prvn poloka bude na offsetu 2

         dw        SEG SegProg              ; segment animanho programu

         db        'ANIM - graficka animace; (c) Miroslav Nemecek',13,10

Start:

; ------ pedefinovn zsobnku na vrchol pamti

         mov       ax,ds:[2]                ; segment s koncem pamti
         sub       ax,1000h                 ; rezerva 64 KB
         mov       ss,ax                    ; segment zsobnku
         mov       sp,0fff8h                ; offset zsobnku

; ------ nastaven pznaku karty EGA

         mov       ah,12h                   ; funkce poskytnut informac EGA
         mov       bx,05e10h                ; podfunkce informac
         call      Int10                    ; poskytnut informac EGA/VGA
         cmp       bh,2                     ; md displeje 0 nebo 1
         jae       Start2                   ; chyba - neplatn obsah registru
         cmp       bl,5                     ; maximln velikost pamti 1 MB
         jbe       Start3                   ; velikost pamti OK
Start2:  mov       byte ptr cs:[EgaVga],0   ; pznak, e nen karta EGA/VGA

; ------ schova videomdu

Start3:  mov       ah,0fh
         call      Int10                    ; poskytnut aktivnho videomdu
         mov       cs:[OldVMod],al          ; schova aktivnho videomdu

; ------ uren segment jednotlivch blok

         mov       cl,4                     ; poet rotac pro pevod
         mov       ax,SEG SegProg           ; segment s daty programu
         mov       ds,ax                    ; segment datovho modulu
         mov       bx,ds:[0]                ; dlka datovho modulu
         mov       cs:[DatNum],bx           ; poet bajt datovho modulu
         add       bx,15                    ; zaokrouhlen na odstavec
         shr       bx,cl                    ; pepoet na odstavce
         add       ax,bx                    ; adresa segmentu s programem
         mov       cs:[ProgMem],ax          ; segment s programem
         mov       ds,ax                    ; segment s programem
         mov       bx,ds:[0]                ; dlka segmentu s programem
         add       bx,15                    ; zaokrouhlen na odstavec
         shr       bx,cl                    ; pepoet na odstavce
         add       ax,bx                    ; adresa segmentu s objekty
         mov       cs:[ObjMem],ax           ; segment s objekty

; ------ uren adresy konce tabulky blok

         mov       word ptr cs:[TopMem],-1  ; pednastaven - zruen konce
         xor       ax,ax                    ; hledan blok 0
         call      SrcObj                   ; nalezen objektu 0 (=koncov)
         mov       cs:[TopMem],dx           ; nov konec pamti

; ------ schova kdu pipraven klvesy

         push      cs
         pop       ds

         xor       ax,ax
Start4:  push      ax
         mov       ah,1
         int       16h                      ; dotaz na stav klvesnice
         pop       ax
         jz        Start5                   ; nen pipraven dn znak
         mov       ah,0
         int       16h                      ; vstup znaku z klvesnice
         jmp       short Start4             ; test dalho znaku
Start5:  mov       ds:[KeyBuf],ax           ; uloen ppadnho kdu klvesy

; ------ definice obsluh peruen INT xx

         mov       ax,2523h
         mov       dx,offset Prerus         ; obsluha INT 23h
         int       21h                      ; adresa peruen programu

         mov       ax,3508h
         int       21h
         mov       word ptr ds:[Old08],bx
         mov       word ptr ds:[Old08+2],es
         mov       dx,offset Int08
         mov       ax,2508h
         int       21h

         mov       ax,3509h
         int       21h
         mov       word ptr ds:[Old09],bx
         mov       word ptr ds:[Old09+2],es
         mov       dx,offset Int09
         mov       ax,2509h
         int       21h

         mov       ax,3500h
         int       21h
         mov       word ptr ds:[Old00],bx
         mov       word ptr ds:[Old00+2],es
         mov       dx,offset Int00
         mov       ax,2500h
         int       21h

         mov       ax,351Bh
         int       21h
         mov       word ptr ds:[Old1B],bx
         mov       word ptr ds:[Old1B+2],es
         mov       dx,offset Int1B
         mov       ax,251Bh
         int       21h

; ------ inicializace genertoru nhody

         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[46ch]
         mov       dx,ds:[46eh]
         mov       word ptr cs:[RandNum],ax
         mov       word ptr cs:[RandNum+2],dx

; ------ interpretace programu

         mov       ds,cs:[ProgMem]          ; segment s programem
         mov       es,cs:[DatMem]           ; segment s daty programu
         mov       si,ds:[2]                ; startovac adresa programu
         sti                                ; povoleno peruen
         cld                                ; smr nahoru
         call      Anim                     ; interpretace programu (procedury)
         mov       byte ptr cs:[RetKod],al  ; nvratov kd programu

; ------ ukonen programu (nebo peruen)

Prerus:  mov       al,cs:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

; ------ nvrat obsluhy peruen INT 08h

Prerus2: lds       dx,cs:[Old08]
         mov       ax,2508h
         int       21h                      ; nvrat adresy obsluhy INT 08h

; ------ nvrat obsluhy peruen INT 09h

         lds       dx,cs:[Old09]
         mov       ax,2509h
         int       21h                      ; nvrat adresy obsluhy INT 09h

; ------ nvrat obsluhy peruen INT 00h

         lds       dx,cs:[Old00]
         mov       ax,2500h
         int       21h                      ; nvrat adresy obsluhy INT 00h

; ------ nvrat obsluhy peruen INT 1Bh

         lds       dx,cs:[Old1B]
         mov       ax,251Bh
         int       21h                      ; nvrat adresy obsluhy INT 1Bh

; ------ vypnut zvukovho genertoru

         in        al,[61h]                 ; vstup na reproduktor
         and       al,not 3
         out       [61h],al                 ; vypnut vstupu na reproduktor

; ------ nvrat z programu

         mov       al,cs:[RetKod]           ; nvratov kd z programu
         mov       ah,4ch
         int       21h                      ; ukonen programu

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 08h (obsluha hodin a zvukovho genertoru)
; -----------------------------------------------------------------------------

Citac    dw        0                        ; ta asu
Old08    dd        0                        ; pvodn adresa INT 08h

UkazMel  dw        0                        ; ukazatel melodie
NumMel   dw        0                        ; poet zbylch znak melodie

CitTon   db        0                        ; ta zbyl doby trvn tnu

public   int08
INT08    PROC      FAR

         inc       word ptr cs:[Citac]
         jnz       Int082                   ; nen peteen
         dec       word ptr cs:[Citac]      ; nvrat sla -1
Int082:


; ------ obsluha tae doby jednoho tnu

         cmp       byte ptr cs:[CitTon],0   ; je ta doby tnu vynulovn ?
         je        Int084                   ; je ji = 0 - dal melodie
         dec       byte ptr cs:[CitTon]     ; snen tae doby tnu
         jnz       Int089                   ; dal ekn

; ------ konec tnu - vypnut zvukovho genertoru

         push      ax
         in        al,[61h]
         and       al,not 3
         out       [61h],al                 ; vypnut genertoru
         pop       ax

; ------ test, zda je pipraven dal tn melodie

Int084:  cmp       word ptr cs:[NumMel],0   ; je dal tn melodie ?
         je        Int089                   ; nen dal tn melodie

; ------ nastaven dalho tnu melodie

         push      ax
         push      bx
         push      ds

         dec       word ptr cs:[NumMel]     ; snen tae tn melodie
         mov       ds,cs:[ProgMem]          ; segment s natenm programem
         mov       bx,cs:[UkazMel]          ; ukazatel melodie
         add       word ptr cs:[UkazMel],2  ; zven ukazatele melodie
         mov       bx,ds:[bx]               ; dal tn melodie a jeho dlka
         mov       cs:[CitTon],bh           ; ta dlky jednoho tnu
         mov       bh,0                     ; BX=slo tnu
         shl       bx,1                     ; slo tnu * 2
         mov       bx,cs:[bx+TabTon-2]      ; dlic konstanta tnu
         jz        Int085                   ; je prodleva

         mov       al,0b6h
         out       [43h],al
         mov       al,bl
         out       [42h],al
         mov       al,bh
         out       [42h],al
         in        al,[61h]
         or        al,3
         out       [61h],al
Int085:
         pop       ds
         pop       bx
         pop       ax

Int089:  jmp       dword ptr cs:[Old08]     ; pokraovn v obsluze INT 08h

Int08    ENDP


TabTon   label     word                     ; tabulka pro nastaven tn
         dw        36485,34437,32505,30680,28958,27333 ; oktva 0
         dw        25799,24351,22984,21694,20477,19327
         dw        18243,17219,16252,15340,14479,13667 ; oktva 1
         dw        12899,12175,11492,10847,10238,9664
         dw        9121,8609,8126,7670,7240,6833       ; oktva 2
         dw        6450,6088,5746,5424,5119,4832
         dw        4561,4305,4063,3835,3620,3417       ; oktva 3
         dw        3225,3044,2873,2712,2560,2416
         dw        2280,2152,2032,1918,1810,1708       ; oktva 4
         dw        1612,1522,1437,1356,1280,1208
         dw        1140,1076,1016,959,905,854          ; oktva 5
         dw        806,761,718,678,640,604
         dw        570,538,508,479,452,427             ; oktva 6
         dw        403,380,359,339,320,302
         dw        285,269,254,240,226,214             ; oktva 7
         dw        202,190,180,169,160,151
         dw        143,135,127,120,113,107             ; oktva 8
         dw        101,95,90,85,80,75
         dw        71,67,63,60,57,53,50,48,45,42,40,38 ; oktva 9

; -----------------------------------------------------------------------------
;        Obsluha klvesnice INT 09h
; -----------------------------------------------------------------------------

Old09    dd        0                        ; pvodn obsluha INT 09h

ExtKey   dw        0                        ; povolen reimu roz. klvesnice
KeyBuf   dw        0                        ; buffer posledn klvesy

Int09    PROC      FAR

; ------ schova registr

         push      ax
         push      bx
         push      ds

; ------ pprava datovho segmentu BIOS

         mov       bx,40h
         mov       ds,bx                    ; datov segment BIOS

; ------ ten kdu stisknut klvesy, kontrola kdu klvesy

         in        al,[60h]                 ; ten kdu klvesy
         mov       bx,ax                    ; kd klvesy
         and       bx,7fh                   ; kd klvesy bez bitu 7
         jz        Int097                   ; je kd 0 - nepovolen klvesa
         cmp       bl,60h                   ; je povolen kd klvesy ?
         jae       Int097                   ; tento kd klvesy je neznm

; ------ nastaven ukazatele klvesy v bufferu

         cmp       byte ptr cs:[ExtKey],0   ; je povolena rozen klvesnice ?
         je        Int093                   ; rozen klvesnice nepovolena
         test      byte ptr ds:[496h],2     ; je rozen kd klvesy ?
         jz        Int093                   ; nen rozen kd klvesy
         cmp       bl,47h                   ; je klvesa v numerickm poli ?
         jb        Int092                   ; nen klvesa v numerickm poli
         cmp       bl,53h                   ; max. klvesa v num. poli
         ja        Int092                   ; nen klvesa v numerickm poli
         add       bl,60h-47h               ; posun kdu
         jmp       short Int093
Int092:  cmp       bl,1ch                   ; je Enter ?
         jne       Int0922                  ; nen Enter
         mov       bl,6fh                   ; je Enter v numerickm poli
         jmp       short Int093
Int0922: cmp       bl,1dh                   ; je Ctrl ?
         jne       Int0923                  ; nen Ctrl
         mov       bl,6dh                   ; je prav Ctrl
         jmp       short Int093
Int0923: cmp       bl,38h                   ; je Alt ?
         jne       Int0924                  ; nen Alt
         mov       bl,64h                   ; je prav Alt
         jmp       short Int093
Int0924: cmp       bl,35h                   ; je / ?
         jne       Int0925                  ; nen /
         mov       bl,70h                   ; je [/] v numerickm poli
Int0925:

; ------ rozlien stisku a uvolnn

Int093:  mov       cs:[TabKey],bl           ; schova kdu posledn klvesy
         test      al,80h                   ; je stisk klvesy ?
         jz        Int094                   ; je stisk klvesy

; ------ je uvolnn klvesy

         mov       byte ptr cs:[bx+TabKey],0 ; oznaen klvesy za uvolnnou
         jmp       short Int097

; ------ je stisk klvesy

Int094:  inc       byte ptr cs:[bx+TabKey]  ; zven tae stisku klvesy
         jnz       Int097                   ; nen peteen
         dec       byte ptr cs:[bx+TabKey]  ; navrt se na 0ffh

; ------ standardn obsluha klvesnice

Int097:  mov       bx,ds:[1ch]              ; schova ukldac adresy do bufferu
         pushf
         call      dword ptr cs:[Old09]     ; voln standardn obsluhy BIOS

; ------ kontrola, zda je v bufferu njak znak

         cmp       bx,ds:[1ch]              ; zmnila se ukldac adresa ?
         je        Int099                   ; nezmnila se - nen nov znak

; ------ vyjmut novho znaku z bufferu

         mov       ax,ds:[bx]               ; vyjmut novho znaku
         mov       cs:[KeyBuf],ax           ; schova znaku do bufferu
         mov       ds:[1ch],bx              ; nvrat ukldac adresy
         mov       ds:[1ah],bx              ; zruen tec adresy

; ------ nvrat registr

Int099:  pop       ds
         pop       bx
         pop       ax
         iret

Int09    ENDP

TabKey   label     byte                     ; tabulka pznak klves

         db        0                        ; 00h: posledn stisknut klvesa
         db        0                        ; 01h: Esc
         db        0                        ; 02h: 1 !
         db        0                        ; 03h: 2 @
         db        0                        ; 04h: 3 #
         db        0                        ; 05h: 4 $
         db        0                        ; 06h: 5 %
         db        0                        ; 07h: 6 ^
         db        0                        ; 08h: 7 &
         db        0                        ; 09h: 8 *
         db        0                        ; 0ah: 9 (
         db        0                        ; 0bh: 0 )
         db        0                        ; 0ch: - _
         db        0                        ; 0dh: = +
         db        0                        ; 0eh: <- (Back Space)
         db        0                        ; 0fh: Tab
         db        0                        ; 10h: Q
         db        0                        ; 11h: W
         db        0                        ; 12h: E
         db        0                        ; 13h: R
         db        0                        ; 14h: T
         db        0                        ; 15h: Y
         db        0                        ; 16h: U
         db        0                        ; 17h: I
         db        0                        ; 18h: O
         db        0                        ; 19h: P
         db        0                        ; 1ah: [ {
         db        0                        ; 1bh: ] }
         db        0                        ; 1ch: Enter
         db        0                        ; 1dh: Ctrl
         db        0                        ; 1eh: A
         db        0                        ; 1fh: S
         db        0                        ; 20h: D
         db        0                        ; 21h: F
         db        0                        ; 22h: G
         db        0                        ; 23h: H
         db        0                        ; 24h: J
         db        0                        ; 25h: K
         db        0                        ; 26h: L
         db        0                        ; 27h: ; :
         db        0                        ; 28h: ' "
         db        0                        ; 29h: ` ~
         db        0                        ; 2ah: lev Shift
         db        0                        ; 2bh: \ |
         db        0                        ; 2ch: Z
         db        0                        ; 2dh: X
         db        0                        ; 2eh: C
         db        0                        ; 2fh: V
         db        0                        ; 30h: B
         db        0                        ; 31h: N
         db        0                        ; 32h: M
         db        0                        ; 33h: , <
         db        0                        ; 34h: . >
         db        0                        ; 35h: / ?
         db        0                        ; 36h: prav Shift
         db        0                        ; 37h: [*] Print Screen
         db        0                        ; 38h: Alt
         db        0                        ; 39h: mezernk
         db        0                        ; 3ah: Caps Lock
         db        0                        ; 3bh: F1
         db        0                        ; 3ch: F2
         db        0                        ; 3dh: F3
         db        0                        ; 3eh: F4
         db        0                        ; 3fh: F5
         db        0                        ; 40h: F6
         db        0                        ; 41h: F7
         db        0                        ; 42h: F8
         db        0                        ; 43h: F9
         db        0                        ; 44h: F10
         db        0                        ; 45h: Num Lock
         db        0                        ; 46h: Scroll Lock
         db        0                        ; 47h: [7] Home
         db        0                        ; 48h: [8] kurzor nahoru
         db        0                        ; 49h: [9] Page Up
         db        0                        ; 4ah: [-]
         db        0                        ; 4bh: [4] kurzor vlevo
         db        0                        ; 4ch: [5]
         db        0                        ; 4dh: [6] kurzor vpravo
         db        0                        ; 4eh: [+]
         db        0                        ; 4fh: [1] End
         db        0                        ; 50h: [2] kurzor dol
         db        0                        ; 51h: [3] Page Down
         db        0                        ; 52h: [0] Insert
         db        0                        ; 53h: [.] Delete
         db        0                        ; 54h: (SysRq - pouze AT 84 klves)
         db        0                        ; 55h:
         db        0                        ; 56h: \ | (AT 102 klves)
         db        0                        ; 57h: F11 (AT 101 a 102 klves)
         db        0                        ; 58h: F12 (AT 101 a 102 klves)
         db        0                        ; 59h:
         db        0                        ; 5ah:
         db        0                        ; 5bh:
         db        0                        ; 5ch:
         db        0                        ; 5dh:
         db        0                        ; 5eh:
         db        0                        ; 5fh:

                                          ;* zde zanaj zdvojen klvesy
         db        0                        ; 60h: Home
         db        0                        ; 61h: kurzor nahoru
         db        0                        ; 62h: Page Up
         db        0                        ; 63h:
         db        0                        ; 64h: kurzor vlevo
         db        0                        ; 65h: [5]
         db        0                        ; 66h: kurzor vpravo
         db        0                        ; 67h:
         db        0                        ; 68h: End
         db        0                        ; 69h: kurzor dol
         db        0                        ; 6ah: Page Down
         db        0                        ; 6bh: Insert
         db        0                        ; 6ch: Delete
         db        0                        ; 6dh: prav Ctrl
         db        0                        ; 6eh: prav Alt
         db        0                        ; 6fh: [Enter]
         db        0                        ; 70h: [/]

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 00h
; -----------------------------------------------------------------------------

Old00    dd        0                        ; pvodn adresa INT 00h

INT00    PROC      FAR

         iret

INT00    ENDP

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 1Bh
; -----------------------------------------------------------------------------

ParBreak db        0                        ; pznak uivatelskho peruen
Old1B    dd        0                        ; pvodn adresa INT 1Bh

INT1B    PROC      FAR

         mov       byte ptr cs:[ParBreak],1 ; pznak peruen
         mov       byte ptr cs:[AdrBrk+1],0 ; nsiln ukonen programu
         mov       byte ptr cs:[AdrBrk2+1],0 ; nsiln ukonen vpotu vrazu
         iret

INT1B    ENDP

; -----------------------------------------------------------------------------
;        Interpretace procedury programu (po pkaz ENDPROC nebo RETURN)
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=ukazatel programu
;        ES=datov segment
; VSTUP: AX=nvratov kd
; -----------------------------------------------------------------------------

PUBLIC   Anim
Anim:    lodsb                              ; identifiktor povelu
         mov       bl,al                    ; identifiktor povelu
         mov       bh,0                     ; BX = slo povelu
         shl       bx,1                     ; slo povelu * 2
         call      word ptr cs:[TabFnc+bx]  ; vyvoln obsluhy funkce
AdrBrk:  jmp       short Anim               ; dal pkaz

; ------ nsledujc procedura se bude provdt pi peruen programu

         xor       ax,ax                    ; nvratov kd pi peruen
         ret                                ; peruen programu

; -----------------------------------------------------------------------------
;        Vpoet hodnoty vrazu
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=ukazatel programu
;        ES=datov segment
; VSTUP:AX=hodnota vrazu
;        DS:SI=nov ukazatel programu
; -----------------------------------------------------------------------------

PUBLIC   Vyraz
Vyraz:
         xor       ax,ax                    ; vchoz hodnota vrazu

; ------ vnitn opertor vrazu

Vyraz1:  mov       bl,ds:[si]               ; identifiktor opertoru
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; slo opertoru * 2
         call      word ptr cs:[TabOper+bx] ; obsluha opertoru
AdrBrk2: jnc       Vyraz1                   ; zpracovn dalho operandu
         clc
         ret                                ; konec vrazu

; -----------------------------------------------------------------------------
;        Konec vrazu
; -----------------------------------------------------------------------------

PUBLIC   OpKonec
OpKonec:
         stc                                ; pznak konce vrazu
         ret

; -----------------------------------------------------------------------------
;        Prav zvorka
; -----------------------------------------------------------------------------

PUBLIC   OpRght
OpRght:  stc                                ; pznak konce vrazu
         ret

; -----------------------------------------------------------------------------
;        ^ mocnina
; -----------------------------------------------------------------------------

PUBLIC   OpMoc
OpMoc:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu
         mov       cx,ax                    ; druh operand

; ------ test, zda je mocnn na 0

         pop       ax                       ; prvn operand
         jcxz      OpMoc3                   ; umocnno na 0

; ------ umocnn sla (nsoben slem BX)

         dec       cx                       ; snen tae mocniny
         jcxz      OpMoc2                   ; je mocnno na 1 - konec
         mov       bx,ax                    ; tmto slem se bude nsobit
OpMoc1:  imul      bx                       ; vynsoben operandem
         loop      OpMoc1                   ; dal mocnn
OpMoc2:  clc                                ; pznak operace OK
         ret

; ------ slo je umocnno na 0

OpMoc3:  mov       ax,1                     ; vsledek operace mocnn na 0
         clc                                ; pznak operace OK
         ret

; -----------------------------------------------------------------------------
;        * nsoben
; -----------------------------------------------------------------------------

PUBLIC   OpMul
OpMul:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ vynsoben operand

         pop       cx                       ; prvn operand
         imul      cx                       ; nsobek
         clc                                ; pznak operace OK
         ret

; -----------------------------------------------------------------------------
;        / dlen
; -----------------------------------------------------------------------------

PUBLIC   OpDiv
OpDiv:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ vydlen operand

         mov       cx,ax                    ; druh operand
         pop       ax                       ; nvrat prvnho operandu
         jcxz      OpDiv1                   ; byla by chyba dlen (peteen)
         cwd                                ; pevod na dvojslovo
         idiv      cx                       ; dlen
         clc                                ; pznak operace OK
         ret

; ------ dlen nulou

OpDiv1:  mov       ax,8000h                 ; peteen
         clc                                ; pznak operace OK
         ret

; -----------------------------------------------------------------------------
;        MOD
; -----------------------------------------------------------------------------

PUBLIC   OpMod
OpMod:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ vydlen operand

         mov       cx,ax                    ; druh operand
         pop       ax                       ; nvrat prvnho operandu
         jcxz      OpMod1                   ; byla by chyba dlen nulou
         cwd                                ; pevod na dvojslovo
         idiv      cx                       ; dlen
         mov       ax,dx                    ; zbytek po dlen
         clc                                ; pznak operace OK
         ret

; ------ dlen nulou

OpMod1:  xor       ax,ax                    ; peteen
         ret

; -----------------------------------------------------------------------------
;        <<
; -----------------------------------------------------------------------------

PUBLIC   OpShl
OpShl:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ rotace operandu

         mov       cx,ax                    ; druh operand
         pop       ax                       ; nvrat prvnho operandu
         cmp       cx,16
         jbe       OpShl1
         mov       cl,16
OpShl1:  shl       ax,cl
         clc                                ; pznak operace OK
         ret

; -----------------------------------------------------------------------------
;        >>
; -----------------------------------------------------------------------------

PUBLIC   OpShr
OpShr:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ rotace operandu

         mov       cx,ax                    ; druh operand
         pop       ax                       ; nvrat prvnho operandu
         cmp       cx,16
         jbe       OpShr1
         mov       cl,16
OpShr1:  shr       ax,cl
         clc                                ; pznak operace OK
         ret

; -----------------------------------------------------------------------------
;        +
; -----------------------------------------------------------------------------

PUBLIC   OpAdd
OpAdd:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ souet operand

         pop       cx                       ; nvrat prvnho operandu
         add       ax,cx                    ; souet operand
         clc
         ret

; -----------------------------------------------------------------------------
;        -
; -----------------------------------------------------------------------------

PUBLIC   OpSub
OpSub:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ rozdl operand

         mov       cx,ax                    ; druh operand
         pop       ax                       ; nvrat prvnho operandu
         sub       ax,cx                    ; rozdl operand
         clc
         ret

; -----------------------------------------------------------------------------
;        =
; -----------------------------------------------------------------------------

PUBLIC   OpEqu
OpEqu:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ porovnn operand

         pop       cx                       ; nvrat prvnho operandu
         cmp       ax,cx                    ; je shoda operand ?
         mov       ax,-1                    ; pznak shody operand
         je        OpEqu1                   ; operandy jsou shodn
         xor       ax,ax                    ; pznak neshody operand
OpEqu1:  ret

; -----------------------------------------------------------------------------
;        <>
; -----------------------------------------------------------------------------

PUBLIC   OpNeq
OpNeq:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ porovnn operand

         pop       cx                       ; nvrat prvnho operandu
         sub       ax,cx                    ; je shoda operand ?
         je        OpNeq1                   ; operandy jsou shodn - nesplnno
         mov       ax,-1                    ; pznak neshody operand
         clc                                ; pznak operace OK
OpNeq1:  ret

; -----------------------------------------------------------------------------
;        <
; -----------------------------------------------------------------------------

PUBLIC   OpLt
OpLt:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ porovnn operand

         pop       cx                       ; nvrat prvnho operandu
         cmp       cx,ax                    ; je prvn operand men ?
         mov       ax,-1                    ; pznak splnn podmnky
         jl        OpLt1                    ; prvn operand je men - OK
         xor       ax,ax                    ; pznak nesplnn podmnky
OpLt1:   clc
         ret

; -----------------------------------------------------------------------------
;        >
; -----------------------------------------------------------------------------

PUBLIC   OpGt
OpGt:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ porovnn operand

         pop       cx                       ; nvrat prvnho operandu
         cmp       cx,ax                    ; je prvn operand vt ?
         mov       ax,-1                    ; pznak splnn podmnky
         jg        OpGt1                    ; prvn operand je vt - OK
         xor       ax,ax                    ; pznak nesplnn podmnky
OpGt1:   clc
         ret

; -----------------------------------------------------------------------------
;        <=
; -----------------------------------------------------------------------------

PUBLIC   OpLte
OpLte:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ porovnn operand

         pop       cx                       ; nvrat prvnho operandu
         cmp       cx,ax                    ; je prvn operand men/shodn ?
         mov       ax,-1                    ; pznak splnn podmnky
         jle       OpLte1                   ; prvn operand je men/shodn - OK
         xor       ax,ax                    ; pznak nesplnn podmnky
OpLte1:  clc
         ret

; -----------------------------------------------------------------------------
;        >=
; -----------------------------------------------------------------------------

PUBLIC   OpGte
OpGte:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ porovnn operand

         pop       cx                       ; nvrat prvnho operandu
         cmp       cx,ax                    ; je prvn operand vt/shodn ?
         mov       ax,-1                    ; pznak splnn podmnky
         jge       OpGte1                   ; prvn operand je vt/shodn - OK
         xor       ax,ax                    ; pznak nesplnn podmnky
OpGte1:  clc
         ret

; -----------------------------------------------------------------------------
;        NOT
; -----------------------------------------------------------------------------

PUBLIC   OpNot
OpNot:

; ------ vpoet nsledujcho operandu

         xor       ax,ax                    ; pednastaven stadae
         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ inverze operandu

         not       ax
         clc
         ret

; -----------------------------------------------------------------------------
;        AND
; -----------------------------------------------------------------------------

PUBLIC   OpAnd
OpAnd:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ operace AND

         pop       cx                       ; nvrat prvnho operandu
         and       ax,cx                    ; operace AND mezi operandy
         ret

; -----------------------------------------------------------------------------
;        OR
; -----------------------------------------------------------------------------

PUBLIC   OpOr
OpOr:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ operace OR

         pop       cx                       ; nvrat prvnho operandu
         or        ax,cx                    ; operace OR mezi operandy
         ret

; -----------------------------------------------------------------------------
;        XOR
; -----------------------------------------------------------------------------

PUBLIC   OpXor
OpXor:
         push      ax                       ; schova stadae vsledku

; ------ vpoet nsledujcho operandu

         mov       bl,ds:[si]               ; identifiktor operandu
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor operandu * 2
         call      word ptr cs:[TabOper+bx] ; stanoven operandu

; ------ operace XOR

         pop       cx                       ; nvrat prvnho operandu
         xor       ax,cx                    ; operace XOR mezi operandy
         ret

; -----------------------------------------------------------------------------
;        Konstanta
; -----------------------------------------------------------------------------

PUBLIC   OpKonst
OpKonst: lodsw
         clc
         ret

; -----------------------------------------------------------------------------
;        Intern procedura - funkce
; -----------------------------------------------------------------------------

PUBLIC   OpInter
OpInter:
         mov       bl,ds:[si]               ; identifiktor procedury
         inc       si                       ; zven ukazatele programu
         mov       bh,0
         shl       bx,1                     ; identifiktor procedury * 2
         call      word ptr cs:[TabFnc+bx]  ; vyvoln obsluhy intern funkce
         clc
         ret

; -----------------------------------------------------------------------------
;        Uivatelsk funkce
; -----------------------------------------------------------------------------

PUBLIC   OpUsr
OpUsr:
         lodsw                              ; adresa uivatelsk funkce
         push      si                       ; schova ukazatele pogramu
         mov       si,ax                    ; nov adresa programu (procedura)
         call      Anim                     ; proveden obsluhy procedury
         pop       si                       ; nvrat ukazatele programu
         clc
         ret

; -----------------------------------------------------------------------------
;        promnn BYTE
; -----------------------------------------------------------------------------

PUBLIC   OpByte
OpByte:
         lodsw                              ; adresa promnn
         mov       bx,ax                    ; adresa promnn
         mov       al,es:[bx]               ; hodnota promnn
         cbw                                ; pevod na slovo
         clc
         ret

; -----------------------------------------------------------------------------
;        promnn WORD
; -----------------------------------------------------------------------------

PUBLIC   OpWord
OpWord:
         lodsw                              ; adresa promnn
         mov       bx,ax                    ; adresa promnn
         mov       ax,es:[bx]               ; hodnota promnn
         clc
         ret

; -----------------------------------------------------------------------------
;        promnn BYTE s indexem
; -----------------------------------------------------------------------------

PUBLIC   OpByteI
OpByteI:
         lodsw                              ; adresa promnn
         push      ax                       ; schova adresy promnn
         call      Vyraz                    ; vpoet indexu
         pop       bx                       ; adresa promnn
         add       bx,ax                    ; piten indexu
         mov       al,es:[bx]
         cbw                                ; pevod na slovo
         clc
         ret

; -----------------------------------------------------------------------------
;        promnn WORD s indexem
; -----------------------------------------------------------------------------

PUBLIC   OpWordI
OpWordI:
         lodsw                              ; adresa promnn
         push      ax                       ; schova adresy promnn
         call      Vyraz                    ; vpoet indexu
         shl       ax,1                     ; index * 2
         pop       bx                       ; adresa promnn
         add       bx,ax                    ; piten indexu
         mov       al,es:[bx]               ; ni bajt promnn
         mov       ah,es:[bx+1]             ; vy bajt promnn
         clc
         ret

; -----------------------------------------------------------------------------
;        Nalezen objektu AX v pamti -> DX (CY=objekt nenalezen)
; -----------------------------------------------------------------------------

PUBLIC   SrcObj

SrcObj:
         push      ds                       ; schova DS
         mov       dx,cs:[ObjMem]           ; segment s objekty

; ------ test, zda je to hledan objekt

SrcObj2: mov       ds,dx                    ; segment objektu
         cmp       ax,ds:[0]                ; je to hledan objekt ?
         je        SrcObj3                  ; objekt nalezen
         add       dx,ds:[2]                ; zven adresy segmentu
         cmp       dx,cs:[TopMem]           ; dosaeno konce pamti ?
         jb        SrcObj2                  ; nen jet konec pamti - dal

; ------ chyba - objekt nenalezen

SrcObj4: stc                                ; pznak, e objekt nebyl nalezen
         pop       ds                       ; nvrat DS
         ret

; ------ objekt nalezen OK (DX=adresa objektu)

SrcObj3: pop       ds                       ; nvrat DS
         ret


; -----------------------------------------------------------------------------
;        Zruen objektu z pamti (DX=adresa objektu)
; -----------------------------------------------------------------------------

PUBLIC   DelObj

DelObj:  push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      ds
         push      es

         sti                                ; mus bt povoleno peruen
         cld                                ; smr nahoru
         mov       es,dx                    ; clov segment k pesunu
         mov       cx,es:[2]                ; velikost objektu
         add       dx,cx                    ; adresa dalho objektu
         mov       bx,cs:[TopMem]           ; konec pamti s objekty
         sub       cs:[TopMem],cx           ; snen konce pamti
         sub       bx,dx                    ; velikost zbytku dat
         jz        DelObj5                  ; nejsou dn data k pesunu
         mov       ds,dx                    ; zdrojov adresa pesunu
         jmp       short DelObj3

; ------ Penos dalho bloku dat

DelObj2: mov       cx,es                    ; clov segment
         add       cx,1000h                 ; zven o 1 segment 64 KB
         mov       es,cx                    ; nov clov segment
         mov       cx,ds                    ; zdrojov segment
         add       cx,1000h                 ; zven o 1 segment 64 KB
         mov       ds,cx                    ; nov zdrojov segment

; ------ Nastaven velikosti penenho bloku

DelObj3: mov       cx,1000h                 ; omezen na 64 KB
         cmp       bx,cx                    ; je blok vt ne 1 segment ?
         jae       DelObj4                  ; je velk segment
         mov       cx,bx                    ; velikost bloku v odstavcch
DelObj4: shl       cx,1
         shl       cx,1
         shl       cx,1                     ; pevod odstavc na slova

; ------ Penos jednoho bloku dat

         xor       si,si
         xor       di,di
         rep       movsw                    ; penos jednoho segmentu
         sub       bx,1000h                 ; je dal segment k penosu ?
         ja        DelObj2                  ; penos dalho segmentu

DelObj5: pop       es
         pop       ds
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        Normalizace adresy DS:SI
; -----------------------------------------------------------------------------

PUBLIC   NormDSSI
NormDSSI:push      ax
         push      cx
         mov       ax,si                    ; offset adresy
         mov       cl,4                     ; poet rotac pro pevod
         shr       ax,cl                    ; pepoet na odstavce
         mov       cx,ds                    ; souasn segment
         add       ax,cx                    ; normalizovan segment
         mov       ds,ax                    ; normalizovan segment
         and       si,0fh                   ; normalizovan offset
         pop       cx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Poskytnut adresy tabulky videomdu
; -----------------------------------------------------------------------------

PUBLIC   GetTabMod
GetTabMod:
         push      ax
         push      dx

         xor       ax,ax
         mov       al,cs:[VMod]             ; aktuln videomd
         mov       bp,offset(TabMod0-TabMod); dlka jedn poloky tabulky
         mul       bp                       ; offset v tabulce
         add       ax,offset TabMod         ; tabulka parametr displeje
         mov       bp,ax                    ; adresa parametr displeje

         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Poskytnut adresy vstupn videostrnky ES:DI
; -----------------------------------------------------------------------------

PUBLIC   GetVRAM
GetVRAM:
         push      ax
         push      dx
         mov       ah,0
         mov       al,cs:[Page2]            ; vstupn videostrnka
         mul       word ptr cs:[DelVRAM]    ; vpoet offsetu videostrnky
         mov       di,ax                    ; offset adresy videostrnky
         mov       es,cs:[SegVRAM]          ; segment videopamti
         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Omezen rozmr obrazce (CY=obrazec se nezobraz)
; -----------------------------------------------------------------------------
; VSTUP: ObjLD, ObjUD, ObjS, ObjV, Wind1, Wind2, Wind3, Wind4
; VSTUP: ObjLO, ObjUO, mn ObjS, ObjV, ObjLD, ObjUD
; -----------------------------------------------------------------------------

PUBLIC   Omez
Omez:

; ------ schova a pprava registr

         push      ax
         push      bx
         push      bp
         push      ds
         push      cs
         pop       ds
         call      GetTabMod                ; adresa tabulky videomdu BP

; ------ omezen levho okraje

         mov       word ptr ds:[ObjLO],0    ; pednastaven potku v objektu
         mov       bx,ds:[ObjLD]            ; poadovan lev okraj
         mov       ax,ds:[Wind1]            ; lev okraj okna
         or        ax,ax                    ; je lev okraj zporn ?
         jns       Omez1                    ; lev okraj nen zaporn
         xor       ax,ax                    ; omezen levho okraje na 0
Omez1:   cmp       ax,bx                    ; je lev okraj ped potkem ?
         jle       Omez2                    ; lev okraj je ped potkem OK
         mov       ds:[ObjLD],ax            ; nov lev okraj zatku zobrazen
         sub       ax,bx                    ; posun potku
         mov       ds:[ObjLO],ax            ; poten pozice v objektu
         sub       ds:[ObjS],ax             ; snen ky obrazce
         jbe       OmezXX                   ; chyba - nen nic k zobrazen

; ------ omezen hornho okraje

Omez2:   mov       word ptr ds:[ObjUO],0    ; pednastaven potku v objektu
         mov       bx,ds:[ObjUD]            ; poadovan horn okraj
         mov       ax,ds:[Wind2]            ; horn okraj okna
         or        ax,ax                    ; je horn okraj zporn ?
         jns       Omez3                    ; horn okraj nen zporn
         xor       ax,ax                    ; omezen hornho okraje na 0
Omez3:   cmp       ax,bx                    ; je horn okraj nad horn likou ?
         jle       Omez4                    ; horn okraj je nad horn linkou OK
         mov       ds:[ObjUD],ax            ; nov horn okraj zatku zobrazen
         sub       ax,bx                    ; posun hornho okraje
         mov       ds:[ObjUO],ax            ; poten linka v objektu
         sub       ds:[ObjV],ax             ; snen vky obrazce
OmezXX:  jbe       OmezX                    ; chyba - nen nic k zobrazen

; ------ omezen ky obrazce

Omez4:   mov       ax,ds:[Wind3]            ; prav okraj okna
         or        ax,ax                    ; je prav okraj zporn ?
         js        OmezX                    ; chyba - prav okraj je zporn
         inc       ax                       ; prav okraj + 1
         jns       Omez5                    ; nen peteen
         dec       ax                       ; oprava na 32767
Omez5:   cmp       ax,ds:[bp+ModSir]        ; pekroen maximln prav okraj ?
         jle       Omez6                    ; maximln prav okraj nepekroen
         mov       ax,ds:[bp+ModSir]        ; prav okraj + 1
Omez6:   sub       ax,ds:[ObjLD]            ; maximln ka obrazce
         jle       OmezX                    ; chyba-prav okraj je ped potkem
         cmp       ax,ds:[ObjS]             ; je max. ka men ?
         jae       Omez7                    ; ka je dostaten - OK
         mov       ds:[ObjS],ax             ; omezen ky obrazce

; ------ omezen vky objektu

Omez7:   mov       ax,ds:[Wind4]            ; spodn okraj okna
         or        ax,ax                    ; je spodn okraj zporn ?
         js        OmezX                    ; chyba - spodn okraj je zporn
         inc       ax                       ; spodn okraj + 1
         jns       Omez8                    ; nen peteen
         dec       ax                       ; oprava na 32767
Omez8:   cmp       ax,ds:[bp+ModVys]        ; pekroen maximln spodn okraj ?
         jle       Omez9                    ; maximln spodn okraj nepekroen
         mov       ax,ds:[bp+ModVys]        ; spodn okraj + 1
Omez9:   sub       ax,ds:[ObjUD]            ; maximln vka obrazce
         jle       OmezX                    ; chyba-spodn okraj je nad zatkem
         cmp       ax,ds:[ObjV]             ; je max. vka men ?
         jae       Omeza                    ; vka je dostaten - OK
         mov       ds:[ObjV],ax             ; omezen vky obrazce

; ------ oven, zda nezstala ka nebo vka = 0

Omeza:   cmp       word ptr ds:[ObjS],0     ; poaduje se ka 0 ?
         je        OmezX                    ; chyba - je ka 0
         cmp       word ptr ds:[ObjV],0     ; poaduje se vka 0 ?
         clc                                ; pznak - operace OK
         jne       Omezb                    ; vka nen 0 = OK

; ------ nvrat registr

OmezX:   stc                                ; pznak - obrazec se nezobraz
Omezb:   pop       ds
         pop       bp
         pop       bx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Vymazn obdlnku v textovm mdu (ES:DI=videopam, AX=barva)
; -----------------------------------------------------------------------------

PUBLIC   ClrTXT

ClrTxt:

         mov       bx,ds:[bp+ModSirB]       ; poet pozic na dek

; ------ vpoet poten adresy ve videopamti

         push      ax                       ; schova poadovan barvy
         mov       ax,ds:[ObjUD]            ; poadovan poten dek
         mul       bx                       ; pepoet dku na pozice
         add       ax,ds:[ObjLD]            ; piten poten pozice
         add       di,ax
         add       di,ax                    ; poten adresa
         pop       ax                       ; poadovan barva k vymazn

; ------ stanoven mazacho znaku

         xchg      ah,al                    ; AH<-barva
         cmp       al,0                     ; je stanoven mazac znak ?
         jne       ClrTxt1                  ; znak je stanoven
         mov       al,219                   ; mazac znak - pln znak

; ------ vymazn obdlnku

ClrTxt1: cld
         shl       bx,1                     ; poet bajt na dek
         mov       cx,ds:[ObjV]             ; vka obdlnku (dk)
ClrTxt2: push      di                       ; schova ukldac adresy
         push      cx                       ; schova tae dk
         mov       cx,ds:[ObjS]             ; ka obdlnku (pozic)
         rep       stosw                    ; vymazn jednoho dku
         pop       cx                       ; nvrat tae dk
         pop       di                       ; nvrat ukldac adresy
         add       di,bx                    ; zven ukldac adresy
         loop      ClrTxt2                  ; zpis dalho dku

         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen objektu v textovm reimu
; -----------------------------------------------------------------------------
; VSTUP: DS=CS
;        ES:DI=poten adresa videopamti
;        krom SI a BP nemus uchovvat registry
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=poten adresa pro zobrazen objektu
; -----------------------------------------------------------------------------

PUBLIC   PrepTxt
PrepTxt:

; ------ nastaven potu bajt na dek

         mov       ax,ds:[Sirka]            ; ka vezu (znak)
         mov       ds:[SirkaB],ax           ; ka dku v batech

; ------ vpoet potu bajt na rovinu

         mul       word ptr ds:[Vyska]      ; poet bajt na rovinu
         mov       ds:[RovinaB],ax          ; poet bajt na rovinu

; ------ vpoet poten adresy ve videopamti

         mov       ax,ds:[ObjUD]            ; hodn okraj potku k zobrazen
         mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
         add       ax,ds:[ObjLD]            ; piten potenho offsetu
         add       di,ax
         add       di,ax                    ; poten adresa k zobrazen
         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen roviny v textovm mdu
; -----------------------------------------------------------------------------
; VSTUP: BL=rovina
;        DS:SI=poten adresa prvn linky
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=poten adresa k zobrazen
;        krom BP a ES:DI nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   SetTXT
SetTXT:

; ------ korekce adresy ve videopamti podle displeje

         mov       bh,0
         add       di,bx                    ; korekce pro rovinu barev 1
         ret


; -----------------------------------------------------------------------------
;        Zobrazen linky v textovm mdu
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispTXT

DispTXT: push      di
         mov       ch,0
         mov       cl,byte ptr cs:[ObjS]    ; ka objektu (poet znak)

DispTXT1:movsb
         inc       di
         loop      DispTXT1

         pop       di
         add       di,cs:[bp+ModSirB]       ; zven adresy
         add       di,cs:[bp+ModSirB]
         ret

; -----------------------------------------------------------------------------
;        Zobrazen ry v mdu TXT
; -----------------------------------------------------------------------------

LineTxt:
         ret

; -----------------------------------------------------------------------------
;        Zobrazen bodu v mdu TXT (AX=barva, BX=pozice, DX=dek)
; -----------------------------------------------------------------------------

PointTXT:

; ------ vpoet poten adresy ve videopamti

         push      ax                       ; schova poadovan barvy
         mov       ax,ds:[bp+ModSirB]       ; poet znak na dek
         mul       dx                       ; pepoet dku na pozice
         add       ax,bx                    ; piten poten pozice
         shl       ax,1                     ; pevod pozic na bajty
         add       di,ax                    ; poten adresa
         pop       ax                       ; poadovan barva k vymazn

; ------ stanoven znaku

         xchg      ah,al                    ; AH<-barva
         cmp       al,0                     ; je stanoven mazac znak ?
         jne       PoiTxt1                  ; znak je stanoven
         mov       al,219                   ; mazac znak - pln znak

; ------ zpis znaku na displej

PoiTxt1: stosw                              ; uloen znaku
         ret

; -----------------------------------------------------------------------------
;        Vymazn obdlnku v mdu CGA4 (ES:DI=videopam, DS:BP=tab., AX=barva)
; -----------------------------------------------------------------------------

PUBLIC   ClrCG4
ClrCG4:
         mov       bx,ax                    ; poadovan barva
         and       bx,303h                  ; maskovn barvy

; ------ vpoet prvn masky objektu (lev okraj)

         mov       cl,byte ptr ds:[ObjLD]   ; lev okraj zatku zobrazen
         and       cl,3                     ; pozice 0 a 3
         mov       al,0ffh                  ; inicializan maska
         shr       al,cl                    ; rotace masky vpravo
         shr       al,cl                    ; jet jednou rotace (2 bity/bod)
         mov       ds:[MaskFrst],al         ; maska prvnho bajtu

; ------ vpoet potu zbylch bod

         mov       dl,4                     ; poet bod na bajt
         sub       dl,cl                    ; poet bod v prvnm bajtu (1 a 4)
         mov       dh,0                     ; BX=poet bod zobrazench vlevo
         mov       ax,ds:[ObjS]             ; ka pro zobrazen objektu
         sub       ax,dx                    ; poet zbylch bod
         js        ClrCG41                  ; je mal poet bod

; ------ vpoet potu celch bajt

         mov       dx,ax                    ; schova potu zbylch bod
         shr       ax,1
         shr       ax,1                     ; poet celch vnitnch bajt
         mov       ds:[MaskNum],al          ; poet vnitnch bajt

; ------ vpoet masky pravho okraje

         and       dl,3                     ; poet zbylch bod vpravo (0 a 3)
         mov       cl,4                     ; poet bod na bajt
         sub       cl,dl                    ; poet nezobraz. bod vpravo (1-4)
         mov       al,0ffh                  ; maska pravho okraje
         shl       al,cl                    ; vpoet masky pravho okraje
         shl       al,cl                    ; jet jednou rotace (2 bity/bod)
         mov       ds:[MaskLst],al          ; maska pravho okraje (00 - FC)
         jmp       short ClrCG42

; ------ oprava prvn masky pro mal poet bod

ClrCG41: add       cl,byte ptr ds:[ObjS]    ; koncov bitov pozice+1 (1 a 3)
         mov       al,4                     ; poet bod na bajt
         sub       al,cl                    ; poet nezobrazench bod vpravo
         mov       cl,al                    ; poet nezobrazench bod vpravo
         mov       al,0ffh                  ; maska
         shl       al,cl                    ; rotace korekn masky
         shl       al,cl                    ; jet jednou rotace (2 bity/bod)
         and       ds:[MaskFrst],al         ; oprava prvn masky
         mov       byte ptr ds:[MaskLst],0  ; nen prav maska
         mov       byte ptr ds:[MaskNum],0  ; nen dn vnitn bajt

; ------ vpoet poten adresy ve videopamti

ClrCG42: mov       ax,ds:[ObjUD]            ; hodn okraj potku k zobrazen
         shr       ax,1                     ; pouze kad sud linka
         jnc       ClrCG43                 ; je sud linka
         xor       di,2000h                 ; korekce pro lichou linku
ClrCG43: mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
         add       di,ax                    ; poten adresa linky
         mov       dx,ds:[ObjLD]            ; lev okraj zatku zobrazen
         shr       dx,1
         shr       dx,1                     ; pepoet na offset v bajtech
         add       di,dx                    ; poten adresa k zobrazen

; ------ stanoven vzorku vpln

         mov       si,ds:[ObjUD]            ; poten linka
         and       si,7                     ; opakovn po 8 linkch
         add       si,offset Pattern        ; adresa v tabulce vpln

; ------ zpis obdlnku do jedn roviny

         mov       cx,ds:[ObjV]             ; vka obdlnku v linkch
ClrCG44: push      cx                       ; schova tae linek
         push      di                       ; schova ukldac adresy
         call      FilCG4                   ; zpis jedn linky
         pop       di                       ; ukldac adresa
         pop       cx                       ; nvrat tae linek
         test      di,2000h                 ; je sud linka ?
         jz        ClrCG45                  ; je sud linka
         add       di,ds:[bp+ModSirB]       ; zven adresy ve videopamti
ClrCG45: xor       di,2000h
         loop      ClrCG44                  ; zobrazen dal linky

         ret

; -----------------------------------------------------------------------------
;        Vymazn linku v mdu CGA - 4 a 5
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa vzorku
;        BL=barva poped
;        BH=barva pozad
; VSTUP: DS:SI=adresa dalho vzorku
; znien registry: AX, DX, DI, CX
; -----------------------------------------------------------------------------

PUBLIC   FilCG4
FilCG4:

; ------ stanoven vzorku vpln

         mov       ah,ds:[si]               ; vzorek vpln
         mov       cx,8                     ; poet bit vzorku
FilCG41: shl       dx,1
         shl       dx,1                     ; posun stadae barvy
         shl       ah,1                     ; je poped nebo pozad ?
         jnc       FilCG42                  ; je pozad
         or        dl,bl                    ; barva poped
         jmp       short FilCG43
FilCG42: or        dl,bh                    ; je barva pozad
FilCG43: loop      FilCG41                  ; dal bit vzorku
         test      di,1                     ; je lich ukldac adresa ?
         jz        FilCG44                  ; je sud adresa
         xchg      dh,dl                    ; lich adresa - bude ni st

; ------ zobrazen prvnho bajtu linky

FilCG44: mov       ah,cs:[MaskFrst]         ; maska prvnho bajtu
         mov       al,dh                    ; prvn bajt k zpisu
         and       al,ah                    ; zamaskovn prvnho bajtu
         not       ah                       ; inverze masky
         and       es:[di],ah               ; maskovn starho bajtu
         or        es:[di],al               ; zpis novho bajtu
         inc       di                       ; zven ukldac adresy

; ------ zobrazen vnitnch bajt linky

         cld                                ; smr nahoru
         mov       cl,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       ch,0                     ; CX=poet bajt
         shr       cx,1                     ; poet bajt / 2
         mov       ax,dx                    ; vzorek k zpisu
         rep       stosw                    ; zpis vnitnch bajt
         jnc       FilCG45                  ; byl sud poet bajt
         stosb                              ; zpis lichho bajtu
         xchg      dh,dl                    ; jako dal bude vy bajt

; ------ zobrazen poslednho bajtu linky

FilCG45: mov       ah,cs:[MaskLst]          ; maska poslednho bajtu
         mov       al,dl                    ; posledn bajt k zpisu
         and       al,ah                    ; zamaskovn poslednho bajtu
         not       ah                       ; inverze masky
         and       es:[di],ah               ; maskovn starho bajtu
         or        es:[di],al               ; zpis novho bajtu

; ------ nastaven ukazatele na dal vzorek vpln

         inc       si                       ; zven adresy vpln
         cmp       si,offset Pattern+8      ; pekroen konec tabulky ?
         jb        FilCG46                  ; konec tabulky nepekroen
         mov       si,offset Pattern        ; ukazatel na zatek tabulky
FilCG46: ret

; -----------------------------------------------------------------------------
;        Vymazn displeje CGA - mdy 6 a 17
; -----------------------------------------------------------------------------

PUBLIC   ClrCG6
ClrCG6:
         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen objektu v CGA (2 bity na bod)
; -----------------------------------------------------------------------------
; VSTUP: DS=CS
;        ES:DI=poten adresa videopamti
;        krom SI a BP nemus uchovvat registry
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=poten adresa pro zobrazen objektu
; -----------------------------------------------------------------------------
; 
PUBLIC   PrepCG4
PrepCG4:

; ------ vpoet potu bajt na linku

         mov       ax,ds:[Sirka]            ; ka vezu (bod)
         add       ax,3                     ; zaokrouhlen na 4 body
         shr       ax,1
         shr       ax,1                     ; pevod na bajty
         mov       ds:[SirkaB],ax           ; ka linky v batech

; ------ vpoet potu bajt na rovinu

         mul       word ptr ds:[Vyska]      ; poet bajt na rovinu
         mov       ds:[RovinaB],ax          ; poet bajt na rovinu

; ------ vpoet prvn masky objektu (lev okraj)

         mov       cl,byte ptr ds:[ObjLD]   ; lev okraj zatku zobrazen
         and       cl,3                     ; pozice 0 a 3
         mov       al,0ffh                  ; inicializan maska
         shr       al,cl                    ; rotace masky vpravo
         shr       al,cl                    ; jet jednou rotace (2 bity/bod)
         mov       ds:[MaskFrst],al         ; maska prvnho bajtu

; ------ vpoet rotace objektu

         mov       ax,ds:[ObjLD]            ; lev okraj zatku zobrazen
         sub       ax,ds:[ObjLO]            ; teoretick lev okraj objektu
         and       al,3                     ; rozdl fze v bodech
         shl       al,1                     ; rotace objektu vpravo
         mov       ds:[MaskRot],al          ; rotace objektu vpravo (v bitech)

; ------ vpoet potu zbylch bod

         mov       bl,4                     ; poet bod na bajt
         sub       bl,cl                    ; poet bod v prvnm bajtu (1 a 4)
         mov       bh,0                     ; BX=poet bod zobrazench vlevo
         mov       ax,ds:[ObjS]             ; ka pro zobrazen objektu
         sub       ax,bx                    ; poet zbylch bod
         js        PrepCG43                 ; je mal poet bod

; ------ vpoet potu celch bajt

         mov       bx,ax                    ; schova potu zbylch bod
         shr       ax,1
         shr       ax,1                     ; poet celch vnitnch bajt
         mov       ds:[MaskNum],al          ; poet vnitnch bajt

; ------ vpoet masky pravho okraje

         and       bl,3                     ; poet zbylch bod vpravo (0 a 3)
         mov       cl,4                     ; poet bod na bajt
         sub       cl,bl                    ; poet nezobraz. bod vpravo (1-4)
         mov       al,0ffh                  ; maska pravho okraje
         shl       al,cl                    ; vpoet masky pravho okraje
         shl       al,cl                    ; jet jednou rotace (2 bity/bod)
         mov       ds:[MaskLst],al          ; maska pravho okraje (00 - FC)
         jmp       short PrepCG44

; ------ oprava prvn masky pro mal poet bod

PrepCG43:add       cl,byte ptr ds:[ObjS]    ; koncov bitov pozice+1 (1 a 3)
         mov       al,4                     ; poet bod na bajt
         sub       al,cl                    ; poet nezobrazench bod vpravo
         mov       cl,al                    ; poet nezobrazench bod vpravo
         mov       al,0ffh                  ; maska
         shl       al,cl                    ; rotace korekn masky
         shl       al,cl                    ; jet jednou rotace (2 bity/bod)
         and       ds:[MaskFrst],al         ; oprava prvn masky
         mov       byte ptr ds:[MaskLst],0  ; nen prav maska
         mov       byte ptr ds:[MaskNum],0  ; nen dn vnitn bajt

; ------ vpoet poten adresy ve videopamti

PrepCG44:mov       ax,ds:[ObjUD]            ; hodn okraj potku k zobrazen
         shr       ax,1                     ; pouze kad sud linka
         jnc       PrepCG45                 ; je sud linka
         xor       di,2000h                 ; korekce pro lichou linku
PrepCG45:mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
         add       di,ax                    ; poten adresa linky
         mov       bx,ds:[ObjLD]            ; lev okraj zatku zobrazen
         shr       bx,1
         shr       bx,1                     ; pepoet na offset v bajtech
         add       di,bx                    ; poten adresa k zobrazen

; ------ nastaven adresy obsluhy zobrazen linky

         test      byte ptr ds:[Param],8    ; je maska ?
         jz        PrepCG48                 ; nen maska
         mov       word ptr ds:[bp+ModDisp],offset DispCG3 ; maska bez rotace
         cmp       byte ptr ds:[MaskRot],0  ; je rotace ?
         je        PrepCG49                 ; nen rotace
         mov       word ptr ds:[bp+ModDisp],offset DispCG4 ; maska s rotac
         jmp       short PrepCG49

PrepCG48:mov       word ptr ds:[bp+ModDisp],offset DispCG2 ; rotace bez masky
         cmp       byte ptr ds:[MaskRot],0  ; je rotace ?
         jne       PrepCG49                 ; je rotace
         mov       word ptr ds:[bp+ModDisp],offset DispCG1 ; bez rotace i masky
PrepCG49:
         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen objektu v CGA (2 bity na bod)
; -----------------------------------------------------------------------------
; VSTUP: DS=CS
;        ES:DI=poten adresa videopamti
;        krom SI a BP nemus uchovvat registry
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=poten adresa pro zobrazen objektu
; -----------------------------------------------------------------------------

PUBLIC   PrepCG6
PrepCG6:

         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen roviny CGA
; -----------------------------------------------------------------------------
; VSTUP: BL=rovina
;        DS:SI=poten adresa prvn linky
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=poten adresa k zobrazen
;        krom BP a ES:DI nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   SetCG4
SetCG4:

; ------ nastaven poten adresy roviny

         mov       ax,cs:[ObjLO]            ; lev okraj potku v objektu
         shl       ax,1                     ; pevod na bity
         add       al,cs:[MaskRot]          ; posun o masku
         adc       ah,0                     ; penos do vyho bajtu
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pepoet na bajty
         add       si,ax                    ; adresa potku linky
         add       word ptr cs:[MaskAdr],ax ; poten adresa masky
         ret


; -----------------------------------------------------------------------------
;        Pprava pro zobrazen roviny CGA
; -----------------------------------------------------------------------------
; VSTUP: BL=rovina
;        DS:SI=poten adresa prvn linky
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=poten adresa k zobrazen
;        krom BP a ES:DI nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   SetCG6
SetCG6:

; ------ nastaven poten adresy roviny

         mov       ax,cs:[ObjLO]            ; lev okraj potku v objektu
         add       al,cs:[MaskRot]          ; posun o masku
         adc       ah,0                     ; penos do vyho bajtu
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pepoet na bajty
         add       si,ax                    ; adresa potku linky
         add       word ptr cs:[MaskAdr],ax ; poten adresa masky
         ret


; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu CGA - bez masky i bez rotace
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispCG1

; ------ schova registr

DispCG1: push      di

; ------ pprava registr

         cld                                ; smr nahoru
         mov       ch,0
         mov       cl,cs:[MaskNum]          ; poet vnitnch bajt linky

; ------ zobrazen prvnho bajtu linky
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         mov       dl,cs:[MaskFrst]         ; maska prvnho bajtu
         lodsb                              ; rovina
         and       al,dl                    ; maskovn bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn prvnho bajtu
         or        al,ah                    ; nastaven novho bajtu
         stosb                              ; uloen novho bajtu

; ------ zobrazen vnitnch bajt linky
                                            ; CX=poet bajt
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         rep       movsb                    ; penos vnitnch bajt

; ------ zobrazen poslednho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         mov       dl,cs:[MaskLst]          ; maska poslednho bajtu
         lodsb                              ; rovina
         and       al,dl                    ; maskovn bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn prvnho bajtu
         or        al,ah                    ; nastaven novho bajtu
         stosb                              ; uloen novho bajtu

; ------ zven adresy displeje

         pop       di
         cmp       byte ptr cs:[VMod],17    ; je videomd 17 (MCGA) ?
         je        DispCG18                 ; je videomd 17 (MCGA)
         xor       di,2000h
         test      di,2000h                 ; je sud linka ?
         jnz       DispCG19                 ; je lich linka
DispCG18:add       di,80                    ; piten potu bajt na dek

DispCG19:ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu CGA - rotace bez masky
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispCG2

; ------ schova registr

DispCG2: push      di

; ------ pprava registr

         cld                                ; smr nahoru
         mov       cl,cs:[MaskRot]          ; poet rotac bajtu
         mov       ch,cs:[MaskNum]          ; poet vnitnch bajt linky

; ------ zobrazen prvnho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         mov       dl,cs:[MaskFrst]         ; maska prvnho bajtu
         mov       ah,ds:[si-1]
         mov       al,ds:[si]               ; rovina
         ror       ax,cl                    ; rotace na pozici
         and       al,dl                    ; maskovn bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn prvnho bajtu
         or        al,ah                    ; nastaven novho bajtu
         stosb                              ; uloen novho bajtu

; ------ zobrazen vnitnch bajt linky
                                            ; CL=rotace vpravo
                                            ; CH=poet bajt
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         or        ch,ch                    ; je njak vnitn bajt ?
         jz        DispCG23                 ; nen dn vnitn bajt
DispCG22:mov       ah,ds:[si]               ; rovina
         mov       al,ds:[si+1]
         inc       si                       ; zven adresy roviny
         ror       ax,cl                    ; rotace na pozici
         stosb                              ; zpis bajtu na displej
         dec       ch                       ; snen tae bajt
         jnz       DispCG22                 ; zpis dalho bajtu

; ------ zobrazen poslednho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

DispCG23:mov       dl,cs:[MaskLst]          ; maska poslednho bajtu
         mov       ah,ds:[si]
         mov       al,ds:[si+1]             ; rovina
         ror       ax,cl                    ; rotace na pozici
         and       al,dl                    ; maskovn bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn prvnho bajtu
         or        al,ah                    ; nastaven novho bajtu
         stosb                              ; uloen novho bajtu

; ------ zven adresy displeje

         pop       di
         cmp       byte ptr cs:[VMod],17    ; je videomd 17 (MCGA) ?
         je        DispCG28                 ; je videomd 17 (MCGA)
         xor       di,2000h
         test      di,2000h                 ; je sud linka ?
         jnz       DispCG29                 ; je lich linka
DispCG28:add       di,80                    ; piten potu bajt na dek

DispCG29:ret


; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu CGA - rotace s maskou
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispCG4

DispCG3:

; ------ schova registr

DispCG4: push      di
         push      bp

; ------ pprava registr

         cld                                ; smr nahoru
         mov       cl,cs:[MaskRot]          ; poet rotac bajtu
         mov       ch,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       bx,word ptr cs:[MaskAdr] ; offset adresy masky
         mov       bp,word ptr cs:[MaskAdr+2] ; segment adresy masky

; ------ zobrazen prvnho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa
                                            ; BP:BX=adresa masky

         push      ds
         mov       ds,bp                    ; segment masky
         mov       dh,ds:[bx-1]             ; pedchoz bajt masky
         mov       dl,ds:[bx]               ; ni bajt masky
         pop       ds
         ror       dx,cl                    ; rotace masky na pozici
         and       dl,cs:[MaskFrst]         ; maska prvnho bajtu

         mov       ah,ds:[si-1]
         mov       al,ds:[si]               ; rovina
         ror       ax,cl                    ; rotace na pozici
         and       al,dl                    ; maskovn bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn prvnho bajtu
         or        al,ah                    ; sestaven novho bajtu
         stosb                              ; uloen novho bajtu

; ------ zobrazen vnitnch bajt linky
                                            ; CL=rotace vpravo
                                            ; CH=poet bajt
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa
                                            ; BP:BX=adresa masky

         or        ch,ch                    ; je njak vnitn bajt ?
         jz        DispCG43                 ; nen dn vnitn bajt
DispCG42:
         push      ds
         mov       ds,bp                    ; segment masky
         mov       dh,ds:[bx]               ; prvn bajt masky
         mov       dl,ds:[bx+1]             ; druh bajt masky
         inc       bx                       ; zven ukazatele masky
         pop       ds
         ror       dx,cl                    ; rotace masky na pozici

         mov       ah,ds:[si]               ; rovina
         mov       al,ds:[si+1]
         inc       si                       ; zven adresy roviny
         ror       ax,cl                    ; rotace na pozici
         and       al,dl                    ; maskovn novho bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn pvodnho bajtu
         or        al,ah                    ; sestaven novho bajtu
         stosb                              ; zpis bajtu na displej
         dec       ch                       ; snen tae bajt
         jnz       DispCG42                 ; zpis dalho bajtu

; ------ zobrazen poslednho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa
                                            ; BP:BX=adresa masky
DispCG43:
         push      ds
         mov       ds,bp                    ; segment masky
         mov       dh,ds:[bx]               ; prvn bajt masky
         mov       dl,ds:[bx+1]             ; druh bajt masky
         pop       ds
         ror       dx,cl                    ; rotace masky na pozici
         and       dl,cs:[MaskLst]          ; maska poslednho bajtu

         mov       ah,ds:[si]               ; rovina
         mov       al,ds:[si+1]
         ror       ax,cl                    ; rotace na pozici
         and       al,dl                    ; maskovn novho bajtu
         not       dl                       ; inverze masky
         mov       ah,es:[di]               ; pvodn bajt
         and       ah,dl                    ; maskovn pvodnho bajtu
         or        al,ah                    ; sestaven novho bajtu
         stosb                              ; zpis bajtu na displej

; ------ zven adresy displeje

         pop       bp
         pop       di

         cmp       byte ptr cs:[VMod],17    ; je videomd 17 (MCGA) ?
         je        DispCG48                 ; je videomd 17 (MCGA)
         xor       di,2000h
         test      di,2000h                 ; je sud linka ?
         jnz       DispCG49                 ; je lich linka
DispCG48:add       di,80                    ; piten potu bajt na dek

DispCG49:ret

; -----------------------------------------------------------------------------
;        Zobrazen ry v mdu CGA 4
; -----------------------------------------------------------------------------

LineCG4:
         ret

; -----------------------------------------------------------------------------
;        Zobrazen ry v mdu CGA 6
; -----------------------------------------------------------------------------

LineCG6:
         ret

; -----------------------------------------------------------------------------
;        Zobrazen bodu v mdu CGA 4
; -----------------------------------------------------------------------------

PointCG4:
         ret

; -----------------------------------------------------------------------------
;        Zobrazen bodu v mdu CGA 6
; -----------------------------------------------------------------------------

PointCG6:
         ret

; -----------------------------------------------------------------------------
;        Vymazn obdlnku v mdu EGA (ES:DI=videopam, DS:BP=tab., AX=barva)
; -----------------------------------------------------------------------------
; 
PUBLIC   ClrEGA
ClrEGA:
         mov       bx,ax                    ; poadovan barva (schova)

; ------ korekce, pokud nen dn pozad

         cmp       byte ptr cs:[AndPatt],0ffh ; je njak pozad ?
         jne       ClrEGA0                  ; je njak pozad
         mov       bh,bl                    ; barva pozad stejn jako poped

; ------ inicializace registr videokarty EGA

ClrEGA0: call      InitREGA                 ; inicializace registr EGA

; ------ nastaven barvy pro stejn roviny poped i pozad

         mov       dx,3ceh
         mov       al,0
         out       dx,al
         inc       dx
         mov       al,bl                    ; barva poped
         out       dx,al                    ; shodn barva poped i pozad
         dec       dx

; ------ maska stejnch rovin poped i pozad

         mov       al,1
         out       dx,al
         inc       dx
         mov       al,bl                    ; barva poped
         xor       al,bh                    ; porovnn s pozadm
         not       al                       ; maska stejnch rovin
         out       dx,al                    ; nastaven masky stejnch rovin

; ------ nastaven masky rovin pro prvn fzi zobrazen

         or        al,bl                    ; stejn roviny a poped
         mov       ah,al                    ; schova masky rovin
         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; registr masky
         inc       dx
         mov       al,ah                    ; maska pro prvn fzi
         out       dx,al                    ; nastaven masky rovin prvn fze

; ------ vpoet prvn masky objektu (lev okraj)

         mov       cl,byte ptr ds:[ObjLD]   ; lev okraj zatku zobrazen
         and       cl,7                     ; poten bitov pozice (0 a 7)
         mov       al,0ffh                  ; inicializan maska
         shr       al,cl                    ; rotace masky vpravo (FF a 01)
         mov       ds:[MaskFrst],al         ; maska prvnho bajtu

; ------ vpoet potu zbylch bod

         mov       dl,8                     ; poet bod na bajt
         sub       dl,cl                    ; poet necelch bod vlevo (1 a 8)
         mov       dh,0                     ; BX=poet bod zobrazench vlevo
         mov       ax,ds:[ObjS]             ; ka pro zobrazen objektu
         sub       ax,dx                    ; poet zbylch bod
         js        ClrEGA1                  ; je mal poet bod

; ------ vpoet potu celch bajt

         mov       dx,ax                    ; schova potu zbylch bod
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; poet celch vnitnch bajt
         mov       ds:[MaskNum],al          ; poet vnitnch bajt

; ------ vpoet masky pravho okraje

         and       dl,7                     ; poet zbylch bod vpravo (0 a 7)
         mov       cl,8                     ; poet bod na bajt
         sub       cl,dl                    ; poet nezobraz. bod vpravo (1-8)
         mov       al,0ffh                  ; maska pravho okraje
         shl       al,cl                    ; vpoet masky pravho okr. (00-FE)
         mov       ds:[MaskLst],al          ; maska pravho okraje (00 - FE)
         jmp       short ClrEGA2

; ------ oprava prvn masky pro mal poet bod

ClrEGA1: add       cl,byte ptr ds:[ObjS]    ; koncov bitov pozice+1 (1 a 6)
         mov       al,8                     ; poet bod na bajt
         sub       al,cl                    ; poet nezobrazench bod vpravo
         mov       cl,al                    ; poet nezobrazench bod vpravo
         mov       al,0ffh                  ; maska
         shl       al,cl                    ; rotace korekn masky
         and       ds:[MaskFrst],al         ; oprava prvn masky
         mov       byte ptr ds:[MaskLst],0  ; nen prav maska
         mov       byte ptr ds:[MaskNum],0  ; nen dn vnitn bajt

; ------ vpoet poten adresy ve videopamti

ClrEGA2: mov       ax,ds:[ObjUD]            ; hodn okraj potku k zobrazen
         mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
         add       di,ax                    ; poten adresa linky
         mov       dx,ds:[ObjLD]            ; lev okraj zatku zobrazen
         shr       dx,1
         shr       dx,1
         shr       dx,1                     ; pepoet na offset v bajtech
         add       di,dx                    ; poten adresa k zobrazen

; ------ stanoven vzorku vpln

         mov       si,ds:[ObjUD]            ; poten linka
         and       si,7                     ; opakovn po 8 linkch
         add       si,offset Pattern        ; adresa v tabulce vpln

; ------ nastaven registry masky

         mov       dx,3ceh                  ; dic registr
         mov       al,8
         out       dx,al                    ; volba registru 8 - reg. masky
         inc       dx                       ; 3cfh - adresa registru masky

; ------ zpis obdlnku

         push      si
         push      di

         mov       cx,ds:[ObjV]             ; vka obdlnku v linkch
ClrEGA4: push      cx                       ; schova tae linek
         push      di                       ; schova ukldac adresy
         mov       ah,ds:[si]
         call      FilEGA                   ; zpis jedn linky
         pop       di                       ; ukldac adresa
         pop       cx                       ; nvrat tae linek
         add       di,ds:[bp+ModSirB]       ; zven adresy ve videopamti
         loop      ClrEGA4                  ; zobrazen dal linky

         pop       di
         pop       si

; ------ stanoven masky pro opravu pozad

         xor       bl,bh                    ; porovnn poped a pozad
         and       bl,bh                    ; maska rovin pozad
         jz        ClrEGA9                  ; nezbyla dn rovina

; ------ volba rovin pro opravu pozad

         mov       dx,3c4h
         mov       al,2
         out       dx,al
         inc       dx
         mov       al,bl                    ; maska rovin pro opravu pozad
         out       dx,al

; ------ pprava registru masky 8

         mov       dx,3ceh
         mov       al,8
         out       dx,al                    ; volba registru 8 - reg. masky
         inc       dx                       ; 3cfh - adresa registru masky

; ------ zpis opravy pozad obdlnku

         mov       cx,ds:[ObjV]             ; vka obdlnku v linkch
ClrEGA5: mov       ah,ds:[si]
         not       ah                       ; pozad
         push      cx                       ; schova tae linek
         push      di                       ; schova ukldac adresy
         call      FilEGA                   ; zpis jedn linky
         pop       di                       ; ukldac adresa
         pop       cx                       ; nvrat tae linek
         add       di,ds:[bp+ModSirB]       ; zven adresy ve videopamti
         loop      ClrEGA5                  ; zobrazen dal linky

; ------ nvrat registr

ClrEGA9: mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity
         dec       dx
         mov       al,1
         out       dx,al
         inc       dx
         xor       al,al
         out       dx,al
         ret




;         mov       bx,ax                    ; poadovan barva
;
;; ------ inicializace registr videokarty EGA
;
;         call      InitREGA                 ; inicializace registr EGA
;
;; ------ vpoet prvn masky objektu (lev okraj)
;
;         mov       cl,byte ptr ds:[ObjLD]   ; lev okraj zatku zobrazen
;         and       cl,7                     ; poten bitov pozice (0 a 7)
;         mov       al,0ffh                  ; inicializan maska
;         shr       al,cl                    ; rotace masky vpravo (FF a 01)
;         mov       ds:[MaskFrst],al         ; maska prvnho bajtu
;
;; ------ vpoet potu zbylch bod
;
;         mov       dl,8                     ; poet bod na bajt
;         sub       dl,cl                    ; poet necelch bod vlevo (1 a 8)
;         mov       dh,0                     ; BX=poet bod zobrazench vlevo
;         mov       ax,ds:[ObjS]             ; ka pro zobrazen objektu
;         sub       ax,dx                    ; poet zbylch bod
;         js        ClrEGA1                  ; je mal poet bod
;
;; ------ vpoet potu celch bajt
;
;         mov       dx,ax                    ; schova potu zbylch bod
;         shr       ax,1
;         shr       ax,1
;         shr       ax,1                     ; poet celch vnitnch bajt
;         mov       ds:[MaskNum],al          ; poet vnitnch bajt
;
;; ------ vpoet masky pravho okraje
;
;         and       dl,7                     ; poet zbylch bod vpravo (0 a 7)
;         mov       cl,8                     ; poet bod na bajt
;         sub       cl,dl                    ; poet nezobraz. bod vpravo (1-8)
;         mov       al,0ffh                  ; maska pravho okraje
;         shl       al,cl                    ; vpoet masky pravho okr. (00-FE)
;         mov       ds:[MaskLst],al          ; maska pravho okraje (00 - FE)
;         jmp       short ClrEGA2
;
;; ------ oprava prvn masky pro mal poet bod
;
;ClrEGA1: add       cl,byte ptr ds:[ObjS]    ; koncov bitov pozice+1 (1 a 6)
;         mov       al,8                     ; poet bod na bajt
;         sub       al,cl                    ; poet nezobrazench bod vpravo
;         mov       cl,al                    ; poet nezobrazench bod vpravo
;         mov       al,0ffh                  ; maska
;         shl       al,cl                    ; rotace korekn masky
;         and       ds:[MaskFrst],al         ; oprava prvn masky
;         mov       byte ptr ds:[MaskLst],0  ; nen prav maska
;         mov       byte ptr ds:[MaskNum],0  ; nen dn vnitn bajt
;
;; ------ vpoet poten adresy ve videopamti
;
;ClrEGA2: mov       ax,ds:[ObjUD]            ; hodn okraj potku k zobrazen
;         mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
;         add       di,ax                    ; poten adresa linky
;         mov       dx,ds:[ObjLD]            ; lev okraj zatku zobrazen
;         shr       dx,1
;         shr       dx,1
;         shr       dx,1                     ; pepoet na offset v bajtech
;         add       di,dx                    ; poten adresa k zobrazen
;
;; ------ stanoven vzorku vpln
;
;         mov       si,ds:[ObjUD]            ; poten linka
;         and       si,7                     ; opakovn po 8 linkch
;         add       si,offset Pattern        ; adresa v tabulce vpln
;
;; ------ pprava registr pro nastaven barevn roviny
;
;         mov       ch,ds:[bp+ModRov]        ; poet barevnch rovin
;         mov       cl,1                     ; bit masky roviny
;
;; ------ nastaven barevn roviny
;
;ClrEGA3: mov       dx,3c4h                  ; port pro nastaven barevn roviny
;         mov       al,2
;         out       dx,al                    ; registr 0 - volba barevn roviny
;         inc       dx
;         mov       al,cl                    ; maska roviny
;         out       dx,al                    ; volba barevn roviny
;
;; ------ nastaven registry masky
;
;         mov       dx,3ceh                  ; dic registr
;         mov       al,8
;         out       dx,al                    ; volba registru 8 - reg. masky
;         inc       dx                       ; 3cfh - adresa registru masky
;
;; ------ zpis obdlnku do jedn roviny
;
;         push      cx                       ; schova tae rovin
;         push      di                       ; schova adresy videopamti
;         push      si                       ; schova ukazatele vzork
;         mov       cx,ds:[ObjV]             ; vka obdlnku v linkch
;ClrEGA4: push      cx                       ; schova tae linek
;         push      di                       ; schova ukldac adresy
;         call      FilEGA                   ; zpis jedn linky
;         pop       di                       ; ukldac adresa
;         pop       cx                       ; nvrat tae linek
;         add       di,ds:[bp+ModSirB]       ; zven adresy ve videopamti
;         loop      ClrEGA4                  ; zobrazen dal linky
;         pop       si                       ; nvrat ukazatele vzork
;         pop       di                       ; nvrat adresy videopamti
;         pop       cx                       ; nvrat tae rovin
;
;; ------ zven ukazatele roviny
;
;         shr       bx,1                     ; posun barev na dal rovinu
;         shl       cl,1                     ; posun bitu masky roviny
;         dec       ch                       ; snen tae rovin
;         jnz       ClrEGA3                  ; zpis dal roviny
;
;; ------ nvrat registr
;
;         mov       al,0ffh                  ; maska - vechny bity
;         out       dx,al                    ; povolen masky pro vechny bity
;         ret

; -----------------------------------------------------------------------------
;        Inicializace registr EGA
; -----------------------------------------------------------------------------

PUBLIC   InitREGA
InitREGA:
         push      ax
         push      dx

         mov       dx,3c4h
         mov       al,2
         out       dx,al
         mov       al,0fh
         inc       dx
         out       dx,al                    ; zpis do vech rovin

         mov       dx,3ceh
         mov       al,5
         out       dx,al
         inc       dx
         mov       al,0
         out       dx,al                    ; zpisov md 0
         dec       dx

         mov       al,0
         out       dx,al
         inc       dx
         mov       al,0fh
         out       dx,al                    ; vechny roviny pro zpis
         dec       dx

         mov       al,1
         out       dx,al
         inc       dx
         mov       al,0
         out       dx,al                    ; dn rovina pro XOR
         dec       dx

         mov       al,3
         out       dx,al
         inc       dx
         mov       al,0
         out       dx,al                    ; funkce zpisu beze zmny dat

         pop       dx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        Vymazn linku v mdu EGA (pro jednu rovinu)
; -----------------------------------------------------------------------------
; VSTUP: AH=vzorek
;        ES:DI=ukldac adresa
;        DS:SI=adresa vzorku
;        DX=adresa registru 3cfh (nastaven registr 8)
; VSTUP: DS:SI=adresa dalho vzorku
; znien registry: AL, DI, CX
; -----------------------------------------------------------------------------

PUBLIC   FilEGA
FilEGA:

; ------ zobrazen prvnho bajtu linky

         mov       al,cs:[MaskFrst]         ; maska prvnho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         mov       al,ah                    ; vzorek vpln
         xchg      al,es:[di]               ; zpis prvnho bajtu linky
         inc       di                       ; zven ukldac adresy

; ------ zobrazen vnitnch bajt linky

         cld                                ; smr nahoru
         mov       cl,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       ch,0                     ; CX=poet bajt
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen zpisu pro vechny bity
         mov       al,ah                    ; vzorek vpln

; ------ zpis vnitnch bajt rychlej metodou

FilEGA2: test      di,1                     ; je lich adresa ?
         jnz       FilEGA5                  ; je lich adresa

                                          ;* je sud adresa
         shr       cx,1                     ; poet bajt / 2
FilEGA6: rep       stosw                    ; zpis vnitnch bajt
         jnc       FilEGA7                  ; byl sud poet bajt
         stosb                              ; zpis lichho bajtu
         jmp       short FilEGA7

                                          ;* je lich adresa
FilEGA5: shr       cx,1                     ; poet bajt / 2
         jnc       FilEGA4                  ; je sud poet bajt
         stosb                              ; zpis lichho bajtu
FilEGA4: rep       stosw                    ; zpis vnitnch bajt

; ------ zobrazen poslednho bajtu linky

FilEGA7: mov       al,cs:[MaskLst]          ; maska poslednho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         mov       al,ah                    ; vzorek vpln
         xchg      al,es:[di]               ; zpis poslednho bajtu linky

; ------ nastaven ukazatele na dal vpl

         inc       si                       ; zven adresy vpln
         cmp       si,offset Pattern+8      ; pekroen konec tabulky ?
         jb        FilEGA3                  ; konec tabulky nepekroen
         mov       si,offset Pattern        ; ukazatel na zatek tabulky
FilEGA3: ret



;
;; ------ stanoven vzorku vpln
;
;         mov       ah,0                     ; pednastaven - nen dn barva
;         test      bh,1                     ; je pozad ?
;         jz        FilEGA1                  ; pozad nen
;         mov       ah,ds:[si]               ; vzorek vpln
;         not       ah                       ; negace - plat bity 0
;FilEGA1: test      bl,1                     ; je poped ?
;         jz        FilEGA2                  ; nen poped
;         or        ah,ds:[si]               ; nastaven bit pro poped
;
;; ------ zobrazen prvnho bajtu linky
;
;FilEGA2: mov       al,cs:[MaskFrst]         ; maska prvnho bajtu
;         out       dx,al                    ; nastaven masky pro zpis
;         mov       al,ah                    ; vzorek pro vpl
;         xchg      al,es:[di]               ; zpis prvnho bajtu linky
;         inc       di                       ; zven ukldac adresy
;
;; ------ zobrazen vnitnch bajt linky
;
;         cld                                ; smr nahoru
;         mov       cl,cs:[MaskNum]          ; poet vnitnch bajt linky
;         mov       ch,0                     ; CX=poet bajt
;         mov       al,0ffh                  ; maska - vechny bity
;         out       dx,al                    ; povolen zpisu pro vechny bity
;         mov       al,ah                    ; vzorek pro zpis
;
;         test      di,1                     ; je lich adresa ?
;         jnz       FilEGA5                  ; je lich adresa
;
;                                          ;* je sud adresa
;         shr       cx,1                     ; poet bajt / 2
;FilEGA6: rep       stosw                    ; zpis vnitnch bajt
;         jnc       FilEGA7                  ; byl sud poet bajt
;         stosb                              ; zpis lichho bajtu
;         jmp       short FilEGA7
;
;                                          ;* je lich adresa
;FilEGA5: shr       cx,1                     ; poet bajt / 2
;         jnc       FilEGA4                  ; je sud poet bajt
;         stosb                              ; zpis lichho bajtu
;FilEGA4: rep       stosw                    ; zpis vnitnch bajt
;
;; ------ zobrazen poslednho bajtu linky
;
;FilEGA7: mov       al,cs:[MaskLst]          ; maska poslednho bajtu
;         out       dx,al                    ; nastaven masky pro zpis
;         mov       al,ah                    ; vzorek
;         xchg      al,es:[di]               ; zpis poslednho bajtu linky
;
;; ------ nastaven ukazatele na dal vpl
;
;         inc       si                       ; zven adresy vpln
;         cmp       si,offset Pattern+8      ; pekroen konec tabulky ?
;         jb        FilEGA3                  ; konec tabulky nepekroen
;         mov       si,offset Pattern        ; ukazatel na zatek tabulky
;FilEGA3: ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen objektu v EGA
; -----------------------------------------------------------------------------
; VSTUP: DS=CS
;        ES:DI=poten adresa videopamti
;        krom SI a BP nemus uchovvat registry
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=poten adresa pro zobrazen objektu
; -----------------------------------------------------------------------------

PUBLIC   PrepEGA
PrepEGA:

; ------ inicializace registr

         call      InitREGA                 ; inicializace registr EGA

; ------ vpoet potu bajt na linku

         mov       ax,ds:[Sirka]            ; ka vezu (bod)
         add       ax,7                     ; zaokrouhlen
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pepoet na bajty
         mov       ds:[SirkaB],ax           ; ka linky v batech

; ------ vpoet potu bajt na rovinu

         mul       word ptr ds:[Vyska]      ; poet bajt na rovinu
         mov       ds:[RovinaB],ax          ; poet bajt na rovinu

; ------ vpoet prvn masky objektu (lev okraj)

         mov       cl,byte ptr ds:[ObjLD]   ; lev okraj zatku zobrazen
         and       cl,7                     ; poten bitov pozice (0 a 7)
         mov       al,0ffh                  ; inicializan maska
         shr       al,cl                    ; rotace masky vpravo (FF a 01)
         mov       ds:[MaskFrst],al         ; maska prvnho bajtu

; ------ vpoet rotace objektu

         mov       ax,ds:[ObjLD]            ; lev okraj zatku zobrazen
         sub       ax,ds:[ObjLO]            ; teoretick lev okraj objektu
         and       al,7                     ; rotace objektu vpravo (0 a 7)
         mov       ds:[MaskRot],al          ; rotace objektu vpravo

; ------ vpoet potu zbylch bod

         mov       bl,8                     ; poet bod na bajt
         sub       bl,cl                    ; poet necelch bod vlevo (1 a 8)
         mov       bh,0                     ; BX=poet bod zobrazench vlevo
         mov       ax,ds:[ObjS]             ; ka pro zobrazen objektu
         sub       ax,bx                    ; poet zbylch bod
         js        PrepEGA3                 ; je mal poet bod

; ------ vpoet potu celch bajt

         mov       bx,ax                    ; schova potu zbylch bod
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; poet celch vnitnch bajt
         mov       ds:[MaskNum],al          ; poet vnitnch bajt

; ------ vpoet masky pravho okraje

         and       bl,7                     ; poet zbylch bod vpravo (0 a 7)
         mov       cl,8                     ; poet bod na bajt
         sub       cl,bl                    ; poet nezobraz. bod vpravo (1-8)
         mov       al,0ffh                  ; maska pravho okraje
         shl       al,cl                    ; vpoet masky pravho okr. (00-FE)
         mov       ds:[MaskLst],al          ; maska pravho okraje (00 - FE)
         jmp       short PrepEGA4

; ------ oprava prvn masky pro mal poet bod

PrepEGA3:add       cl,byte ptr ds:[ObjS]    ; koncov bitov pozice+1 (1 a 6)
         mov       al,8                     ; poet bod na bajt
         sub       al,cl                    ; poet nezobrazench bod vpravo
         mov       cl,al                    ; poet nezobrazench bod vpravo
         mov       al,0ffh                  ; maska
         shl       al,cl                    ; rotace korekn masky
         and       ds:[MaskFrst],al         ; oprava prvn masky
         mov       byte ptr ds:[MaskLst],0  ; nen prav maska
         mov       byte ptr ds:[MaskNum],0  ; nen dn vnitn bajt

; ------ vpoet poten adresy ve videopamti

PrepEGA4:mov       ax,ds:[ObjUD]            ; hodn okraj potku k zobrazen
         mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
         add       di,ax                    ; poten adresa linky
         mov       bx,ds:[ObjLD]            ; lev okraj zatku zobrazen
         shr       bx,1
         shr       bx,1
         shr       bx,1                     ; pepoet na offset v bajtech
         add       di,bx                    ; poten adresa k zobrazen

; ------ nastaven adresy obsluhy zobrazen linky

         test      byte ptr ds:[Param],8    ; je maska ?
         jz        PrepEGA5                 ; nen maska
         mov       word ptr ds:[bp+ModDisp],offset DispEG3 ; maska bez rotace
         cmp       byte ptr ds:[MaskRot],0  ; je rotace ?
         je        PrepEGA6                 ; nen rotace
         mov       word ptr ds:[bp+ModDisp],offset DispEG4 ; maska s rotac
         jmp       short PrepEGA6

PrepEGA5:mov       word ptr ds:[bp+ModDisp],offset DispEG2 ; rotace bez masky
         cmp       byte ptr ds:[MaskRot],0  ; je rotace ?
         jne       PrepEGA6                 ; je rotace
         mov       word ptr ds:[bp+ModDisp],offset DispEG1 ; bez rotace i masky
PrepEGA6:
         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen roviny EGA
; -----------------------------------------------------------------------------
; VSTUP: BL=rovina
;        DS:SI=poten adresa prvn linky
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=poten adresa k zobrazen
;        krom BP a ES:DI nemus uchovvat registry
; -----------------------------------------------------------------------------
; 
PUBLIC   SetEGA
SetEGA:

; ------ uren vstupn roviny

         mov       cl,bl                    ; slo roviny
         mov       al,1
         shl       al,cl                    ; rotace na pozici
         mov       cl,al                    ; slo roviny (bitov maska)

; ------ nastaven roviny pro vstup

         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; registr 0 - volba barevn roviny
         inc       dx
         mov       al,cl                    ; maska roviny
         out       dx,al                    ; volba barevn roviny

; ------ nastaven vech bit pro zpis

         mov       dx,3ceh
         mov       al,8
         out       dx,al                    ; registr 8 - maska pro zpis
         inc       dx
         mov       al,0ffh
         out       dx,al                    ; zpis mony pro vechny body

; ------ nastaven poten adresy roviny

         mov       ax,cs:[ObjLO]            ; lev okraj potku v objektu
         add       al,cs:[MaskRot]          ; posun o masku
         adc       ah,0                     ; penos do vyho bajtu
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pepoet na bajty
         add       si,ax                    ; adresa potku linky
         add       word ptr cs:[MaskAdr],ax ; poten adresa masky

         ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu EGA - bez rotace a bez masky
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispEG1

; ------ schova registr

DispEG1: push      di

; ------ pprava registr

         cld                                ; smr nahoru
         mov       cl,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       ch,0                     ; CX=poet bajt
         mov       dx,3cfh                  ; registr masky

; ------ zobrazen prvnho bajtu linky

         mov       al,cs:[MaskFrst]         ; maska prvnho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         lodsb
         xchg      al,es:[di]
         inc       di

; ------ zobrazen vnitnch bajt linky

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen zpisu pro vechny bity
         rep       movsb                    ; penos vnitnch bajt

; ------ zobrazen poslednho bajtu linky

         mov       al,cs:[MaskLst]          ; maska poslednho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         lodsb
         xchg      al,es:[di]

; ------ nvrat registr

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity
         pop       di
         add       di,cs:[bp+ModSirB]       ; zven ukldac adresy
         ret


; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu EGA - rotace bez masky
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispEG2

; ------ schova registr

DispEG2: push      di
         push      bp

; ------ pprava registr

         cld                                ; smr nahoru
         mov       cl,cs:[MaskRot]          ; poet rotac bajtu
         mov       ch,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       dx,3cfh                  ; registr masky

; ------ zobrazen prvnho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         mov       al,cs:[MaskFrst]         ; maska prvnho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         mov       ah,ds:[si-1]
         mov       al,ds:[si]               ; rovina
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy

; ------ zobrazen vnitnch bajt linky
                                            ; CL=rotace vpravo
                                            ; CH=poet bajt
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         or        ch,ch                    ; je njak vnitn bajt ?
         jz        DispEG23                 ; nen dn vnitn bajt
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity
DispEG22:mov       ah,ds:[si]               ; rovina
         mov       al,ds:[si+1]
         inc       si                       ; zven adresy roviny
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy
         dec       ch                       ; snen tae bajt
         jnz       DispEG22                 ; zpis dalho bajtu

; ------ zobrazen poslednho bajtu linky
                                            ; CL=rotace bajtu vpravo
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

DispEG23:mov       al,cs:[MaskLst]          ; maska poslednho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         mov       al,ds:[si+1]
         mov       ah,ds:[si]               ; rovina
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej

; ------ nvrat registr

         pop       bp
         pop       di
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity

         add       di,cs:[bp+ModSirB]       ; zven ukldac adresy
         ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu EGA - maska bez rotace
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispEG3

; ------ schova registr

DispEG3: push      di
         push      bp

; ------ pprava registr

         cld                                ; smr nahoru
         mov       cl,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       ch,0                     ; CX=poet vnitnch bajt linky
         mov       bx,word ptr cs:[MaskAdr] ; offset adresy masky
         mov       bp,word ptr cs:[MaskAdr+2] ; segment adresy masky
         mov       dx,3cfh                  ; registr masky

; ------ zobrazen prvnho bajtu linky
                                            ; BP:BX=adresa masky
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         push      ds                       ; schova DS
         mov       ds,bp                    ; segment masky
         mov       al,ds:[bx]               ; maska
         inc       bx
         pop       ds                       ; nvrat DS
         and       al,cs:[MaskFrst]         ; zamaskovn prvnho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         lodsb                              ; rovina
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy

; ------ zobrazen vnitnch bajt linky
                                            ; BP:BX=adresa masky
                                            ; CX=poet bajt
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         jcxz      DispEG33                 ; nen dn vnitn bajt
DispEG32:push      ds                       ; schova DS
         mov       ds,bp                    ; segment masky
         mov       al,ds:[bx]               ; maska
         inc       bx                       ; zven ukazatele masky
         pop       ds                       ; nvrat DS
         out       dx,al                    ; nastaven masky pro zpis
         lodsb                              ; rovina
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy
         loop      DispEG32                 ; zpis dalho bajtu

; ------ zobrazen poslednho bajtu linky
                                            ; BP:BX=adresa masky
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

DispEG33:push      ds                       ; schova DS
         mov       ds,bp                    ; segment masky
         mov       al,ds:[bx]               ; maska
         pop       ds                       ; nvrat DS
         and       al,cs:[MaskLst]          ; zamaskovn poslednho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         lodsb                              ; rovina
         xchg      al,es:[di]               ; zpis bajtu na displej

; ------ nvrat registr

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity
         pop       bp
         pop       di

         add       di,cs:[bp+ModSirB]       ; zven ukldac adresy
         ret


; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu EGA - rotace i maska
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa
;        DS:SI=adresa obrzku
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=nov ukldac adresa
;        krom BP a DS nemus uchovvat registry
; -----------------------------------------------------------------------------

PUBLIC   DispEG4

; ------ schova registr

DispEG4: push      di
         push      bp

; ------ pprava registr

         cld                                ; smr nahoru
         mov       cl,cs:[MaskRot]          ; poet rotac bajtu
         mov       ch,cs:[MaskNum]          ; poet vnitnch bajt linky
         mov       bx,word ptr cs:[MaskAdr] ; offset adresy masky
         mov       bp,word ptr cs:[MaskAdr+2] ; segment adresy masky
         mov       dx,3cfh                  ; registr masky

; ------ zobrazen prvnho bajtu linky
                                            ; BP:BX=adresa masky
                                            ; CL=rotace bajtu vpravo
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         push      ds                       ; schova DS
         mov       ds,bp                    ; segment masky
         mov       ah,ds:[bx-1]
         mov       al,ds:[bx]               ; maska
         pop       ds                       ; nvrat DS
         ror       ax,cl                    ; rotace na pozici
         and       al,cs:[MaskFrst]         ; zamaskovn prvnho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         mov       ah,ds:[si-1]
         mov       al,ds:[si]               ; rovina
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy

; ------ zobrazen vnitnch bajt linky
                                            ; BP:BX=adresa masky
                                            ; CL=rotace vpravo
                                            ; CH=poet bajt
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

         or        ch,ch                    ; je njak vnitn bajt ?
         jz        DispEG43                 ; nen dn vnitn bajt
DispEG42:push      ds                       ; schova DS
         mov       ds,bp                    ; segment masky
         mov       ah,ds:[bx]
         mov       al,ds:[bx+1]             ; maska
         inc       bx                       ; zven ukazatele masky
         pop       ds                       ; nvrat DS
         ror       ax,cl                    ; rotace na pozici
         out       dx,al                    ; nastaven masky pro zpis
         mov       ah,ds:[si]
         mov       al,ds:[si+1]             ; rovina
         inc       si                       ; zven adresy roviny
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej
         inc       di                       ; zven ukldac adresy
         dec       ch                       ; snen tae bajt
         jnz       DispEG42                 ; zpis dalho bajtu

; ------ zobrazen poslednho bajtu linky
                                            ; BP:BX=adresa masky
                                            ; CL=rotace bajtu vpravo
                                            ; DX=adresa portu masky (03cfh)
                                            ; DS:SI=adresa zdroje (roviny)
                                            ; ES:DI=vstupn adresa

DispEG43:push      ds                       ; schova DS
         mov       ds,bp                    ; segment masky
         mov       al,ds:[bx+1]
         mov       ah,ds:[bx]               ; maska
         pop       ds                       ; nvrat DS
         ror       ax,cl                    ; rotace na pozici
         and       al,cs:[MaskLst]          ; zamaskovn poslednho bajtu
         out       dx,al                    ; nastaven masky pro zpis
         mov       al,ds:[si+1]
         mov       ah,ds:[si]               ; rovina
         ror       ax,cl                    ; rotace na pozici
         xchg      al,es:[di]               ; zpis bajtu na displej

; ------ nvrat registr

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity
         pop       bp
         pop       di

         add       di,cs:[bp+ModSirB]       ; zven ukldac adresy
         ret


; -----------------------------------------------------------------------------
;        Zobrazen ry v mdu EGA (AX=barva)
; -----------------------------------------------------------------------------

LineEGA:

         mov       ch,al                    ; poadovan barva (schova)

; ------ inicializace registr videokarty EGA

         call      InitREGA                 ; inicializace registr EGA

; ------ vpoet poten adresy ve videopamti

         mov       ax,ds:[bp+ModSirB]
         mov       ds:[LineB],ax
         mul       word ptr ds:[LineY1]     ; vpoet potenho offsetu linky
         add       di,ax                    ; poten adresa linky
         mov       bx,ds:[LineX1]
         mov       cl,bl                    ; pozice bodu - ni slovo
         shr       bx,1
         shr       bx,1
         shr       bx,1                     ; pepoet na offset v bajtech
         add       di,bx                    ; poten adresa k zobrazen

; ------ nastaven registru rovin (podle barvy)

         mov       dx,3ceh
         mov       al,0
         out       dx,al
         inc       dx
         mov       al,ch
         out       dx,al                    ; barva
         dec       dx

; ------ nastaven registru rovin XOR

         mov       al,1
         out       dx,al
         inc       dx
         mov       al,0ffh
         out       dx,al
         dec       dx

; ------ maskovac bit zatku

         and       cl,7                     ; poten bitov pozice v bajtu
         mov       al,8
         out       dx,al
         inc       dx
         mov       al,80h
         shr       al,cl

; ------ rozdl souadnic Y (je zajitno, e Y2 >= Y1)

         mov       si,ds:[LineY2]
         sub       si,ds:[LineY1]

; ------ rozdl souadnic X a rozlien, zda jde shora vlevo nebo vpravo)

         mov       bx,ds:[LineX2]
         sub       bx,ds:[LineX1]           ; rozdl souadnic X
         js        Lin3EGA                  ; jde smrem vlevo

; ------ ra jde shora vpravo

; ------ rozlien, zda jde strm vpravo

         cmp       bx,si                    ; je vt prustek ve smru X ?
         jb        Lin2EGA                  ; jde strm vpravo dol

; ------ ra jde mrn vpravo dol

         mov       cx,bx                    ; urujc je prustek X
         inc       cx                       ; poet krok ry
         shl       si,1                     ; rozdl souadnic dY*2
         mov       bp,si                    ; schova dY*2
         sub       bp,bx                    ; dY*2 - dX
         shl       bx,1                     ; dX*2
         sub       si,bx                    ; dY*2 - dX*2
         add       bx,si                    ; dX*2 + dY*2 - dX*2 = dY*2
         mov       ah,al                    ; maska potenho bitu
Lin1EGA1:or        al,ah
         or        bp,bp
         jns       Lin1EGA2
         add       bp,bx
         jmp       short Lin1EGA3
Lin1EGA2:out       dx,al
         xchg      al,es:[di]
         xor       al,al
         add       di,ds:[LineB]
         add       bp,si
         ror       ah,1
         adc       di,0
         jmp       short Lin1EGA4
Lin1EGA3:ror       ah,1
         jnc       Lin1EGA4
         out       dx,al
         xchg      al,es:[di]
         inc       di
         xor       al,al
Lin1EGA4:loop      Lin1EGA1
         out       dx,al
         xchg      al,es:[di]
         jmp       LinEGA9

; ------ ra jde strm vpravo dol

Lin2EGA: mov       cx,si
         inc       cx
         shl       bx,1
         mov       bp,bx
         sub       bp,si
         shl       si,1
         sub       bx,si
         add       si,bx
         out       dx,al
Lin2EGA1:xchg      ah,es:[di]
         or        bp,bp
         jns       Lin2EGA3
         add       bp,si
         jmp       short Lin2EGA4
Lin2EGA3:ror       al,1
         adc       di,0
         out       dx,al
         add       bp,bx
Lin2EGA4:add       di,ds:[LineB]
         loop      Lin2EGA1
         jmp       LinEGA9

; ------ ra jde shora vlevo

Lin3EGA: neg       bx
         cmp       bx,si
         jb        Lin4EGA

; ------ ra jde mrn vlevo

         mov       cx,bx
         inc       cx
         shl       si,1
         mov       bp,si
         sub       bp,bx
         shl       bx,1
         sub       si,bx
         add       bx,si
         mov       ah,al
Lin3EGA1:or        al,ah
         or        bp,bp
         jns       Lin3EGA3
         add       bp,bx
         jmp       short Lin3EGA4
Lin3EGA3:out       dx,al
         xchg      al,es:[di]
         xor       al,al
         add       di,ds:[LineB]
         add       bp,si
         rol       ah,1
         sbb       di,0
         jmp       short Lin3EGA5
Lin3EGA4:rol       ah,1
         jnb       Lin3EGA5
         out       dx,al
         xchg      al,es:[di]
         dec       di
         xor       al,al
Lin3EGA5:loop      Lin3EGA1
         out       dx,al
         xchg      al,es:[di]
         jmp       LinEGA9

; ------ ra jde strm vlevo

Lin4EGA: mov       cx,si
         inc       cx
         shl       bx,1
         mov       bp,bx
         sub       bp,si
         shl       si,1
         sub       bx,si
         add       si,bx
         out       dx,al
Lin4EGA1:xchg      ah,es:[di]
         or        bp,bp
         jns       Lin4EGA2
         add       bp,si
         jmp       short Lin4EGA3
Lin4EGA2:rol       al,1
         sbb       di,0
         out       dx,al
         add       bp,bx
Lin4EGA3:add       di,ds:[LineB]
         loop      Lin4EGA1

; ------ konec

LinEGA9:
         mov       al,0ffh
         out       dx,al
         dec       dx
         mov       al,1
         out       dx,al
         inc       dx
         xor       al,al
         out       dx,al

         ret


; -----------------------------------------------------------------------------
;        Zobrazen bodu v mdu EGA (BX=pozice, DX=linka, AX=barva)
; -----------------------------------------------------------------------------

PointEGA:

         mov       ch,al                    ; poadovan barva (schova)

; ------ inicializace registr videokarty EGA

         call      InitREGA                 ; inicializace registr EGA

; ------ vpoet adresy ve videopamti

         mov       ax,dx                    ; linka bodu
         mul       word ptr ds:[bp+ModSirB] ; vpoet potenho offsetu linky
         add       di,ax                    ; poten adresa linky
         mov       cl,bl                    ; pozice bodu - ni slovo
         shr       bx,1
         shr       bx,1
         shr       bx,1                     ; pepoet na offset v bajtech
         add       di,bx                    ; poten adresa k zobrazen

; ------ nastaven registru rovin (podle barvy)

         mov       dx,3ceh
         mov       al,0
         out       dx,al
         inc       dx
         mov       al,ch
         out       dx,al                    ; barva
         dec       dx

; ------ nastaven registru rovin XOR

         mov       al,1
         out       dx,al
         inc       dx
         mov       al,0ffh
         out       dx,al
         dec       dx

; ------ nastaven registru masky

         mov       al,8
         out       dx,al                    ; volba registru 8 - reg. masky
         inc       dx                       ; 3cfh - adresa registru masky
         and       cl,7                     ; bitov pozice (0 a 7)
         mov       al,80h                   ; inicializan maska
         shr       al,cl                    ; rotace masky vpravo (80h a 01h)
         out       dx,al                    ; nastaven masky bodu

; ------ zpis bodu

         xchg      al,es:[di]               ; zpis bodu do roviny

; ------ nvrat registr

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; povolen masky pro vechny bity
         dec       dx
         mov       al,1
         out       dx,al
         inc       dx
         xor       al,al
         out       dx,al
         ret

; -----------------------------------------------------------------------------
;        Vymazn displeje MCGA
; -----------------------------------------------------------------------------

ClrMCG:
         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen objektu MCGA
; -----------------------------------------------------------------------------

PrepMCG:
         ret

; -----------------------------------------------------------------------------
;        Pprava pro zobrazen jedn roviny MCGA
; -----------------------------------------------------------------------------

SetMCG:

         ret

; -----------------------------------------------------------------------------
;        Zobrazen linky v mdu MCGA
; -----------------------------------------------------------------------------

DispMCG:
         ret

; -----------------------------------------------------------------------------
;        Zobrazen ry v mdu MCGA
; -----------------------------------------------------------------------------

LineMCG:
         ret

; -----------------------------------------------------------------------------
;        Zobrazen bodu v mdu MCGA
; -----------------------------------------------------------------------------

PointMCG:
         ret



ClrPCJ:
         ret

PrepPCJ:
         ret

SetPCJ:
         ret

DispPCJ:
         ret

LinePCJ:
         ret

PointPCJ:
         ret



; -----------------------------------------------------------------------------
;        NOP - dn funkce
; -----------------------------------------------------------------------------

PUBLIC   XNop
XNop:    xor       ax,ax
         ret

; -----------------------------------------------------------------------------
;        ENDPROC
; -----------------------------------------------------------------------------

PUBLIC   XEndProc
XEndProc:pop       ax                       ; zruen nvratov adresy
         xor       ax,ax                    ; nvratov kd - 0
         ret                                ; nvrat z procedury

; -----------------------------------------------------------------------------
;        RETURN
; -----------------------------------------------------------------------------

PUBLIC   XReturn
XReturn:
         pop       ax                       ; zruen nvratov adresy
         call      Vyraz                    ; vpoet hodnoty vrazu
         ret                                ; nvrat z procedury

; -----------------------------------------------------------------------------
;        EXEC
; -----------------------------------------------------------------------------

PUBLIC   XExec
XExec:
         ret

; -----------------------------------------------------------------------------
;        IF
; -----------------------------------------------------------------------------

PUBLIC   XIf
XIf:     call      Vyraz                    ; vpoet vrazu
         or        ax,ax                    ; je podmnk splnna ?
         lodsw                              ; adresa, pokud podmnka nesplnna
         jz        XIf2                     ; podmnka nesplnna - peskoen
         ret                                ; podmnka splnna - dle

XIf2:    mov       si,ax                    ; jinak ELSE resp. ENDIF
         ret

; -----------------------------------------------------------------------------
;        ELSE
; -----------------------------------------------------------------------------

PUBLIC   XElse
XElse:   mov       si,ds:[si]                ; vtev s ELSE se pesko
         ret

; -----------------------------------------------------------------------------
;        FOR
; -----------------------------------------------------------------------------

PUBLIC   XFor
XFor:
         ret

; -----------------------------------------------------------------------------
;        ON
; -----------------------------------------------------------------------------

PUBLIC   XOn
XOn:     call      Vyraz                    ; vpoet vrazu
         or        ax,ax                    ; je podmnka splnna ?
         lodsw                              ; adresa, pokud podmnka splnna
         jnz       XOn1                     ; podmnka splnna - ENDDO
         ret

XOn1:    mov       si,ax                    ; adresa za ENDDO
         ret

; -----------------------------------------------------------------------------
;        ENDDO
; -----------------------------------------------------------------------------

PUBLIC   XEndDo
XEndDo:  mov       si,ds:[si]               ; nepodmnn skok na DO
         ret

; -----------------------------------------------------------------------------
;        CASE
; -----------------------------------------------------------------------------

PUBLIC   XCase
XCase:   call      Vyraz                    ; testovan vraz
         mov       bx,ax                    ; testovan vraz

; ------ naten parametr vtve IN

XCase1:  lodsb                              ; ten bajtu IN
         cmp       al,21                    ; je kd IN ?
         jne       XCase5                   ; nen dal podmnka IN
         lodsw                              ; spodn mez intervalu
         mov       cx,ax                    ; spodn mez intervalu
         lodsw                              ; horn mez intervalu
         mov       dx,ax                    ; horn mez intervalu
         lodsw                              ; adresa pi nesplnn podmnce
         cmp       cx,dx                    ; je spodn mez pod horn ?
         ja        XCase2                   ; spodn mez je nad horn - znamnko

; ------ porovnn sel bez znamnka

         cmp       bx,cx                    ; porovnn se spodn mez intervalu
         jb        XCase4                   ; nen v intervalu
         cmp       bx,dx                    ; porovnn s horn mez intervalu
         ja        XCase4                   ; nen v intervalu
         ret                                ; podmnka splnna - pokraovn

; ------ porovnn sel se znamnkem (nebo obrcen poad)

XCase2:  cmp       bx,cx                    ; porovnn se spodn mez intervalu
         jae       XCase8                   ; slo je v intervalu
         cmp       bx,dx                    ; porovnn s horn mez intervalu
         jbe       XCase8                   ; je v intervalu

; ------ podmnka nesplnna - nastaven na dal vtev IN

XCase4:  mov       si,ax                    ; adresa dalho pkazu IN
         jmp       short XCase1             ; dal pkaz IN

; ------ vtev IN nenalezena - ppadn pokraovn povelem OUT

XCase5:  cmp       al,22                    ; je vtev OUT ?
         je        XCase6                   ; je vtev OUT
         dec       si                       ; nvrat kdu dalho povelu
         ret                                ; pokraovn v programu

XCase6:  add       si,2                     ; peskoen adresy konce CASE v OUT
XCase8:  ret

; -----------------------------------------------------------------------------
;        IN
; -----------------------------------------------------------------------------

PUBLIC   XIn
XIn:     add       si,4                     ; peskoen mez IN
         mov       si,ds:[si]               ; adresa pokraovn v programu
         ret

; -----------------------------------------------------------------------------
;        OUT
; -----------------------------------------------------------------------------

PUBLIC   XOut
XOut:    mov       si,ds:[si]               ; adresa pokraovn v programu
         ret

; -----------------------------------------------------------------------------
;        VAL
; -----------------------------------------------------------------------------

PUBLIC   XVal
XVal:
         ret

; -----------------------------------------------------------------------------
;        STR
; -----------------------------------------------------------------------------

PUBLIC   XStr
XStr:
         ret

; -----------------------------------------------------------------------------
;        LEN
; -----------------------------------------------------------------------------

PUBLIC   XLen
XLen:
         ret

; -----------------------------------------------------------------------------
;        CARD
; -----------------------------------------------------------------------------

PUBLIC   XCard
XCard:
         mov       ah,0
         mov       al,cs:[EgaVga]           ; pznak karty EGA/VGA
         ret

; -----------------------------------------------------------------------------
;        VIDEO
; -----------------------------------------------------------------------------

PUBLIC   XVideo
XVideo:

; ------ zjitn poadovanho videomdu

         call      Vyraz                    ; ten sla videomdu
         cmp       ax,8000h                 ; nastavuje se videomd ?
         je        XVideo1                  ; nem se nastavovat

; ------ kontrola, zda se poaduje oprvnn videomd EGA/VGA

         push      ax
         and       al,7fh
         cmp       al,7
         pop       ax
         jbe       XVideo0                  ; nepoaduje se videomd EGA/VGA
         cmp       byte ptr cs:[EgaVga],0   ; je karta EGA/VGA ?
         jne       XVIdeo0                  ; je karta EGA/VGA OK

; ------ chyba - videomd nelze nastavit

         push      cs
         pop       ds

         mov       al,ds:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

         mov       dx,offset KartTxt        ; chybov hlen
         mov       ah,9
         int       21h                      ; zobrazen zbytku hlen
         jmp       Prerus2                  ; nvrat z programu

; ------ nastaven poadovanho videomdu

XVideo0: mov       ah,0                     ; funkce nastaven videomdu
         call      Int10                    ; nastaven videomdu
XVideo1: mov       ah,0fh                   ; funkce poskytnut videomdu
         call      Int10                    ; poskytnut videomdu
         mov       cs:[VMod],al             ; schova videomdu

; ------ stanoven adresy videostrnky

         mov       bx,0b800h
         cmp       al,7
         jb        XVideo2
         mov       bh,0b0h
         cmp       al,13
         jb        XVideo2
         mov       bh,0a0h
XVideo2: mov       cs:[SegVRAM],bx          ; segment videopamti

; ------ stanoven dlky videostrnky, poet znak na dek a poet dk

         push      ds
         xor       ax,ax
         mov       ds,ax
         mov       al,ds:[44ah]             ; poet pozic na dek
         mov       cs:[MaxPoz],al           ; poet pozice na dek
         mov       al,ds:[484h]             ; slo poslednho dku
         mov       byte ptr cs:[MaxRad],25  ; pednastaven 25 dk
         cmp       al,15                    ; je rozumn daj ?
         jb        XVideo3                  ; nen sprvn daj
         inc       al                       ; poet dk
         mov       cs:[MaxRad],al           ; poet dk
XVideo3: mov       ax,ds:[44ch]             ; dlka videostrnky
         pop       ds
         mov       cs:[DelVRAM],ax          ; dlka videostrnky

; ------ nastaven aktivn videostrnky

         mov       al,cs:[Page1]            ; aktivn videostrnka
         mov       bh,al
         mov       ah,5
         call      Int10                    ; nastaven aktivn strnky displeje

; ------ nastaven pvodn pozice kurzoru

         mov       dx,cs:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
         call      Int10                    ; nastaven pvodn pozice kurzoru

; ------ stanoven nvratovho kdu (slo videomdu)

         mov       ah,0
         mov       al,cs:[VMod]             ; aktuln videomd
         ret

; -----------------------------------------------------------------------------
;        MODE
; -----------------------------------------------------------------------------

PUBLIC   XMode
XMode:
         call      Vyraz                    ; zjitn mdu displeje
         jc        XMode8                   ; nepoaduje se nastaven
         mov       cs:[BitDisp],ax          ; pznakov bity

         cmp       byte ptr cs:[VMod],4
         je        XMode1
         cmp       byte ptr cs:[VMod],5
         jne       XMode3
XMode1:
         mov       dx,3d9h
         out       dx,al                    ; nastaven mdu

         jmp       short XMode8


XMode3:

XMode8:  mov       ax,cs:[BitDisp]
         ret

; -----------------------------------------------------------------------------
;        PAGE
; -----------------------------------------------------------------------------

PUBLIC   XPage
XPage:

; ------ zjitn sel novch videostrnek

         call      Vyraz                    ; ten slova
         cmp       ax,8000h
         je        XPage1                   ; nenastavuje se
         mov       byte ptr cs:[Page1],al   ; aktivn videostrnka
XPage1:  call      Vyraz
         cmp       ax,8000h
         je        XPage2                   ; nenastavuje se
         mov       byte ptr cs:[Page2],al   ; vstupn videostrnka

; ------ nastaven nov aktivn videostrnky

XPage2:  mov       al,cs:[Page1]
         mov       bh,al
         call      SetPage                  ; nastaven videostrnky AL
;         mov       ah,5
;         call      Int10                    ; nastaven aktivn strnky displeje

; ------ nastaven pvodn pozice kurzoru

         mov       dx,cs:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
;         call      Int10                    ; nastaven pvodn pozice kurzoru

; ------ navrcen aktivn videostrnky

         mov       ah,0
         mov       al,cs:[Page1]            ; aktivn videostrnka
         ret

; -----------------------------------------------------------------------------
;        XPAGE
; -----------------------------------------------------------------------------

PUBLIC   XXPage
XXPage:

; ------ zmna videostrnek

         mov       ax,word ptr cs:[Page1]
         xchg      ah,al                    ; zmna videostrnek
         mov       word ptr cs:[Page1],ax

; ------ nastaven nov aktivn videostrnky

         mov       al,cs:[Page1]
         mov       bh,al
         call      SetPage                  ; nastaven videostrnky AL
;         mov       ah,5
;         call      Int10                    ; nastaven aktivn strnky displeje

; ------ nastaven pvodn pozice kurzoru

         mov       dx,cs:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
;         call      Int10                    ; nastaven pvodn pozice kurzoru

; ------ navrcen vstupn videostrnky

         mov       ah,0
         mov       al,cs:[Page2]            ; vstupn videostrnka
         ret

; -----------------------------------------------------------------------------
;        Nastaven videostrnky AL
; -----------------------------------------------------------------------------

SetPage:

; ------ schova registr

         push      ax
         push      bx
         push      dx

; ------ nastaven novho sla videostrnky v RAM BIOS

         push      ds
         xor       dx,dx
         mov       ds,dx                    ; DS <- 0
         mov       ds:[462h],al             ; schova aktivn strnky displeje

; ------ vpoet adresy videostrnky

         mov       ah,0                     ; AX=slo videostrnky
         mul       word ptr cs:[DelVRAM]    ; vpoet adresy videostrnky
         mov       bx,ax                    ; schova adresy videostrnky
         mov       ds:[44eh],ax             ; schova adresy videostrnky
         pop       ds

; ------ pro textov videomd polovin dlka

         cmp       byte ptr cs:[VMod],7
         je        SetPage2
         cmp       byte ptr cs:[VMod],3
         ja        SetPage3
SetPage2:shr       dx,1
         rcr       bx,1
SetPage3:

; ------ synchronizace na snmkov zptn bh

         call      GetPort                  ; poskytnut adresy stav. registru
;SetPage4:in        al,dx
;         test      al,8
;         jnz       SetPage4                 ; ekn na konec ppadnho impulsu
;SetPage1:in        al,dx                    ; ten stavu adie
;         test      al,8                     ; je snmkov zptn bh ?
;         jz        SetPage1                 ; ekn na snmkov zptn bh
         sub       dx,6                     ; adresa dicho registru CRT

; ------ nastaven adresy videostrnky

         mov       al,0dh                   ; registr niho bajtu adresy
         out       dx,al                    ; nastaven registru 0dh
         inc       dx                       ; data dicho registru
         mov       al,bl                    ; ni bajt adresy
         out       dx,al                    ; nastaven niho bajtu adresy

         dec       dx                       ; slo registru

         mov       al,0ch                   ; registr vyho bajtu adresy
         out       dx,al                    ; nastaven registru 0ch
         inc       dx                       ; data dicho registru
         mov       al,bh                    ; vy bajt adresy
         out       dx,al                    ; nastaven vyho bajtu adresy

; ------ nvrat registr

         pop       dx
         pop       bx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        WINDOW
; -----------------------------------------------------------------------------

PUBLIC   XWind
XWind:   mov       di,offset Wind1          ; lev okraj okna
         mov       cx,4                     ; poet parametr

; ------ dekdovn jednotlivch parametr

XWind1:  push      cx
         push      di
         call      Vyraz                    ; parametr - rozmr okna
         pop       di
         pop       cx
         cmp       ax,8000h
         je        XWind2                   ; parametr se nenastavuje
         mov       cs:[di],ax               ; nastaven parametru
XWind2:  add       di,2                     ; zven adresy
         loop      XWind1                   ; dal parametr

; ------ kontrola poad hornho a dolnho okraje

         mov       ax,cs:[Wind2]            ; horn okraj
         cmp       ax,cs:[Wind4]            ; je sprvn nad dolnm okrajem ?
         jle       XWind3                   ; je sprvn nad dolnm okrajem
         xchg      ax,cs:[Wind4]            ; zmna s dolnm okrajem
         mov       cs:[Wind2],ax            ; nov horn okraj

; ------ kontrola poad levho a pravho okraje

XWind3:  mov       ax,cs:[Wind1]            ; lev pozice
         cmp       ax,cs:[Wind3]            ; je sprvn ped pravou pozic ?
         jle       XWind4                   ; je sprvn ped pravou pozic
         xchg      ax,cs:[Wind3]            ; zmna s pravou pozic
         mov       cs:[Wind1],ax            ; nov lev pozice
XWind4:  ret

; -----------------------------------------------------------------------------
;        PALETE
; -----------------------------------------------------------------------------

PUBLIC   XPal
XPal:
         mov       di,offset TabPal         ; tabulka palet
         mov       cx,17                    ; poet palet v definici

; ------ vpoet hodnot paletovch registr

XPal1:   push      cx
         push      di
         call      Vyraz                    ; ten hodnoty registru
         pop       di
         pop       cx
         cmp       ax,8000h
         je        XPal2                    ; hodnota se nemn
         mov       cs:[di],al               ; definice palety
XPal2:   inc       di
         loop      XPal1                    ; dal registr

; ------ pprava registr pro pedefinovn palet

         push      si
         push      ds

         push      cs
         pop       ds
         mov       si,offset TabPal         ; ukazatel tabulky palet
         mov       cx,16                    ; poet palet k pedefinovn
         mov       ah,0                     ; slo registru 0
         cld                                ; smr nahoru
         call      GetPort                  ; poskytnut adresy stav. registru

; ------ synchronizace na zatek vertiklnho synchronizanho impulsu

         sti
XPal4:   in        al,dx
         test      al,8
         jnz       XPal4                   ; ekn na konec synchroimpulsu
XPal5:   in        al,dx
         test      al,8
         jz        XPal5                   ; ekn na zatek synchoimpulsu

; ------ definice vech paletovch registr

         cli
         mov       dx,3c0h                  ; adresa portu adie
XPal6:   mov       al,ah                    ; slo registru
         out       dx,al                    ; nastaven sla registru
         lodsb                              ; poadovan paleta registru
         out       dx,al                    ; definice palety
         inc       ah                       ; zven sla registru
         loop      XPal6                   ; definice dalho registru

; ------ pedefinovn paletovho registru pozad

         mov       al,11h                   ; slo registru palety pozad
         out       dx,al                    ; nastaven sla registru
         lodsb                              ; poadovan paleta registru
         out       dx,al                    ; definice palety registru pozad

; ------ optovn zapnut videosignlu

         mov       al,20h                   ; ukonovac bajt
         out       dx,al                    ; zapnut videosignlu
         sti

         pop       ds
         pop       si

         ret

; -----------------------------------------------------------------------------
;        XCOLOR
; -----------------------------------------------------------------------------

PUBLIC   XXCol
XXCol:
         ret

; -----------------------------------------------------------------------------
;        SETCURS
; -----------------------------------------------------------------------------

PUBLIC   XSetCur
XSetCur:
         call      Vyraz                    ; pozice kurzoru
         jc        XSetCur1
         mov       byte ptr cs:[KurzPoz],al ; pozice
XSetCur1:call      Vyraz                    ; dek kurzoru
         jc        XSetCur2
         mov       byte ptr cs:[KurzPoz+1],al ; dek

XSetCur2:mov       dx,cs:[KurzPoz]          ; aktuln pozice kurzoru
         mov       ah,2
         mov       bh,cs:[Page1]
         call      Int10                    ; nastaven pvodn pozice kurzoru

         mov       ah,0
         mov       al,byte ptr cs:[KurzPoz] ; souasn pozice
         ret

; -----------------------------------------------------------------------------
;        CURSOFF
; -----------------------------------------------------------------------------

PUBLIC   XCurOff
XCurOff:
         mov       dh,cs:[MaxRad]           ; maximln poet dk
         mov       dl,0
         mov       ah,2
         mov       bh,cs:[Page1]
         call      Int10
         mov       ah,0
         mov       al,cs:[MaxRad]           ; dek, na kterm je kurzor
         ret

; -----------------------------------------------------------------------------
;        LOAD
; -----------------------------------------------------------------------------

PUBLIC   XLoad
XLoad:

; ------ pokud objekt existuje, jeho zruen

         lodsw                              ; ten sla objektu
         call      SrcObj                   ; nalezen objektu v pamti
         jc        XLoad1                   ; objekt nen v pamti
         call      DelObj                   ; zruen objektu DX z pamti

; ------ oteven poadovanho souboru

XLoad1:  mov       di,ax                    ; schova sla objektu
         mov       dx,si                    ; ukazatel na jmno programu
         mov       ax,3d00h
         int       21h                      ; oteven souboru
         mov       bx,ax                    ; identifiktor souboru
         jnc       XLoad6                   ; soubor oteven OK

; ------ chyba - soubor nenalezen

         mov       al,cs:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

         push      ds
         push      cs
         pop       ds
         mov       dx,offset FndTxt         ; text - "Soubor"
         mov       ah,9
         int       21h                      ; zobrazen prvn sti hlen
         pop       ds

XLoad2:  lodsb
         or        al,al
         jz        XLoad3                   ; konec textu
         mov       dl,al
         mov       ah,2
         int       21h                      ; zobrazen znaku jmna souboru
         jmp       short XLoad2

XLoad3:  mov       dx,offset Fnd2Txt        ; text "nenalezen"
XLoad4:  push      cs
         pop       ds
         mov       ah,9
         int       21h                      ; zobrazen zbytku hlen

         jmp       Prerus2                  ; nvrat z programu

; ------ chyba - nedostatek pamti

XLoad5:  mov       al,cs:[OldVMod]          ; pvodn videomd
         mov       ah,0
         call      Int10                    ; nvrat videomdu

         mov       dx,offset MemTxt         ; text - nedostatek pamti
         jmp       short XLoad4


; ------ zjitn volnho msta pro jeden blok

XLoad6:  mov       dx,cs:[TopMem]           ; adresa k naten bloku
XLoad7:  mov       cx,ss                    ; konec pamti
         add       cx,0d00h                 ; rezerva pro zsobnk 12 KB
         sub       cx,cs:[TopMem]           ; voln prostor v pamti
         jbe       XLoad5                   ; nen voln pam
         cmp       cx,0f00h                 ; je blok vt ne 0f000h bajt ?
         jbe       XLoad8                   ; nen vt
         mov       cx,0f00h                 ; omezen na 0f000h bajt

; ------ naten jednoho bloku ze souboru

XLoad8:  shl       cx,1
         shl       cx,1
         shl       cx,1
         shl       cx,1                     ; pevod na bajty
         push      ds
         push      dx
         mov       ds,dx                    ; segment k naten bloku souboru
         xor       dx,dx                    ; offset ke ten souboru
         mov       ah,3fh
         int       21h                      ; naten bloku ze souboru
         pop       dx
         pop       ds
         jc        XLoada                   ; chyba ten - konec

; ------ zven adresy segmentu

         cmp       ax,cx                    ; navrceno vce bajt ne bylo ?
         jbe       XLoad9                   ; daj je OK
         mov       ax,cx                    ; omezen na poadovan bajty
XLoad9:  add       ax,15                    ; zaokrouhlen
         shr       ax,1
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; pevod na odstavce
         add       dx,ax                    ; zven segmentu
         or        ax,ax                    ; bylo nco nateno ?
         jnz       XLoad7                   ; bylo nco nateno - dal

; ------ inicializace ukazatel objektu a pamti

XLoada:  mov       ax,dx                    ; segment konce dat
         sub       ax,cs:[TopMem]           ; velikost novho bloku
         push      ds
         mov       ds,cs:[TopMem]           ; zatek novho bloku
         mov       ds:[0],di                ; slo objektu
         mov       ds:[2],ax                ; velikost bloku
         pop       ds
         mov       cs:[TopMem],dx           ; nov konec pamti

; ------ uzaven souboru

         mov       ah,3eh
         int       21h                      ; uzaven souboru

; ------ nalezen konce textu v programu

         cld
XLoadb:  lodsb                              ; ten znaku
         or        al,al
         jnz       XLoadb                   ; nen konec textu - dal znak
         ret

; -----------------------------------------------------------------------------
;        OBJECT
; -----------------------------------------------------------------------------

PUBLIC   XObj
XObj:

; ------ zjitn sla objektu

         lodsw                              ; slo objektu
         push      ax                       ; schova sla objektu

; ------ uren pozice k umstn objektu

         call      Vyraz                    ; ten slova - pozice X
         mov       cs:[ObjLD],ax            ; poadovan poten pozice
         call      Vyraz                    ; ten slova - linka Y
         mov       cs:[ObjUD],ax            ; poadovan poten linka

         pop       ax                       ; slo objektu

; ------ schova registr

         push      si
         push      ds
         push      es

; ------ nalezen zhlav objektu

         call      SrcObj                   ; nalezen adresy objektu
         mov       ds,dx                    ; segment objektu
         jc        Objekt0                  ; objekt nenalezen

; ------ schova parametr objektu

         push      cs
         pop       es                       ; ES <- CS
         mov       si,4                     ; adresa ky objektu
         mov       di,offset Sirka          ; buffer k schov parametr
         mov       cx,6                     ; dlka (slov)
         cld
         rep       movsw                    ; schova zhlav objektu
         call      GetTabMod                ; adresa tabulky videomdu

; ------ nastaven parametr objektu

         mov       ax,cs:[Sirka]            ; poadovan ka objektu
         mov       cs:[ObjS],ax             ; poadovan ka objektu
         mov       ax,cs:[Vyska]            ; poadovan vka objektu
         mov       cs:[ObjV],ax             ; poadovan vka objektu
         call      Omez                     ; omezen rozmr objektu
Objekt0: jc        Objekt9                  ; objekt se nezobraz - je mimo

; ------ pprava ukazatel pro zobrazen objektu

         call      GetVRAM                  ; poskytnut adresy VRAM
         push      ds
         push      cs
         pop       ds
         call      word ptr cs:[bp+ModPrep] ; pprava pro zobrazen objektu
         pop       ds
         call      NormDSSI                 ; normalizace adresy (SI=16)
         xor       bx,bx                    ; BX=ukazatel rovin

; ------ je maskovn obrzku - peskoen masky

         test      byte ptr cs:[Param],8    ; je maska obrzku ?
         jz        Objekt1                  ; nen maska

         mov       word ptr cs:[MaskAdr+2],ds ; segment masky pozad (offset=0)
         add       si,cs:[RovinaB]          ; adresa dal roviny
         call      NormDSSI                 ; normalizace zdrojov adresy

; ------ zobrazen jedn roviny obrzku

Objekt1: cld
         push      bx                       ; schova sla roviny
         push      si                       ; schova adresy obrzku
         push      di                       ; schova adresy ve videopamti
         mov       ax,cs:[SirkaB]           ; ka objektu v bajtech
         mul       word ptr cs:[ObjUO]      ; poten offset v bajtech
         mov       word ptr cs:[MaskAdr],ax ; poten offset adresy masky
         add       si,ax                    ; poten offset linky
         call      word ptr cs:[bp+ModSet]  ; pprava pro zobrazen roviny
         mov       cx,cs:[ObjV]             ; vka objektu k zobrazen
Objekt2: push      cx                       ; schova tae potu linek
         push      si                       ; schova zdrojov adresy
         call      word ptr cs:[bp+ModDisp] ; zobrazen jedn linky
         pop       si                       ; nvrat zdrojov adresy
         pop       cx                       ; nvrat tae linek
         mov       ax,cs:[SirkaB]           ; ka linky v bajtech
         add       si,ax                    ; zven zdrojov adresy linky
         add       word ptr cs:[MaskAdr],ax ; zven adresy masky
         loop      Objekt2                  ; zobrazen dal linky
Objekt4: pop       di                       ; nvrat adresy ve videopamti
         pop       si                       ; nvrat adresy obrzku
         pop       bx                       ; nvrat sla roviny

; ------ zven adres na dal linku

         add       si,cs:[RovinaB]          ; zven adresy na dal rovinu
         call      NormDSSI                 ; normalizace adresy
         inc       bx                       ; zven sla roviny
         cmp       bx,cs:[Rovin]            ; jsou ji vechny roviny ?
         jae       Objekt9                  ; jsou ji vechny roviny
         test      byte ptr cs:[Param],4    ; je paraleln uloen barev ?
         jz        Objekt1                  ; nen paraleln uloen barev-dal

; ------ nvrat registr

Objekt9: pop       es
         pop       ds
         pop       si
         cld
         sti
         ret

; -----------------------------------------------------------------------------
;        UNLOAD
; -----------------------------------------------------------------------------

PUBLIC   XUnld
XUnld:
         lodsw                              ; ten sla objektu
         call      SrcObj                   ; nalezen objektu v pamti
         jc        XUnld2                   ; objekt nen v pamti
         call      DelObj                   ; zruen objektu DX z pamti
XUnld2:  ret

; -----------------------------------------------------------------------------
;        TEXT
; -----------------------------------------------------------------------------

PUBLIC   XText
XText:
         call      Vyraz                    ; barva textu
         push      ax                       ; schova barvy
         call      Vyraz                    ; souadnice X
         push      ax                       ; schova souadnice X
         call      Vyraz                    ; souadnice Y
         pop       dx                       ; DL=souadnice X
         mov       dh,al                    ; souadnice Y
         pop       bx                       ; BL=barva

; ------ nastaven pozice kurzoru

XDisp1:  push      dx
         push      bx
         mov       ah,2
         mov       bh,cs:[Page2]            ; vstupn strnka
         call      Int10                    ; nastaven pozice kurzoru
         pop       bx
         pop       dx

; ------ zobrazen jednoho znaku

         cld
         lodsb                              ; ten dalho znaku
         cmp       al,0
         je        XDisp2                   ; konec textu

         cmp       dl,cs:[MaxPoz]           ; dosaeno maximln pozice ?
         jae       XDisp1                   ; je maximln pozice

         push      dx
         push      bx
         mov       ah,9
         mov       cx,1
         mov       bh,cs:[Page2]            ; vstupn strnka
         call      Int10                    ; zobrazen znaku
         pop       bx
         pop       dx

; ------ zven pozice kurzoru

         inc       dl                       ; zven pozice na dku
         jmp       short XDisp1             ; zobrazen dalho znaku

XDisp2:  ret

; -----------------------------------------------------------------------------
;        POINT
; -----------------------------------------------------------------------------

PUBLIC   XPoint
XPoint:

         call      Vyraz                    ; barva bodu
         push      ax
         call      Vyraz                    ; X
         push      ax
         call      Vyraz                    ; Y
         mov       dx,ax                    ; Y
         pop       bx                       ; X
         pop       ax                       ; barva

         call      GetTabMod                ; poskytnut tabulky videomdu

; ------ kontrola souadnic

XPoint1: cmp       bx,cs:[bp+ModSir]        ; pekroen maximln prav okraj ?
         jae       XPoint9                  ; maximln prav okraj pekroen
         cmp       dx,cs:[bp+ModVys]        ; pekroen doln okraj ?
         jae       XPoint9                  ; pekroen doln okraj
         cmp       bx,cs:[Wind1]
         jl        XPoint9
         cmp       dx,cs:[Wind2]
         jl        XPoint9
         cmp       bx,cs:[Wind3]
         jg        XPoint9
         cmp       dx,cs:[Wind4]
         jg        XPoint9

; ------ zobrazen bodu (barva AX)

         push      ax
         push      cx
         push      si
         push      di
         push      ds
         push      es

         push      cs
         pop       ds

         call      GetVRAM                  ; poskytnut adresy VRAM
         call      word ptr ds:[bp+ModPoint] ; zobrazen bodu barvy AX,
                                            ; linka DX, pozice BX

         pop       es
         pop       ds
         pop       di
         pop       si
         pop       cx
         pop       ax
XPoint9:
         ret

; -----------------------------------------------------------------------------
;        LINE
; -----------------------------------------------------------------------------

PUBLIC   XLine
XLine:

; ------ zadn barvy a souadnic

         call      Vyraz                    ; barva ry
         push      ax
         call      Vyraz                    ; X1
         mov       cs:[LineX1],ax           ; X1
         call      Vyraz                    ; Y1
         mov       cs:[LineY1],ax           ; Y1
         call      Vyraz                    ; X2
         mov       cs:[LineX2],ax           ; X2
         call      Vyraz                    ; Y2
         mov       cs:[LineY2],ax           ; Y2

; ------ kontrola poad, zda je Y2 vt ne Y1

         cmp       ax,cs:[LineY1]
         jge       XLine2                   ; poad je OK
         xchg      ax,cs:[LineY1]           ; oprava poad Y
         mov       cs:[LineY2],ax
         mov       ax,cs:[LineX1]
         xchg      ax,cs:[LineX2]           ; oprava poad X
         mov       cs:[LineX1],ax
XLine2:  pop       ax                       ; barva



         call      GetTabMod                ; poskytnut tabulky videomdu

; ------ zobrazen ry (barva AX)

         push      si
         push      es
         push      ds

         push      cs
         pop       ds

         call      GetVRAM                  ; poskytnut adresy VRAM
         call      word ptr ds:[bp+ModLine] ; zobrazen ry barvy AX

         pop       ds
         pop       es
         pop       si

         ret

; -----------------------------------------------------------------------------
;        RLINE
; -----------------------------------------------------------------------------

PUBLIC   XRLine
XRLine:
         ret

; -----------------------------------------------------------------------------
;        BOX
; -----------------------------------------------------------------------------

PUBLIC   XBox
XBox:
         ret

; -----------------------------------------------------------------------------
;        FBOX - pln obdlnk
; -----------------------------------------------------------------------------

PUBLIC   XFBox
XFBox:
         call      GetTabMod                ; poskytnut tabulky videomdu

; ------ zjitn barvy

         call      Vyraz                    ; ten slova - barva
         push      ax                       ; schova barvy

; ------ poten pozice X

         call      Vyraz                    ; poten pozice X
         mov       cs:[ObjLD],ax            ; lev okraj zatku zobrazen

; ------ poten linka Y

         call      Vyraz                    ; poten linka Y
         mov       cs:[ObjUD],ax            ; horn okraj zatku zobrazen

; ------ ka obdlnku

         call      Vyraz                    ; koncov pozice X
         cmp       ax,cs:[ObjLD]            ; je ped poten pozic ?
         jge       XFBox1                   ; pozice je OK
         xchg      ax,cs:[ObjLD]            ; oprava poad pozic
XFBox1:  sub       ax,cs:[ObjLD]            ; vpoet ky obdlnku
         inc       ax                       ; ka obdlnku (jednotek)
         mov       cs:[ObjS],ax             ; schova ky obdlnku

; ------ vka obdlnku

         call      Vyraz                    ; koncov linka Y
         cmp       ax,cs:[ObjUD]            ; je nad horn linkou ?
         jge       XFBox2                   ; nen nad horn linkou
         xchg      ax,cs:[ObjUD]            ; oprava poad linek
XFBox2:  sub       ax,cs:[ObjUD]            ; vpoet vky obdlnku
         inc       ax                       ; vka obdlnku (jednotek)
         mov       cs:[ObjV],ax             ; schova vky obdlnku

; ------ pprava ukazatel pro zobrazen objektu

         call      Omez                     ; omezen rozmr obdlnku
         pop       ax                       ; nvrat poadovan barvy
         jc        XFBox9                   ; obdlnk se nezobraz - je mimo

; ------ zobrazen obdlnku

         push      si
         push      es
         push      ds
         push      cs
         pop       ds
         call      GetVRAM                  ; poskytnut adresy VRAM
         call      word ptr ds:[bp+ModCLR]  ; vymazn displeje zadanou barvou
         pop       ds
         pop       es
         pop       si

XFBox9:  ret

; -----------------------------------------------------------------------------
;        CIRC - krunice
; -----------------------------------------------------------------------------
;
PUBLIC   XCirc
XCirc:

; ------ zskn parametr

         call      Vyraz                    ; barva bodu
         push      ax                       ; barva
         call      Vyraz                    ; X
         push      ax                       ; X
         call      Vyraz                    ; Y
         push      ax                       ; Y
         call      Vyraz                    ; polomr
         mov       di,ax                    ; polomr
         mov       cx,ax                    ; ta
         shr       ax,1
         shr       ax,1                     ; polomr / 4
         sub       cx,ax                    ; odeten 1/4 potu bod
         shr       ax,1
         shr       ax,1
         shr       ax,1
         sub       cx,ax                    ; odeten jet 1/32 bod
         pop       dx                       ; Y
         pop       bx                       ; X
         pop       ax                       ; barva
         or        di,di                    ; polomr
         jg        XCirc1                   ; je njak polomr - OK
         jmp       XCirc9                   ; polomr = 0

XCirc1:
         call      GetTabMod                ; poskytnut tabulky videomdu

; ------ vpoet hodnoty krunice

XCirc3:  push      si

         push      ax
         push      bx
         push      cx
         push      dx

         xor       dx,dx
         mov       ax,cx                    ; stav tae
         shl       ax,1
         rcl       dx,1

         shl       ax,1
         rcl       dx,1

         shl       ax,1
         rcl       dx,1

         shl       ax,1
         rcl       dx,1                     ; slo * 16

         div       di                       ; stav relativn
         mov       cx,dx                    ; schova zbytku (*16)

         mov       si,ax
         shl       si,1
         mov       ax,cs:[si+TabCirc]
         mul       di
         mov       al,ah
         mov       ah,dl

         mov       dx,cs:[si+TabCirc]
         sub       dx,cs:[si+TabCirc+2]
         mov       si,ax

         mov       ax,cx                    ; zbytek * 16
         mul       dx                       ;
         add       ax,128
         adc       dx,0
         mov       al,ah
         mov       ah,dl
         sub       si,ax

         pop       dx
         pop       cx
         pop       bx
         pop       ax

; ------ zobrazen osmice bod:
;
;            AX=barva
;            BX=pozice stedu
;            CX=ta (pozice dol)
;            DX=linka stedu
;            SI=hodnota
;            DI=polomr

; ------ zprava nahoru

         push      bx
         push      dx
         sub       dx,cx                    ; Y
         add       bx,si                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ zprava dol

         push      bx
         push      dx
         add       dx,cx                    ; Y
         add       bx,si                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ zleva nahoru

         push      bx
         push      dx
         sub       dx,cx                    ; Y
         sub       bx,si                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ zleva dol

         push      bx
         push      dx
         add       dx,cx                    ; Y
         sub       bx,si                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ shora vlevo

         push      bx
         push      dx
         sub       dx,si                    ; Y
         sub       bx,cx                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ shora vpravo

         push      bx
         push      dx
         sub       dx,si                    ; Y
         add       bx,cx                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ zdola vlevo

         push      bx
         push      dx
         add       dx,si                    ; Y
         sub       bx,cx                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

; ------ zdola vpravo

         push      bx
         push      dx
         add       dx,si                    ; Y
         add       bx,cx                    ; X
         call      XPoint1                  ; zobrazen bodu
         pop       dx
         pop       bx

         pop       si

         sub       cx,1
         jc        XCirc9
         jmp       XCirc3

XCirc9:

         ret


TabCirc  dw        256                      ; 0
         dw        255                      ; 1
         dw        254                      ; 2
         dw        251                      ; 3
         dw        248                      ; 4
         dw        243                      ; 5
         dw        237                      ; 6
         dw        230                      ; 7
         dw        222                      ; 8
         dw        212                      ; 9
         dw        200                      ; 10
         dw        186                      ; 11
         dw        169                      ; 12
         dw        149                      ; 13
         dw        124                      ; 14
         dw        89                       ; 15
         dw        0                        ; 16

; -----------------------------------------------------------------------------
;        FCIRC
; -----------------------------------------------------------------------------

PUBLIC   XFCirc
XFCirc:
         ret

; -----------------------------------------------------------------------------
;        PRESS
; -----------------------------------------------------------------------------

PUBLIC   XPress
XPress:  call      Vyraz                    ; zjitn kdu poadovan klvesy
         cmp       ax,70h                   ; je povolen kd klvesy ?
         jbe       XPress2                  ; kd klvesy je povolen
         xor       ax,ax                    ; nhradn kd 0
XPress2: cmp       al,60h                   ; je rozen klvesnice ?
         jb        XPress3                  ; nen rozen klvesnice
         mov       byte ptr cs:[ExtKey],1   ; pznak rozen klvesnice
XPress3: mov       bx,ax                    ; offset v tabulce
         mov       al,cs:[bx+TabKey]        ; stav poadovan klvesy
         ret

; -----------------------------------------------------------------------------
;        TESTKEY
; -----------------------------------------------------------------------------

PUBLIC   XTstKey
XTstKey: mov       ax,cs:[KeyBuf]           ; kd pipraven klvesy
         ret

; -----------------------------------------------------------------------------
;        GETKEY
; -----------------------------------------------------------------------------

PUBLIC   XGtKey
XGtKey:  sti                                ; peruen mus bt povoleno
         xor       ax,ax                    ; AX <- 0
         xchg      ax,cs:[KeyBuf]           ; kd pipraven klvesy
         or        ax,ax                    ; je to platn klvesa ?
         jz        XGtKey                   ; ekn na pchod klvesy
         ret

; -----------------------------------------------------------------------------
;        STATKEY
; -----------------------------------------------------------------------------
; VSTUP: AX = bit 0: 1=prav Shift stisknut
;              bit 1: 1=lev Shift stisknut
;              bit 2: 1=klvesa Ctrl stisknuta
;              bit 3: 1=klvesa Alt stisknuta
;              bit 4: 1=Scroll Lock zapnut
;              bit 5: 1=Num Lock zapnut
;              bit 6: 1=Caps Lock zapnut
;              bit 7: 1=Insert zapnut
;
;              bit 8: 1=prav klvesa Ctrl stisknuta  Ŀ
;              bit 9: 1=prav klvesa Alt stisknuta     pouze AT 101/102
;              bit 10: 1=klvesa Sys Rq stisknuta     
;              bit 11: 1=je rozen klvesnice AT 101/102 klves
;              bit 12: 1=klvesa Scroll Lock stisknuta
;              bit 13: 1=klvesa Num Lock stisknuta
;              bit 14: 1=klvesa Caps Lock stisknuta
;              bit 15: 1=klvesa Insert stisknuta
; -----------------------------------------------------------------------------

PUBLIC   XStatKey
XStatKey:
         push      ds
         mov       ax,40h
         mov       ds,ax
         mov       ax,ds:[17h]              ; statut pesmyka
         and       ah,not 8                 ; zruen bitu 3 (pznak Pause)
         test      byte ptr ds:[96h],10h    ; instalovna klvesnice 101/102 ?
         jz        XStatK1                  ; nen klvesnice 101/102 klves
         or        ah,8                     ; pznak klvesnice 101/102
XStatK1: ret

; -----------------------------------------------------------------------------
;        INPUT
; -----------------------------------------------------------------------------

PUBLIC   XInp
XInp:
         ret

; -----------------------------------------------------------------------------
;        SOUND
; -----------------------------------------------------------------------------

PUBLIC   XSound
XSound:
         call      Vyraz                    ; ten slova
         or        ax,ax                    ; vypnut genertoru ?
         jnz       Sound2                   ; nen vypnut genertoru

         in        al,[61h]
         and       al,not 3
         out       [61h],al                 ; vypnut genertoru
         ret


Sound2:  mov       bx,ax
         mov       al,0b6h
         out       [43h],al
         mov       al,bl
         out       [42h],al
         mov       al,bh
         out       [42h],al
         in        al,[61h]
         or        al,3
         out       [61h],al

         ret

; -----------------------------------------------------------------------------
;        TON
; -----------------------------------------------------------------------------

PUBLIC   XTon
XTon:
         ret

; -----------------------------------------------------------------------------
;        MUSIC
; -----------------------------------------------------------------------------

PUBLIC   XMusic
XMusic:


         cli                                ; mus bt zakzno peruen
         cld
         lodsw                              ; poet slov melodie
         mov       cs:[UkazMel],si          ; ukazatel zatku melodie
         mov       cs:[NumMel],ax           ; poet zbylch tn melodie
         sti
         shl       ax,1                     ; poet bajt
         add       si,ax                    ; zven adresy v programu
         ret

; -----------------------------------------------------------------------------
;        MUSICSTOP
; -----------------------------------------------------------------------------

PUBLIC   XMStop
XMStop:
         mov       word ptr cs:[NumMel],0   ; zruen tae znak melodie
         mov       byte ptr cs:[CitTon],0   ; inicializace tae tnu
         in        al,[61h]
         and       al,not 3
         out       [61h],al                 ; vypnut genertoru
         ret

; -----------------------------------------------------------------------------
;        MUSICGET
; -----------------------------------------------------------------------------

PUBLIC   XMusGet
XMusGet:
         mov       ax,cs:[NumMel]           ; poet zbylch znak melodie
         ret

; -----------------------------------------------------------------------------
;        WAIT
; -----------------------------------------------------------------------------

PUBLIC   XWait
XWait:   push      word ptr cs:[Citac]      ; schova pvodnho stavu tae
         call      Vyraz                    ; ten slova
         or        ax,ax                    ; je zporn slo ?
         js        XWait2                   ; je zporn slo - neplat
         sti                                ; povolen peruen
XWait1:  cmp       byte ptr cs:[ParBreak],0 ; je uivatelsk peruen ?
         jne       XWait2                   ; je uivatelsk peruen
         cmp       word ptr cs:[Citac],ax
         jb        XWait1                   ; nen jet dosaen as
         mov       word ptr cs:[Citac],0    ; inicializace tae
XWait2:  pop       ax                       ; pvodn stav tae
         ret

; -----------------------------------------------------------------------------
;        TIME
; -----------------------------------------------------------------------------

PUBLIC   XTime
XTime:
         ret

; -----------------------------------------------------------------------------
;        DATE
; -----------------------------------------------------------------------------

PUBLIC   XDate
XDate:
         ret

; -----------------------------------------------------------------------------
;        XMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XXMous
XXMous:
         ret

; -----------------------------------------------------------------------------
;        YMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XYMous
XYMous:
         ret

; -----------------------------------------------------------------------------
;        GETMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XKMous
XKMous:
         ret

; -----------------------------------------------------------------------------
;        MOUSEON
; -----------------------------------------------------------------------------

PUBLIC   XMon
XMon:
         ret

; -----------------------------------------------------------------------------
;        MOUSEOFF
; -----------------------------------------------------------------------------

PUBLIC   XMoff
XMoff:
         ret

; -----------------------------------------------------------------------------
;        CURMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XDefm
XDefm:
         ret

; -----------------------------------------------------------------------------
;        WINMOUSE
; -----------------------------------------------------------------------------

PUBLIC   XWinm
XWinm:
         ret

; -----------------------------------------------------------------------------
;        RND
; -----------------------------------------------------------------------------

PUBLIC   XRnd
XRnd:    call      Vyraz                    ; poadovan interval
         mov       bx,ax                    ; interval
         or        ax,ax
         jz        XRnd2

         mov       ax,word ptr cs:[RandNum]
         mov       di,word ptr cs:[RandNum+2]
         rol       ax,1
         rol       di,1
         xor       al,ss:[di]
         xor       ah,ss:[di+1]
         xor       di,ax
         mov       word ptr cs:[RandNum],ax
         mov       word ptr cs:[RandNum+2],di

         xor       dx,dx
         div       bx
         mov       ax,dx

XRnd2:   ret

RandNum  dd        0

; -----------------------------------------------------------------------------
;        REGISTER - nastaven registru videoadie
; -----------------------------------------------------------------------------

XReg:    call      GetPort                  ; poskytnut adresy stav. registru
         sub       dx,6                     ; adresa dicho registru
         push      dx
         call      Vyraz                    ; poadovan registr
         pop       dx
         out       dx,al                    ; nastaven sla registru
         inc       dx                       ; data registru
         push      dx
         call      Vyraz                    ; poadovan hodnota registru
         pop       dx
         out       dx,al                    ; nastaven registru
         ret

; -----------------------------------------------------------------------------
;        HSYN - horizontln synchronizace
; -----------------------------------------------------------------------------

XHSyn:

; ------ zjitn poadovanho potu impuls, pprava registr

         call      Vyraz                    ; poadovan poet impuls
         mov       cx,ax                    ; poadovan poet impuls
         call      GetPort                  ; poskytnut adresy stav. registru
         jcxz      XHSyn3                   ; nepoaduje se synchronizace
         or        cx,cx                    ; je zporn slo ?
         js        XHSyn3                   ; zporn slo - nen synchronizace

; ------ ekn na konec ppadnho impulsu

         sti                                ; mus bt povoleno peruen
XHSyn1:  cmp       byte ptr cs:[ParBreak],0 ; je uivatelsk peruen ?
         jne       XHSyn4                   ; je peruen
         in        al,dx                    ; ten stavovho registru
         shr       al,1                     ; je horizontln impuls ?
         jc        XHSyn1                   ; ekn na konec impulsu

; ------ ekn na zatek horizontlnho impulsu

XHSyn2:  cmp       byte ptr cs:[ParBreak],0 ; je uivatelsk peruen ?
         jne       XHSyn4                   ; je peruen
         in        al,dx                    ; ten stavovho registru
         shr       al,1                     ; je horizontln impuls ?
         jnc       XHSyn2                   ; ekn na zatek impulsu
         loop      XHSyn1                   ; ekn na dal impuls
         jmp       short XHSyn4

; ------ zjitn stavu horizontlnho impulsu

XHSyn3:  in        al,dx                    ; ten stavu portu
         and       ax,1                     ; probh horizontn impuls ?
         jz        XHSyn5                   ; neprobh
XHSyn4:  mov       ax,-1                    ; pznak, e je horiz. impuls
XHSyn5:  ret

; -----------------------------------------------------------------------------
;        VSyn - Vertikln synchronizace
; -----------------------------------------------------------------------------

XVSyn:

; ------ zjitn poadovanho potu impuls, pprava registr

         call      Vyraz                    ; poadovan poet impuls
         mov       cx,ax                    ; poadovan poet impuls
         call      GetPort                  ; poskytnut adresy stav. registru
         jcxz      XVSyn3                   ; nepoaduje se synchronizace
         or        cx,cx                    ; je zporn slo ?
         js        XVSyn3                   ; zporn slo - nen synchronizace

; ------ ekn na konec ppadnho impulsu

         sti                                ; mus bt povoleno peruen
XVSyn1:  cmp       byte ptr cs:[ParBreak],0 ; je uivatelsk peruen ?
         jne       XVSyn4                   ; je peruen
         in        al,dx                    ; ten stavovho registru
         test      al,8                     ; je vertikln impuls ?
         jnz       XVSyn1                   ; ekn na konec impulsu

; ------ ekn na zatek vertiklnho impulsu

XVSyn2:  cmp       byte ptr cs:[ParBreak],0 ; je uivatelsk peruen ?
         jne       XVSyn4                   ; je peruen
         in        al,dx                    ; ten stavovho registru
         test      al,8                     ; je vertikln impuls ?
         jz        XVSyn2                   ; ekn na zatek impulsu
         loop      XVSyn1                   ; ekn na dal impuls
         jmp       short XVSyn4

; ------ zjitn stavu horizontlnho impulsu

XVSyn3:  in        al,dx                    ; ten stavu portu
         and       ax,8                     ; probh horizontn impuls ?
         jz        XVSyn5                   ; neprobh
XVSyn4:  mov       ax,-1                    ; pznak, e je horiz. impuls
XVSyn5:  ret

; -----------------------------------------------------------------------------
;        PATTERN - definice vpln
; -----------------------------------------------------------------------------

PUBLIC   XPatt
XPatt:
         mov       di,offset Pattern        ; tabulka definice vpln
         mov       cx,8                     ; poet bajt k definici

; ------ stanoven hodnot vpln

XPatt1:  push      cx
         push      di
         call      Vyraz                    ; ten hodnoty pro vpl
         pop       di
         pop       cx
         cmp       ax,8000h                 ; nastavuje se hodnota ?
         je        XPatt2                   ; hodnota se nemn
         mov       cs:[di],al               ; definice vpln
XPatt2:  mov       al,cs:[di]               ; vpl
         or        cs:[OrPatt],al           ; logick souet vpln
         and       cs:[AndPatt],al          ; logick souin vpln
         inc       di                       ; zven ukldac adresy
         loop      XPatt1                   ; dal bajt definice
         mov       ax,word ptr cs:[Pattern] ; prvn dva bajty definice
         ret

; -----------------------------------------------------------------------------
;        STICK - joystickov vstup
; -----------------------------------------------------------------------------
; VSTUP: AX:  0=nen dn smr
;              1=nahoru                        8    /\ 1  2
;              2=vpravo nahoru                   \      /
;              3=vpravo
;              4=vpravo dol                 7 <---    ---> 3
;              5=dol
;              6=vlevo dol                    6 /      \  4
;              7=vlevo                              \/
;              8=vlevo nahoru                         5
; -----------------------------------------------------------------------------

PUBLIC   XStick
XStick:

         mov       bh,0
         mov       ax,40
         cli
                                          ;* 1 - nahoru
         mov       bl,48h
         mov       dh,-18
         mov       dl,0
         call      XStickX
                                          ;* 2 - vpravo nahoru
         mov       bl,49h
         mov       dh,-9
         mov       dl,1
         call      XStickX
                                          ;* 3 - vpravo
         mov       bl,4dh
         mov       dh,0
         mov       dl,2
         call      XStickX
                                          ;* 4 - vpravo dol
         mov       bl,51h
         mov       dh,9
         mov       dl,1
         call      XStickX
                                          ;* 5 - dol
         mov       bl,50h
         mov       dh,18
         mov       dl,0
         call      XStickX
                                          ;* 6 - vlevo dol
         mov       bl,4fh
         mov       dh,9
         mov       dl,-1
         call      XStickX
                                          ;* 7 - vlevo
         mov       bl,4bh
         mov       dh,0
         mov       dl,-2
         call      XStickX
                                          ;* 8 - vlevo nahoru
         mov       bl,47h
         mov       dh,-9
         mov       dl,-1
         call      XStickX

         mov       bx,ax
         mov       al,cs:[TabSmer+bx]

         sti
         ret


                                          ;* test, zda je nastaven smr BX
XStickX: cmp       byte ptr cs:[KeyBuf+1],bl
         jne       XStickX0
         mov       word ptr cs:[KeyBuf],0
         jmp       short XStickX1
XStickX0:cmp       byte ptr cs:[TabKey+bx],0 ; je poadovan smr ?
         jne       XStickX1                 ; poadovan smr je
         cmp       byte ptr cs:[TabKey+bx+60h-47h],0 ; je zdvojen klvesa ?
         je        XStickX2                 ; smr nen
XStickX1:add       al,dl
         add       al,dh
XStickX2:ret


TabSmer  label     byte
         db        8,8,8,1,1,1,1,2,2
         db        8,8,8,1,1,1,2,2,2
         db        7,8,8,8,1,1,2,2,2
         db        7,7,7,8,1,2,2,3,3
         db        7,7,7,7,0,3,3,3,3
         db        7,7,6,6,5,4,3,3,3
         db        6,6,6,5,5,4,4,4,3
         db        6,6,6,5,5,5,4,4,4
         db        6,6,5,5,5,5,4,4,4


; 8         1   2
;  b7    /\ b0 b1
;     \      /
;7
;b6 <---    --->b2 3
;
; 6 b5/      \ b3
;        \/      4
;         b4
;          5

;TabSmer  label     byte                   ;* tabulka smr Joysticku
;         db        0,1,2,1,3,2,2,2,4,2,3,2,3,3,3,2 ; b4=0, b5=0, b6=0, b7=0
;         db        5,0,3,2,4,3,3,2,4,3,4,3,4,3,3,3 ; b4=1, b5=0, b6=0, b7=0
;         db        6,7,0,8,4,2,2,2,5,5,4,1,4,3,3,2 ; b4=0, b5=1, b6=0, b7=0
;         db        5,6,5,0,5,5,4,2,5,5,4,5,4,4,4,3 ; b4=1, b5=1, b6=0, b7=0
;
;         db        0,1,2,1,3,2,2,2,4,2,3,2,3,3,3,2 ; b4=0, b5=0, b6=1, b7=0
;         db        5,0,3,2,4,3,3,2,4,3,4,3,4,3,3,3 ; b4=1, b5=0, b6=1, b7=0
;         db        6,7,0,8,4,2,2,2,5,5,4,1,4,3,3,2 ; b4=0, b5=1, b6=1, b7=0
;         db        5,6,5,0,5,5,4,2,5,5,4,5,4,4,4,3 ; b4=1, b5=1, b6=1, b7=0

; -----------------------------------------------------------------------------
;        TRIG - aktivan vstup z joysticku
; -----------------------------------------------------------------------------

PUBLIC   XTrig
XTrig:
         mov       ax,-1
         cmp       byte ptr cs:[TabKey+39h],0    ; je mezernk ?
         jne       XTrig1                   ; je mezernk
         cmp       byte ptr cs:[TabKey+4ch],0
         jne       XTrig1
         cmp       byte ptr cs:[TabKey+65h],0
         jne       XTrig1
         xor       ax,ax
XTrig1:  ret

; -----------------------------------------------------------------------------
;        COS
; -----------------------------------------------------------------------------
;
PUBLIC   XCos
XCos:    call      Vyraz

; ------ korekce - prava na SIN

XCosin:  add       ax,4000h                 ; piten kvadrantu - nyn jako SIN
         jmp       short XSinus             ; dle jako SIN

; -----------------------------------------------------------------------------
;        SIN
; -----------------------------------------------------------------------------

PUBLIC   XSin
XSin:    call      Vyraz

; ------ absolutn hodnota sla

XSinus:  mov       di,ax                    ; schova znamnka sla
         or        ax,ax
         jns       XSin2
         neg       ax

; ------ druh kvadrant bude stejn jako prvn

XSin2:   cmp       ax,4000h                 ; je druh kvadrant ?
         jb        XSin3                    ; je prvn kvadrant - OK
         sub       ax,8000h                 ; pevrcen na prvn kvadrant
         neg       ax                       ; oprava znamnka

; ------ pevod hlu na hodnotu

XSin3:   shl       ax,1                     ; hodnota * 2
         mov       bl,ah
         xor       bh,bh
         shl       bx,1
         mov       cx,cs:[SinTab+bx]        ; prozatimn hodnota

; ------ upesnn hodnoty

         mov       dx,cs:[SinTab+bx+2]      ; nsledujc hodnota
         sub       dx,cx                    ; rozdl hodnot
         xor       ah,ah                    ; AX = zbytek hodnoty
         mul       dx                       ; vynsoben zbytkem
         mov       al,ah
         mov       ah,dl                    ; AX = oprava vsledku
         add       ax,cx                    ; vsledek

; ------ oprava znamnka vsledku

         or        di,di
         jns       XSin5
         neg       ax
XSin5:   ret



SinTab   label     word
         dw        0                        ; 0
;         dw        201                      ; 1
         dw        402                      ; 2
;         dw        603                      ; 3
         dw        804                      ; 4
;         dw        1005                     ; 5
         dw        1206                     ; 6
;         dw        1407                     ; 7
         dw        1608                     ; 8
;         dw        1809                     ; 9
         dw        2009                     ; 10
;         dw        2210                     ; 11
         dw        2410                     ; 12
;         dw        2611                     ; 13
         dw        2811                     ; 14
;         dw        3012                     ; 15
         dw        3212                     ; 16
;         dw        3412                     ; 17
         dw        3612                     ; 18
;         dw        3811                     ; 19
         dw        4011                     ; 20
;         dw        4210                     ; 21
         dw        4410                     ; 22
;         dw        4609                     ; 23
         dw        4808                     ; 24
;         dw        5007                     ; 25
         dw        5205                     ; 26
;         dw        5404                     ; 27
         dw        5602                     ; 28
;         dw        5800                     ; 29
         dw        5998                     ; 30
;         dw        6195                     ; 31
         dw        6393                     ; 32
;         dw        6590                     ; 33
         dw        6786                     ; 34
;         dw        6983                     ; 35
         dw        7179                     ; 36
;         dw        7375                     ; 37
         dw        7571                     ; 38
;         dw        7767                     ; 39
         dw        7962                     ; 40
;         dw        8157                     ; 41
         dw        8351                     ; 42
;         dw        8545                     ; 43
         dw        8739                     ; 44
;         dw        8933                     ; 45
         dw        9126                     ; 46
;         dw        9319                     ; 47
         dw        9512                     ; 48
;         dw        9704                     ; 49
         dw        9896                     ; 50
;         dw        10087                    ; 51
         dw        10278                    ; 52
;         dw        10469                    ; 53
         dw        10659                    ; 54
;         dw        10849                    ; 55
         dw        11039                    ; 56
;         dw        11228                    ; 57
         dw        11417                    ; 58
;         dw        11605                    ; 59
         dw        11793                    ; 60
;         dw        11980                    ; 61
         dw        12167                    ; 62
;         dw        12353                    ; 63
         dw        12539                    ; 64
;         dw        12725                    ; 65
         dw        12910                    ; 66
;         dw        13094                    ; 67
         dw        13279                    ; 68
;         dw        13462                    ; 69
         dw        13645                    ; 70
;         dw        13828                    ; 71
         dw        14010                    ; 72
;         dw        14191                    ; 73
         dw        14372                    ; 74
;         dw        14553                    ; 75
         dw        14732                    ; 76
;         dw        14912                    ; 77
         dw        15090                    ; 78
;         dw        15269                    ; 79
         dw        15446                    ; 80
;         dw        15623                    ; 81
         dw        15800                    ; 82
;         dw        15976                    ; 83
         dw        16151                    ; 84
;         dw        16325                    ; 85
         dw        16499                    ; 86
;         dw        16673                    ; 87
         dw        16846                    ; 88
;         dw        17018                    ; 89
         dw        17189                    ; 90
;         dw        17360                    ; 91
         dw        17530                    ; 92
;         dw        17700                    ; 93
         dw        17869                    ; 94
;         dw        18037                    ; 95
         dw        18204                    ; 96
;         dw        18371                    ; 97
         dw        18537                    ; 98
;         dw        18703                    ; 99
         dw        18868                    ; 100
;         dw        19032                    ; 101
         dw        19195                    ; 102
;         dw        19357                    ; 103
         dw        19519                    ; 104
;         dw        19680                    ; 105
         dw        19841                    ; 106
;         dw        20000                    ; 107
         dw        20159                    ; 108
;         dw        20317                    ; 109
         dw        20475                    ; 110
;         dw        20631                    ; 111
         dw        20787                    ; 112
;         dw        20942                    ; 113
         dw        21096                    ; 114
;         dw        21250                    ; 115
         dw        21403                    ; 116
;         dw        21554                    ; 117
         dw        21705                    ; 118
;         dw        21856                    ; 119
         dw        22005                    ; 120
;         dw        22154                    ; 121
         dw        22301                    ; 122
;         dw        22448                    ; 123
         dw        22594                    ; 124
;         dw        22739                    ; 125
         dw        22884                    ; 126
;         dw        23027                    ; 127
         dw        23170                    ; 128
;         dw        23312                    ; 129
         dw        23452                    ; 130
;         dw        23592                    ; 131
         dw        23731                    ; 132
;         dw        23870                    ; 133
         dw        24007                    ; 134
;         dw        24143                    ; 135
         dw        24279                    ; 136
;         dw        24413                    ; 137
         dw        24547                    ; 138
;         dw        24680                    ; 139
         dw        24811                    ; 140
;         dw        24942                    ; 141
         dw        25072                    ; 142
;         dw        25201                    ; 143
         dw        25329                    ; 144
;         dw        25456                    ; 145
         dw        25582                    ; 146
;         dw        25708                    ; 147
         dw        25832                    ; 148
;         dw        25955                    ; 149
         dw        26077                    ; 150
;         dw        26198                    ; 151
         dw        26319                    ; 152
;         dw        26438                    ; 153
         dw        26556                    ; 154
;         dw        26674                    ; 155
         dw        26790                    ; 156
;         dw        26905                    ; 157
         dw        27019                    ; 158
;         dw        27133                    ; 159
         dw        27245                    ; 160
;         dw        27356                    ; 161
         dw        27466                    ; 162
;         dw        27575                    ; 163
         dw        27683                    ; 164
;         dw        27790                    ; 165
         dw        27896                    ; 166
;         dw        28001                    ; 167
         dw        28105                    ; 168
;         dw        28208                    ; 169
         dw        28310                    ; 170
;         dw        28411                    ; 171
         dw        28510                    ; 172
;         dw        28609                    ; 173
         dw        28706                    ; 174
;         dw        28803                    ; 175
         dw        28898                    ; 176
;         dw        28992                    ; 177
         dw        29085                    ; 178
;         dw        29177                    ; 179
         dw        29268                    ; 180
;         dw        29358                    ; 181
         dw        29447                    ; 182
;         dw        29535                    ; 183
         dw        29621                    ; 184
;         dw        29706                    ; 185
         dw        29791                    ; 186
;         dw        29874                    ; 187
         dw        29956                    ; 188
;         dw        30037                    ; 189
         dw        30117                    ; 190
;         dw        30195                    ; 191
         dw        30273                    ; 192
;         dw        30349                    ; 193
         dw        30424                    ; 194
;         dw        30498                    ; 195
         dw        30571                    ; 196
;         dw        30643                    ; 197
         dw        30714                    ; 198
;         dw        30783                    ; 199
         dw        30852                    ; 200
;         dw        30919                    ; 201
         dw        30985                    ; 202
;         dw        31050                    ; 203
         dw        31113                    ; 204
;         dw        31176                    ; 205
         dw        31237                    ; 206
;         dw        31297                    ; 207
         dw        31356                    ; 208
;         dw        31414                    ; 209
         dw        31470                    ; 210
;         dw        31526                    ; 211
         dw        31580                    ; 212
;         dw        31633                    ; 213
         dw        31685                    ; 214
;         dw        31736                    ; 215
         dw        31785                    ; 216
;         dw        31833                    ; 217
         dw        31880                    ; 218
;         dw        31926                    ; 219
         dw        31971                    ; 220
;         dw        32014                    ; 221
         dw        32057                    ; 222
;         dw        32098                    ; 223
         dw        32137                    ; 224
;         dw        32176                    ; 225
         dw        32213                    ; 226
;         dw        32250                    ; 227
         dw        32285                    ; 228
;         dw        32318                    ; 229
         dw        32351                    ; 230
;         dw        32382                    ; 231
         dw        32412                    ; 232
;         dw        32441                    ; 233
         dw        32469                    ; 234
;         dw        32495                    ; 235
         dw        32521                    ; 236
;         dw        32545                    ; 237
         dw        32567                    ; 238
;         dw        32589                    ; 239
         dw        32609                    ; 240
;         dw        32628                    ; 241
         dw        32646                    ; 242
;         dw        32663                    ; 243
         dw        32678                    ; 244
;         dw        32692                    ; 245
         dw        32705                    ; 246
;         dw        32717                    ; 247
         dw        32728                    ; 248
;         dw        32737                    ; 249
         dw        32745                    ; 250
;         dw        32752                    ; 251
         dw        32757                    ; 252
;         dw        32761                    ; 253
         dw        32765                    ; 254
;         dw        32766                    ; 255
         dw        32767                    ; 256


; -----------------------------------------------------------------------------
;        TAN
; -----------------------------------------------------------------------------

PUBLIC   XTan
XTan:    call      Vyraz
         ret

; -----------------------------------------------------------------------------
;        ABS
; -----------------------------------------------------------------------------

PUBLIC   XAbs
XAbs:    call      Vyraz
         or        ax,ax                    ; je zporn slo ?
         jns       XAbs2                    ; je kladn slo
         neg       ax                       ; negace zpornho sla na kladn
XAbs2:   ret

; -----------------------------------------------------------------------------
;        ATN
; -----------------------------------------------------------------------------

PUBLIC   XAtn
XAtn:    call      Vyraz
         ret

; -----------------------------------------------------------------------------
;        SQR
; -----------------------------------------------------------------------------

PUBLIC   XSqr
XSqr:    call      Vyraz

XSqr0:   push      ax                       ; schova sla

; ------ absolutn hodnota sla

         or        ax,ax                    ; je zporn slo ?
         jns       XSqr1
         neg       ax
XSqr1:   cmp       ax,1                     ; je slo 0 nebo 1 ?
         jbe       XSqr4                    ; slo je nzk - vsledek stejn

; ------ cyklus vpotu odmocniny

         mov       cx,ax                    ; schova sla
         mov       bx,ax
XSqr2:   mov       di,bx                    ; mezischova starho vsledku
         mov       bx,ax                    ; nov mezivsledek
         mov       ax,cx                    ; AX <- potan slo
         xor       dx,dx                    ; DX:AX=vchoz operand
         div       bx
         add       ax,bx
         shr       ax,1                     ; nov mezivsledek
         cmp       ax,bx                    ; zmnil se vsledek ?
         je        XSqr3                    ; vsledek se ji nemn
         cmp       ax,di                    ; zacyklil se vpoet ?
         jne       XSqr2                    ; dal cyklus

XSqr3:   add       ax,bx
         inc       ax
         shr       ax,1                     ; oprava hodnoty

; ------ nvrat znamnka sla

XSqr4:   pop       di
         or        di,di
         jns       XSqr5
         neg       ax
XSqr5:
         ret

; -----------------------------------------------------------------------------
;        BYTE
; -----------------------------------------------------------------------------

PUBLIC   XUsrByte
XUsrByte:lodsw                              ; adresa promnn
         push      ax
         call      Vyraz                    ; vpoet vrazu
         pop       bx
         mov       es:[bx],al               ; nastaven promnn BYTE
         ret

; -----------------------------------------------------------------------------
;        WORD
; -----------------------------------------------------------------------------

PUBLIC   XUsrWord
XUsrWord:lodsw                              ; adresa promnn
         push      ax
         call      Vyraz                    ; vpoet vrazu
         pop       bx
         mov       es:[bx],ax               ; nastaven promnn WORD
         ret

; -----------------------------------------------------------------------------
;        BYTE index
; -----------------------------------------------------------------------------

PUBLIC   XUsrBytI
XUsrBytI:lodsw                              ; adresa promnn
         push      ax
         call      Vyraz                    ; vpoet indexu
         push      ax
         call      Vyraz                    ; vpoet vrazu
         pop       bx                       ; index v promnn
         pop       cx                       ; adresa promnn
         add       bx,cx                    ; adresa poloky
         cmp       bx,cs:[DatNum]           ; pekroen konec dat ?
         jae       XUsrBtI2                 ; pekroen konec datovho modulu
         mov       es:[bx],al               ; nastaven promnn BYTE
XUsrBtI2:ret

; -----------------------------------------------------------------------------
;        WORD index
; -----------------------------------------------------------------------------

PUBLIC   XUsrWorI
XUsrWorI:lodsw                              ; adresa promnn
         push      ax                       ; adresa promnn
         call      Vyraz                    ; vpoet vrazu
         shl       ax,1                     ; offset poloky
         push      ax                       ; offset poloky
         call      Vyraz                    ; vpoet vrazu
         pop       bx                       ; offset poloky
         pop       cx                       ; adresa promnn
         add       bx,cx                    ; adresa poloky
         cmp       bx,cs:[DatNum]           ; pekroen konec dat ?
         jae       XUsrWrI2                 ; pekroen konec datovho modulu
         mov       es:[bx],ax               ; nastaven promnn WORD
XUsrWrI2:ret

; -----------------------------------------------------------------------------
;        Uivatelsk procedura
; -----------------------------------------------------------------------------

PUBLIC   XUser
XUser:   lodsw                              ; adresa uivatelsk procedury
         push      si                       ; schova nvratov adresy
         mov       si,ax                    ; nov adresa programu (procedura)
         call      Anim                     ; proveden obsluhy procedury
         pop       si                       ; nvrat ukazatele programu
         ret

; -----------------------------------------------------------------------------
;        Poskytnut adresy stavovho registru CRT
; -----------------------------------------------------------------------------

GetPort:
         push      ds
         xor       dx,dx                    ; DX <- 0
         mov       ds,dx
         mov       dx,ds:[463h]             ; adresa dicho registru CRT
         pop       ds
         add       dx,6                     ; stavov registr CRT
         ret

; *****************************************************************************
;
;                          Obsluhy funkc BIOS
;
; *****************************************************************************

PUBLIC   Int10
Int10:   pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es
         int       10h
         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret

; *****************************************************************************
;
;                         Datov segment
;
; *****************************************************************************

TabOper  label     word                   ;* tabulka obsluh opertor

         dw        offset OpKonec           ; 0: konec vrazu
         dw        offset Vyraz             ; 1: (
         dw        offset OpRght            ; 2: )
         dw        offset OpMoc             ; 3: ^
         dw        offset OpMul             ; 4: *
         dw        offset OpDiv             ; 5: /
         dw        offset OpMod             ; 6: MOD
         dw        offset OpShl             ; 7: <<
         dw        offset OpShr             ; 8: >>
         dw        offset OpAdd             ; 9: +
         dw        offset OpSub             ; 10: -
         dw        offset OpEqu             ; 11: =
         dw        offset OpNeq             ; 12: <>
         dw        offset OpLt              ; 13: <
         dw        offset OpGt              ; 14: >
         dw        offset OpLte             ; 15: <=
         dw        offset OpGte             ; 16: >=
         dw        offset OpNot             ; 17: NOT
         dw        offset OpAnd             ; 18: AND
         dw        offset OpOr              ; 19: OR
         dw        offset OpXor             ; 20: XOR

         dw        81h - 20 - 1 dup(offset OpKonec)

         dw        offset OpKonst           ; 81h: seln konstanta
         dw        offset OpInter           ; 82h: intern procedura
         dw        offset OpUsr             ; 83h: uivatelsk procedura
         dw        offset OpByte            ; 84h: promnn BYTE
         dw        offset OpWord            ; 85h: promnn WORD
         dw        offset OpByteI           ; 86h: promnn BYTE s indexem
         dw        offset OpWordI           ; 87h: promnn WORD s indexem


TabFnc   label     word                   ;* tabulka internch funkc

         dw        offset XNop              ; 0   (LINK), t przdn pkaz NOP
         dw        offset XNop              ; 1   (INCLUDE)
         dw        offset XNop              ; 2   (BYTE)
         dw        offset XNop              ; 3   (WORD)
         dw        offset XNop              ; 4   (STRING)
         dw        offset XNop              ; 5   (PROC)
         dw        offset XEndProc          ; 6 ENDPROC
         dw        offset XReturn           ; 7 RETURN
         dw        offset XExec             ; 8 EXEC
         dw        offset XIf               ; 9 IF
         dw        offset XNop              ; 10   (THEN)
         dw        offset XElse             ; 11   ELSE
         dw        offset XNop              ; 12   (ENDIF)
         dw        offset XFor              ; 13 FOR
         dw        offset XNop              ; 14   (TO)
         dw        offset XNop              ; 15   (STEP)
         dw        offset XNop              ; 16   (DO)
         dw        offset XOn               ; 17 ON
         dw        offset XEndDo            ; 18 ENDDO
         dw        offset XNop              ; 19   (EXIT)
         dw        offset XCase             ; 20 CASE
         dw        offset XIn               ; 21 IN
         dw        offset XOut              ; 22 OUT
         dw        offset XNop              ; 23   (ENDCASE)
         dw        offset XVal              ; 24 VAL
         dw        offset XStr              ; 25 STR
         dw        offset XLen              ; 26 LEN
         dw        offset XCard             ; 27 CARD
         dw        offset XVideo            ; 28 VIDEO
         dw        offset XNop              ; 29   (GVIDEO)
         dw        offset XMode             ; 30 MODE
         dw        offset XPage             ; 31 PAGE
         dw        offset XXPage            ; 32 XPAGE
         dw        offset XWind             ; 33 WINDOW
         dw        offset XPal              ; 34 PALETE
         dw        offset XXCol             ; 35 XCOLOR
         dw        offset XSetCur           ; 36 SETCURS
         dw        offset XCurOff           ; 37 CURSOFF
         dw        offset XLoad             ; 38 LOAD
         dw        offset XObj              ; 39 OBJECT
         dw        offset XUnld             ; 40 UNLOAD
         dw        offset XText             ; 41 TEXT
         dw        offset XPoint            ; 42 POINT
         dw        offset XLine             ; 43 LINE
         dw        offset XRLine            ; 44 RLINE
         dw        offset XBox              ; 45 BOX
         dw        offset XFBox             ; 46 FBOX
         dw        offset XCirc             ; 47 CIRC
         dw        offset XFCirc            ; 48 FCIRC
         dw        offset XPress            ; 49 PRESS
         dw        offset XTstKey           ; 50 TESTKEY
         dw        offset XGtKey            ; 51 GETKEY
         dw        offset XStatKey          ; 52 STATKEY
         dw        offset XInp              ; 53 INPUT
         dw        offset XSound            ; 54 SOUND
         dw        offset XTon              ; 55 TON
         dw        offset XMusic            ; 56 MUSIC
         dw        offset XMStop            ; 57 MUSICSTOP
         dw        offset XMusGet           ; 58 MUSICGET
         dw        offset XWait             ; 59 WAIT
         dw        offset XTime             ; 60 TIME
         dw        offset XDate             ; 61 DATE
         dw        offset XXMous            ; 62 XMOUSE
         dw        offset XYMous            ; 63 YMOUSE
         dw        offset XKMous            ; 64 GETMOUSE
         dw        offset XMon              ; 65 MOUSEON
         dw        offset XMoff             ; 66 MOUSEOFF
         dw        offset XDefm             ; 67 CURMOUSE
         dw        offset XWinm             ; 68 WINMOUSE
         dw        offset XRnd              ; 69 XRND
         dw        offset XReg              ; 70 REGISTER
         dw        offset XHSyn             ; 71 HSYN
         dw        offset XVSyn             ; 72 VSYN
         dw        offset XPatt             ; 73 PATTERN
         dw        offset XStick            ; 74 STICK
         dw        offset XTrig             ; 75 TRIG
         dw        offset XSin              ; 76 SIN
         dw        offset XCos              ; 77 COS
         dw        offset XTan              ; 78 TAN
         dw        offset XAbs              ; 79 ABS
         dw        offset XAtn              ; 80 ATN
         dw        offset XSqr              ; 81 SQR

         dw        0f8h - 81 - 1 dup(offset XNop)

         dw        offset XUsrByte          ; f8h BYTE
         dw        offset XUsrWord          ; f9h WORD
         dw        offset XUsrBytI          ; fah BYTE index
         dw        offset XUsrWorI          ; fbh WORD index

         dw        3 dup(offset XNop)

         dw        offset XUser             ; ffh uivatelsk procedura



; Struktura objekt:
;                     0 (2) = slo objektu
;                     2 (2) = velikost bloku pamti (v odstavcch)
;                     4 (2) = rozmry X
;                     6 (2) = rozmry Y
;                     8 (2) = poet barevnch rovin
;                    10 (2) = barva pozad
;                    12 (2) = poet bajt definice palet
;                    14 (1) = videomd
;                    15 (1) = parametry
;                                bit 0: 1=komprese
;                                bit 1: 1=textov md
;                                bit 2: 1=paraleln uloen barev
;                    10h    = data

ModSir   EQU       0                        ; ka dku (jednotek)
ModVys   EQU       2                        ; vka dku (jednotek)
ModSirB  EQU       4                        ; ka dku (bajt)
ModRov   EQU       6                        ; poet barevnch rovin
ModCLR   EQU       8                        ; obsluha vymazn displeje
ModPrep  EQU       10                       ; pprava parametr pro zobrazen
ModSet   EQU       12                       ; nastaven pro zobrazen roviny AX
ModDisp  EQU       14                       ; obsluha zobrazen linky
ModLine  EQU       16                       ; obsluha zobrazen ry
ModPoint EQU       18                       ; zobrazen bodu


TabMod   label     word                   ;* tabulka videomd

                                          ;* 0: 40x25 text
         dw        40                       ; ka (jednotek)
         dw        25                       ; vka (linek)
         dw        40                       ; ka dku (bajt)
         dw        2                        ; poet barevnch rovin
         dw        offset ClrTXT            ; vymazn nastavenou barvou
         dw        offset PrepTxt           ; pprava parametr pro zobrazen
         dw        offset SetTXT            ; nastaven pro zobrazen roviny AX
         dw        offset DispTxt           ; zobrazen linky
         dw        offset LineTxt           ; zobrazen ry
         dw        offset PointTxt          ; zobrazen bodu

TabMod0  label     word                     ; nvt pro vpoet dlky poloky

                                          ;* 1: 40x25 text
         dw        40,25,40,2
         dw        offset ClrTXT
         dw        offset PrepTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset LineTxt
         dw        offset PointTxt

                                          ;* 2: 80x25 text
         dw        80,25,80,2
         dw        offset ClrTXT
         dw        offset PrepTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset LineTxt
         dw        offset PointTxt

                                          ;* 3: 80x25 text
         dw        80,25,80,2
         dw        offset ClrTXT
         dw        offset PrepTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset LineTxt
         dw        offset PointTxt

                                          ;* 4: 320x200/4 graf
         dw        320,200,80,2
         dw        offset ClrCG4
         dw        offset PrepCG4
         dw        offset SetCG4
         dw        offset DispCG4
         dw        offset LineCG4
         dw        offset PointCG4

                                          ;* 5: 320x200/4 graf
         dw        320,200,80,2
         dw        offset ClrCG4
         dw        offset PrepCG4
         dw        offset SetCG4
         dw        offset DispCG4
         dw        offset LineCG4
         dw        offset PointCG4

                                          ;* 6: 640x200/2 graf
         dw        640,200,80,1
         dw        offset ClrCG6
         dw        offset PrepCG6
         dw        offset SetCG6
         dw        offset DispCG4
         dw        offset LineCG6
         dw        offset PointCG6

                                          ;* 7: 80x25 text
         dw        80,25,80,2
         dw        offset ClrTXT
         dw        offset PrepTXT
         dw        offset SetTXT
         dw        offset DispTXT
         dw        offset LineTxt
         dw        offset PointTxt

                                          ;* 8: 160x200/16 graf.
         dw        160,200,80,4
         dw        offset ClrPCJ
         dw        offset PrepPCJ
         dw        offset SetPCJ
         dw        offset DispPCJ
         dw        offset LinePCJ
         dw        offset PointPCJ

                                          ;* 9: 320x200/16 graf.
         dw        320,200,160,4
         dw        offset ClrPCJ
         dw        offset PrepPCJ
         dw        offset SetPCJ
         dw        offset DispPCJ
         dw        offset LinePCJ
         dw        offset PointPCJ

                                          ;* 10: 640x200/4 graf.
         dw        640,200,160,4
         dw        offset ClrPCJ
         dw        offset PrepPCJ
         dw        offset SetPCJ
         dw        offset DispPCJ
         dw        offset LinePCJ
         dw        offset PointPCJ

                                          ;* 11: intern
         dw        80,25,80,2
         dw        offset ClrTXT
         dw        offset PrepTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset LineTxt
         dw        offset PointTxt

                                          ;* 12: intern
         dw        80,25,80,2
         dw        offset ClrTXT
         dw        offset PrepTXT
         dw        offset SetTXT
         dw        offset DispTxt
         dw        offset LineTxt
         dw        offset PointTxt

                                          ;* 13: 320x200/16 graf
         dw        320,200,40,4
         dw        offset ClrEGA
         dw        offset PrepEGA
         dw        offset SetEGA
         dw        offset DispEG3
         dw        offset LineEGA
         dw        offset PointEGA

                                          ;* 14: 640x200/16 graf
         dw        640,200,80,4
         dw        offset ClrEGA
         dw        offset PrepEGA
         dw        offset SetEGA
         dw        offset DispEG3
         dw        offset LineEGA
         dw        offset PointEGA

                                          ;* 15: 640x350/2 graf
         dw        640,350,80,1
         dw        offset ClrEGA
         dw        offset PrepEGA
         dw        offset SetEGA
         dw        offset DispEG3
         dw        offset LineEGA
         dw        offset PointEGA

                                          ;* 16: 640x350/16 graf
         dw        640,350,80,4
         dw        offset ClrEGA
         dw        offset PrepEGA
         dw        offset SetEGA
         dw        offset DispEG3
         dw        offset LineEGA
         dw        offset PointEGA

                                          ;* 17: 640x480/2 graf
         dw        640,480,80,1
         dw        offset ClrCG6
         dw        offset PrepCG6
         dw        offset SetCG6
         dw        offset DispCG4
         dw        offset LineCG6
         dw        offset PointCG6

                                          ;* 18: 640x480/16 graf
         dw        640,480,80,4
         dw        offset ClrEGA
         dw        offset PrepEGA
         dw        offset SetEGA
         dw        offset DispEG3
         dw        offset LineEGA
         dw        offset PointEGA

                                          ;* 19: 320x200/256 graf
         dw        320,200,320,8
         dw        offset ClrMCG
         dw        offset PrepMCG
         dw        offset SetMCG
         dw        offset DispMCG
         dw        offset LineMCG
         dw        offset PointMCG

TabPal   db        0,1,2,3,4,5,14h,7,38h,39h,3ah,3bh,3ch,3dh,3eh,3fh,0 ; palety

; ------ parametry pro zobrazen objekt

                                          ;* parametry ze zhlav objektu (12 B)
Sirka    dw        0                        ; ka vezu (pozic)
Vyska    dw        0                        ; vka vezu (linek)
Rovin    dw        0                        ; poet barevnch rovin
Pozadi   dw        0                        ; barva pozad
Palet    dw        0                        ; poet bajt palet
Mod      db        0                        ; videomd displeje
Param    db        0                        ; parametry
                                            ;  bit 0: 1=komprese
                                            ;  bit 1: 1=textov videomd
                                            ;  bit 2: 1=paraleln uloen barev
                                            ;  bit 3: 1=je maska pozad

                                          ;* rozmry vstupnho okna
Wind1    dw        8000h                    ; lev okraj okna
Wind2    dw        8000h                    ; horn okraj okna
Wind3    dw        7fffh                    ; prav okraj okna
Wind4    dw        7fffh                    ; spodn okraj okna

                                          ;* parametry okna (rozmry)
ObjLD    dw        0                        ; lev okraj zatku zobrazen
ObjUD    dw        0                        ; horn okraj zatku zobrazen
ObjLO    dw        0                        ; lev okraj potku v objektu
ObjUO    dw        0                        ; horn okraj potku v objektu
ObjS     dw        0                        ; ka vezu k zobrazen
ObjV     dw        0                        ; vka vezu k zobrazen

                                          ;* parametry pro zobrazen ry
LineX1   dw        0                        ; poten souadnice X1
LineY1   dw        0                        ; poten souadnice Y1
LineX2   dw        0                        ; poten souadnice X2
LineY2   dw        0                        ; poten souadnice Y2
LineB    dw        0                        ; poet bajt na linku


                                          ;* pracovn parametry pro zobrazen
SirkaB   dw        0                        ; ka vezu (bajt)
RovinaB  dw        0                        ; poet bajt na rovinu
MaskAdr  dd        0                        ; adresa masky
MaskRot  db        0                        ; poet rotac bajtu pi zobrazen
MaskNum  db        0                        ; poet vnitnch bajt linky
MaskFrst db        0ffh                     ; maska prvnho bajtu linky
MaskLst  db        0ffh                     ; maska poslednho bajtu linky

Pattern  db        8 dup(0ffh)              ; vzorek pro vpl
AndPatt  db        0ffh                     ; logick souin vzork vpln
OrPatt   db        0ffh                     ; logick souet vzork vpln

; ------ obsluha klvesnice

Keys     dw        0                        ; posledn znak z klvesnice

; ------ parametry pro prci s pamt

DatNum   dw        0                        ; poet bajt datovho modulu
DatMem   dw        SEG SegProg              ; segment s daty programu
ProgMem  dw        0                        ; segment s natenm programem
ObjMem   dw        0                        ; segment s prvnm objektem
TopMem   dw        0                        ; segment zatku voln pamti

; ------ parametry displeje

BitDisp  dw        0                        ; md displeje (pznakov bity)
OldVMod  db        3                        ; pvodn videomd
VMod     db        3                        ; aktuln videomd
SegVRAM  dw        0b800h                   ; segment videopamti
DelVRAM  dw        2000h                    ; dlka videostrnky
EgaVga   db        1                        ; pznak karty EGA/VGA
KurzPoz  dw        0                        ; aktuln pozice kurzoru
MaxPoz   db        80                       ; maximln poet pozic
MaxRad   db        25                       ; maximln poet dk

Page1    db        0                        ; aktivn zobrazen strnka
Page2    db        0                        ; vstupn strnka

; ------ Chybov texty

MemTxt   db        'Chyba - nedostatek pameti !',13,10,'$'
KartTxt  db        'Program vyzaduje grafickou kartu EGA nebo VGA !',13,10,'$'

FndTxt   db        'Chyba - soubor $'
Fnd2Txt  db        ' nenalezen !',13,10,'$'

RetKod   db        -1                       ; nvrat. kd z programu (=peru.)
SegPSP   dw        0                        ; schova adresy PSP


Code     ENDS

; *****************************************************************************
;
;                  Pechodn zsobnk pro interpreter
;
; *****************************************************************************

Stack    SEGMENT   stack para

         db        20h dup(0)

Stack    ENDS

; *****************************************************************************
;
;                       Segment programu
;
; *****************************************************************************

SegProg  SEGMENT PARA


SegProg  ENDS

         END       Start
